/**
 * <copyright>
 * 
 * Copyright (c) 2013 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.common.metamodel;

import org.eclipse.sphinx.emf.metamodel.MetaModelVersionData;

public class SAFEMetaModelVersionData extends MetaModelVersionData implements Comparable<SAFEMetaModelVersionData> {

	protected static String getNsPostfix(int major, int minor, int revision) {
		return major + "." + minor + "." + revision; //$NON-NLS-1$ //$NON-NLS-2$
	}

	private int major;
	private int minor;
	private int revision;

	public SAFEMetaModelVersionData(String name, int major, int minor, int revision, int ordinal) {
		super(getNsPostfix(major, minor, revision), getNsPostfix(major, minor, revision), name, SAFEReleaseDescriptor.INSTANCE);
		this.major = major;
		this.minor = minor;
		this.revision = revision;
	}

	public int getMajor() {
		return major;
	}

	public int getMinor() {
		return minor;
	}

	public int getRevision() {
		return revision;
	}

	public int compareTo(SAFEMetaModelVersionData other) {
		int result;

		result = new Integer(major).compareTo(other.major);
		if (result != 0) {
			return result;
		}

		result = new Integer(minor).compareTo(other.minor);
		if (result != 0) {
			return result;
		}

		result = new Integer(revision).compareTo(other.revision);

		return result;
	}
}
