/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.edit.providers;


import java.util.Collection;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.command.Command;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.RemoveCommand;

import org.eclipse.emf.edit.domain.EditingDomain;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.sphinx.emf.edit.CustomCommandRegistry;
import org.eclipse.sphinx.emf.edit.ResourceLocatorRegistry;

import org.safe.metamodel.safe10.Item;
import org.safe.metamodel.safe10.Safe10Factory;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * This is the item provider adapter for a {@link org.safe.metamodel.safe10.Item} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ItemItemProvider
  extends IdentifiableItemProvider
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ItemItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addDevelopmentCategoryPropertyDescriptor(object);
      addOtherItemPropertyDescriptor(object);
      addOperationalSituationPropertyDescriptor(object);
      addFeaturePropertyDescriptor(object);
      addLegalRequirementsPropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Development Category feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addDevelopmentCategoryPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Item_developmentCategory_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Item_developmentCategory_feature", "_UI_Item_type"),
         Safe10Package.eINSTANCE.getItem_DevelopmentCategory(),
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Other Item feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addOtherItemPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Item_otherItem_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Item_otherItem_feature", "_UI_Item_type"),
         Safe10Package.eINSTANCE.getItem_OtherItem(),
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Operational Situation feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addOperationalSituationPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Item_operationalSituation_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Item_operationalSituation_feature", "_UI_Item_type"),
         Safe10Package.eINSTANCE.getItem_OperationalSituation(),
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Feature feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addFeaturePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Item_feature_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Item_feature_feature", "_UI_Item_type"),
         Safe10Package.eINSTANCE.getItem_Feature(),
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Legal Requirements feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addLegalRequirementsPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Item_legalRequirements_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Item_legalRequirements_feature", "_UI_Item_type"),
         Safe10Package.eINSTANCE.getItem_LegalRequirements(),
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction());
      childrenFeatures.add(Safe10Package.eINSTANCE.getItem_ItemFunction());
      childrenFeatures.add(Safe10Package.eINSTANCE.getItem_OperatingMode());
      childrenFeatures.add(Safe10Package.eINSTANCE.getItem_SafeState());
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns Item.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    if(object != null){
      String nsURI = ((EObject) object).eClass().getEPackage().getNsURI();
      ResourceLocator resourceLocator = ResourceLocatorRegistry.INSTANCE
            .getResourceLocator(nsURI);
        if (resourceLocator != null) {
          try {
            Object image = resourceLocator.getImage("full/obj16/Item"); 
            if (image != null) {
              return overlayImage(object, image);
            }
          }catch(MissingResourceException ex){
            // Fail silent
          }
        }
      return overlayImage(object, getResourceLocator().getImage("full/obj16/Item"));
    }
    return null;
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    String label = ((Item)object).getShortName();
    String typeLabel = getString("_UI_Item_type"); 
      return label == null || label.length() == 0 ? typeLabel : label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(Item.class))
    {
      case Safe10Package.ITEM__DEVELOPMENT_CATEGORY:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
        return;
      case Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION:
      case Safe10Package.ITEM__ITEM_FUNCTION:
      case Safe10Package.ITEM__OPERATING_MODE:
      case Safe10Package.ITEM__SAFE_STATE:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMalfunctionPrototype()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMFPFunctionPort()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMFPHardwarePin()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMFPHardwarePort()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMFPSwcPort()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMFPOperation()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_PossibleItemMalfunction(),
         Safe10Factory.eINSTANCE.createMFPVariable()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_ItemFunction(),
         Safe10Factory.eINSTANCE.createItemFunctionDescription()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_OperatingMode(),
         Safe10Factory.eINSTANCE.createOperatingMode()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getItem_SafeState(),
         Safe10Factory.eINSTANCE.createSafeState()));
  }

   
  @Override
   protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
    Command addCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection, index),
        AddCommand.class);
    if (addCommand != null) {
      return addCommand  ;
    }
    return super.createAddCommand(domain, owner, feature, collection, index);
  }
  
  @Override
  protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
    Command removeCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection),
        RemoveCommand.class);
    if (removeCommand != null) {
      return removeCommand;
    }
    return super.createRemoveCommand(domain, owner, feature, collection);
  }
}
