/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Abstract Quantifiable Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * AbstractQuantifiableSafetyRequirement is used to specify requirements which contain qualified properties. Examples of such properties are diagnostic coverage and hardware metrics.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.AbstractQuantifiableSafetyRequirement</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AbstractQuantifiableSafetyRequirement#getDiagnosticCoverage <em>Diagnostic Coverage</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAbstractQuantifiableSafetyRequirement()
 * @model abstract="true"
 *        annotation="MetaData guid='{2F394F24-DC6E-4e4b-B04D-BCFBD8E819B6}' id='1060136974' EA\040name='AbstractQuantifiableSafetyRequirement'"
 *        extendedMetaData="name='ABSTRACT-QUANTIFIABLE-SAFETY-REQUIREMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ABSTRACT-QUANTIFIABLE-SAFETY-REQUIREMENTS'"
 * @generated
 */
public interface AbstractQuantifiableSafetyRequirement extends AbstractSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Diagnostic Coverage</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Diagnostic Coverage</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Diagnostic Coverage</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractQuantifiableSafetyRequirement_DiagnosticCoverage()
   * @model containment="true" upper="2"
   *        annotation="MetaData guid='{DC8B75FE-51F7-403f-A1E0-622FF3B65DDF}' id='475765747' EA\040name=''"
   *        extendedMetaData="name='DIAGNOSTIC-COVERAGE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DIAGNOSTIC-COVERAGES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<QuantifiedDiagnosticCoverageProperty> getDiagnosticCoverage();

} // AbstractQuantifiableSafetyRequirement
