/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.Requirement;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Abstract Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * In the SAFE meta model AbstratcSafetyRequirement is used as the as the abstract superclass for 
 * <ul>
 * 	<li>SafetyGoals, </li>
 * 	<li>FunctionalSafetyRequirements and</li>
 * 	<li>TechnicalSafetyRequirements.</li>
 * </ul>
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.AbstractSafetyRequirement</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getAsil <em>Asil</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getDecomposedASIL <em>Decomposed ASIL</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirementType <em>Requirement Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirement <em>Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirementLinks <em>Requirement Links</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getTactic <em>Tactic</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement()
 * @model abstract="true"
 *        annotation="MetaData guid='{A0DC6555-FECC-44d0-99B4-CB637A7BF936}' id='1348942244' EA\040name='AbstractSafetyRequirement'"
 *        annotation="Stereotype Stereotype='abstract'"
 *        extendedMetaData="name='ABSTRACT-SAFETY-REQUIREMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ABSTRACT-SAFETY-REQUIREMENTS'"
 * @generated
 */
public interface AbstractSafetyRequirement extends TraceableSpecification, AllocatableElement
{
  /**
   * Returns the value of the '<em><b>Asil</b></em>' attribute.
   * The default value is <code>"ASIL_A"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.ASILEnum}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * ASIL which has been assigned via decomposition 
   * <!-- end-model-doc -->
   * @return the value of the '<em>Asil</em>' attribute.
   * @see org.safe.metamodel.safe10.ASILEnum
   * @see #isSetAsil()
   * @see #unsetAsil()
   * @see #setAsil(ASILEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement_Asil()
   * @model default="ASIL_A" unsettable="true" required="true"
   *        annotation="MetaData guid='{0B02AF9B-A1DD-4551-874B-3BF2C8AF9D86}' id='351173077' EA\040name='asil'"
   *        extendedMetaData="name='ASIL' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ASILS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ASILEnum getAsil();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getAsil <em>Asil</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Asil</em>' attribute.
   * @see org.safe.metamodel.safe10.ASILEnum
   * @see #isSetAsil()
   * @see #Asil()
   * @see #getAsil()
   * @generated
   */
  void setAsil(ASILEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getAsil <em>Asil</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetAsil()
   * @see #getAsil()
   * @see #setAsil(ASILEnum)
   * @generated
   */
  void unsetAsil();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getAsil <em>Asil</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Asil</em>' attribute is set.
   * @see #Asil()
   * @see #getAsil()
   * @see #setAsil(ASILEnum)
   * @generated
   */
  boolean isSetAsil();

  /**
   * Returns the value of the '<em><b>Decomposed ASIL</b></em>' attribute.
   * The default value is <code>"ASIL_A"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.ASILDecomposedEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Decomposed ASIL</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Decomposed ASIL</em>' attribute.
   * @see org.safe.metamodel.safe10.ASILDecomposedEnum
   * @see #isSetDecomposedASIL()
   * @see #unsetDecomposedASIL()
   * @see #setDecomposedASIL(ASILDecomposedEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement_DecomposedASIL()
   * @model default="ASIL_A" unsettable="true" required="true"
   *        annotation="MetaData guid='{184E0864-81E6-4fa6-9D9F-28327B5A3A7F}' id='1372926744' EA\040name='decomposedASIL'"
   *        extendedMetaData="name='DECOMPOSED-ASIL' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DECOMPOSED-ASILS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ASILDecomposedEnum getDecomposedASIL();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getDecomposedASIL <em>Decomposed ASIL</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Decomposed ASIL</em>' attribute.
   * @see org.safe.metamodel.safe10.ASILDecomposedEnum
   * @see #isSetDecomposedASIL()
   * @see #DecomposedASIL()
   * @see #getDecomposedASIL()
   * @generated
   */
  void setDecomposedASIL(ASILDecomposedEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getDecomposedASIL <em>Decomposed ASIL</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDecomposedASIL()
   * @see #getDecomposedASIL()
   * @see #setDecomposedASIL(ASILDecomposedEnum)
   * @generated
   */
  void unsetDecomposedASIL();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getDecomposedASIL <em>Decomposed ASIL</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Decomposed ASIL</em>' attribute is set.
   * @see #DecomposedASIL()
   * @see #getDecomposedASIL()
   * @see #setDecomposedASIL(ASILDecomposedEnum)
   * @generated
   */
  boolean isSetDecomposedASIL();

  /**
   * Returns the value of the '<em><b>Requirement Type</b></em>' attribute.
   * The default value is <code>"QUANTITATIVE"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.RequirementTypeEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirement Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirement Type</em>' attribute.
   * @see org.safe.metamodel.safe10.RequirementTypeEnum
   * @see #isSetRequirementType()
   * @see #unsetRequirementType()
   * @see #setRequirementType(RequirementTypeEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement_RequirementType()
   * @model default="QUANTITATIVE" unsettable="true" required="true"
   *        annotation="MetaData guid='{03D40F7F-FDB9-42b1-A324-D12F4C4573D0}' id='1013025593' EA\040name='requirementType'"
   *        extendedMetaData="name='REQUIREMENT-TYPE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENT-TYPES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  RequirementTypeEnum getRequirementType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirementType <em>Requirement Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Requirement Type</em>' attribute.
   * @see org.safe.metamodel.safe10.RequirementTypeEnum
   * @see #isSetRequirementType()
   * @see #RequirementType()
   * @see #getRequirementType()
   * @generated
   */
  void setRequirementType(RequirementTypeEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirementType <em>Requirement Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRequirementType()
   * @see #getRequirementType()
   * @see #setRequirementType(RequirementTypeEnum)
   * @generated
   */
  void unsetRequirementType();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirementType <em>Requirement Type</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Requirement Type</em>' attribute is set.
   * @see #RequirementType()
   * @see #getRequirementType()
   * @see #setRequirementType(RequirementTypeEnum)
   * @generated
   */
  boolean isSetRequirementType();

  /**
   * Returns the value of the '<em><b>Requirement</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirement</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirement</em>' reference.
   * @see #setRequirement(Requirement)
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement_Requirement()
   * @model annotation="MetaData guid='{A48163B3-AD74-46d0-A3CF-35089FE306FF}' id='-228765156' EA\040name=''"
   *        extendedMetaData="name='REQUIREMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Requirement getRequirement();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getRequirement <em>Requirement</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Requirement</em>' reference.
   * @see #getRequirement()
   * @generated
   */
  void setRequirement(Requirement value);

  /**
   * Returns the value of the '<em><b>Requirement Links</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.RequirementsLink}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirement Links</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirement Links</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement_RequirementLinks()
   * @model containment="true"
   *        annotation="MetaData guid='{C087A86C-77E6-4929-9DE3-7CC707E0D4FF}' id='2135217910' EA\040name=''"
   *        extendedMetaData="name='REQUIREMENT-LINKS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENT-LINKSS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<RequirementsLink> getRequirementLinks();

  /**
   * Returns the value of the '<em><b>Tactic</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Tactic</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Tactic</em>' containment reference.
   * @see #setTactic(Tactic)
   * @see org.safe.metamodel.safe10.Safe10Package#getAbstractSafetyRequirement_Tactic()
   * @model containment="true"
   *        annotation="MetaData guid='{FBB968D0-633F-4077-B099-AC578DF079DD}' id='1846282008' EA\040name=''"
   *        extendedMetaData="name='TACTIC' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TACTICS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  Tactic getTactic();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement#getTactic <em>Tactic</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Tactic</em>' containment reference.
   * @see #getTactic()
   * @generated
   */
  void setTactic(Tactic value);

} // AbstractSafetyRequirement
