/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Actuator Monitor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class represents the actuator monitor requirement. It extends the meta-class SSR from SAFE meta model. 
 * 
 * To define an actuator monitor requirement the engineer has to reference the monitored actuator through the ActuatorMonitor attribute actuator and the inputs through which the monitoring occurs, using the attribute sensors. Furthermore, the engineer has to specify an evaluation function which maps input from sensors to the provided actuator output.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ActuatorMonitor.ActuatorMonitor</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ActuatorMonitor#getFunc <em>Func</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getActuatorMonitor()
 * @model annotation="MetaData guid='{92CB4092-AF3C-4439-8C66-4FAC6D07AAD2}' id='223' EA\040name='ActuatorMonitor'"
 *        extendedMetaData="name='ACTUATOR-MONITOR' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ACTUATOR-MONITORS'"
 * @generated
 */
public interface ActuatorMonitor extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Func</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The function used to evaluate the actuator behavior.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Func</em>' containment reference.
   * @see #setFunc(EvaluationFunction)
   * @see org.safe.metamodel.safe10.Safe10Package#getActuatorMonitor_Func()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{94144219-6D60-4711-8CEF-8028526E611A}' id='154971888' EA\040name=''"
   *        extendedMetaData="name='FUNC' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FUNCS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EvaluationFunction getFunc();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ActuatorMonitor#getFunc <em>Func</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Func</em>' containment reference.
   * @see #getFunc()
   * @generated
   */
  void setFunc(EvaluationFunction value);

} // ActuatorMonitor
