/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Actuator Monitor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Specific meta class for the AUTOSAR actuator monitor software safety requirement.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ActuatorMonitor.AutosarActuatorMonitor</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarActuatorMonitor#getActuator <em>Actuator</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarActuatorMonitor()
 * @model annotation="MetaData guid='{07605C97-D3D1-44fd-A072-8936DF342AE4}' id='225' EA\040name='AutosarActuatorMonitor'"
 *        extendedMetaData="name='AUTOSAR-ACTUATOR-MONITOR' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-ACTUATOR-MONITORS'"
 * @generated
 */
public interface AutosarActuatorMonitor extends ActuatorMonitor
{
  /**
   * Returns the value of the '<em><b>Actuator</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The instance reference to the monitored actuator component in AUTOSAR
   * <!-- end-model-doc -->
   * @return the value of the '<em>Actuator</em>' containment reference.
   * @see #setActuator(AutosarComponentInCompositionInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarActuatorMonitor_Actuator()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{8368BA2A-8389-4b0a-9EEC-40219C48A5AF}' id='2034266499' EA\040name=''"
   *        extendedMetaData="name='ACTUATOR' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ACTUATORS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarComponentInCompositionInstanceRef getActuator();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarActuatorMonitor#getActuator <em>Actuator</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Actuator</em>' containment reference.
   * @see #getActuator()
   * @generated
   */
  void setActuator(AutosarComponentInCompositionInstanceRef value);

} // AutosarActuatorMonitor
