/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.commonstructure.internalbehavior.ExecutableEntity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Check Point</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * AUTOSAR specific checkpoint
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.AlivenessMonitor.AutosarCheckPoint</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarCheckPoint#getComponent <em>Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AutosarCheckPoint#getTargetRunnable <em>Target Runnable</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarCheckPoint()
 * @model annotation="MetaData guid='{B9256669-E5F1-4c61-BA20-5F8E5FCF741A}' id='231' EA\040name='AutosarCheckPoint'"
 *        extendedMetaData="name='AUTOSAR-CHECK-POINT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-CHECK-POINTS'"
 * @generated
 */
public interface AutosarCheckPoint extends CheckPoint
{
  /**
   * Returns the value of the '<em><b>Component</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target component containing the internal behavior whose runnable entity is monitored
   * <!-- end-model-doc -->
   * @return the value of the '<em>Component</em>' containment reference.
   * @see #setComponent(AutosarComponentInCompositionInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarCheckPoint_Component()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{0E587FB1-5DEC-4624-8019-B1946750C06F}' id='1845000764' EA\040name=''"
   *        extendedMetaData="name='COMPONENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='COMPONENTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarComponentInCompositionInstanceRef getComponent();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarCheckPoint#getComponent <em>Component</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Component</em>' containment reference.
   * @see #getComponent()
   * @generated
   */
  void setComponent(AutosarComponentInCompositionInstanceRef value);

  /**
   * Returns the value of the '<em><b>Target Runnable</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Runnable</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Runnable</em>' reference.
   * @see #setTargetRunnable(ExecutableEntity)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarCheckPoint_TargetRunnable()
   * @model required="true"
   *        annotation="MetaData guid='{74AFD2B2-7500-4fdb-BC3F-57E7AD7C1F09}' id='447706538' EA\040name=''"
   *        extendedMetaData="name='TARGET-RUNNABLE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-RUNNABLE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ExecutableEntity getTargetRunnable();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarCheckPoint#getTargetRunnable <em>Target Runnable</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Runnable</em>' reference.
   * @see #getTargetRunnable()
   * @generated
   */
  void setTargetRunnable(ExecutableEntity value);

} // AutosarCheckPoint
