/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Evaluation Function</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Evaluation function defined by the engineer to relate the input from sensors to the output value provided by the actuator controller.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ActuatorMonitor.AutosarEvaluationFunction</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarEvaluationFunction#getSignature <em>Signature</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AutosarEvaluationFunction#getParameter <em>Parameter</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarEvaluationFunction()
 * @model annotation="MetaData guid='{32D04A96-C497-42c1-AACC-F47B76C1F9EC}' id='224' EA\040name='AutosarEvaluationFunction'"
 *        extendedMetaData="name='AUTOSAR-EVALUATION-FUNCTION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-EVALUATION-FUNCTIONS'"
 * @generated
 */
public interface AutosarEvaluationFunction extends EvaluationFunction
{
  /**
   * Returns the value of the '<em><b>Signature</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Signature</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Signature</em>' attribute.
   * @see #isSetSignature()
   * @see #unsetSignature()
   * @see #setSignature(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarEvaluationFunction_Signature()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{E9797288-C347-4ad6-B6C0-F158EB116FA9}' id='-1509952924' EA\040name='signature'"
   *        extendedMetaData="name='SIGNATURE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SIGNATURES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getSignature();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarEvaluationFunction#getSignature <em>Signature</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Signature</em>' attribute.
   * @see #isSetSignature()
   * @see #Signature()
   * @see #getSignature()
   * @generated
   */
  void setSignature(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.AutosarEvaluationFunction#getSignature <em>Signature</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetSignature()
   * @see #getSignature()
   * @see #setSignature(String)
   * @generated
   */
  void unsetSignature();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.AutosarEvaluationFunction#getSignature <em>Signature</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Signature</em>' attribute is set.
   * @see #Signature()
   * @see #getSignature()
   * @see #setSignature(String)
   * @generated
   */
  boolean isSetSignature();

  /**
   * Returns the value of the '<em><b>Parameter</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parameter</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parameter</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarEvaluationFunction_Parameter()
   * @model containment="true"
   *        annotation="MetaData guid='{8C063E92-604C-4408-8EC4-0A07FA650E8C}' id='-1340474949' EA\040name=''"
   *        extendedMetaData="name='PARAMETER' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PARAMETERS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<AutosarVariableDataPrototypeInstanceRef> getParameter();

} // AutosarEvaluationFunction
