/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.commonstructure.modedeclaration.ModeDeclarationGroupPrototype;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Mode In Port From Component In Composition Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A reference to an AUTOSAR mode for a specific port of a specific software component within a software component composition defined in another model / file.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.AUTOSARInstanceRefs.AutosarModeInPortFromComponentInCompositionInstanceRef</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef#getTargetModeGroup <em>Target Mode Group</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarModeInPortFromComponentInCompositionInstanceRef()
 * @model annotation="MetaData guid='{210E2C40-FD29-4dbf-A698-6C626C20151A}' id='-140722537' EA\040name='AutosarModeInPortFromComponentInCompositionInstanceRef'"
 *        extendedMetaData="name='AUTOSAR-MODE-IN-PORT-FROM-COMPONENT-IN-COMPOSITION-INSTANCE-REF' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-MODE-IN-PORT-FROM-COMPONENT-IN-COMPOSITION-INSTANCE-REFS'"
 * @generated
 */
public interface AutosarModeInPortFromComponentInCompositionInstanceRef extends AutosarAbstractPortInComponentInstanceRef
{
  /**
   * Returns the value of the '<em><b>Target Mode Group</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Mode Group</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Mode Group</em>' reference.
   * @see #setTargetModeGroup(ModeDeclarationGroupPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarModeInPortFromComponentInCompositionInstanceRef_TargetModeGroup()
   * @model required="true"
   *        annotation="MetaData guid='{1A167624-FCCF-469a-B3BF-FC7BECF64D50}' id='2098711118' EA\040name=''"
   *        extendedMetaData="name='TARGET-MODE-GROUP-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-MODE-GROUP-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ModeDeclarationGroupPrototype getTargetModeGroup();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef#getTargetModeGroup <em>Target Mode Group</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Mode Group</em>' reference.
   * @see #getTargetModeGroup()
   * @generated
   */
  void setTargetModeGroup(ModeDeclarationGroupPrototype value);

} // AutosarModeInPortFromComponentInCompositionInstanceRef
