/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.swcomponent.datatype.dataprototypes.VariableDataPrototype;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Variable Data Prototype Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A reference to an AUTOSAR variable data prototype of a specific software component within a software component composition which is defined in another model / file.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.AUTOSARInstanceRefs.AutosarVariableDataPrototypeInstanceRef</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef#getTargetDataElement <em>Target Data Element</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarVariableDataPrototypeInstanceRef()
 * @model annotation="MetaData guid='{305FB2D4-5E89-48a4-8774-EE14AC314890}' id='1780284590' EA\040name='AutosarVariableDataPrototypeInstanceRef'"
 *        extendedMetaData="name='AUTOSAR-VARIABLE-DATA-PROTOTYPE-INSTANCE-REF' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-VARIABLE-DATA-PROTOTYPE-INSTANCE-REFS'"
 * @generated
 */
public interface AutosarVariableDataPrototypeInstanceRef extends AutosarAbstractPortInComponentInstanceRef
{
  /**
   * Returns the value of the '<em><b>Target Data Element</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Data Element</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Data Element</em>' reference.
   * @see #setTargetDataElement(VariableDataPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarVariableDataPrototypeInstanceRef_TargetDataElement()
   * @model required="true"
   *        annotation="MetaData guid='{A9EC56DB-76B1-4705-BAAE-C75497E8DFA1}' id='61026604' EA\040name=''"
   *        extendedMetaData="name='TARGET-DATA-ELEMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-DATA-ELEMENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  VariableDataPrototype getTargetDataElement();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef#getTargetDataElement <em>Target Data Element</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Data Element</em>' reference.
   * @see #getTargetDataElement()
   * @generated
   */
  void setTargetDataElement(VariableDataPrototype value);

} // AutosarVariableDataPrototypeInstanceRef
