/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CRC</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class represents the requirement cyclic-redundancy-check.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CRCChecksum.CRC</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.CRC#getConfig <em>Config</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getCRC()
 * @model annotation="MetaData guid='{58FF56CF-CDED-40dd-B0B7-26CA25AE20A4}' id='253' EA\040name='CRC'"
 *        extendedMetaData="name='CRC' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CRCS'"
 * @generated
 */
public interface CRC extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Config</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The configuration information for the CRC mechanism.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Config</em>' reference.
   * @see #setConfig(CRCConfig)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRC_Config()
   * @model required="true"
   *        annotation="MetaData guid='{85EF3F02-E750-404c-9D90-2A3411B8B451}' id='129' EA\040name=''"
   *        extendedMetaData="name='CONFIG-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONFIG-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  CRCConfig getConfig();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRC#getConfig <em>Config</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Config</em>' reference.
   * @see #getConfig()
   * @generated
   */
  void setConfig(CRCConfig value);

} // CRC
