/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CRC Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class provides the means for configuring the CRC requirement. The attributes are used by both specializations of the abstract version of the SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CRCChecksum.CRCConfig</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.CRCConfig#getCheckValue <em>Check Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CRCConfig#getCrcBits <em>Crc Bits</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CRCConfig#getMagicValue <em>Magic Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CRCConfig#getPolynomialBits <em>Polynomial Bits</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CRCConfig#getStartValue <em>Start Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CRCConfig#getXorValue <em>Xor Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig()
 * @model annotation="MetaData guid='{19EB61D9-5A39-4dc8-BDB7-D4574B18EA6D}' id='256' EA\040name='CRCConfig'"
 *        extendedMetaData="name='CRC-CONFIG' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CRC-CONFIGS'"
 * @generated
 */
public interface CRCConfig extends EObject
{
  /**
   * Returns the value of the '<em><b>Check Value</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Check Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Check Value</em>' attribute.
   * @see #isSetCheckValue()
   * @see #unsetCheckValue()
   * @see #setCheckValue(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig_CheckValue()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{77374ED6-FFF6-4392-BA42-42BB81DD84F0}' id='36' EA\040name='checkValue'"
   *        extendedMetaData="name='CHECK-VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECK-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getCheckValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getCheckValue <em>Check Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Check Value</em>' attribute.
   * @see #isSetCheckValue()
   * @see #CheckValue()
   * @see #getCheckValue()
   * @generated
   */
  void setCheckValue(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getCheckValue <em>Check Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetCheckValue()
   * @see #getCheckValue()
   * @see #setCheckValue(Integer)
   * @generated
   */
  void unsetCheckValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getCheckValue <em>Check Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Check Value</em>' attribute is set.
   * @see #CheckValue()
   * @see #getCheckValue()
   * @see #setCheckValue(Integer)
   * @generated
   */
  boolean isSetCheckValue();

  /**
   * Returns the value of the '<em><b>Crc Bits</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Crc Bits</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Crc Bits</em>' attribute.
   * @see #isSetCrcBits()
   * @see #unsetCrcBits()
   * @see #setCrcBits(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig_CrcBits()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{6CCDE5F4-F64B-496c-AD8E-D2412DB489CE}' id='37' EA\040name='crcBits'"
   *        extendedMetaData="name='CRC-BITS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CRC-BITSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getCrcBits();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getCrcBits <em>Crc Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Crc Bits</em>' attribute.
   * @see #isSetCrcBits()
   * @see #CrcBits()
   * @see #getCrcBits()
   * @generated
   */
  void setCrcBits(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getCrcBits <em>Crc Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetCrcBits()
   * @see #getCrcBits()
   * @see #setCrcBits(Integer)
   * @generated
   */
  void unsetCrcBits();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getCrcBits <em>Crc Bits</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Crc Bits</em>' attribute is set.
   * @see #CrcBits()
   * @see #getCrcBits()
   * @see #setCrcBits(Integer)
   * @generated
   */
  boolean isSetCrcBits();

  /**
   * Returns the value of the '<em><b>Magic Value</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Magic Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Magic Value</em>' attribute.
   * @see #isSetMagicValue()
   * @see #unsetMagicValue()
   * @see #setMagicValue(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig_MagicValue()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{DBECBE7F-2E54-45df-A143-889DBB0D58BC}' id='38' EA\040name='magicValue'"
   *        extendedMetaData="name='MAGIC-VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MAGIC-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getMagicValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getMagicValue <em>Magic Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Magic Value</em>' attribute.
   * @see #isSetMagicValue()
   * @see #MagicValue()
   * @see #getMagicValue()
   * @generated
   */
  void setMagicValue(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getMagicValue <em>Magic Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMagicValue()
   * @see #getMagicValue()
   * @see #setMagicValue(Integer)
   * @generated
   */
  void unsetMagicValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getMagicValue <em>Magic Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Magic Value</em>' attribute is set.
   * @see #MagicValue()
   * @see #getMagicValue()
   * @see #setMagicValue(Integer)
   * @generated
   */
  boolean isSetMagicValue();

  /**
   * Returns the value of the '<em><b>Polynomial Bits</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Polynomial Bits</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Polynomial Bits</em>' attribute.
   * @see #isSetPolynomialBits()
   * @see #unsetPolynomialBits()
   * @see #setPolynomialBits(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig_PolynomialBits()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{9E591BFB-A8DD-4192-B93B-D759926F141C}' id='39' EA\040name='polynomialBits'"
   *        extendedMetaData="name='POLYNOMIAL-BITS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='POLYNOMIAL-BITSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getPolynomialBits();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getPolynomialBits <em>Polynomial Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Polynomial Bits</em>' attribute.
   * @see #isSetPolynomialBits()
   * @see #PolynomialBits()
   * @see #getPolynomialBits()
   * @generated
   */
  void setPolynomialBits(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getPolynomialBits <em>Polynomial Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetPolynomialBits()
   * @see #getPolynomialBits()
   * @see #setPolynomialBits(Integer)
   * @generated
   */
  void unsetPolynomialBits();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getPolynomialBits <em>Polynomial Bits</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Polynomial Bits</em>' attribute is set.
   * @see #PolynomialBits()
   * @see #getPolynomialBits()
   * @see #setPolynomialBits(Integer)
   * @generated
   */
  boolean isSetPolynomialBits();

  /**
   * Returns the value of the '<em><b>Start Value</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Start Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Start Value</em>' attribute.
   * @see #isSetStartValue()
   * @see #unsetStartValue()
   * @see #setStartValue(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig_StartValue()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{0BBEAF83-B005-4763-8910-4593139F688D}' id='40' EA\040name='startValue'"
   *        extendedMetaData="name='START-VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='START-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getStartValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getStartValue <em>Start Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Start Value</em>' attribute.
   * @see #isSetStartValue()
   * @see #StartValue()
   * @see #getStartValue()
   * @generated
   */
  void setStartValue(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getStartValue <em>Start Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetStartValue()
   * @see #getStartValue()
   * @see #setStartValue(Integer)
   * @generated
   */
  void unsetStartValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getStartValue <em>Start Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Start Value</em>' attribute is set.
   * @see #StartValue()
   * @see #getStartValue()
   * @see #setStartValue(Integer)
   * @generated
   */
  boolean isSetStartValue();

  /**
   * Returns the value of the '<em><b>Xor Value</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Xor Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Xor Value</em>' attribute.
   * @see #isSetXorValue()
   * @see #unsetXorValue()
   * @see #setXorValue(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCRCConfig_XorValue()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{6F487D4E-ADB8-45d7-85E0-D25D2ACC7BF6}' id='41' EA\040name='xorValue'"
   *        extendedMetaData="name='XOR-VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='XOR-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getXorValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getXorValue <em>Xor Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Xor Value</em>' attribute.
   * @see #isSetXorValue()
   * @see #XorValue()
   * @see #getXorValue()
   * @generated
   */
  void setXorValue(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getXorValue <em>Xor Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetXorValue()
   * @see #getXorValue()
   * @see #setXorValue(Integer)
   * @generated
   */
  void unsetXorValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CRCConfig#getXorValue <em>Xor Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Xor Value</em>' attribute is set.
   * @see #XorValue()
   * @see #getXorValue()
   * @see #setXorValue(Integer)
   * @generated
   */
  boolean isSetXorValue();

} // CRCConfig
