/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Chromosome Comparison Parameter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Chromosome specific comparison parameter. Allows to reference a specific Chromosome topic, which acts as a comparison entity.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Comparison.ChromosomeComparisonParameter</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeComparisonParameter#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeComparisonParameter()
 * @model annotation="MetaData guid='{E7E6B697-40B2-4665-87ED-F57ABBCE268B}' id='220441645' EA\040name='ChromosomeComparisonParameter'"
 *        extendedMetaData="name='CHROMOSOME-COMPARISON-PARAMETER' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHROMOSOME-COMPARISON-PARAMETERS'"
 * @generated
 */
public interface ChromosomeComparisonParameter extends ComparisonParameter
{
  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(Topic)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeComparisonParameter_Target()
   * @model required="true"
   *        annotation="MetaData guid='{0FAE4617-624B-4269-B00E-3D03BB87E4F8}' id='693156840' EA\040name=''"
   *        extendedMetaData="name='TARGET-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Topic getTarget();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeComparisonParameter#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(Topic value);

} // ChromosomeComparisonParameter
