/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Chromosome Cpu Self Test</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * CHROMOSOME specific CPU self-test meta class.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CpuSelfTest.ChromosomeCpuSelfTest</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeCpuSelfTest#getSatisfiedBy <em>Satisfied By</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeCpuSelfTest#getChecks <em>Checks</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeCpuSelfTest()
 * @model annotation="MetaData guid='{9ED5C9C6-2B12-48dd-A32A-47C178067B8B}' id='251' EA\040name='ChromosomeCpuSelfTest'"
 *        extendedMetaData="name='CHROMOSOME-CPU-SELF-TEST' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHROMOSOME-CPU-SELF-TESTS'"
 * @generated
 */
public interface ChromosomeCpuSelfTest extends CpuSelfTest
{
  /**
   * Returns the value of the '<em><b>Satisfied By</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Generated CHROMOSOME component that satisfies the SSR.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Satisfied By</em>' reference.
   * @see #setSatisfiedBy(Component)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeCpuSelfTest_SatisfiedBy()
   * @model required="true"
   *        annotation="MetaData guid='{E156EBDA-EE26-4cde-BFF4-5888FC3949A5}' id='-590867193' EA\040name=''"
   *        extendedMetaData="name='SATISFIED-BY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFIED-BY-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Component getSatisfiedBy();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeCpuSelfTest#getSatisfiedBy <em>Satisfied By</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Satisfied By</em>' reference.
   * @see #getSatisfiedBy()
   * @generated
   */
  void setSatisfiedBy(Component value);

  /**
   * Returns the value of the '<em><b>Checks</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Checks</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Checks</em>' reference.
   * @see #setChecks(Node)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeCpuSelfTest_Checks()
   * @model required="true"
   *        annotation="MetaData guid='{1A2F233B-F32B-412d-A010-4E47E862D5CD}' id='551515586' EA\040name=''"
   *        extendedMetaData="name='CHECKS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECKS-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Node getChecks();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeCpuSelfTest#getChecks <em>Checks</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Checks</em>' reference.
   * @see #getChecks()
   * @generated
   */
  void setChecks(Node value);

} // ChromosomeCpuSelfTest
