/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Chromosome Error Event Condition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A CHROMOSOME specific error condition, which is triggered by reception of a message via a predefined CHROMOSOME topic referenced by triggeredBy relation.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.HealthMonitor.ChromosomeErrorEventCondition</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeErrorEventCondition#getTriggeredBy <em>Triggered By</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeErrorEventCondition()
 * @model annotation="MetaData guid='{46954A52-8B59-47ac-83B4-C76621CBD821}' id='-1009278581' EA\040name='ChromosomeErrorEventCondition'"
 *        extendedMetaData="name='CHROMOSOME-ERROR-EVENT-CONDITION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHROMOSOME-ERROR-EVENT-CONDITIONS'"
 * @generated
 */
public interface ChromosomeErrorEventCondition extends HealthMonitorErrorCondition
{
  /**
   * Returns the value of the '<em><b>Triggered By</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Triggered By</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Triggered By</em>' reference.
   * @see #setTriggeredBy(Topic)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeErrorEventCondition_TriggeredBy()
   * @model required="true"
   *        annotation="MetaData guid='{E6964735-E3F9-45a6-995F-9E525811F0CD}' id='44741203' EA\040name=''"
   *        extendedMetaData="name='TRIGGERED-BY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TRIGGERED-BY-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Topic getTriggeredBy();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeErrorEventCondition#getTriggeredBy <em>Triggered By</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Triggered By</em>' reference.
   * @see #getTriggeredBy()
   * @generated
   */
  void setTriggeredBy(Topic value);

} // ChromosomeErrorEventCondition
