/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Chromosome Memory Test</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A CHROMOSOME-specific MemorySelfTest requirement.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.MemorySelfTest.ChromosomeMemoryTest</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeMemoryTest#getTests <em>Tests</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeMemoryTest#getSatisfiedBy <em>Satisfied By</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeMemoryTest()
 * @model annotation="MetaData guid='{4726C9AF-9582-46d3-B716-0BEF48C57231}' id='873595502' EA\040name='ChromosomeMemoryTest'"
 *        extendedMetaData="name='CHROMOSOME-MEMORY-TEST' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHROMOSOME-MEMORY-TESTS'"
 * @generated
 */
public interface ChromosomeMemoryTest extends MemorySelfTest
{
  /**
   * Returns the value of the '<em><b>Tests</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Tests</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Tests</em>' reference.
   * @see #setTests(Node)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeMemoryTest_Tests()
   * @model required="true"
   *        annotation="MetaData guid='{4FE816BC-7A9D-4e9a-814B-25E508B161FA}' id='-2083671004' EA\040name=''"
   *        extendedMetaData="name='TESTS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TESTS-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Node getTests();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeMemoryTest#getTests <em>Tests</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Tests</em>' reference.
   * @see #getTests()
   * @generated
   */
  void setTests(Node value);

  /**
   * Returns the value of the '<em><b>Satisfied By</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * A satisfy relation mapping MemorySelfTest SSRs to generated CHROMOSOME components.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Satisfied By</em>' reference.
   * @see #setSatisfiedBy(Component)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeMemoryTest_SatisfiedBy()
   * @model required="true"
   *        annotation="MetaData guid='{9BFF1CBA-E488-40b6-8002-B108B0CCCFBC}' id='-986865394' EA\040name=''"
   *        extendedMetaData="name='SATISFIED-BY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFIED-BY-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Component getSatisfiedBy();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeMemoryTest#getSatisfiedBy <em>Satisfied By</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Satisfied By</em>' reference.
   * @see #getSatisfiedBy()
   * @generated
   */
  void setSatisfiedBy(Component value);

} // ChromosomeMemoryTest
