/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Code Generation Configuration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An SSMConfiguration defines the parameters needed by specific code generators. It provides a set of name/value pairs which contain additional information not defined within the software safety mechanism.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Software.Configuration.CodeGenerationConfiguration</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.CodeGenerationConfiguration#getFromRequirement <em>From Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CodeGenerationConfiguration#getParams <em>Params</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getCodeGenerationConfiguration()
 * @model annotation="MetaData guid='{22B97EDE-B737-4896-AAE9-C4F264B4A520}' id='206' EA\040name='CodeGenerationConfiguration'"
 *        extendedMetaData="name='CODE-GENERATION-CONFIGURATION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CODE-GENERATION-CONFIGURATIONS'"
 * @generated
 */
public interface CodeGenerationConfiguration extends Identifiable
{
  /**
   * Returns the value of the '<em><b>From Requirement</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The mechanism configured by the SSMConfiguration element
   * <!-- end-model-doc -->
   * @return the value of the '<em>From Requirement</em>' reference.
   * @see #setFromRequirement(SoftwareSafetyRequirement)
   * @see org.safe.metamodel.safe10.Safe10Package#getCodeGenerationConfiguration_FromRequirement()
   * @model required="true"
   *        annotation="MetaData guid='{E9ECC986-9719-421c-9E22-D9F342D002C2}' id='184' EA\040name=''"
   *        extendedMetaData="name='FROM-REQUIREMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FROM-REQUIREMENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  SoftwareSafetyRequirement getFromRequirement();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CodeGenerationConfiguration#getFromRequirement <em>From Requirement</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>From Requirement</em>' reference.
   * @see #getFromRequirement()
   * @generated
   */
  void setFromRequirement(SoftwareSafetyRequirement value);

  /**
   * Returns the value of the '<em><b>Params</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ConfigParameter}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Parameters necessary for the configuration of a safety mechanism.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Params</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getCodeGenerationConfiguration_Params()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{9D729FCF-935D-4c19-859B-C1FED36544D7}' id='173' EA\040name=''"
   *        extendedMetaData="name='PARAMS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PARAMSS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ConfigParameter> getParams();

} // CodeGenerationConfiguration
