/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Comparison</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Value comparison SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Comparison.Comparison</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Comparison#getTolerance <em>Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Comparison#getOperation <em>Operation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Comparison#getParamB <em>Param B</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Comparison#getParamA <em>Param A</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getComparison()
 * @model annotation="MetaData guid='{5EFC4ED3-B3FB-429c-9677-DA588E550F38}' id='235' EA\040name='Comparison'"
 *        extendedMetaData="name='COMPARISON' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='COMPARISONS'"
 * @generated
 */
public interface Comparison extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Tolerance</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Tolerance</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Tolerance</em>' attribute.
   * @see #isSetTolerance()
   * @see #unsetTolerance()
   * @see #setTolerance(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getComparison_Tolerance()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{3ED55FCA-29B9-47dc-8D1D-1798B5DFE5EF}' id='33' EA\040name='tolerance'"
   *        extendedMetaData="name='TOLERANCE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TOLERANCES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getTolerance();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Comparison#getTolerance <em>Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Tolerance</em>' attribute.
   * @see #isSetTolerance()
   * @see #Tolerance()
   * @see #getTolerance()
   * @generated
   */
  void setTolerance(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Comparison#getTolerance <em>Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetTolerance()
   * @see #getTolerance()
   * @see #setTolerance(Double)
   * @generated
   */
  void unsetTolerance();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Comparison#getTolerance <em>Tolerance</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Tolerance</em>' attribute is set.
   * @see #Tolerance()
   * @see #getTolerance()
   * @see #setTolerance(Double)
   * @generated
   */
  boolean isSetTolerance();

  /**
   * Returns the value of the '<em><b>Operation</b></em>' attribute.
   * The default value is <code>"LT"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.ComparisonOperationEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Operation</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Operation</em>' attribute.
   * @see org.safe.metamodel.safe10.ComparisonOperationEnum
   * @see #isSetOperation()
   * @see #unsetOperation()
   * @see #setOperation(ComparisonOperationEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getComparison_Operation()
   * @model default="LT" unsettable="true" required="true"
   *        annotation="MetaData guid='{560EF7D8-96A4-4cdc-82E1-2A475FC43C1D}' id='1361539610' EA\040name='operation'"
   *        extendedMetaData="name='OPERATION' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATIONS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ComparisonOperationEnum getOperation();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Comparison#getOperation <em>Operation</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Operation</em>' attribute.
   * @see org.safe.metamodel.safe10.ComparisonOperationEnum
   * @see #isSetOperation()
   * @see #Operation()
   * @see #getOperation()
   * @generated
   */
  void setOperation(ComparisonOperationEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Comparison#getOperation <em>Operation</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetOperation()
   * @see #getOperation()
   * @see #setOperation(ComparisonOperationEnum)
   * @generated
   */
  void unsetOperation();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Comparison#getOperation <em>Operation</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Operation</em>' attribute is set.
   * @see #Operation()
   * @see #getOperation()
   * @see #setOperation(ComparisonOperationEnum)
   * @generated
   */
  boolean isSetOperation();

  /**
   * Returns the value of the '<em><b>Param B</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The second parameter for the comparison.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Param B</em>' reference.
   * @see #setParamB(ComparisonParameter)
   * @see org.safe.metamodel.safe10.Safe10Package#getComparison_ParamB()
   * @model required="true"
   *        annotation="MetaData guid='{29A80DE6-140C-4143-A520-3D7CF99A2027}' id='147' EA\040name=''"
   *        extendedMetaData="name='PARAM-B-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PARAM-B-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ComparisonParameter getParamB();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Comparison#getParamB <em>Param B</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Param B</em>' reference.
   * @see #getParamB()
   * @generated
   */
  void setParamB(ComparisonParameter value);

  /**
   * Returns the value of the '<em><b>Param A</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The first parameter for the comparison.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Param A</em>' reference.
   * @see #setParamA(ComparisonParameter)
   * @see org.safe.metamodel.safe10.Safe10Package#getComparison_ParamA()
   * @model required="true"
   *        annotation="MetaData guid='{433C00B1-8353-4709-A24E-F312ED19718C}' id='149' EA\040name=''"
   *        extendedMetaData="name='PARAM-A-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PARAM-A-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ComparisonParameter getParamA();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Comparison#getParamA <em>Param A</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Param A</em>' reference.
   * @see #getParamA()
   * @generated
   */
  void setParamA(ComparisonParameter value);

} // Comparison
