/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Prototype CRC</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class is the specialization of the abstract SSR CRC which is deployed for a specific instance of a component providing a given interface.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CRCChecksum.ComponentPrototypeCRC</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ComponentPrototypeCRC#getChecks <em>Checks</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getComponentPrototypeCRC()
 * @model annotation="MetaData guid='{911A8A2E-DF04-4da3-BCED-A90E44F11A88}' id='254' EA\040name='ComponentPrototypeCRC'"
 *        extendedMetaData="name='COMPONENT-PROTOTYPE-CRC' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='COMPONENT-PROTOTYPE-CRCS'"
 * @generated
 */
public interface ComponentPrototypeCRC extends AutosarCRC
{
  /**
   * Returns the value of the '<em><b>Checks</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The AUTOSAR variable data prototype of a software component whose value is check using the CRC SSR.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Checks</em>' containment reference.
   * @see #setChecks(AutosarVariableDataPrototypeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getComponentPrototypeCRC_Checks()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{C0922E93-AC5B-4513-9266-1DBBB5A64965}' id='1739920247' EA\040name=''"
   *        extendedMetaData="name='CHECKS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECKSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarVariableDataPrototypeInstanceRef getChecks();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ComponentPrototypeCRC#getChecks <em>Checks</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Checks</em>' containment reference.
   * @see #getChecks()
   * @generated
   */
  void setChecks(AutosarVariableDataPrototypeInstanceRef value);

} // ComponentPrototypeCRC
