/**
 */
package org.safe.metamodel.safe10;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Error Behavior Kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * The ErrorBehaviorKind metaclass represents an enumeration of literals describing various types of formalisms used for specifying error behavior.
 * 
 * Semantics:
 * ErrorBehaviorKind represents different formalisms for ErrorBehavior. The semantics is defined at each enumeration literal. 
 * 
 * Extension: 
 * Enumeration, no extension.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorBehavior.ErrorBehaviorKind</b></em> 
 * <!-- end-model-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package#getErrorBehaviorKind()
 * @model annotation="MetaData guid='{7FF18370-9566-4347-B28B-A03B785B2888}' id='1888807351' EA\040name='ErrorBehaviorKind'"
 *        annotation="Stereotype Stereotype='enumeration'"
 *        extendedMetaData="name='ERROR-BEHAVIOR-KIND'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-BEHAVIOR-KINDS'"
 * @generated
 */
public enum ErrorBehaviorKind implements Enumerator
{
  /**
   * The '<em><b>HIP HOPS</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #HIP_HOPS_VALUE
   * @generated
   * @ordered
   */
  HIP_HOPS(0, "HIP_HOPS", "HIP_HOPS"),

  /**
   * The '<em><b>ALTARICA</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ALTARICA_VALUE
   * @generated
   * @ordered
   */
  ALTARICA(1, "ALTARICA", "ALTARICA"),

  /**
   * The '<em><b>AADL</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #AADL_VALUE
   * @generated
   * @ordered
   */
  AADL(2, "AADL", "AADL"),

  /**
   * The '<em><b>OTHER</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #OTHER_VALUE
   * @generated
   * @ordered
   */
  OTHER(3, "OTHER", "OTHER");

  /**
   * The '<em><b>HIP HOPS</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>HIP HOPS</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #HIP_HOPS
   * @model
   * @generated
   * @ordered
   */
  public static final int HIP_HOPS_VALUE = 0;

  /**
   * The '<em><b>ALTARICA</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ALTARICA</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ALTARICA
   * @model
   * @generated
   * @ordered
   */
  public static final int ALTARICA_VALUE = 1;

  /**
   * The '<em><b>AADL</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>AADL</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #AADL
   * @model
   * @generated
   * @ordered
   */
  public static final int AADL_VALUE = 2;

  /**
   * The '<em><b>OTHER</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>OTHER</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #OTHER
   * @model
   * @generated
   * @ordered
   */
  public static final int OTHER_VALUE = 3;

  /**
   * An array of all the '<em><b>Error Behavior Kind</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final ErrorBehaviorKind[] VALUES_ARRAY =
    new ErrorBehaviorKind[]
    {
      HIP_HOPS,
      ALTARICA,
      AADL,
      OTHER,
    };

  /**
   * A public read-only list of all the '<em><b>Error Behavior Kind</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<ErrorBehaviorKind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Error Behavior Kind</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ErrorBehaviorKind get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      ErrorBehaviorKind result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Error Behavior Kind</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ErrorBehaviorKind getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      ErrorBehaviorKind result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Error Behavior Kind</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ErrorBehaviorKind get(int value)
  {
    switch (value)
    {
      case HIP_HOPS_VALUE: return HIP_HOPS;
      case ALTARICA_VALUE: return ALTARICA;
      case AADL_VALUE: return AADL;
      case OTHER_VALUE: return OTHER;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private ErrorBehaviorKind(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //ErrorBehaviorKind
