/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Error Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The error model is a container for all artifacts, which are needed to describe the error model of an architectural element: malfunctions, error types and error behaviors
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorModel</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModel#getRootErrorModelType <em>Root Error Model Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModel#getBehavior <em>Behavior</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModel#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModel#getMalfunction <em>Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModel#getMapping <em>Mapping</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getErrorModel()
 * @model annotation="MetaData guid='{E938A295-E9F5-4d3a-9DEF-0DE6B8EFE2F3}' id='2036383851' EA\040name='ErrorModel'"
 *        extendedMetaData="name='ERROR-MODEL' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-MODELS'"
 * @generated
 */
public interface ErrorModel extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Root Error Model Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Root Error Model Type</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Root Error Model Type</em>' reference.
   * @see #setRootErrorModelType(ErrorModelType)
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModel_RootErrorModelType()
   * @model annotation="MetaData guid='{E1194767-FCF2-436b-95FF-069E8A9B3B3E}' id='-723617123' EA\040name=''"
   *        extendedMetaData="name='ROOT-ERROR-MODEL-TYPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ROOT-ERROR-MODEL-TYPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ErrorModelType getRootErrorModelType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ErrorModel#getRootErrorModelType <em>Root Error Model Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Root Error Model Type</em>' reference.
   * @see #getRootErrorModelType()
   * @generated
   */
  void setRootErrorModelType(ErrorModelType value);

  /**
   * Returns the value of the '<em><b>Behavior</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.AbstractErrorBehavior}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * an arbitrary number of error behaviors
   * <!-- end-model-doc -->
   * @return the value of the '<em>Behavior</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModel_Behavior()
   * @model containment="true"
   *        annotation="MetaData guid='{C00F236E-9E9F-4632-A9B1-356A9165F5F7}' id='520845224' EA\040name=''"
   *        extendedMetaData="name='BEHAVIOR' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='BEHAVIORS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<AbstractErrorBehavior> getBehavior();

  /**
   * Returns the value of the '<em><b>Type</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ErrorModelType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * an arbitrary number of error model types
   * <!-- end-model-doc -->
   * @return the value of the '<em>Type</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModel_Type()
   * @model containment="true"
   *        annotation="MetaData guid='{6415733C-18A5-4229-8FFC-9DAAEDE2C794}' id='1647259043' EA\040name=''"
   *        extendedMetaData="name='TYPE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TYPES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ErrorModelType> getType();

  /**
   * Returns the value of the '<em><b>Malfunction</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.MalfunctionType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * an arbitrary number of malfunction types
   * <!-- end-model-doc -->
   * @return the value of the '<em>Malfunction</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModel_Malfunction()
   * @model containment="true"
   *        annotation="MetaData guid='{06C549EC-A157-42b0-9A79-57E10416507B}' id='1686435977' EA\040name=''"
   *        extendedMetaData="name='MALFUNCTION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MALFUNCTIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<MalfunctionType> getMalfunction();

  /**
   * Returns the value of the '<em><b>Mapping</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ErrorModelMapping}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mapping</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mapping</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModel_Mapping()
   * @model containment="true"
   *        annotation="MetaData guid='{E08FC972-B0C1-440d-9BC6-3656677695C1}' id='-687267540' EA\040name=''"
   *        extendedMetaData="name='MAPPING' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MAPPINGS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ErrorModelMapping> getMapping();

} // ErrorModel
