/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Error Model Mapping</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class contains mapping information for error model.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Mapping.ErrorModelMapping</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModelMapping#getErrorBehaviorMapping <em>Error Behavior Mapping</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModelMapping#getMalfunctionMapping <em>Malfunction Mapping</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getErrorModelMapping()
 * @model annotation="MetaData guid='{0E6A4B52-8F24-4e75-AF05-9D7E8CD8851D}' id='1382964040' EA\040name='ErrorModelMapping'"
 *        extendedMetaData="name='ERROR-MODEL-MAPPING' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-MODEL-MAPPINGS'"
 * @generated
 */
public interface ErrorModelMapping extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Error Behavior Mapping</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ErrorBehaviorMapping}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * An arbitrary number of error behavior mappings.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Error Behavior Mapping</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModelMapping_ErrorBehaviorMapping()
   * @model containment="true"
   *        annotation="MetaData guid='{25CD7563-90F1-4fd2-9354-C372841469AE}' id='-1371958277' EA\040name=''"
   *        extendedMetaData="name='ERROR-BEHAVIOR-MAPPING' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-BEHAVIOR-MAPPINGS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ErrorBehaviorMapping> getErrorBehaviorMapping();

  /**
   * Returns the value of the '<em><b>Malfunction Mapping</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.MalfunctionMapping}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Malfunction Mapping</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Malfunction Mapping</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModelMapping_MalfunctionMapping()
   * @model containment="true"
   *        annotation="MetaData guid='{4C154B23-5551-40f3-A0DE-6596FB90A6C1}' id='1905167871' EA\040name=''"
   *        extendedMetaData="name='MALFUNCTION-MAPPING' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MALFUNCTION-MAPPINGS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<MalfunctionMapping> getMalfunctionMapping();

} // ErrorModelMapping
