/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Evaluation Function</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Abstract element representing an user defined evaluation function for deciding if the actuator behaves correctly.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ActuatorMonitor.EvaluationFunction</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.EvaluationFunction#getResourcePath <em>Resource Path</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getEvaluationFunction()
 * @model annotation="MetaData guid='{165BD99D-54D5-448b-A2CA-D5288C2B9500}' id='221' EA\040name='EvaluationFunction'"
 *        extendedMetaData="name='EVALUATION-FUNCTION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EVALUATION-FUNCTIONS'"
 * @generated
 */
public interface EvaluationFunction extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Resource Path</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Resource Path</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Resource Path</em>' attribute.
   * @see #isSetResourcePath()
   * @see #unsetResourcePath()
   * @see #setResourcePath(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getEvaluationFunction_ResourcePath()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{8D6416BB-B9DB-44e8-B35D-187B47CDFAC6}' id='-960269419' EA\040name='resourcePath'"
   *        extendedMetaData="name='RESOURCE-PATH' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RESOURCE-PATHS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getResourcePath();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.EvaluationFunction#getResourcePath <em>Resource Path</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Resource Path</em>' attribute.
   * @see #isSetResourcePath()
   * @see #ResourcePath()
   * @see #getResourcePath()
   * @generated
   */
  void setResourcePath(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.EvaluationFunction#getResourcePath <em>Resource Path</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetResourcePath()
   * @see #getResourcePath()
   * @see #setResourcePath(String)
   * @generated
   */
  void unsetResourcePath();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.EvaluationFunction#getResourcePath <em>Resource Path</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Resource Path</em>' attribute is set.
   * @see #ResourcePath()
   * @see #getResourcePath()
   * @see #setResourcePath(String)
   * @generated
   */
  boolean isSetResourcePath();

} // EvaluationFunction
