/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Formula Expression</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represents the syntax of the formula language. The class is modeled as an abstract class in order to be specialized into particular use cases. For each use case the referable objects might be specified in the specialization.
 * 
 * The stereotype "mixedString" of this class and the specialized sub-classes indicates the usage of mixed content model with intermixed text. The grammar of the mixed content model is described in the description field of the dedicated class.
 * The term "mixed content" is used as defined in XML (http://www.w3schools.com/schema/schema_complex_mixed.asp).
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.FormulaExpression.FormulaExpression</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.FormulaExpression#getFormula <em>Formula</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getFormulaExpression()
 * @model abstract="true"
 *        annotation="MetaData guid='{9B1D2573-BFAD-4b13-BDF7-F061BA72B720}' id='-1866208753' EA\040name='FormulaExpression'"
 *        extendedMetaData="name='FORMULA-EXPRESSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FORMULA-EXPRESSIONS'"
 * @generated
 */
public interface FormulaExpression extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Formula</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Formula</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Formula</em>' attribute.
   * @see #isSetFormula()
   * @see #unsetFormula()
   * @see #setFormula(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getFormulaExpression_Formula()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{B1264F60-2B20-4534-9ACD-B8A41EF645D4}' id='-689064590' EA\040name='Formula'"
   *        extendedMetaData="name='FORMULA' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FORMULAS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getFormula();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FormulaExpression#getFormula <em>Formula</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Formula</em>' attribute.
   * @see #isSetFormula()
   * @see #Formula()
   * @see #getFormula()
   * @generated
   */
  void setFormula(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.FormulaExpression#getFormula <em>Formula</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFormula()
   * @see #getFormula()
   * @see #setFormula(String)
   * @generated
   */
  void unsetFormula();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.FormulaExpression#getFormula <em>Formula</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Formula</em>' attribute is set.
   * @see #Formula()
   * @see #getFormula()
   * @see #setFormula(String)
   * @generated
   */
  boolean isSetFormula();

} // FormulaExpression
