/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Goal</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * <ul>
 * 	<li>rendered as a rectangle, </li>
 * 	<li>presents a claim forming part of the argument.</li>
 * 	<li>One or more sub-goals may be declared for a given goal. This structure then asserts that if the claims presented in the sub-goals are true, this is sufficient to establish that the claim in the main goal is true.</li>
 * </ul>
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SafetyCase.Goal</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getRequirement <em>Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getJustification <em>Justification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getAssumption <em>Assumption</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getInContextOf <em>In Context Of</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getSolution <em>Solution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getSupportedBy <em>Supported By</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Goal#getStrategy <em>Strategy</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getGoal()
 * @model annotation="MetaData guid='{AA168740-C2F7-4236-9ECB-98156AEC6567}' id='1613831685' EA\040name='Goal'"
 *        extendedMetaData="name='GOAL' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='GOALS'"
 * @generated
 */
public interface Goal extends EObject
{
  /**
   * Returns the value of the '<em><b>Requirement</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.AbstractSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirement</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirement</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_Requirement()
   * @model containment="true"
   *        annotation="MetaData guid='{D15D08A4-B819-4e63-A59C-134103BEA9B5}' id='-1065954751' EA\040name=''"
   *        extendedMetaData="name='REQUIREMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<AbstractSafetyRequirement> getRequirement();

  /**
   * Returns the value of the '<em><b>Justification</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Justification}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Justification</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Justification</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_Justification()
   * @model annotation="MetaData guid='{857192E9-EA83-4957-B13E-60E4D4978318}' id='-1842562461' EA\040name=''"
   *        extendedMetaData="name='JUSTIFICATION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='JUSTIFICATION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Justification> getJustification();

  /**
   * Returns the value of the '<em><b>Assumption</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Assumption}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Assumption</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Assumption</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_Assumption()
   * @model annotation="MetaData guid='{88A82745-6A5A-4db3-84B5-4FFD05851490}' id='-1386595882' EA\040name=''"
   *        extendedMetaData="name='ASSUMPTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ASSUMPTION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Assumption> getAssumption();

  /**
   * Returns the value of the '<em><b>In Context Of</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Context}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>In Context Of</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>In Context Of</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_InContextOf()
   * @model annotation="MetaData guid='{491DC2D8-E5C3-4a1b-95F4-82AAB1C6EA3B}' id='-1055956158' EA\040name=''"
   *        extendedMetaData="name='IN-CONTEXT-OF-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='IN-CONTEXT-OF-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Context> getInContextOf();

  /**
   * Returns the value of the '<em><b>Solution</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Solution}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Solution</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Solution</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_Solution()
   * @model required="true"
   *        annotation="MetaData guid='{B1D3E0B0-C607-4b8b-B8D7-5CA6E9C07516}' id='-888031896' EA\040name=''"
   *        extendedMetaData="name='SOLUTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SOLUTION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Solution> getSolution();

  /**
   * Returns the value of the '<em><b>Supported By</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Goal}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Supported By</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Supported By</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_SupportedBy()
   * @model required="true"
   *        annotation="MetaData guid='{350559CC-2544-4ccf-9ED6-B760BC6A15C3}' id='-317172919' EA\040name=''"
   *        extendedMetaData="name='SUPPORTED-BY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SUPPORTED-BY-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Goal> getSupportedBy();

  /**
   * Returns the value of the '<em><b>Strategy</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Strategy</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Strategy</em>' reference.
   * @see #setStrategy(Strategy)
   * @see org.safe.metamodel.safe10.Safe10Package#getGoal_Strategy()
   * @model annotation="MetaData guid='{CE00C4AE-B7A9-44ff-8F01-253C2C00603B}' id='1265275365' EA\040name=''"
   *        extendedMetaData="name='STRATEGY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='STRATEGY-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Strategy getStrategy();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Goal#getStrategy <em>Strategy</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Strategy</em>' reference.
   * @see #getStrategy()
   * @generated
   */
  void setStrategy(Strategy value);

} // Goal
