/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Gradient Check</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class element defines a gradient check SSR. The limit and tolerance attributes are used to check if the values are varying within a valid range. The SSR is executed periodically according to its period attribute.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.GradientCheck.GradientCheck</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.GradientCheck#getMaxLimit <em>Max Limit</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.GradientCheck#getMaxTolerance <em>Max Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.GradientCheck#getMinLimit <em>Min Limit</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.GradientCheck#getMinTolerance <em>Min Tolerance</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getGradientCheck()
 * @model annotation="MetaData guid='{2DA03EEE-3ACD-4479-BA72-FF02AE8EF8C7}' id='258' EA\040name='GradientCheck'"
 *        extendedMetaData="name='GRADIENT-CHECK' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='GRADIENT-CHECKS'"
 * @generated
 */
public interface GradientCheck extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Max Limit</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Max Limit</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Max Limit</em>' attribute.
   * @see #isSetMaxLimit()
   * @see #unsetMaxLimit()
   * @see #setMaxLimit(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getGradientCheck_MaxLimit()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{D953F7F3-1420-4b37-8D04-0E3E863FD81C}' id='42' EA\040name='maxLimit'"
   *        extendedMetaData="name='MAX-LIMIT' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MAX-LIMITS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getMaxLimit();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMaxLimit <em>Max Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Max Limit</em>' attribute.
   * @see #isSetMaxLimit()
   * @see #MaxLimit()
   * @see #getMaxLimit()
   * @generated
   */
  void setMaxLimit(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMaxLimit <em>Max Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMaxLimit()
   * @see #getMaxLimit()
   * @see #setMaxLimit(Double)
   * @generated
   */
  void unsetMaxLimit();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMaxLimit <em>Max Limit</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Max Limit</em>' attribute is set.
   * @see #MaxLimit()
   * @see #getMaxLimit()
   * @see #setMaxLimit(Double)
   * @generated
   */
  boolean isSetMaxLimit();

  /**
   * Returns the value of the '<em><b>Max Tolerance</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Max Tolerance</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Max Tolerance</em>' attribute.
   * @see #isSetMaxTolerance()
   * @see #unsetMaxTolerance()
   * @see #setMaxTolerance(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getGradientCheck_MaxTolerance()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{29F04C1F-D89D-4f70-B666-4318A1099BCC}' id='44' EA\040name='maxTolerance'"
   *        extendedMetaData="name='MAX-TOLERANCE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MAX-TOLERANCES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getMaxTolerance();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMaxTolerance <em>Max Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Max Tolerance</em>' attribute.
   * @see #isSetMaxTolerance()
   * @see #MaxTolerance()
   * @see #getMaxTolerance()
   * @generated
   */
  void setMaxTolerance(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMaxTolerance <em>Max Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMaxTolerance()
   * @see #getMaxTolerance()
   * @see #setMaxTolerance(Double)
   * @generated
   */
  void unsetMaxTolerance();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMaxTolerance <em>Max Tolerance</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Max Tolerance</em>' attribute is set.
   * @see #MaxTolerance()
   * @see #getMaxTolerance()
   * @see #setMaxTolerance(Double)
   * @generated
   */
  boolean isSetMaxTolerance();

  /**
   * Returns the value of the '<em><b>Min Limit</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Min Limit</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Min Limit</em>' attribute.
   * @see #isSetMinLimit()
   * @see #unsetMinLimit()
   * @see #setMinLimit(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getGradientCheck_MinLimit()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{6F2A2C68-7D16-49c1-A181-B8B53BCDB872}' id='43' EA\040name='minLimit'"
   *        extendedMetaData="name='MIN-LIMIT' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MIN-LIMITS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getMinLimit();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMinLimit <em>Min Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Min Limit</em>' attribute.
   * @see #isSetMinLimit()
   * @see #MinLimit()
   * @see #getMinLimit()
   * @generated
   */
  void setMinLimit(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMinLimit <em>Min Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMinLimit()
   * @see #getMinLimit()
   * @see #setMinLimit(Double)
   * @generated
   */
  void unsetMinLimit();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMinLimit <em>Min Limit</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Min Limit</em>' attribute is set.
   * @see #MinLimit()
   * @see #getMinLimit()
   * @see #setMinLimit(Double)
   * @generated
   */
  boolean isSetMinLimit();

  /**
   * Returns the value of the '<em><b>Min Tolerance</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Min Tolerance</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Min Tolerance</em>' attribute.
   * @see #isSetMinTolerance()
   * @see #unsetMinTolerance()
   * @see #setMinTolerance(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getGradientCheck_MinTolerance()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{F67A73CC-B1D4-4e58-BDE6-0EABD0D6706A}' id='40928483' EA\040name='minTolerance'"
   *        extendedMetaData="name='MIN-TOLERANCE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MIN-TOLERANCES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getMinTolerance();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMinTolerance <em>Min Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Min Tolerance</em>' attribute.
   * @see #isSetMinTolerance()
   * @see #MinTolerance()
   * @see #getMinTolerance()
   * @generated
   */
  void setMinTolerance(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMinTolerance <em>Min Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMinTolerance()
   * @see #getMinTolerance()
   * @see #setMinTolerance(Double)
   * @generated
   */
  void unsetMinTolerance();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.GradientCheck#getMinTolerance <em>Min Tolerance</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Min Tolerance</em>' attribute is set.
   * @see #MinTolerance()
   * @see #getMinTolerance()
   * @see #setMinTolerance(Double)
   * @generated
   */
  boolean isSetMinTolerance();

} // GradientCheck
