/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Architectural Metrics</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represents an abstract definition of all quantified failure analysis required by the ISO Part 5 Clause 8. This class allows to map all meta class for the HWArchitecturalMetrics also described in the ISO Part 5-Annex C (Single-Point-Fault Metric, Latent-Fault Metric). 
 * 
 * Each HWQuantifiedFailureAnalysis belongs to exactly one malfunction (link to violation of a SafetyGoal). The ASIL-TargetValue (e.g. ASIL-D) is derived from the SafetyGoal.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.HWQuantitativeMeasure.HWArchitecturalMetrics</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWArchitecturalMetrics#getHwLantentFaultMetric <em>Hw Lantent Fault Metric</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWArchitecturalMetrics#getHwSinglePointFaultMetric <em>Hw Single Point Fault Metric</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWArchitecturalMetrics()
 * @model abstract="true"
 *        annotation="MetaData guid='{D019A521-C90A-4cc3-8EED-AD582084AF69}' id='779220654' EA\040name='HWArchitecturalMetrics'"
 *        extendedMetaData="name='HW-ARCHITECTURAL-METRICS' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-ARCHITECTURAL-METRICSS'"
 * @generated
 */
public interface HWArchitecturalMetrics extends EObject
{
  /**
   * Returns the value of the '<em><b>Hw Lantent Fault Metric</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Lantent Fault Metric</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Lantent Fault Metric</em>' containment reference.
   * @see #setHwLantentFaultMetric(HWLatentFaultMetric)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWArchitecturalMetrics_HwLantentFaultMetric()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{F9184928-D679-4154-9D31-4EC09F62AAEC}' id='513706188' EA\040name=''"
   *        extendedMetaData="name='HW-LANTENT-FAULT-METRIC' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-LANTENT-FAULT-METRICS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWLatentFaultMetric getHwLantentFaultMetric();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWArchitecturalMetrics#getHwLantentFaultMetric <em>Hw Lantent Fault Metric</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Lantent Fault Metric</em>' containment reference.
   * @see #getHwLantentFaultMetric()
   * @generated
   */
  void setHwLantentFaultMetric(HWLatentFaultMetric value);

  /**
   * Returns the value of the '<em><b>Hw Single Point Fault Metric</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Single Point Fault Metric</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Single Point Fault Metric</em>' containment reference.
   * @see #setHwSinglePointFaultMetric(HWSinglePointFaultMetric)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWArchitecturalMetrics_HwSinglePointFaultMetric()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{0478FEA3-D223-401a-9BF4-F57D9DF9BF32}' id='130372573' EA\040name=''"
   *        extendedMetaData="name='HW-SINGLE-POINT-FAULT-METRIC' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-SINGLE-POINT-FAULT-METRICS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWSinglePointFaultMetric getHwSinglePointFaultMetric();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWArchitecturalMetrics#getHwSinglePointFaultMetric <em>Hw Single Point Fault Metric</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Single Point Fault Metric</em>' containment reference.
   * @see #getHwSinglePointFaultMetric()
   * @generated
   */
  void setHwSinglePointFaultMetric(HWSinglePointFaultMetric value);

} // HWArchitecturalMetrics
