/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Component Prototype Scope</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the context for the definition of a hardware component. The attribute defines a results of the analysis if the Hardware Component is safety related means impacted by the contribution to the violation of the malfunction
 * 
 * During modeling a design rule must be ensured that HardwareComponentType used as BaseHwComponent for the instanceRef relation is the same as the root hierarchy on the HwComponentprototypeScope creation
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.Failure.HWComponentPrototypeScope</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getSafetyRelated <em>Safety Related</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getNameWasNotSet_0 <em>Name Was Not Set 0</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getHwFaultCharacterization <em>Hw Fault Characterization</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentPrototypeScope()
 * @model annotation="MetaData guid='{709647B8-E848-4c09-BDB8-F795F37CCCF3}' id='-1009160888' EA\040name='HWComponentPrototypeScope'"
 *        extendedMetaData="name='HW-COMPONENT-PROTOTYPE-SCOPE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-COMPONENT-PROTOTYPE-SCOPES'"
 * @generated
 */
public interface HWComponentPrototypeScope extends EObject
{
  /**
   * Returns the value of the '<em><b>Safety Related</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * This attribute stores the contribution of the HWComponent to a malfunction as a boolean information
   * <!-- end-model-doc -->
   * @return the value of the '<em>Safety Related</em>' attribute.
   * @see #isSetSafetyRelated()
   * @see #unsetSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentPrototypeScope_SafetyRelated()
   * @model default="false" unsettable="true" dataType="org.safe.metamodel.safe10.Boolean" required="true"
   *        annotation="MetaData guid='{FEB31D72-DE3F-481a-8EE7-26122D3D744F}' id='-1352211031' EA\040name='safetyRelated'"
   *        extendedMetaData="name='SAFETY-RELATED' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-RELATEDS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Boolean getSafetyRelated();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getSafetyRelated <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Safety Related</em>' attribute.
   * @see #isSetSafetyRelated()
   * @see #SafetyRelated()
   * @see #getSafetyRelated()
   * @generated
   */
  void setSafetyRelated(Boolean value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getSafetyRelated <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetSafetyRelated()
   * @see #getSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @generated
   */
  void unsetSafetyRelated();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getSafetyRelated <em>Safety Related</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Safety Related</em>' attribute is set.
   * @see #SafetyRelated()
   * @see #getSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @generated
   */
  boolean isSetSafetyRelated();

  /**
   * Returns the value of the '<em><b>Name Was Not Set 0</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getHWComponentScope <em>HW Component Scope</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Was Not Set 0</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Was Not Set 0</em>' reference.
   * @see #setNameWasNotSet_0(HardwareFailureAnalysis)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentPrototypeScope_NameWasNotSet_0()
   * @see org.safe.metamodel.safe10.HardwareFailureAnalysis#getHWComponentScope
   * @model opposite="hWComponentScope"
   *        annotation="MetaData guid='{C4502C23-225F-47d5-8FD2-A94884AEE8BE}' id='-1053431883' EA\040name=''"
   *        extendedMetaData="name='NAME-WAS-NOT-SET-0-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NAME-WAS-NOT-SET-0-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareFailureAnalysis getNameWasNotSet_0();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getNameWasNotSet_0 <em>Name Was Not Set 0</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Was Not Set 0</em>' reference.
   * @see #getNameWasNotSet_0()
   * @generated
   */
  void setNameWasNotSet_0(HardwareFailureAnalysis value);

  /**
   * Returns the value of the '<em><b>Hw Fault Characterization</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWFault}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Fault Characterization</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Fault Characterization</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentPrototypeScope_HwFaultCharacterization()
   * @model annotation="MetaData guid='{82DC3EBF-A42F-4198-AC5D-1DC91DF75805}' id='1225952639' EA\040name=''"
   *        extendedMetaData="name='HW-FAULT-CHARACTERIZATION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-FAULT-CHARACTERIZATION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HWFault> getHwFaultCharacterization();

  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getNameWasNotSet_1 <em>Name Was Not Set 1</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(HwComponentScopeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentPrototypeScope_Scope()
   * @see org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getNameWasNotSet_1
   * @model opposite="NameWasNotSet_1" required="true"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HwComponentScopeInstanceRef getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(HwComponentScopeInstanceRef value);

} // HWComponentPrototypeScope
