/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Element Prototype Scope</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the context for the definition of a hardware Element. The attribute defines a results of the analysis if the Hardware Component is safety related means impacted by the contribution to the violation of the malfunction
 * 
 * During modeling a design rule must be ensured that HWElementType used as BaseHwComponent for the instanceRef relation is the same as the root hierarchy on the HwElementPrototypeScope creation
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.FailurePart.HWElementPrototypeScope</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getSafetyRelated <em>Safety Related</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getNameWasNotSet_2 <em>Name Was Not Set 2</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWElementPrototypeScope()
 * @model annotation="MetaData guid='{56EFC5F4-FD04-49da-8632-7956D475CF7B}' id='-1763263864' EA\040name='HWElementPrototypeScope'"
 *        extendedMetaData="name='HW-ELEMENT-PROTOTYPE-SCOPE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-ELEMENT-PROTOTYPE-SCOPES'"
 * @generated
 */
public interface HWElementPrototypeScope extends EObject
{
  /**
   * Returns the value of the '<em><b>Safety Related</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * This attribute stores the contribution of the HWElement to a malfunction as a boolean information
   * <!-- end-model-doc -->
   * @return the value of the '<em>Safety Related</em>' attribute.
   * @see #isSetSafetyRelated()
   * @see #unsetSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWElementPrototypeScope_SafetyRelated()
   * @model default="false" unsettable="true" dataType="org.safe.metamodel.safe10.Boolean" required="true"
   *        annotation="MetaData guid='{DD9A0D1D-972D-4fe8-9C44-DCF3DBEBFC44}' id='-1786580556' EA\040name='safetyRelated'"
   *        extendedMetaData="name='SAFETY-RELATED' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-RELATEDS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Boolean getSafetyRelated();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getSafetyRelated <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Safety Related</em>' attribute.
   * @see #isSetSafetyRelated()
   * @see #SafetyRelated()
   * @see #getSafetyRelated()
   * @generated
   */
  void setSafetyRelated(Boolean value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getSafetyRelated <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetSafetyRelated()
   * @see #getSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @generated
   */
  void unsetSafetyRelated();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getSafetyRelated <em>Safety Related</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Safety Related</em>' attribute is set.
   * @see #SafetyRelated()
   * @see #getSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @generated
   */
  boolean isSetSafetyRelated();

  /**
   * Returns the value of the '<em><b>Name Was Not Set 2</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HWPartFailureAnalysis#getHwElementScope <em>Hw Element Scope</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Was Not Set 2</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Was Not Set 2</em>' reference.
   * @see #setNameWasNotSet_2(HWPartFailureAnalysis)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWElementPrototypeScope_NameWasNotSet_2()
   * @see org.safe.metamodel.safe10.HWPartFailureAnalysis#getHwElementScope
   * @model opposite="hwElementScope"
   *        annotation="MetaData guid='{8C9EDB06-1EA5-4626-9E6C-A4FC8B13C4C5}' id='-1562844396' EA\040name=''"
   *        extendedMetaData="name='NAME-WAS-NOT-SET-2-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NAME-WAS-NOT-SET-2-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWPartFailureAnalysis getNameWasNotSet_2();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getNameWasNotSet_2 <em>Name Was Not Set 2</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Was Not Set 2</em>' reference.
   * @see #getNameWasNotSet_2()
   * @generated
   */
  void setNameWasNotSet_2(HWPartFailureAnalysis value);

  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(HWElementScopeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWElementPrototypeScope_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{A64CAB43-407F-4661-96DD-6A87EA12E223}' id='1904714137' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWElementScopeInstanceRef getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWElementPrototypeScope#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(HWElementScopeInstanceRef value);

} // HWElementPrototypeScope
