/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.ecuresource.HwElement;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Element Scope Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This "instanceRef" meta-class is the container for holding the relation of HWElementScope in context of AutosarHWElementPrototype
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.FailurePart._instanceRef.HWElementScopeInstanceRef</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef#getContext <em>Context</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef#getBase <em>Base</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWElementScopeInstanceRef()
 * @model annotation="MetaData guid='{9A9E1A06-E68C-4ad9-A08E-098B629DBA56}' id='615265462' EA\040name='HWElementScopeInstanceRef'"
 *        annotation="Stereotype Stereotype='InstanceRef'"
 *        extendedMetaData="name='HW-ELEMENT-SCOPE-INSTANCE-REF' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-ELEMENT-SCOPE-INSTANCE-REFS'"
 * @generated
 */
public interface HWElementScopeInstanceRef extends EObject
{
  /**
   * Returns the value of the '<em><b>Context</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Context</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Context</em>' reference.
   * @see #setContext(HwElement)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWElementScopeInstanceRef_Context()
   * @model annotation="MetaData guid='{7592424C-B20E-4aef-B591-B7D76B6BCD67}' id='-306464718' EA\040name=''"
   *        annotation="Stereotype Stereotype='instanceRef.context'"
   *        extendedMetaData="name='CONTEXT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HwElement getContext();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef#getContext <em>Context</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Context</em>' reference.
   * @see #getContext()
   * @generated
   */
  void setContext(HwElement value);

  /**
   * Returns the value of the '<em><b>Base</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Base</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Base</em>' reference.
   * @see #setBase(HwElement)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWElementScopeInstanceRef_Base()
   * @model annotation="MetaData guid='{B1A071E8-3847-4413-9E49-1F26F1DD3947}' id='66866379' EA\040name=''"
   *        annotation="Stereotype Stereotype='instanceRef.base'"
   *        extendedMetaData="name='BASE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='BASE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HwElement getBase();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef#getBase <em>Base</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Base</em>' reference.
   * @see #getBase()
   * @generated
   */
  void setBase(HwElement value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(HwElement)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWElementScopeInstanceRef_Target()
   * @model required="true"
   *        annotation="MetaData guid='{6912406C-FABF-4bba-8B4D-FFDD6C5B3AC0}' id='350368819' EA\040name=''"
   *        annotation="Stereotype Stereotype='instanceRef.target'"
   *        extendedMetaData="name='TARGET-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HwElement getTarget();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(HwElement value);

} // HWElementScopeInstanceRef
