/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Failure Class Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class is container to store all HW element  failure class results and associated assumptions taken (number of cut-set as typical).
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.ProbabilisticMethods.HWFailureClassContainer</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRationaleCutSet <em>Rationale Cut Set</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRelevantCutSet <em>Relevant Cut Set</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWFailureClassContainer#getHwelementFailureRateClass <em>Hwelement Failure Rate Class</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWFailureClassContainer()
 * @model annotation="MetaData guid='{A54D428D-647C-4921-B8F5-A79C668CD8D7}' id='1254805652' EA\040name='HWFailureClassContainer'"
 *        extendedMetaData="name='HW-FAILURE-CLASS-CONTAINER' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-FAILURE-CLASS-CONTAINERS'"
 * @generated
 */
public interface HWFailureClassContainer extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Rationale Cut Set</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * This attribute provides a textual rationale for the number of relevant cut-sets.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Rationale Cut Set</em>' attribute.
   * @see #isSetRationaleCutSet()
   * @see #unsetRationaleCutSet()
   * @see #setRationaleCutSet(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWFailureClassContainer_RationaleCutSet()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{1B56954B-DE3D-40b0-9B8E-8BEF0F0F74CA}' id='-1643404795' EA\040name='rationaleCutSet'"
   *        extendedMetaData="name='RATIONALE-CUT-SET' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONALE-CUT-SETS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRationaleCutSet();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRationaleCutSet <em>Rationale Cut Set</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rationale Cut Set</em>' attribute.
   * @see #isSetRationaleCutSet()
   * @see #RationaleCutSet()
   * @see #getRationaleCutSet()
   * @generated
   */
  void setRationaleCutSet(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRationaleCutSet <em>Rationale Cut Set</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRationaleCutSet()
   * @see #getRationaleCutSet()
   * @see #setRationaleCutSet(String)
   * @generated
   */
  void unsetRationaleCutSet();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRationaleCutSet <em>Rationale Cut Set</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rationale Cut Set</em>' attribute is set.
   * @see #RationaleCutSet()
   * @see #getRationaleCutSet()
   * @see #setRationaleCutSet(String)
   * @generated
   */
  boolean isSetRationaleCutSet();

  /**
   * Returns the value of the '<em><b>Relevant Cut Set</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * This attributes stores the number of relevant cut sets.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Relevant Cut Set</em>' attribute.
   * @see #isSetRelevantCutSet()
   * @see #unsetRelevantCutSet()
   * @see #setRelevantCutSet(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWFailureClassContainer_RelevantCutSet()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{C617DE8D-E4B0-493e-A2CB-9124B55FC233}' id='1675360482' EA\040name='relevantCutSet'"
   *        extendedMetaData="name='RELEVANT-CUT-SET' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RELEVANT-CUT-SETS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getRelevantCutSet();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRelevantCutSet <em>Relevant Cut Set</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Relevant Cut Set</em>' attribute.
   * @see #isSetRelevantCutSet()
   * @see #RelevantCutSet()
   * @see #getRelevantCutSet()
   * @generated
   */
  void setRelevantCutSet(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRelevantCutSet <em>Relevant Cut Set</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRelevantCutSet()
   * @see #getRelevantCutSet()
   * @see #setRelevantCutSet(Integer)
   * @generated
   */
  void unsetRelevantCutSet();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWFailureClassContainer#getRelevantCutSet <em>Relevant Cut Set</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Relevant Cut Set</em>' attribute is set.
   * @see #RelevantCutSet()
   * @see #getRelevantCutSet()
   * @see #setRelevantCutSet(Integer)
   * @generated
   */
  boolean isSetRelevantCutSet();

  /**
   * Returns the value of the '<em><b>Hwelement Failure Rate Class</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWElementFailureRateClass}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hwelement Failure Rate Class</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hwelement Failure Rate Class</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHWFailureClassContainer_HwelementFailureRateClass()
   * @model containment="true"
   *        annotation="MetaData guid='{4F4FFD8B-64A0-4d6f-A9A6-3FADA7A9CCFF}' id='1678853477' EA\040name=''"
   *        extendedMetaData="name='HWELEMENT-FAILURE-RATE-CLASS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HWELEMENT-FAILURE-RATE-CLASSS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<HWElementFailureRateClass> getHwelementFailureRateClass();

} // HWFailureClassContainer
