/**
 */
package org.safe.metamodel.safe10;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>HW Fault Metrics Enum</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * null
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.HWFaultMetricsEnum</b></em> 
 * <!-- end-model-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package#getHWFaultMetricsEnum()
 * @model annotation="MetaData guid='{69833674-B906-4c20-AF99-D4158D4EFB13}' id='354224535' EA\040name='HWFaultMetricsEnum'"
 *        annotation="Stereotype Stereotype='enumeration'"
 *        extendedMetaData="name='HW-FAULT-METRICS-ENUM'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-FAULT-METRICS-ENUMS'"
 * @generated
 */
public enum HWFaultMetricsEnum implements Enumerator
{
  /**
   * The '<em><b>Single Point Fault</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #SINGLE_POINT_FAULT_VALUE
   * @generated
   * @ordered
   */
  SINGLE_POINT_FAULT(0, "SinglePointFault", "SINGLEPOINTFAULT"),

  /**
   * The '<em><b>Latent Fault</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #LATENT_FAULT_VALUE
   * @generated
   * @ordered
   */
  LATENT_FAULT(1, "LatentFault", "LATENTFAULT"),

  /**
   * The '<em><b>Max Probability Malfunction</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #MAX_PROBABILITY_MALFUNCTION_VALUE
   * @generated
   * @ordered
   */
  MAX_PROBABILITY_MALFUNCTION(2, "MaxProbabilityMalfunction", "MAXPROBABILITYMALFUNCTION");

  /**
   * The '<em><b>Single Point Fault</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Single Point Fault</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #SINGLE_POINT_FAULT
   * @model name="SinglePointFault" literal="SINGLEPOINTFAULT"
   * @generated
   * @ordered
   */
  public static final int SINGLE_POINT_FAULT_VALUE = 0;

  /**
   * The '<em><b>Latent Fault</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Latent Fault</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #LATENT_FAULT
   * @model name="LatentFault" literal="LATENTFAULT"
   * @generated
   * @ordered
   */
  public static final int LATENT_FAULT_VALUE = 1;

  /**
   * The '<em><b>Max Probability Malfunction</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Max Probability Malfunction</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #MAX_PROBABILITY_MALFUNCTION
   * @model name="MaxProbabilityMalfunction" literal="MAXPROBABILITYMALFUNCTION"
   * @generated
   * @ordered
   */
  public static final int MAX_PROBABILITY_MALFUNCTION_VALUE = 2;

  /**
   * An array of all the '<em><b>HW Fault Metrics Enum</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final HWFaultMetricsEnum[] VALUES_ARRAY =
    new HWFaultMetricsEnum[]
    {
      SINGLE_POINT_FAULT,
      LATENT_FAULT,
      MAX_PROBABILITY_MALFUNCTION,
    };

  /**
   * A public read-only list of all the '<em><b>HW Fault Metrics Enum</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<HWFaultMetricsEnum> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>HW Fault Metrics Enum</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static HWFaultMetricsEnum get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      HWFaultMetricsEnum result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>HW Fault Metrics Enum</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static HWFaultMetricsEnum getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      HWFaultMetricsEnum result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>HW Fault Metrics Enum</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static HWFaultMetricsEnum get(int value)
  {
    switch (value)
    {
      case SINGLE_POINT_FAULT_VALUE: return SINGLE_POINT_FAULT;
      case LATENT_FAULT_VALUE: return LATENT_FAULT;
      case MAX_PROBABILITY_MALFUNCTION_VALUE: return MAX_PROBABILITY_MALFUNCTION;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private HWFaultMetricsEnum(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //HWFaultMetricsEnum
