/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Lambda Part Formula</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the lambda failure rate contribution of all HWPartFailureMode of HardwarePart to a dedicated HWFailureMode of a HWComponent.
 * 
 * The formula expression shall be for each HWFailureMode of a Safety Related HWComponent (related as parts of the Item) expressed from the different safety-related AUTOSAR HW Element (part of the item).
 * 
 * lambdaFailureMode = function all HWPartFailureMode [Value(HWPartFailureRate) * FailureRateDistribution(HWPartFailureMode), AutosarHWelement) 
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.FailureFormula.HWLambdaPartFormula</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWLambdaPartFormula#getHwPartFailureRateValue <em>Hw Part Failure Rate Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWLambdaPartFormula#getFailureRateDistributionValue <em>Failure Rate Distribution Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWLambdaPartFormula()
 * @model annotation="MetaData guid='{1752423D-0586-457d-B2E1-7FCF559B6FE0}' id='826810910' EA\040name='HWLambdaPartFormula'"
 *        extendedMetaData="name='HW-LAMBDA-PART-FORMULA' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-LAMBDA-PART-FORMULAS'"
 * @generated
 */
public interface HWLambdaPartFormula extends FormulaDocumentation
{
  /**
   * Returns the value of the '<em><b>Hw Part Failure Rate Value</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWPartFailureRate}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Part Failure Rate Value</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Part Failure Rate Value</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHWLambdaPartFormula_HwPartFailureRateValue()
   * @model annotation="MetaData guid='{F99C612C-E195-4ddb-A583-96A8FE92127E}' id='-1863722578' EA\040name=''"
   *        extendedMetaData="name='HW-PART-FAILURE-RATE-VALUE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PART-FAILURE-RATE-VALUE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HWPartFailureRate> getHwPartFailureRateValue();

  /**
   * Returns the value of the '<em><b>Failure Rate Distribution Value</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWPartFailureMode}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Failure Rate Distribution Value</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Failure Rate Distribution Value</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHWLambdaPartFormula_FailureRateDistributionValue()
   * @model annotation="MetaData guid='{0F0E95F6-0142-48f9-BFBB-58952BA0BDF5}' id='1643816832' EA\040name=''"
   *        extendedMetaData="name='FAILURE-RATE-DISTRIBUTION-VALUE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FAILURE-RATE-DISTRIBUTION-VALUE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HWPartFailureMode> getFailureRateDistributionValue();

} // HWLambdaPartFormula
