/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Part Failure Rate</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class captures the HWPartFailureRate of a AUTOSAR HWElement. Each AUTOSAR HWElement has one single Part HWFailureRate.
 * 
 * The appropriate Part FailureRate can be derived from e.g. Industry Source.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.FailurePart.HWPartFailureRate</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailureRate#getRationaleScalingFactor <em>Rationale Scaling Factor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailureRate#getScalingFactor <em>Scaling Factor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailureRate#getSource <em>Source</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailureRate#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailureRate()
 * @model annotation="MetaData guid='{21CE4AB9-1EAE-4aeb-AD68-A73C7EC6DBD3}' id='588847846' EA\040name='HWPartFailureRate'"
 *        extendedMetaData="name='HW-PART-FAILURE-RATE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PART-FAILURE-RATES'"
 * @generated
 */
public interface HWPartFailureRate extends EObject
{
  /**
   * Returns the value of the '<em><b>Rationale Scaling Factor</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The rationaleScalingFactor shall provide a rationale, if a scaling factor different to 1.0 is applied.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Rationale Scaling Factor</em>' attribute.
   * @see #isSetRationaleScalingFactor()
   * @see #unsetRationaleScalingFactor()
   * @see #setRationaleScalingFactor(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailureRate_RationaleScalingFactor()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{732BD3DD-47E6-4a1e-9990-651A41AA1F97}' id='1964269167' EA\040name='rationaleScalingFactor'"
   *        extendedMetaData="name='RATIONALE-SCALING-FACTOR' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONALE-SCALING-FACTORS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRationaleScalingFactor();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getRationaleScalingFactor <em>Rationale Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rationale Scaling Factor</em>' attribute.
   * @see #isSetRationaleScalingFactor()
   * @see #RationaleScalingFactor()
   * @see #getRationaleScalingFactor()
   * @generated
   */
  void setRationaleScalingFactor(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getRationaleScalingFactor <em>Rationale Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRationaleScalingFactor()
   * @see #getRationaleScalingFactor()
   * @see #setRationaleScalingFactor(String)
   * @generated
   */
  void unsetRationaleScalingFactor();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getRationaleScalingFactor <em>Rationale Scaling Factor</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rationale Scaling Factor</em>' attribute is set.
   * @see #RationaleScalingFactor()
   * @see #getRationaleScalingFactor()
   * @see #setRationaleScalingFactor(String)
   * @generated
   */
  boolean isSetRationaleScalingFactor();

  /**
   * Returns the value of the '<em><b>Scaling Factor</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The scalingFactor allows potential scaling between different sources of failure rates as described in ISO Part 5 Annex F.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Scaling Factor</em>' attribute.
   * @see #isSetScalingFactor()
   * @see #unsetScalingFactor()
   * @see #setScalingFactor(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailureRate_ScalingFactor()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{F20E3DEC-5200-48ea-86F9-D4B41684461D}' id='-1842588796' EA\040name='scalingFactor'"
   *        extendedMetaData="name='SCALING-FACTOR' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCALING-FACTORS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getScalingFactor();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getScalingFactor <em>Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scaling Factor</em>' attribute.
   * @see #isSetScalingFactor()
   * @see #ScalingFactor()
   * @see #getScalingFactor()
   * @generated
   */
  void setScalingFactor(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getScalingFactor <em>Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetScalingFactor()
   * @see #getScalingFactor()
   * @see #setScalingFactor(Double)
   * @generated
   */
  void unsetScalingFactor();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getScalingFactor <em>Scaling Factor</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Scaling Factor</em>' attribute is set.
   * @see #ScalingFactor()
   * @see #getScalingFactor()
   * @see #setScalingFactor(Double)
   * @generated
   */
  boolean isSetScalingFactor();

  /**
   * Returns the value of the '<em><b>Source</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * FIT rate source shall documented according to possible source as described in ISO 26262 Part 5 8.4.3:
   * a) failure rate from industry source (IEC/TR 62380, IEC 61709, ...)
   * b) statistic based on return field or test
   * c) Expert judgement
   * <!-- end-model-doc -->
   * @return the value of the '<em>Source</em>' attribute.
   * @see #isSetSource()
   * @see #unsetSource()
   * @see #setSource(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailureRate_Source()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{DD61E4BF-9541-4c90-9102-62FEAF7D75CB}' id='-774683083' EA\040name='source'"
   *        extendedMetaData="name='SOURCE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SOURCES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getSource();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getSource <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' attribute.
   * @see #isSetSource()
   * @see #Source()
   * @see #getSource()
   * @generated
   */
  void setSource(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getSource <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetSource()
   * @see #getSource()
   * @see #setSource(String)
   * @generated
   */
  void unsetSource();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getSource <em>Source</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Source</em>' attribute is set.
   * @see #Source()
   * @see #getSource()
   * @see #setSource(String)
   * @generated
   */
  boolean isSetSource();

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * FIT rate for the hardware part element.
   * 
   * It shall be expressed in FIT.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #isSetValue()
   * @see #unsetValue()
   * @see #setValue(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailureRate_Value()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{1FB8F0BA-2776-4120-8281-581B6EF75FCF}' id='-143198894' EA\040name='value'"
   *        extendedMetaData="name='VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #isSetValue()
   * @see #Value()
   * @see #getValue()
   * @generated
   */
  void setValue(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetValue()
   * @see #getValue()
   * @see #setValue(Double)
   * @generated
   */
  void unsetValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPartFailureRate#getValue <em>Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Value</em>' attribute is set.
   * @see #Value()
   * @see #getValue()
   * @see #setValue(Double)
   * @generated
   */
  boolean isSetValue();

} // HWPartFailureRate
