/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Probabilistic Value</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represents an abstract definition of all failure analysis required by the ISO Part 5 Clause 9. This class allows to map all meta class for the evaluation of safety goal violation (PMHF and Failure Rate Class). 
 * 
 * Each HWQuantifiedFailureAnalysis belongs to exactly one malfunction (link to violation of a SafetyGoal). The ASIL-TargetValue (e.g. ASIL-D) is derived from the SafetyGoal.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.HWQuantitativeMeasure.HWProbabilisticValue</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWProbabilisticValue#getHwFailureClassContainer <em>Hw Failure Class Container</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWProbabilisticValue#getHwPMHF <em>Hw PMHF</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWProbabilisticValue()
 * @model abstract="true"
 *        annotation="MetaData guid='{65103584-DF55-4b7e-B8EB-EBF6A0DE90F2}' id='-631194496' EA\040name='HWProbabilisticValue'"
 *        extendedMetaData="name='HW-PROBABILISTIC-VALUE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PROBABILISTIC-VALUES'"
 * @generated
 */
public interface HWProbabilisticValue extends EObject
{
  /**
   * Returns the value of the '<em><b>Hw Failure Class Container</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Failure Class Container</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Failure Class Container</em>' containment reference.
   * @see #setHwFailureClassContainer(HWFailureClassContainer)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWProbabilisticValue_HwFailureClassContainer()
   * @model containment="true"
   *        annotation="MetaData guid='{DA80471E-2B3D-407a-9471-93C6CA7609F1}' id='1395722581' EA\040name=''"
   *        extendedMetaData="name='HW-FAILURE-CLASS-CONTAINER' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-FAILURE-CLASS-CONTAINERS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWFailureClassContainer getHwFailureClassContainer();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWProbabilisticValue#getHwFailureClassContainer <em>Hw Failure Class Container</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Failure Class Container</em>' containment reference.
   * @see #getHwFailureClassContainer()
   * @generated
   */
  void setHwFailureClassContainer(HWFailureClassContainer value);

  /**
   * Returns the value of the '<em><b>Hw PMHF</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw PMHF</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw PMHF</em>' containment reference.
   * @see #setHwPMHF(HWPMHF)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWProbabilisticValue_HwPMHF()
   * @model containment="true"
   *        annotation="MetaData guid='{089F8924-9732-4664-9BBD-4AAAAE7B39C0}' id='-1238288604' EA\040name=''"
   *        extendedMetaData="name='HW-PMHF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PMHFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWPMHF getHwPMHF();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWProbabilisticValue#getHwPMHF <em>Hw PMHF</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw PMHF</em>' containment reference.
   * @see #getHwPMHF()
   * @generated
   */
  void setHwPMHF(HWPMHF value);

} // HWProbabilisticValue
