/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Handle</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Classifies requirements as handling requirements.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.Tactic.Handle</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Handle#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Handle#getHandledSituation <em>Handled Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Handle#getErrorSituation <em>Error Situation</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHandle()
 * @model annotation="MetaData guid='{F6109B06-D1FE-43c5-80C9-6008640842A0}' id='-1117824678' EA\040name='Handle'"
 *        extendedMetaData="name='HANDLE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HANDLES'"
 * @generated
 */
public interface Handle extends Tactic
{
  /**
   * Returns the value of the '<em><b>Type</b></em>' attribute.
   * The default value is <code>"CONTROL"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.HandlingType}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' attribute.
   * @see org.safe.metamodel.safe10.HandlingType
   * @see #isSetType()
   * @see #unsetType()
   * @see #setType(HandlingType)
   * @see org.safe.metamodel.safe10.Safe10Package#getHandle_Type()
   * @model default="CONTROL" unsettable="true" required="true"
   *        annotation="MetaData guid='{7184B1E1-6606-48d0-A493-CBE1B2FF6E6C}' id='1743428840' EA\040name='type'"
   *        extendedMetaData="name='TYPE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TYPES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HandlingType getType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Handle#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' attribute.
   * @see org.safe.metamodel.safe10.HandlingType
   * @see #isSetType()
   * @see #Type()
   * @see #getType()
   * @generated
   */
  void setType(HandlingType value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Handle#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetType()
   * @see #getType()
   * @see #setType(HandlingType)
   * @generated
   */
  void unsetType();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Handle#getType <em>Type</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Type</em>' attribute is set.
   * @see #Type()
   * @see #getType()
   * @see #setType(HandlingType)
   * @generated
   */
  boolean isSetType();

  /**
   * Returns the value of the '<em><b>Handled Situation</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Handled Situation</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Handled Situation</em>' reference.
   * @see #setHandledSituation(Situation)
   * @see org.safe.metamodel.safe10.Safe10Package#getHandle_HandledSituation()
   * @model required="true"
   *        annotation="MetaData guid='{7AE2DCEA-0691-46ae-AD17-614D621799D2}' id='-592327102' EA\040name=''"
   *        extendedMetaData="name='HANDLED-SITUATION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HANDLED-SITUATION-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Situation getHandledSituation();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Handle#getHandledSituation <em>Handled Situation</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Handled Situation</em>' reference.
   * @see #getHandledSituation()
   * @generated
   */
  void setHandledSituation(Situation value);

  /**
   * Returns the value of the '<em><b>Error Situation</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Situation}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Error Situation</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Error Situation</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHandle_ErrorSituation()
   * @model containment="true"
   *        annotation="MetaData guid='{1B612C85-A371-4bf8-9C4D-BDDD817FD3D5}' id='1187332284' EA\040name=''"
   *        extendedMetaData="name='ERROR-SITUATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-SITUATIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Situation> getErrorSituation();

} // Handle
