/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.HardwareComponentType;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hardware Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represent the Safety Extension point for referenced element of Hardware Component Type (respectively from EAST-ADL) to allow the capture of hardware failure and summary failure and analysis results.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.TechnicalSafetyExtension.HardwareSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSafetyExtension#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSafetyExtension#getHardwareSafetyAnalysis <em>Hardware Safety Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSafetyExtension#getRandomHardwareFailure <em>Random Hardware Failure</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSafetyExtension()
 * @model annotation="MetaData guid='{C1942C7F-8F5F-4483-BD9F-670B189341AF}' id='581214117' EA\040name='HardwareSafetyExtension'"
 *        extendedMetaData="name='HARDWARE-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface HardwareSafetyExtension extends TechnicalSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(HardwareComponentType)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSafetyExtension_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{8AF4C2A4-68A5-444c-872D-B6D1AD0E195C}' id='-1448328825' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareComponentType getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSafetyExtension#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(HardwareComponentType value);

  /**
   * Returns the value of the '<em><b>Hardware Safety Analysis</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HardwareFailureAnalysis}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hardware Safety Analysis</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hardware Safety Analysis</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSafetyExtension_HardwareSafetyAnalysis()
   * @model containment="true"
   *        annotation="MetaData guid='{D240B1DE-B86D-411c-943E-099B92A7E9BB}' id='1131506669' EA\040name=''"
   *        extendedMetaData="name='HARDWARE-SAFETY-ANALYSIS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-SAFETY-ANALYSISS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<HardwareFailureAnalysis> getHardwareSafetyAnalysis();

  /**
   * Returns the value of the '<em><b>Random Hardware Failure</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Random Hardware Failure</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Random Hardware Failure</em>' containment reference.
   * @see #setRandomHardwareFailure(HardwareComponentFailure)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSafetyExtension_RandomHardwareFailure()
   * @model containment="true"
   *        annotation="MetaData guid='{DF71C150-D17F-4c92-AD14-A780AED2D79E}' id='-792224996' EA\040name=''"
   *        extendedMetaData="name='RANDOM-HARDWARE-FAILURE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RANDOM-HARDWARE-FAILURES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareComponentFailure getRandomHardwareFailure();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSafetyExtension#getRandomHardwareFailure <em>Random Hardware Failure</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Random Hardware Failure</em>' containment reference.
   * @see #getRandomHardwareFailure()
   * @generated
   */
  void setRandomHardwareFailure(HardwareComponentFailure value);

} // HardwareSafetyExtension
