/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Heartbeat</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A Heartbeat SSR requires that two runnable entities on different nodes are instantiated and one of them monitors the signals arriving from the other one.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Heartbeat.Heartbeat</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Heartbeat#getConfig <em>Config</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Heartbeat#getReceiver <em>Receiver</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Heartbeat#getSender <em>Sender</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeat()
 * @model annotation="MetaData guid='{74F1CD43-E0E2-41cc-9E06-727028C3FCCD}' id='269' EA\040name='Heartbeat'"
 *        extendedMetaData="name='HEARTBEAT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HEARTBEATS'"
 * @generated
 */
public interface Heartbeat extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Config</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Configures the Heartbeat SSR
   * <!-- end-model-doc -->
   * @return the value of the '<em>Config</em>' containment reference.
   * @see #setConfig(HeartbeatConfig)
   * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeat_Config()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{65211D10-8870-40df-9B1E-45AF8A071B1E}' id='-317977007' EA\040name=''"
   *        extendedMetaData="name='CONFIG' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONFIGS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HeartbeatConfig getConfig();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Heartbeat#getConfig <em>Config</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Config</em>' containment reference.
   * @see #getConfig()
   * @generated
   */
  void setConfig(HeartbeatConfig value);

  /**
   * Returns the value of the '<em><b>Receiver</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Contains hearbeet receiver
   * <!-- end-model-doc -->
   * @return the value of the '<em>Receiver</em>' containment reference.
   * @see #setReceiver(HeartbeatReceiver)
   * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeat_Receiver()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{592D9AA6-D377-4c1c-BAA5-498FE86648AD}' id='114' EA\040name=''"
   *        extendedMetaData="name='RECEIVER' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RECEIVERS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  HeartbeatReceiver getReceiver();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Heartbeat#getReceiver <em>Receiver</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Receiver</em>' containment reference.
   * @see #getReceiver()
   * @generated
   */
  void setReceiver(HeartbeatReceiver value);

  /**
   * Returns the value of the '<em><b>Sender</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Contains hearbeet sender SSR
   * <!-- end-model-doc -->
   * @return the value of the '<em>Sender</em>' containment reference.
   * @see #setSender(HeartbeatSender)
   * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeat_Sender()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{788142CD-A59A-41e7-B3FA-AFF6CA4D7496}' id='113' EA\040name=''"
   *        extendedMetaData="name='SENDER' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SENDERS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  HeartbeatSender getSender();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Heartbeat#getSender <em>Sender</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Sender</em>' containment reference.
   * @see #getSender()
   * @generated
   */
  void setSender(HeartbeatSender value);

} // Heartbeat
