/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Implementation Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * null
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.ImplementationSafetyExtension.ImplementationSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ImplementationSafetyExtension#getHardwareSafetyRequirement <em>Hardware Safety Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ImplementationSafetyExtension#getSoftwareRequirement <em>Software Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ImplementationSafetyExtension#getCodeGenerationConfiguration <em>Code Generation Configuration</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getImplementationSafetyExtension()
 * @model annotation="MetaData guid='{B965AD00-5E5B-4de8-9BA0-39B939AD6F8E}' id='377175707' EA\040name='ImplementationSafetyExtension'"
 *        extendedMetaData="name='IMPLEMENTATION-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='IMPLEMENTATION-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface ImplementationSafetyExtension extends SingleLevelSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Hardware Safety Requirement</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HardwareSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hardware Safety Requirement</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hardware Safety Requirement</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getImplementationSafetyExtension_HardwareSafetyRequirement()
   * @model containment="true"
   *        annotation="MetaData guid='{3CE07436-2246-48d6-BA84-54D358724F53}' id='1845259181' EA\040name=''"
   *        extendedMetaData="name='HARDWARE-SAFETY-REQUIREMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-SAFETY-REQUIREMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<HardwareSafetyRequirement> getHardwareSafetyRequirement();

  /**
   * Returns the value of the '<em><b>Software Requirement</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.SoftwareSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Software Requirement</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Software Requirement</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getImplementationSafetyExtension_SoftwareRequirement()
   * @model containment="true"
   *        annotation="MetaData guid='{A74B1799-5609-435a-97BF-027138C6101D}' id='-601169813' EA\040name=''"
   *        extendedMetaData="name='SOFTWARE-REQUIREMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SOFTWARE-REQUIREMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<SoftwareSafetyRequirement> getSoftwareRequirement();

  /**
   * Returns the value of the '<em><b>Code Generation Configuration</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.CodeGenerationConfiguration}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Code Generation Configuration</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Code Generation Configuration</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getImplementationSafetyExtension_CodeGenerationConfiguration()
   * @model containment="true"
   *        annotation="MetaData guid='{10803685-D885-455b-B2C3-9AD087BD3E99}' id='-305936290' EA\040name=''"
   *        extendedMetaData="name='CODE-GENERATION-CONFIGURATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CODE-GENERATION-CONFIGURATIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<CodeGenerationConfiguration> getCodeGenerationConfiguration();

} // ImplementationSafetyExtension
