/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.swcomponent.datatype.dataprototypes.VariableDataPrototype;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Interface CRC</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class is the specialization of the CRC SSR deployed as the property of data elements of a given interface. This means the CRC is a property of the interface and not of a specific instance (realization) of the interface.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CRCChecksum.InterfaceCRC</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.InterfaceCRC#getChecks <em>Checks</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getInterfaceCRC()
 * @model annotation="MetaData guid='{EC132C6A-EC3C-4866-88B2-70C47BF5F0F5}' id='255' EA\040name='InterfaceCRC'"
 *        extendedMetaData="name='INTERFACE-CRC' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INTERFACE-CRCS'"
 * @generated
 */
public interface InterfaceCRC extends AutosarCRC
{
  /**
   * Returns the value of the '<em><b>Checks</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Checks</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Checks</em>' reference.
   * @see #setChecks(VariableDataPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getInterfaceCRC_Checks()
   * @model required="true"
   *        annotation="MetaData guid='{33050A5B-F922-435a-9BEC-D7598B56E2D4}' id='131650278' EA\040name=''"
   *        extendedMetaData="name='CHECKS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECKS-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  VariableDataPrototype getChecks();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.InterfaceCRC#getChecks <em>Checks</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Checks</em>' reference.
   * @see #getChecks()
   * @generated
   */
  void setChecks(VariableDataPrototype value);

} // InterfaceCRC
