/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MFP Operation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The MalfunctionPrototype pointing to an AUTOSAR operation instance
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Malfunction.MFPOperation</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MFPOperation#getOperation <em>Operation</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMFPOperation()
 * @model annotation="MetaData guid='{AD1F7FD9-B103-4a8f-B448-A42306283369}' id='-999059745' EA\040name='MFPOperation'"
 *        extendedMetaData="name='MFP-OPERATION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MFP-OPERATIONS'"
 * @generated
 */
public interface MFPOperation extends MFPSwcPort
{
  /**
   * Returns the value of the '<em><b>Operation</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target operation prototype instance.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Operation</em>' containment reference.
   * @see #setOperation(AutosarClientServerOperationInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getMFPOperation_Operation()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{8AFB1FDF-F00A-4ee6-9B2D-8DB3EAEC9900}' id='-100196109' EA\040name=''"
   *        extendedMetaData="name='OPERATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATIONS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarClientServerOperationInstanceRef getOperation();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MFPOperation#getOperation <em>Operation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Operation</em>' containment reference.
   * @see #getOperation()
   * @generated
   */
  void setOperation(AutosarClientServerOperationInstanceRef value);

} // MFPOperation
