/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MFP Variable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The MalfunctionPrototype pointing to an AUTOSAR variable instance
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Malfunction.MFPVariable</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MFPVariable#getVariable <em>Variable</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMFPVariable()
 * @model annotation="MetaData guid='{CD7D4793-76C0-442f-9FC9-F0F70C907351}' id='1663902336' EA\040name='MFPVariable'"
 *        extendedMetaData="name='MFP-VARIABLE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MFP-VARIABLES'"
 * @generated
 */
public interface MFPVariable extends MFPSwcPort
{
  /**
   * Returns the value of the '<em><b>Variable</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target variable data prototype instance.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Variable</em>' containment reference.
   * @see #setVariable(AutosarVariableDataPrototypeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getMFPVariable_Variable()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{98054EEF-D604-43b7-88E3-31A496BCEC7C}' id='-980578034' EA\040name=''"
   *        extendedMetaData="name='VARIABLE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VARIABLES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarVariableDataPrototypeInstanceRef getVariable();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MFPVariable#getVariable <em>Variable</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Variable</em>' containment reference.
   * @see #getVariable()
   * @generated
   */
  void setVariable(AutosarVariableDataPrototypeInstanceRef value);

} // MFPVariable
