/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MT Composite</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This composite malfunction type allows to define the different ways, how the malfunction becomes visible. As a typical example, a composite malfunction type could have the elements "commission" and "omission".
 * 
 * BrakeMalfunctionType (type: MTComposite):
 * 
 * - BrakePressureTooLow (type: MTPrimitive):
 * 
 * Semantics="brake pressure is below 20% of requested value"
 * 
 * - Omission (type: MTPrimitive):
 * 
 * Semantics="brake pressure is below 10% of maximal brake pressure"
 * 
 * - Commission (type: MTPrimitive):
 * 
 * Semantics="brake pressure exceeds requested value with more than 10% of maximal brake pressure".
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Malfunction.MTComposite</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MTComposite#getElement <em>Element</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMTComposite()
 * @model annotation="MetaData guid='{9C299DCD-63CD-47c6-BA62-B20E19B189B4}' id='711607062' EA\040name='MTComposite'"
 *        extendedMetaData="name='MT-COMPOSITE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MT-COMPOSITES'"
 * @generated
 */
public interface MTComposite extends MalfunctionType
{
  /**
   * Returns the value of the '<em><b>Element</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.MTCompositeElementPrototype}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Elements of the composite malfunction type.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Element</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getMTComposite_Element()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{1971733D-E10D-41c8-B55C-AF4EA4FB39CD}' id='354379297' EA\040name=''"
   *        extendedMetaData="name='ELEMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ELEMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<MTCompositeElementPrototype> getElement();

} // MTComposite
