/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Operating Mode</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The Operating Mode is, according to ISO 26262, a perceivable functional state of an item or element. Therefore, it is associated with the item. Moreover, it is associated with the risk description since it describes a state of the item.
 * 
 * <i><u>Reference:</u></i>
 * ISO26262-1-1-81
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hazards.OperatingMode</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.OperatingMode#getSafetyRelated <em>Safety Related</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getOperatingMode()
 * @model annotation="MetaData guid='{10219929-E2B9-4b52-A06A-91EE2C2AB8C7}' id='542677297' EA\040name='OperatingMode'"
 *        extendedMetaData="name='OPERATING-MODE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATING-MODES'"
 * @generated
 */
public interface OperatingMode extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Safety Related</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Safety Related</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Safety Related</em>' attribute.
   * @see #isSetSafetyRelated()
   * @see #unsetSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @see org.safe.metamodel.safe10.Safe10Package#getOperatingMode_SafetyRelated()
   * @model default="false" unsettable="true" dataType="org.safe.metamodel.safe10.Boolean" required="true"
   *        annotation="MetaData guid='{E98C43EC-6E6A-42a5-A891-2C9CC671ECBA}' id='1151314092' EA\040name='safetyRelated'"
   *        extendedMetaData="name='SAFETY-RELATED' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-RELATEDS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Boolean getSafetyRelated();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.OperatingMode#getSafetyRelated <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Safety Related</em>' attribute.
   * @see #isSetSafetyRelated()
   * @see #SafetyRelated()
   * @see #getSafetyRelated()
   * @generated
   */
  void setSafetyRelated(Boolean value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.OperatingMode#getSafetyRelated <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetSafetyRelated()
   * @see #getSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @generated
   */
  void unsetSafetyRelated();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.OperatingMode#getSafetyRelated <em>Safety Related</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Safety Related</em>' attribute is set.
   * @see #SafetyRelated()
   * @see #getSafetyRelated()
   * @see #setSafetyRelated(Boolean)
   * @generated
   */
  boolean isSetSafetyRelated();

} // OperatingMode
