/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Quantified Diagnostic Coverage Property</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * QuantifiedHWDiagnosticCoverageProperty defines the diagnostic coverage information for a given AbstractQuantifiableSafetyRequirement.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.QuantifiedDiagnosticCoverageProperty</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getFaultType <em>Fault Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getDcValue <em>Dc Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getContext <em>Context</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedDiagnosticCoverageProperty()
 * @model annotation="MetaData guid='{879FEB18-12FF-43e0-BD1B-5B6EF10C6074}' id='-56529445' EA\040name='QuantifiedDiagnosticCoverageProperty'"
 *        extendedMetaData="name='QUANTIFIED-DIAGNOSTIC-COVERAGE-PROPERTY' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='QUANTIFIED-DIAGNOSTIC-COVERAGE-PROPERTYS'"
 * @generated
 */
public interface QuantifiedDiagnosticCoverageProperty extends EObject
{
  /**
   * Returns the value of the '<em><b>Fault Type</b></em>' attribute.
   * The default value is <code>"RESIDUALFAULT"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fault Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fault Type</em>' attribute.
   * @see org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum
   * @see #isSetFaultType()
   * @see #unsetFaultType()
   * @see #setFaultType(DiagnosticCoverageTypeEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedDiagnosticCoverageProperty_FaultType()
   * @model default="RESIDUALFAULT" unsettable="true" required="true"
   *        annotation="MetaData guid='{5D3132C9-4500-40da-8696-1F46D39F031A}' id='-858269518' EA\040name='faultType'"
   *        extendedMetaData="name='FAULT-TYPE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FAULT-TYPES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  DiagnosticCoverageTypeEnum getFaultType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getFaultType <em>Fault Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fault Type</em>' attribute.
   * @see org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum
   * @see #isSetFaultType()
   * @see #FaultType()
   * @see #getFaultType()
   * @generated
   */
  void setFaultType(DiagnosticCoverageTypeEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getFaultType <em>Fault Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFaultType()
   * @see #getFaultType()
   * @see #setFaultType(DiagnosticCoverageTypeEnum)
   * @generated
   */
  void unsetFaultType();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getFaultType <em>Fault Type</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Fault Type</em>' attribute is set.
   * @see #FaultType()
   * @see #getFaultType()
   * @see #setFaultType(DiagnosticCoverageTypeEnum)
   * @generated
   */
  boolean isSetFaultType();

  /**
   * Returns the value of the '<em><b>Dc Value</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Dc Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Dc Value</em>' attribute.
   * @see #isSetDcValue()
   * @see #unsetDcValue()
   * @see #setDcValue(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedDiagnosticCoverageProperty_DcValue()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{7C9C88B5-C809-4869-93E6-6AFAF5E714A0}' id='555811659' EA\040name='dcValue'"
   *        extendedMetaData="name='DC-VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DC-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getDcValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getDcValue <em>Dc Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Dc Value</em>' attribute.
   * @see #isSetDcValue()
   * @see #DcValue()
   * @see #getDcValue()
   * @generated
   */
  void setDcValue(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getDcValue <em>Dc Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDcValue()
   * @see #getDcValue()
   * @see #setDcValue(Double)
   * @generated
   */
  void unsetDcValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getDcValue <em>Dc Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Dc Value</em>' attribute is set.
   * @see #DcValue()
   * @see #getDcValue()
   * @see #setDcValue(Double)
   * @generated
   */
  boolean isSetDcValue();

  /**
   * Returns the value of the '<em><b>Context</b></em>' attribute.
   * The default value is <code>"HW"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.DiagnosticCoverageContextEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Context</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Context</em>' attribute.
   * @see org.safe.metamodel.safe10.DiagnosticCoverageContextEnum
   * @see #isSetContext()
   * @see #unsetContext()
   * @see #setContext(DiagnosticCoverageContextEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedDiagnosticCoverageProperty_Context()
   * @model default="HW" unsettable="true" required="true"
   *        annotation="MetaData guid='{0C058158-CF48-404b-A053-88BC6C12788E}' id='-1267664011' EA\040name='context'"
   *        extendedMetaData="name='CONTEXT' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  DiagnosticCoverageContextEnum getContext();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getContext <em>Context</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Context</em>' attribute.
   * @see org.safe.metamodel.safe10.DiagnosticCoverageContextEnum
   * @see #isSetContext()
   * @see #Context()
   * @see #getContext()
   * @generated
   */
  void setContext(DiagnosticCoverageContextEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getContext <em>Context</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetContext()
   * @see #getContext()
   * @see #setContext(DiagnosticCoverageContextEnum)
   * @generated
   */
  void unsetContext();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty#getContext <em>Context</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Context</em>' attribute is set.
   * @see #Context()
   * @see #getContext()
   * @see #setContext(DiagnosticCoverageContextEnum)
   * @generated
   */
  boolean isSetContext();

} // QuantifiedDiagnosticCoverageProperty
