/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Quantified HW Property</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * QuantifiedHWProperty specifies the quantitative properties for a given AbstractQuantifiableSafetyRequirement
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.QuantifiedHWProperty</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getMetric <em>Metric</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getRational <em>Rational</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getUnit <em>Unit</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedHWProperty()
 * @model annotation="MetaData guid='{2CECB652-620F-48a4-ABB2-D7251F3FA638}' id='892567333' EA\040name='QuantifiedHWProperty'"
 *        extendedMetaData="name='QUANTIFIED-HW-PROPERTY' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='QUANTIFIED-HW-PROPERTYS'"
 * @generated
 */
public interface QuantifiedHWProperty extends EObject
{
  /**
   * Returns the value of the '<em><b>Metric</b></em>' attribute.
   * The default value is <code>"SINGLEPOINTFAULT"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.HWFaultMetricsEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metric</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metric</em>' attribute.
   * @see org.safe.metamodel.safe10.HWFaultMetricsEnum
   * @see #isSetMetric()
   * @see #unsetMetric()
   * @see #setMetric(HWFaultMetricsEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedHWProperty_Metric()
   * @model default="SINGLEPOINTFAULT" unsettable="true" required="true"
   *        annotation="MetaData guid='{C54E1112-EE91-429e-85FB-D6697EAD977C}' id='798721437' EA\040name='metric'"
   *        extendedMetaData="name='METRIC' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='METRICS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWFaultMetricsEnum getMetric();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getMetric <em>Metric</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metric</em>' attribute.
   * @see org.safe.metamodel.safe10.HWFaultMetricsEnum
   * @see #isSetMetric()
   * @see #Metric()
   * @see #getMetric()
   * @generated
   */
  void setMetric(HWFaultMetricsEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getMetric <em>Metric</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMetric()
   * @see #getMetric()
   * @see #setMetric(HWFaultMetricsEnum)
   * @generated
   */
  void unsetMetric();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getMetric <em>Metric</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Metric</em>' attribute is set.
   * @see #Metric()
   * @see #getMetric()
   * @see #setMetric(HWFaultMetricsEnum)
   * @generated
   */
  boolean isSetMetric();

  /**
   * Returns the value of the '<em><b>Rational</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Rational</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rational</em>' attribute.
   * @see #isSetRational()
   * @see #unsetRational()
   * @see #setRational(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedHWProperty_Rational()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{7F4F2556-EA58-44d2-BBB3-5B2D5E00069E}' id='782338714' EA\040name='rational'"
   *        extendedMetaData="name='RATIONAL' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONALS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRational();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getRational <em>Rational</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rational</em>' attribute.
   * @see #isSetRational()
   * @see #Rational()
   * @see #getRational()
   * @generated
   */
  void setRational(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getRational <em>Rational</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRational()
   * @see #getRational()
   * @see #setRational(String)
   * @generated
   */
  void unsetRational();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getRational <em>Rational</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rational</em>' attribute is set.
   * @see #Rational()
   * @see #getRational()
   * @see #setRational(String)
   * @generated
   */
  boolean isSetRational();

  /**
   * Returns the value of the '<em><b>Unit</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Unit</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Unit</em>' attribute.
   * @see #isSetUnit()
   * @see #unsetUnit()
   * @see #setUnit(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedHWProperty_Unit()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{B23D15CF-8167-4528-8E3B-D99531663FAC}' id='2037102867' EA\040name='unit'"
   *        extendedMetaData="name='UNIT' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='UNITS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getUnit();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getUnit <em>Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Unit</em>' attribute.
   * @see #isSetUnit()
   * @see #Unit()
   * @see #getUnit()
   * @generated
   */
  void setUnit(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getUnit <em>Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetUnit()
   * @see #getUnit()
   * @see #setUnit(String)
   * @generated
   */
  void unsetUnit();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getUnit <em>Unit</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Unit</em>' attribute is set.
   * @see #Unit()
   * @see #getUnit()
   * @see #setUnit(String)
   * @generated
   */
  boolean isSetUnit();

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #isSetValue()
   * @see #unsetValue()
   * @see #setValue(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantifiedHWProperty_Value()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{14805159-DDFE-4dd0-B336-A4621842B664}' id='1173789272' EA\040name='value'"
   *        extendedMetaData="name='VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #isSetValue()
   * @see #Value()
   * @see #getValue()
   * @generated
   */
  void setValue(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetValue()
   * @see #getValue()
   * @see #setValue(Double)
   * @generated
   */
  void unsetValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.QuantifiedHWProperty#getValue <em>Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Value</em>' attribute is set.
   * @see #Value()
   * @see #getValue()
   * @see #setValue(Double)
   * @generated
   */
  boolean isSetValue();

} // QuantifiedHWProperty
