/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Requirements Link</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * RequirementsLink is owned by requirement. It is used to establish links between requirements. The type of the link is determined by the RequirementsLinkType.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.RequirementsLink</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.RequirementsLink#getRequirementsLinkType <em>Requirements Link Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.RequirementsLink#getLinkedRequirement <em>Linked Requirement</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getRequirementsLink()
 * @model annotation="MetaData guid='{73DD9EF2-BE12-4ac2-AEA1-58D6D6D243EC}' id='-936789172' EA\040name='RequirementsLink'"
 *        extendedMetaData="name='REQUIREMENTS-LINK' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS-LINKS'"
 * @generated
 */
public interface RequirementsLink extends EObject
{
  /**
   * Returns the value of the '<em><b>Requirements Link Type</b></em>' attribute.
   * The default value is <code>"COVERS"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.RequirementsLinkTypeEnum}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The type of the link between requirements is determined by the RequirementsLinkType.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Requirements Link Type</em>' attribute.
   * @see org.safe.metamodel.safe10.RequirementsLinkTypeEnum
   * @see #isSetRequirementsLinkType()
   * @see #unsetRequirementsLinkType()
   * @see #setRequirementsLinkType(RequirementsLinkTypeEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getRequirementsLink_RequirementsLinkType()
   * @model default="COVERS" unsettable="true" required="true"
   *        annotation="MetaData guid='{656985AB-C732-497c-9C00-2D1AD6433CEC}' id='77345885' EA\040name='requirementsLinkType'"
   *        extendedMetaData="name='REQUIREMENTS-LINK-TYPE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS-LINK-TYPES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  RequirementsLinkTypeEnum getRequirementsLinkType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RequirementsLink#getRequirementsLinkType <em>Requirements Link Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Requirements Link Type</em>' attribute.
   * @see org.safe.metamodel.safe10.RequirementsLinkTypeEnum
   * @see #isSetRequirementsLinkType()
   * @see #RequirementsLinkType()
   * @see #getRequirementsLinkType()
   * @generated
   */
  void setRequirementsLinkType(RequirementsLinkTypeEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.RequirementsLink#getRequirementsLinkType <em>Requirements Link Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRequirementsLinkType()
   * @see #getRequirementsLinkType()
   * @see #setRequirementsLinkType(RequirementsLinkTypeEnum)
   * @generated
   */
  void unsetRequirementsLinkType();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.RequirementsLink#getRequirementsLinkType <em>Requirements Link Type</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Requirements Link Type</em>' attribute is set.
   * @see #RequirementsLinkType()
   * @see #getRequirementsLinkType()
   * @see #setRequirementsLinkType(RequirementsLinkTypeEnum)
   * @generated
   */
  boolean isSetRequirementsLinkType();

  /**
   * Returns the value of the '<em><b>Linked Requirement</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.AbstractSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Linked Requirement</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Linked Requirement</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getRequirementsLink_LinkedRequirement()
   * @model annotation="MetaData guid='{95AD6EB5-2A82-4621-B425-D88DB9586D05}' id='-1480929985' EA\040name=''"
   *        extendedMetaData="name='LINKED-REQUIREMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='LINKED-REQUIREMENT-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<AbstractSafetyRequirement> getLinkedRequirement();

} // RequirementsLink
