/**
 */
package org.safe.metamodel.safe10;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Requirements Link Type Enum</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * RequirementsLinkType defines the type of the link between requirements.
 * Covers: The requirement which owns a link of this type covers the linked requirements
 * Refines: The requirement which owns a link of this type refines the linked requirements
 * Conflicts: The requirement which owns a link of this type conflicts with the linked requirements
 * Decomposes: The requirement which owns a link of this type decomposes the linked requirements
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.RequirementsLinkTypeEnum</b></em> 
 * <!-- end-model-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package#getRequirementsLinkTypeEnum()
 * @model annotation="MetaData guid='{7BA358EA-88F8-4d1b-8734-356CBAED84CA}' id='1627325907' EA\040name='RequirementsLinkTypeEnum'"
 *        annotation="Stereotype Stereotype='enumeration'"
 *        extendedMetaData="name='REQUIREMENTS-LINK-TYPE-ENUM'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS-LINK-TYPE-ENUMS'"
 * @generated
 */
public enum RequirementsLinkTypeEnum implements Enumerator
{
  /**
   * The '<em><b>Covers</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #COVERS_VALUE
   * @generated
   * @ordered
   */
  COVERS(0, "Covers", "COVERS"),

  /**
   * The '<em><b>Refines</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #REFINES_VALUE
   * @generated
   * @ordered
   */
  REFINES(1, "Refines", "REFINES"),

  /**
   * The '<em><b>Conflicts</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CONFLICTS_VALUE
   * @generated
   * @ordered
   */
  CONFLICTS(2, "Conflicts", "CONFLICTS"),

  /**
   * The '<em><b>Decomposes</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #DECOMPOSES_VALUE
   * @generated
   * @ordered
   */
  DECOMPOSES(3, "Decomposes", "DECOMPOSES");

  /**
   * The '<em><b>Covers</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Covers</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #COVERS
   * @model name="Covers" literal="COVERS"
   * @generated
   * @ordered
   */
  public static final int COVERS_VALUE = 0;

  /**
   * The '<em><b>Refines</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Refines</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #REFINES
   * @model name="Refines" literal="REFINES"
   * @generated
   * @ordered
   */
  public static final int REFINES_VALUE = 1;

  /**
   * The '<em><b>Conflicts</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Conflicts</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #CONFLICTS
   * @model name="Conflicts" literal="CONFLICTS"
   * @generated
   * @ordered
   */
  public static final int CONFLICTS_VALUE = 2;

  /**
   * The '<em><b>Decomposes</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Decomposes</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #DECOMPOSES
   * @model name="Decomposes" literal="DECOMPOSES"
   * @generated
   * @ordered
   */
  public static final int DECOMPOSES_VALUE = 3;

  /**
   * An array of all the '<em><b>Requirements Link Type Enum</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final RequirementsLinkTypeEnum[] VALUES_ARRAY =
    new RequirementsLinkTypeEnum[]
    {
      COVERS,
      REFINES,
      CONFLICTS,
      DECOMPOSES,
    };

  /**
   * A public read-only list of all the '<em><b>Requirements Link Type Enum</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<RequirementsLinkTypeEnum> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Requirements Link Type Enum</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static RequirementsLinkTypeEnum get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      RequirementsLinkTypeEnum result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Requirements Link Type Enum</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static RequirementsLinkTypeEnum getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      RequirementsLinkTypeEnum result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Requirements Link Type Enum</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static RequirementsLinkTypeEnum get(int value)
  {
    switch (value)
    {
      case COVERS_VALUE: return COVERS;
      case REFINES_VALUE: return REFINES;
      case CONFLICTS_VALUE: return CONFLICTS;
      case DECOMPOSES_VALUE: return DECOMPOSES;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private RequirementsLinkTypeEnum(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //RequirementsLinkTypeEnum
