/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Restrictable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A RestrictableElement allows connecting SAFE model elements with variant information.
 * 
 * The identified element, pointed to by  VariableElement of the class RestrictableElement, is part of a variant if at least one of the defined restrictions evaluate to true.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Configuration.Restrictable</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Restrictable#getVariableElement <em>Variable Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Restrictable#getResSet <em>Res Set</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getRestrictable()
 * @model annotation="MetaData guid='{9E0EEB68-FDDD-47b4-A23D-7E93B53E5E9D}' id='218098432' EA\040name='Restrictable'"
 *        extendedMetaData="name='RESTRICTABLE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RESTRICTABLES'"
 * @generated
 */
public interface Restrictable extends PackageableElement
{
  /**
   * Returns the value of the '<em><b>Variable Element</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Variable Element</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Variable Element</em>' reference.
   * @see #setVariableElement(Identifiable)
   * @see org.safe.metamodel.safe10.Safe10Package#getRestrictable_VariableElement()
   * @model required="true"
   *        annotation="MetaData guid='{093FE626-E7E4-41de-8B61-CCAA756A9B8E}' id='-593614770' EA\040name=''"
   *        extendedMetaData="name='VARIABLE-ELEMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VARIABLE-ELEMENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Identifiable getVariableElement();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Restrictable#getVariableElement <em>Variable Element</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Variable Element</em>' reference.
   * @see #getVariableElement()
   * @generated
   */
  void setVariableElement(Identifiable value);

  /**
   * Returns the value of the '<em><b>Res Set</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Restriction}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Res Set</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Res Set</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getRestrictable_ResSet()
   * @model containment="true"
   *        annotation="MetaData guid='{6449FF76-7630-435f-9CC6-84897D4C0626}' id='1718619590' EA\040name=''"
   *        extendedMetaData="name='RES-SET' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RES-SETS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Restriction> getResSet();

} // Restrictable
