/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Restriction</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A Restriction defines an expression that can be evaluated to true or false.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Configuration.Restriction</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Restriction#getExpression <em>Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getRestriction()
 * @model annotation="MetaData guid='{13FFF141-F8F5-4bc1-88F2-BD05BEBBA2E9}' id='-165785855' EA\040name='Restriction'"
 *        extendedMetaData="name='RESTRICTION' kind='simple'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RESTRICTIONS'"
 * @generated
 */
public interface Restriction extends EObject
{
  /**
   * Returns the value of the '<em><b>Expression</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Expression</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Expression</em>' attribute.
   * @see #isSetExpression()
   * @see #unsetExpression()
   * @see #setExpression(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getRestriction_Expression()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{7C0DB854-94EC-4745-ABE5-6CB9ED499623}' id='-108082898' EA\040name='expression'"
   *        extendedMetaData="name='EXPRESSION' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXPRESSIONS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getExpression();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Restriction#getExpression <em>Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Expression</em>' attribute.
   * @see #isSetExpression()
   * @see #Expression()
   * @see #getExpression()
   * @generated
   */
  void setExpression(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Restriction#getExpression <em>Expression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetExpression()
   * @see #getExpression()
   * @see #setExpression(String)
   * @generated
   */
  void unsetExpression();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Restriction#getExpression <em>Expression</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Expression</em>' attribute is set.
   * @see #Expression()
   * @see #getExpression()
   * @see #setExpression(String)
   * @generated
   */
  boolean isSetExpression();

} // Restriction
