/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Risk Description</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Description how the malfunction contributes to the hazardous event
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hazards.RiskDescription</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.RiskDescription#getInvolvedMalfunction <em>Involved Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.RiskDescription#getHazardousEvent <em>Hazardous Event</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.RiskDescription#getInvolvedFunction <em>Involved Function</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getRiskDescription()
 * @model annotation="MetaData guid='{07F235C9-216A-4d9c-A37A-982AA062C087}' id='15910334' EA\040name='RiskDescription'"
 *        extendedMetaData="name='RISK-DESCRIPTION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RISK-DESCRIPTIONS'"
 * @generated
 */
public interface RiskDescription extends TraceableSpecification
{
  /**
   * Returns the value of the '<em><b>Involved Malfunction</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Involved Malfunction</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Involved Malfunction</em>' reference.
   * @see #setInvolvedMalfunction(MalfunctionPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getRiskDescription_InvolvedMalfunction()
   * @model annotation="MetaData guid='{4FEDBC0B-EBBB-463e-93F6-73E72CFB825A}' id='-1470960725' EA\040name=''"
   *        extendedMetaData="name='INVOLVED-MALFUNCTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INVOLVED-MALFUNCTION-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  MalfunctionPrototype getInvolvedMalfunction();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RiskDescription#getInvolvedMalfunction <em>Involved Malfunction</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Involved Malfunction</em>' reference.
   * @see #getInvolvedMalfunction()
   * @generated
   */
  void setInvolvedMalfunction(MalfunctionPrototype value);

  /**
   * Returns the value of the '<em><b>Hazardous Event</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hazardous Event</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hazardous Event</em>' reference.
   * @see #setHazardousEvent(HazardousEvent)
   * @see org.safe.metamodel.safe10.Safe10Package#getRiskDescription_HazardousEvent()
   * @model required="true"
   *        annotation="MetaData guid='{9F986FE4-7CAE-406c-946F-81F1C844E3F3}' id='-368111856' EA\040name=''"
   *        extendedMetaData="name='HAZARDOUS-EVENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HAZARDOUS-EVENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HazardousEvent getHazardousEvent();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RiskDescription#getHazardousEvent <em>Hazardous Event</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hazardous Event</em>' reference.
   * @see #getHazardousEvent()
   * @generated
   */
  void setHazardousEvent(HazardousEvent value);

  /**
   * Returns the value of the '<em><b>Involved Function</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Involved Function</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Involved Function</em>' reference.
   * @see #setInvolvedFunction(ItemFunctionDescription)
   * @see org.safe.metamodel.safe10.Safe10Package#getRiskDescription_InvolvedFunction()
   * @model annotation="MetaData guid='{7B86C7E3-A8BA-4cc7-86A4-2D1B0858936C}' id='476665115' EA\040name=''"
   *        extendedMetaData="name='INVOLVED-FUNCTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INVOLVED-FUNCTION-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ItemFunctionDescription getInvolvedFunction();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RiskDescription#getInvolvedFunction <em>Involved Function</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Involved Function</em>' reference.
   * @see #getInvolvedFunction()
   * @generated
   */
  void setInvolvedFunction(ItemFunctionDescription value);

} // RiskDescription
