/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SAFE Package</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Used for organization of the packageable elements in the model.
 * 
 * Semantics:
 * SAFEPackages can be organized hierarchically, where each level may contain a number of SAFEPackageableElements.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.TopLevel.SAFEPackage</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.SAFEPackage#getElement <em>Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SAFEPackage#getSubPackage <em>Sub Package</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSAFEPackage()
 * @model annotation="MetaData guid='{4AC74F0F-7022-4ecb-ACC0-ADC0FC347B96}' id='-1635944548' EA\040name='SAFEPackage'"
 *        extendedMetaData="name='SAFE-PACKAGE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFE-PACKAGES'"
 * @generated
 */
public interface SAFEPackage extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Element</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.PackageableElement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Element</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Element</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSAFEPackage_Element()
   * @model containment="true"
   *        annotation="MetaData guid='{A303F1EC-A98B-4745-A115-888FF086A898}' id='-1027629468' EA\040name=''"
   *        annotation="Stereotype Stereotype='splittable'"
   *        extendedMetaData="name='ELEMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ELEMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<PackageableElement> getElement();

  /**
   * Returns the value of the '<em><b>Sub Package</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.SAFEPackage}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Sub Package</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Sub Package</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSAFEPackage_SubPackage()
   * @model containment="true"
   *        annotation="MetaData guid='{B581827D-8518-4b64-BAD7-3C656DEB9276}' id='2076739137' EA\040name=''"
   *        annotation="Stereotype Stereotype='splittable'"
   *        extendedMetaData="name='SUB-PACKAGE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SUB-PACKAGES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<SAFEPackage> getSubPackage();

} // SAFEPackage
