/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Safe State</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The safe state is defined as an operating mode of an item without an unreasonable level of risk.
 * The safe state shall be reached within the allocated FaultTolerantTimeInterval.
 * In case that the safe state is defiened for a emergency operation it shall be reached within the EmergencyOperationTimeInterval.
 * 
 * <i><u>Reference:</u></i>
 * <i>ISO 26262-1-1.102</i>
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hazards.SafeState</b></em> 
 * <!-- end-model-doc -->
 *
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSafeState()
 * @model annotation="MetaData guid='{609881EF-E11F-40cb-8211-020AB73F01ED}' id='771901005' EA\040name='SafeState'"
 *        extendedMetaData="name='SAFE-STATE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFE-STATES'"
 * @generated
 */
public interface SafeState extends Identifiable
{
} // SafeState
