/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Safety Case</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Defines safety case as defined in ISO26262.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SafetyCase.SafetyCase</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getElementType <em>Element Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getAssumption <em>Assumption</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getContext <em>Context</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getGoal <em>Goal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getJustification <em>Justification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getSolution <em>Solution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.SafetyCase#getStrategy <em>Strategy</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase()
 * @model annotation="MetaData guid='{EE8AA2E1-D1EB-49bd-B1C6-F075EED52532}' id='1354021919' EA\040name='SafetyCase'"
 *        extendedMetaData="name='SAFETY-CASE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-CASES'"
 * @generated
 */
public interface SafetyCase extends EObject
{
  /**
   * Returns the value of the '<em><b>Element Type</b></em>' attribute.
   * The default value is <code>"UNKNOWN"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.SafeElementType}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Element Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Element Type</em>' attribute.
   * @see org.safe.metamodel.safe10.SafeElementType
   * @see #isSetElementType()
   * @see #unsetElementType()
   * @see #setElementType(SafeElementType)
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_ElementType()
   * @model default="UNKNOWN" unsettable="true" required="true"
   *        annotation="MetaData guid='{592FB376-2B61-4ea9-8DB7-9DBFD21C3FA3}' id='1838914405' EA\040name='elementType'"
   *        extendedMetaData="name='ELEMENT-TYPE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ELEMENT-TYPES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  SafeElementType getElementType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.SafetyCase#getElementType <em>Element Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Element Type</em>' attribute.
   * @see org.safe.metamodel.safe10.SafeElementType
   * @see #isSetElementType()
   * @see #ElementType()
   * @see #getElementType()
   * @generated
   */
  void setElementType(SafeElementType value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.SafetyCase#getElementType <em>Element Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetElementType()
   * @see #getElementType()
   * @see #setElementType(SafeElementType)
   * @generated
   */
  void unsetElementType();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.SafetyCase#getElementType <em>Element Type</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Element Type</em>' attribute is set.
   * @see #ElementType()
   * @see #getElementType()
   * @see #setElementType(SafeElementType)
   * @generated
   */
  boolean isSetElementType();

  /**
   * Returns the value of the '<em><b>Assumption</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Assumption}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Assumption</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Assumption</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_Assumption()
   * @model containment="true"
   *        annotation="MetaData guid='{1BA01DAB-0923-4bd0-8BD9-4D682AE3B71C}' id='88116979' EA\040name=''"
   *        extendedMetaData="name='ASSUMPTION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ASSUMPTIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Assumption> getAssumption();

  /**
   * Returns the value of the '<em><b>Context</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Context}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Context</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Context</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_Context()
   * @model containment="true"
   *        annotation="MetaData guid='{4A7EAE96-72EC-4f92-9128-5B6BF300A5A7}' id='713519800' EA\040name=''"
   *        extendedMetaData="name='CONTEXT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Context> getContext();

  /**
   * Returns the value of the '<em><b>Goal</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Goal}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Goal</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Goal</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_Goal()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{6B1096BA-931D-44ea-93D0-4E46086F5E32}' id='793922540' EA\040name=''"
   *        extendedMetaData="name='GOAL' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='GOALS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Goal> getGoal();

  /**
   * Returns the value of the '<em><b>Justification</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Justification}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Justification</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Justification</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_Justification()
   * @model containment="true"
   *        annotation="MetaData guid='{8D50796C-A6F2-4075-AE2C-EB8F4B5B214B}' id='-1599250307' EA\040name=''"
   *        extendedMetaData="name='JUSTIFICATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='JUSTIFICATIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Justification> getJustification();

  /**
   * Returns the value of the '<em><b>Solution</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Solution}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Solution</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Solution</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_Solution()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{4DF43BEF-A3D9-449d-BE56-CA348DA3A46B}' id='-585522825' EA\040name=''"
   *        extendedMetaData="name='SOLUTION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SOLUTIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Solution> getSolution();

  /**
   * Returns the value of the '<em><b>Strategy</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Strategy}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Strategy</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Strategy</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyCase_Strategy()
   * @model containment="true"
   *        annotation="MetaData guid='{E6BCE3FA-8BDD-4db0-811D-3B7FD37F1A9A}' id='1902789626' EA\040name=''"
   *        extendedMetaData="name='STRATEGY' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='STRATEGYS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Strategy> getStrategy();

} // SafetyCase
