/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The abstract parent class of the different abstraction-level specific safety extensions.
 * 
 * Depending on the specific level of abstraction (HazardRiskModel, FunctionalSafetyExtension, TechnicalSafetyExtension, ...), the following restriction apply:
 * - the subtypes of AbstractSafetyRequirement (TechnicalSafetyRequirement, FunctionalSafetyRequirement, SafetyGoal, HW/SWSafetyRequirement) shall be used in the respective level of abstraction via the "requirements" relation of the safety extension
 * - the error model associated with the safety extension via the "erroModel" relation shall only allow to reference system model artifacts which are visibly at the level of abstraction of the safety extension (e.g. an AUTOSAR software component is not visible in the HazardandRiskModel) 
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.SafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.SafetyExtension#getRequirementsRelationship <em>Requirements Relationship</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSafetyExtension()
 * @model abstract="true"
 *        annotation="MetaData guid='{86040A33-0428-4836-BE2E-6115D3C1348C}' id='1375250537' EA\040name='SafetyExtension'"
 *        annotation="Stereotype Stereotype='abstract'"
 *        extendedMetaData="name='SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-EXTENSIONS'"
 * @generated
 */
public interface SafetyExtension extends SAFEElement
{
  /**
   * Returns the value of the '<em><b>Requirements Relationship</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.RequirementsReleationship}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirements Relationship</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirements Relationship</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSafetyExtension_RequirementsRelationship()
   * @model containment="true"
   *        annotation="MetaData guid='{4F477057-3007-473f-8E54-667070B98070}' id='1276286176' EA\040name=''"
   *        extendedMetaData="name='REQUIREMENTS-RELATIONSHIP' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS-RELATIONSHIPS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<RequirementsReleationship> getRequirementsRelationship();

} // SafetyExtension
