/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Tactic</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The Tactic element is responsible for defining the role a given requirement has regarding error management. Three kinds of tactic are allowed for requirements, namely, avoid, detect and handle. The tactic also refers to the malfunction being avoided, detected or handled.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.Tactic.Tactic</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Tactic#getMalfunction <em>Malfunction</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getTactic()
 * @model abstract="true"
 *        annotation="MetaData guid='{D54349D2-214E-49db-929B-C279816450FC}' id='1360039323' EA\040name='Tactic'"
 *        extendedMetaData="name='TACTIC' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TACTICS'"
 * @generated
 */
public interface Tactic extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Malfunction</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Malfunction</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Malfunction</em>' containment reference.
   * @see #setMalfunction(MalfunctionInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getTactic_Malfunction()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{3BA75016-7D62-46b5-8205-106E488FF40F}' id='526482481' EA\040name=''"
   *        annotation="TaggedValues xml.name='MALFUNCTION-IREF' xml.namePlural='MALFUNCTION-IREFS' xml.roleElement='true' xml.typeElement='false' xml.typeWrapperElement='false'"
   *        extendedMetaData="name='MALFUNCTION-IREF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MALFUNCTION-IREFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  MalfunctionInstanceRef getMalfunction();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Tactic#getMalfunction <em>Malfunction</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Malfunction</em>' containment reference.
   * @see #getMalfunction()
   * @generated
   */
  void setMalfunction(MalfunctionInstanceRef value);

} // Tactic
