/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Traceable Specification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Abstract superclass for elements which can be traces (e.g. Requirements)
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.TraceableSpecification</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.TraceableSpecification#getFormal <em>Formal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.TraceableSpecification#getInformal <em>Informal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.TraceableSpecification#getStakeholder <em>Stakeholder</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getTraceableSpecification()
 * @model abstract="true"
 *        annotation="MetaData guid='{AA0EDB29-34DC-46cb-B8E2-B2D435B09097}' id='1617139173' EA\040name='TraceableSpecification'"
 *        annotation="Stereotype Stereotype='abstract'"
 *        extendedMetaData="name='TRACEABLE-SPECIFICATION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TRACEABLE-SPECIFICATIONS'"
 * @generated
 */
public interface TraceableSpecification extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Formal</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Formal</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Formal</em>' attribute.
   * @see #isSetFormal()
   * @see #unsetFormal()
   * @see #setFormal(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getTraceableSpecification_Formal()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{A3D34610-ECC4-4f8c-AB14-505B4E83F540}' id='711792450' EA\040name='formal'"
   *        extendedMetaData="name='FORMAL' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FORMALS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getFormal();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getFormal <em>Formal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Formal</em>' attribute.
   * @see #isSetFormal()
   * @see #Formal()
   * @see #getFormal()
   * @generated
   */
  void setFormal(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getFormal <em>Formal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFormal()
   * @see #getFormal()
   * @see #setFormal(String)
   * @generated
   */
  void unsetFormal();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getFormal <em>Formal</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Formal</em>' attribute is set.
   * @see #Formal()
   * @see #getFormal()
   * @see #setFormal(String)
   * @generated
   */
  boolean isSetFormal();

  /**
   * Returns the value of the '<em><b>Informal</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Informal description of the element
   * <!-- end-model-doc -->
   * @return the value of the '<em>Informal</em>' attribute.
   * @see #isSetInformal()
   * @see #unsetInformal()
   * @see #setInformal(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getTraceableSpecification_Informal()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{7A2503C5-6C5D-4df3-99B4-D26639B3A327}' id='2123522715' EA\040name='informal'"
   *        extendedMetaData="name='INFORMAL' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INFORMALS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getInformal();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getInformal <em>Informal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Informal</em>' attribute.
   * @see #isSetInformal()
   * @see #Informal()
   * @see #getInformal()
   * @generated
   */
  void setInformal(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getInformal <em>Informal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetInformal()
   * @see #getInformal()
   * @see #setInformal(String)
   * @generated
   */
  void unsetInformal();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getInformal <em>Informal</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Informal</em>' attribute is set.
   * @see #Informal()
   * @see #getInformal()
   * @see #setInformal(String)
   * @generated
   */
  boolean isSetInformal();

  /**
   * Returns the value of the '<em><b>Stakeholder</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Stakeholders for the element
   * <!-- end-model-doc -->
   * @return the value of the '<em>Stakeholder</em>' attribute list.
   * @see #isSetStakeholder()
   * @see #unsetStakeholder()
   * @see org.safe.metamodel.safe10.Safe10Package#getTraceableSpecification_Stakeholder()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{9151096A-73BE-405c-9560-ABA8C775F9E7}' id='455611969' EA\040name='stakeholder'"
   *        extendedMetaData="name='STAKEHOLDER' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='STAKEHOLDERS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<String> getStakeholder();

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getStakeholder <em>Stakeholder</em>}' attribute list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetStakeholder()
   * @see #getStakeholder()
   * @generated
   */
  void unsetStakeholder();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.TraceableSpecification#getStakeholder <em>Stakeholder</em>}' attribute list is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Stakeholder</em>' attribute list is set.
   * @see #Stakeholder()
   * @see #getStakeholder()
   * @generated
   */
  boolean isSetStakeholder();

} // TraceableSpecification
