/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variant</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Represents the "actual" variant.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Configuration.Variant</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Variant#getOrigin <em>Origin</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Variant#getDescriptionMode <em>Description Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Variant#getExcludedElements <em>Excluded Elements</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Variant#getIncludedElements <em>Included Elements</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getVariant()
 * @model annotation="MetaData guid='{3AFCC50F-2B43-44d9-A208-8CA6330084D0}' id='1384945934' EA\040name='Variant'"
 *        extendedMetaData="name='VARIANT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VARIANTS'"
 * @generated
 */
public interface Variant extends PackageableElement
{
  /**
   * Returns the value of the '<em><b>Origin</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Origin</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Origin</em>' attribute.
   * @see #isSetOrigin()
   * @see #unsetOrigin()
   * @see #setOrigin(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getVariant_Origin()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{6AA97A11-FAE9-40d0-ADF1-E61A6FDA896D}' id='658269502' EA\040name='origin'"
   *        extendedMetaData="name='ORIGIN' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ORIGINS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getOrigin();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Variant#getOrigin <em>Origin</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Origin</em>' attribute.
   * @see #isSetOrigin()
   * @see #Origin()
   * @see #getOrigin()
   * @generated
   */
  void setOrigin(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Variant#getOrigin <em>Origin</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetOrigin()
   * @see #getOrigin()
   * @see #setOrigin(String)
   * @generated
   */
  void unsetOrigin();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Variant#getOrigin <em>Origin</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Origin</em>' attribute is set.
   * @see #Origin()
   * @see #getOrigin()
   * @see #setOrigin(String)
   * @generated
   */
  boolean isSetOrigin();

  /**
   * Returns the value of the '<em><b>Description Mode</b></em>' attribute.
   * The default value is <code>"INCLUDEDELEMENTS"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.VariantDescriptionMode}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Description Mode</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Description Mode</em>' attribute.
   * @see org.safe.metamodel.safe10.VariantDescriptionMode
   * @see #isSetDescriptionMode()
   * @see #unsetDescriptionMode()
   * @see #setDescriptionMode(VariantDescriptionMode)
   * @see org.safe.metamodel.safe10.Safe10Package#getVariant_DescriptionMode()
   * @model default="INCLUDEDELEMENTS" unsettable="true" required="true"
   *        annotation="MetaData guid='{E88C60BC-7AC2-4063-B346-AC02546B8B90}' id='-1038909465' EA\040name='descriptionMode'"
   *        extendedMetaData="name='DESCRIPTION-MODE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DESCRIPTION-MODES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  VariantDescriptionMode getDescriptionMode();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Variant#getDescriptionMode <em>Description Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Description Mode</em>' attribute.
   * @see org.safe.metamodel.safe10.VariantDescriptionMode
   * @see #isSetDescriptionMode()
   * @see #DescriptionMode()
   * @see #getDescriptionMode()
   * @generated
   */
  void setDescriptionMode(VariantDescriptionMode value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Variant#getDescriptionMode <em>Description Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDescriptionMode()
   * @see #getDescriptionMode()
   * @see #setDescriptionMode(VariantDescriptionMode)
   * @generated
   */
  void unsetDescriptionMode();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Variant#getDescriptionMode <em>Description Mode</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Description Mode</em>' attribute is set.
   * @see #DescriptionMode()
   * @see #getDescriptionMode()
   * @see #setDescriptionMode(VariantDescriptionMode)
   * @generated
   */
  boolean isSetDescriptionMode();

  /**
   * Returns the value of the '<em><b>Excluded Elements</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Identifiable}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Excluded Elements</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Excluded Elements</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getVariant_ExcludedElements()
   * @model annotation="MetaData guid='{9A6F5A4F-68D1-41e8-A8BB-2F3303FF420D}' id='-926074458' EA\040name=''"
   *        extendedMetaData="name='EXCLUDED-ELEMENTS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXCLUDED-ELEMENTS-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Identifiable> getExcludedElements();

  /**
   * Returns the value of the '<em><b>Included Elements</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Identifiable}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Included Elements</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Included Elements</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getVariant_IncludedElements()
   * @model annotation="MetaData guid='{55B21CA3-81C4-4caf-BF9D-75905404D778}' id='-779713447' EA\040name=''"
   *        extendedMetaData="name='INCLUDED-ELEMENTS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INCLUDED-ELEMENTS-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Identifiable> getIncludedElements();

} // Variant
