/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Voter Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Configuration of a Voting SSR
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Voting.VoterConfig</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.VoterConfig#getNumberOfItems <em>Number Of Items</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.VoterConfig#getConsensusThreshold <em>Consensus Threshold</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.VoterConfig#getAlgorithm <em>Algorithm</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.VoterConfig#getActivationScheme <em>Activation Scheme</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getVoterConfig()
 * @model annotation="MetaData guid='{02AD8A5E-5C40-4164-B34C-6D0B286D0EA8}' id='-1054683069' EA\040name='VoterConfig'"
 *        extendedMetaData="name='VOTER-CONFIG' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VOTER-CONFIGS'"
 * @generated
 */
public interface VoterConfig extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Number Of Items</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Number Of Items</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Number Of Items</em>' attribute.
   * @see #isSetNumberOfItems()
   * @see #unsetNumberOfItems()
   * @see #setNumberOfItems(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getVoterConfig_NumberOfItems()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{B94ABE0B-39D5-438d-864E-EED6DFB9DF8A}' id='1302235446' EA\040name='numberOfItems'"
   *        extendedMetaData="name='NUMBER-OF-ITEMS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NUMBER-OF-ITEMSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getNumberOfItems();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getNumberOfItems <em>Number Of Items</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Number Of Items</em>' attribute.
   * @see #isSetNumberOfItems()
   * @see #NumberOfItems()
   * @see #getNumberOfItems()
   * @generated
   */
  void setNumberOfItems(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getNumberOfItems <em>Number Of Items</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetNumberOfItems()
   * @see #getNumberOfItems()
   * @see #setNumberOfItems(Integer)
   * @generated
   */
  void unsetNumberOfItems();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getNumberOfItems <em>Number Of Items</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Number Of Items</em>' attribute is set.
   * @see #NumberOfItems()
   * @see #getNumberOfItems()
   * @see #setNumberOfItems(Integer)
   * @generated
   */
  boolean isSetNumberOfItems();

  /**
   * Returns the value of the '<em><b>Consensus Threshold</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Consensus Threshold</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Consensus Threshold</em>' attribute.
   * @see #isSetConsensusThreshold()
   * @see #unsetConsensusThreshold()
   * @see #setConsensusThreshold(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getVoterConfig_ConsensusThreshold()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{1EC7767B-0D98-4fe2-90CD-6E0C83DE3BA5}' id='-744185217' EA\040name='consensusThreshold'"
   *        extendedMetaData="name='CONSENSUS-THRESHOLD' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONSENSUS-THRESHOLDS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getConsensusThreshold();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getConsensusThreshold <em>Consensus Threshold</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Consensus Threshold</em>' attribute.
   * @see #isSetConsensusThreshold()
   * @see #ConsensusThreshold()
   * @see #getConsensusThreshold()
   * @generated
   */
  void setConsensusThreshold(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getConsensusThreshold <em>Consensus Threshold</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetConsensusThreshold()
   * @see #getConsensusThreshold()
   * @see #setConsensusThreshold(Integer)
   * @generated
   */
  void unsetConsensusThreshold();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getConsensusThreshold <em>Consensus Threshold</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Consensus Threshold</em>' attribute is set.
   * @see #ConsensusThreshold()
   * @see #getConsensusThreshold()
   * @see #setConsensusThreshold(Integer)
   * @generated
   */
  boolean isSetConsensusThreshold();

  /**
   * Returns the value of the '<em><b>Algorithm</b></em>' attribute.
   * The default value is <code>"MEDIAN"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.VotingAlgorithmEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Algorithm</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Algorithm</em>' attribute.
   * @see org.safe.metamodel.safe10.VotingAlgorithmEnum
   * @see #isSetAlgorithm()
   * @see #unsetAlgorithm()
   * @see #setAlgorithm(VotingAlgorithmEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getVoterConfig_Algorithm()
   * @model default="MEDIAN" unsettable="true" required="true"
   *        annotation="MetaData guid='{26B39081-0DF4-44f3-AD12-0BBF19C9D843}' id='1362399335' EA\040name='algorithm'"
   *        extendedMetaData="name='ALGORITHM' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ALGORITHMS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  VotingAlgorithmEnum getAlgorithm();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getAlgorithm <em>Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Algorithm</em>' attribute.
   * @see org.safe.metamodel.safe10.VotingAlgorithmEnum
   * @see #isSetAlgorithm()
   * @see #Algorithm()
   * @see #getAlgorithm()
   * @generated
   */
  void setAlgorithm(VotingAlgorithmEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getAlgorithm <em>Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetAlgorithm()
   * @see #getAlgorithm()
   * @see #setAlgorithm(VotingAlgorithmEnum)
   * @generated
   */
  void unsetAlgorithm();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getAlgorithm <em>Algorithm</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Algorithm</em>' attribute is set.
   * @see #Algorithm()
   * @see #getAlgorithm()
   * @see #setAlgorithm(VotingAlgorithmEnum)
   * @generated
   */
  boolean isSetAlgorithm();

  /**
   * Returns the value of the '<em><b>Activation Scheme</b></em>' attribute.
   * The default value is <code>"EVENTTRIGGERED"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.VoterActivationSchemeEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Activation Scheme</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Activation Scheme</em>' attribute.
   * @see org.safe.metamodel.safe10.VoterActivationSchemeEnum
   * @see #isSetActivationScheme()
   * @see #unsetActivationScheme()
   * @see #setActivationScheme(VoterActivationSchemeEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getVoterConfig_ActivationScheme()
   * @model default="EVENTTRIGGERED" unsettable="true" required="true"
   *        annotation="MetaData guid='{251318A4-E4C3-4907-AC6D-0694B1F6C5C7}' id='-692458468' EA\040name='activationScheme'"
   *        extendedMetaData="name='ACTIVATION-SCHEME' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ACTIVATION-SCHEMES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  VoterActivationSchemeEnum getActivationScheme();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getActivationScheme <em>Activation Scheme</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Activation Scheme</em>' attribute.
   * @see org.safe.metamodel.safe10.VoterActivationSchemeEnum
   * @see #isSetActivationScheme()
   * @see #ActivationScheme()
   * @see #getActivationScheme()
   * @generated
   */
  void setActivationScheme(VoterActivationSchemeEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getActivationScheme <em>Activation Scheme</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetActivationScheme()
   * @see #getActivationScheme()
   * @see #setActivationScheme(VoterActivationSchemeEnum)
   * @generated
   */
  void unsetActivationScheme();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.VoterConfig#getActivationScheme <em>Activation Scheme</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Activation Scheme</em>' attribute is set.
   * @see #ActivationScheme()
   * @see #getActivationScheme()
   * @see #setActivationScheme(VoterActivationSchemeEnum)
   * @generated
   */
  boolean isSetActivationScheme();

} // VoterConfig
