/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Warning And Degradation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The warning- and degradation concept is a specification of how to alert the driver of potentially reduced functionality and of how to provide this reduced functionality to reach a safe state.
 * <b>
 * </b>The warning and degradation concept shall be specified by FunctionalSafetyRequirements 
 * 
 * 
 * The warning- and degradation-concept describes the system transition of the system in case of occurrence of a safety relevant failure to the safe state that is defined for that failure. 
 * The warn- and degradation-concept also contains functional safety requirements. The functional safety requirements of the warn- and degradation-concept shall be allocated to the safe state that shall be reached. 
 * The functional safety requirements of the warn- and degradation-concept shall be classified with the same ASIL as the allocated safe state. 
 * The exit condition of the safe state back to the normal operation mode is also part of the warn-and degradation-concept. 
 * 
 * 
 * <i><u>Reference:</u></i>
 * ISO 26262-3-8.4.2.5
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.FunctionalSafetyRequirements.WarningAndDegradation.WarningAndDegradation</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.WarningAndDegradation#getDriverActions <em>Driver Actions</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.WarningAndDegradation#getMeansAndControls <em>Means And Controls</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.WarningAndDegradation#getOperationsTimeInterval <em>Operations Time Interval</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradation()
 * @model annotation="MetaData guid='{D876B9EC-DA63-49b1-90CC-EAAA26F0512D}' id='-971852068' EA\040name='WarningAndDegradation'"
 *        extendedMetaData="name='WARNING-AND-DEGRADATION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='WARNING-AND-DEGRADATIONS'"
 * @generated
 */
public interface WarningAndDegradation extends FunctionalSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Driver Actions</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Driver Actions</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Driver Actions</em>' attribute.
   * @see #isSetDriverActions()
   * @see #unsetDriverActions()
   * @see #setDriverActions(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradation_DriverActions()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{B6F13628-C848-4a1e-A615-99631BB2909E}' id='1363153025' EA\040name='driverActions'"
   *        extendedMetaData="name='DRIVER-ACTIONS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DRIVER-ACTIONSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getDriverActions();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getDriverActions <em>Driver Actions</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Driver Actions</em>' attribute.
   * @see #isSetDriverActions()
   * @see #DriverActions()
   * @see #getDriverActions()
   * @generated
   */
  void setDriverActions(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getDriverActions <em>Driver Actions</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDriverActions()
   * @see #getDriverActions()
   * @see #setDriverActions(String)
   * @generated
   */
  void unsetDriverActions();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getDriverActions <em>Driver Actions</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Driver Actions</em>' attribute is set.
   * @see #DriverActions()
   * @see #getDriverActions()
   * @see #setDriverActions(String)
   * @generated
   */
  boolean isSetDriverActions();

  /**
   * Returns the value of the '<em><b>Means And Controls</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Means And Controls</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Means And Controls</em>' attribute.
   * @see #isSetMeansAndControls()
   * @see #unsetMeansAndControls()
   * @see #setMeansAndControls(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradation_MeansAndControls()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{5A279A53-95BC-428c-8DFB-A61100FFF8DC}' id='844549294' EA\040name='meansAndControls'"
   *        extendedMetaData="name='MEANS-AND-CONTROLS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MEANS-AND-CONTROLSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getMeansAndControls();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getMeansAndControls <em>Means And Controls</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Means And Controls</em>' attribute.
   * @see #isSetMeansAndControls()
   * @see #MeansAndControls()
   * @see #getMeansAndControls()
   * @generated
   */
  void setMeansAndControls(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getMeansAndControls <em>Means And Controls</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMeansAndControls()
   * @see #getMeansAndControls()
   * @see #setMeansAndControls(String)
   * @generated
   */
  void unsetMeansAndControls();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getMeansAndControls <em>Means And Controls</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Means And Controls</em>' attribute is set.
   * @see #MeansAndControls()
   * @see #getMeansAndControls()
   * @see #setMeansAndControls(String)
   * @generated
   */
  boolean isSetMeansAndControls();

  /**
   * Returns the value of the '<em><b>Operations Time Interval</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Operations Time Interval</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Operations Time Interval</em>' attribute.
   * @see #isSetOperationsTimeInterval()
   * @see #unsetOperationsTimeInterval()
   * @see #setOperationsTimeInterval(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradation_OperationsTimeInterval()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{663CA648-7385-4cee-9C39-3477C71DF2B4}' id='775525274' EA\040name='operationsTimeInterval'"
   *        extendedMetaData="name='OPERATIONS-TIME-INTERVAL' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATIONS-TIME-INTERVALS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getOperationsTimeInterval();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getOperationsTimeInterval <em>Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Operations Time Interval</em>' attribute.
   * @see #isSetOperationsTimeInterval()
   * @see #OperationsTimeInterval()
   * @see #getOperationsTimeInterval()
   * @generated
   */
  void setOperationsTimeInterval(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getOperationsTimeInterval <em>Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetOperationsTimeInterval()
   * @see #getOperationsTimeInterval()
   * @see #setOperationsTimeInterval(Integer)
   * @generated
   */
  void unsetOperationsTimeInterval();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradation#getOperationsTimeInterval <em>Operations Time Interval</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Operations Time Interval</em>' attribute is set.
   * @see #OperationsTimeInterval()
   * @see #getOperationsTimeInterval()
   * @see #setOperationsTimeInterval(Integer)
   * @generated
   */
  boolean isSetOperationsTimeInterval();

} // WarningAndDegradation
