/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.ErrorBehavior;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AbstractErrorBehavior;
import org.safe.metamodel.safe10.ErrorModelType;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract Error Behavior</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractErrorBehaviorImpl#getEastADLErrorBehavior <em>East ADL Error Behavior</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractErrorBehaviorImpl#getErrorModel <em>Error Model</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractErrorBehaviorImpl#getProcessFault <em>Process Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractErrorBehaviorImpl#getInternalFault <em>Internal Fault</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AbstractErrorBehaviorImpl extends IdentifiableImpl implements AbstractErrorBehavior
{
  /**
   * The cached value of the '{@link #getEastADLErrorBehavior() <em>East ADL Error Behavior</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEastADLErrorBehavior()
   * @generated
   * @ordered
   */
  protected ErrorBehavior eastADLErrorBehavior;

  /**
   * The cached value of the '{@link #getErrorModel() <em>Error Model</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModel()
   * @generated
   * @ordered
   */
  protected ErrorModelType errorModel;

  /**
   * The cached value of the '{@link #getProcessFault() <em>Process Fault</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProcessFault()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> processFault;

  /**
   * The cached value of the '{@link #getInternalFault() <em>Internal Fault</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInternalFault()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> internalFault;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AbstractErrorBehaviorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAbstractErrorBehavior();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorBehavior getEastADLErrorBehavior()
  {
    return eastADLErrorBehavior;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetEastADLErrorBehavior(ErrorBehavior newEastADLErrorBehavior, NotificationChain msgs)
  {
    ErrorBehavior oldEastADLErrorBehavior = eastADLErrorBehavior;
    eastADLErrorBehavior = newEastADLErrorBehavior;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR, oldEastADLErrorBehavior, newEastADLErrorBehavior);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEastADLErrorBehavior(ErrorBehavior newEastADLErrorBehavior)
  {
    if (newEastADLErrorBehavior != eastADLErrorBehavior)
    {
      NotificationChain msgs = null;
      if (eastADLErrorBehavior != null)
        msgs = ((InternalEObject)eastADLErrorBehavior).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR, null, msgs);
      if (newEastADLErrorBehavior != null)
        msgs = ((InternalEObject)newEastADLErrorBehavior).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR, null, msgs);
      msgs = basicSetEastADLErrorBehavior(newEastADLErrorBehavior, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR, newEastADLErrorBehavior, newEastADLErrorBehavior));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelType getErrorModel()
  {
    if (errorModel != null && errorModel.eIsProxy())
    {
      InternalEObject oldErrorModel = (InternalEObject)errorModel;
      errorModel = (ErrorModelType)eResolveProxy(oldErrorModel);
      if (errorModel != oldErrorModel)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.ABSTRACT_ERROR_BEHAVIOR__ERROR_MODEL, oldErrorModel, errorModel));
      }
    }
    return errorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelType basicGetErrorModel()
  {
    return errorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setErrorModel(ErrorModelType newErrorModel)
  {
    ErrorModelType oldErrorModel = errorModel;
    errorModel = newErrorModel;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_ERROR_BEHAVIOR__ERROR_MODEL, oldErrorModel, errorModel));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getProcessFault()
  {
    if (processFault == null)
    {
      processFault = new EObjectContainmentEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.ABSTRACT_ERROR_BEHAVIOR__PROCESS_FAULT);
    }
    return processFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getInternalFault()
  {
    if (internalFault == null)
    {
      internalFault = new EObjectContainmentEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.ABSTRACT_ERROR_BEHAVIOR__INTERNAL_FAULT);
    }
    return internalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR:
        return basicSetEastADLErrorBehavior(null, msgs);
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__PROCESS_FAULT:
        return ((InternalEList<?>)getProcessFault()).basicRemove(otherEnd, msgs);
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__INTERNAL_FAULT:
        return ((InternalEList<?>)getInternalFault()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR:
        return getEastADLErrorBehavior();
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__ERROR_MODEL:
        if (resolve) return getErrorModel();
        return basicGetErrorModel();
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__PROCESS_FAULT:
        return getProcessFault();
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__INTERNAL_FAULT:
        return getInternalFault();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR:
   			setEastADLErrorBehavior((ErrorBehavior)newValue);
        return;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__ERROR_MODEL:
   			setErrorModel((ErrorModelType)newValue);
        return;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__PROCESS_FAULT:
        getProcessFault().clear();
        getProcessFault().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__INTERNAL_FAULT:
        getInternalFault().clear();
        getInternalFault().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR:
        	setEastADLErrorBehavior((ErrorBehavior)null);
        return;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__ERROR_MODEL:
        	setErrorModel((ErrorModelType)null);
        return;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__PROCESS_FAULT:
        getProcessFault().clear();
        return;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__INTERNAL_FAULT:
        getInternalFault().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__EAST_ADL_ERROR_BEHAVIOR:
        return eastADLErrorBehavior != null;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__ERROR_MODEL:
        return errorModel != null;
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__PROCESS_FAULT:
        return processFault != null && !processFault.isEmpty();
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR__INTERNAL_FAULT:
        return internalFault != null && !internalFault.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //AbstractErrorBehaviorImpl
