/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AbstractQuantifiableSafetyRequirement;
import org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract Quantifiable Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractQuantifiableSafetyRequirementImpl#getDiagnosticCoverage <em>Diagnostic Coverage</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AbstractQuantifiableSafetyRequirementImpl extends AbstractSafetyRequirementImpl implements AbstractQuantifiableSafetyRequirement
{
  /**
   * The cached value of the '{@link #getDiagnosticCoverage() <em>Diagnostic Coverage</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDiagnosticCoverage()
   * @generated
   * @ordered
   */
  protected EList<QuantifiedDiagnosticCoverageProperty> diagnosticCoverage;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AbstractQuantifiableSafetyRequirementImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAbstractQuantifiableSafetyRequirement();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<QuantifiedDiagnosticCoverageProperty> getDiagnosticCoverage()
  {
    if (diagnosticCoverage == null)
    {
      diagnosticCoverage = new EObjectContainmentEList<QuantifiedDiagnosticCoverageProperty>(QuantifiedDiagnosticCoverageProperty.class, this, Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT__DIAGNOSTIC_COVERAGE);
    }
    return diagnosticCoverage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT__DIAGNOSTIC_COVERAGE:
        return ((InternalEList<?>)getDiagnosticCoverage()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT__DIAGNOSTIC_COVERAGE:
        return getDiagnosticCoverage();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT__DIAGNOSTIC_COVERAGE:
        getDiagnosticCoverage().clear();
        getDiagnosticCoverage().addAll((Collection<? extends QuantifiedDiagnosticCoverageProperty>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT__DIAGNOSTIC_COVERAGE:
        getDiagnosticCoverage().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT__DIAGNOSTIC_COVERAGE:
        return diagnosticCoverage != null && !diagnosticCoverage.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //AbstractQuantifiableSafetyRequirementImpl
