/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.Requirement;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.ASILDecomposedEnum;
import org.safe.metamodel.safe10.ASILEnum;
import org.safe.metamodel.safe10.AbstractSafetyRequirement;
import org.safe.metamodel.safe10.RequirementTypeEnum;
import org.safe.metamodel.safe10.RequirementsLink;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Tactic;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractSafetyRequirementImpl#getAsil <em>Asil</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractSafetyRequirementImpl#getDecomposedASIL <em>Decomposed ASIL</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractSafetyRequirementImpl#getRequirementType <em>Requirement Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractSafetyRequirementImpl#getRequirement <em>Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractSafetyRequirementImpl#getRequirementLinks <em>Requirement Links</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AbstractSafetyRequirementImpl#getTactic <em>Tactic</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AbstractSafetyRequirementImpl extends TraceableSpecificationImpl implements AbstractSafetyRequirement
{
  /**
   * The default value of the '{@link #getAsil() <em>Asil</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAsil()
   * @generated
   * @ordered
   */
  protected static final ASILEnum ASIL_EDEFAULT = ASILEnum.ASIL_A;

  /**
   * The cached value of the '{@link #getAsil() <em>Asil</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAsil()
   * @generated
   * @ordered
   */
  protected ASILEnum asil = ASIL_EDEFAULT;

  /**
   * This is true if the Asil attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean asilESet;

  /**
   * The default value of the '{@link #getDecomposedASIL() <em>Decomposed ASIL</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDecomposedASIL()
   * @generated
   * @ordered
   */
  protected static final ASILDecomposedEnum DECOMPOSED_ASIL_EDEFAULT = ASILDecomposedEnum.ASIL_A;

  /**
   * The cached value of the '{@link #getDecomposedASIL() <em>Decomposed ASIL</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDecomposedASIL()
   * @generated
   * @ordered
   */
  protected ASILDecomposedEnum decomposedASIL = DECOMPOSED_ASIL_EDEFAULT;

  /**
   * This is true if the Decomposed ASIL attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean decomposedASILESet;

  /**
   * The default value of the '{@link #getRequirementType() <em>Requirement Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirementType()
   * @generated
   * @ordered
   */
  protected static final RequirementTypeEnum REQUIREMENT_TYPE_EDEFAULT = RequirementTypeEnum.QUANTITATIVE;

  /**
   * The cached value of the '{@link #getRequirementType() <em>Requirement Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirementType()
   * @generated
   * @ordered
   */
  protected RequirementTypeEnum requirementType = REQUIREMENT_TYPE_EDEFAULT;

  /**
   * This is true if the Requirement Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean requirementTypeESet;

  /**
   * The cached value of the '{@link #getRequirement() <em>Requirement</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirement()
   * @generated
   * @ordered
   */
  protected Requirement requirement;

  /**
   * The cached value of the '{@link #getRequirementLinks() <em>Requirement Links</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirementLinks()
   * @generated
   * @ordered
   */
  protected EList<RequirementsLink> requirementLinks;

  /**
   * The cached value of the '{@link #getTactic() <em>Tactic</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTactic()
   * @generated
   * @ordered
   */
  protected Tactic tactic;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AbstractSafetyRequirementImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAbstractSafetyRequirement();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ASILEnum getAsil()
  {
    return asil;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setAsil(ASILEnum newAsil)
  {
    ASILEnum oldAsil = asil;
    asil = newAsil == null ? ASIL_EDEFAULT : newAsil;
    boolean oldAsilESet = asilESet;
    asilESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__ASIL, oldAsil, asil, !oldAsilESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetAsil()
  {
    ASILEnum oldAsil = asil;
    boolean oldAsilESet = asilESet;
    asil = ASIL_EDEFAULT;
    asilESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__ASIL, oldAsil, ASIL_EDEFAULT, oldAsilESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetAsil()
  {
    return asilESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ASILDecomposedEnum getDecomposedASIL()
  {
    return decomposedASIL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDecomposedASIL(ASILDecomposedEnum newDecomposedASIL)
  {
    ASILDecomposedEnum oldDecomposedASIL = decomposedASIL;
    decomposedASIL = newDecomposedASIL == null ? DECOMPOSED_ASIL_EDEFAULT : newDecomposedASIL;
    boolean oldDecomposedASILESet = decomposedASILESet;
    decomposedASILESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__DECOMPOSED_ASIL, oldDecomposedASIL, decomposedASIL, !oldDecomposedASILESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetDecomposedASIL()
  {
    ASILDecomposedEnum oldDecomposedASIL = decomposedASIL;
    boolean oldDecomposedASILESet = decomposedASILESet;
    decomposedASIL = DECOMPOSED_ASIL_EDEFAULT;
    decomposedASILESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__DECOMPOSED_ASIL, oldDecomposedASIL, DECOMPOSED_ASIL_EDEFAULT, oldDecomposedASILESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetDecomposedASIL()
  {
    return decomposedASILESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RequirementTypeEnum getRequirementType()
  {
    return requirementType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRequirementType(RequirementTypeEnum newRequirementType)
  {
    RequirementTypeEnum oldRequirementType = requirementType;
    requirementType = newRequirementType == null ? REQUIREMENT_TYPE_EDEFAULT : newRequirementType;
    boolean oldRequirementTypeESet = requirementTypeESet;
    requirementTypeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_TYPE, oldRequirementType, requirementType, !oldRequirementTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRequirementType()
  {
    RequirementTypeEnum oldRequirementType = requirementType;
    boolean oldRequirementTypeESet = requirementTypeESet;
    requirementType = REQUIREMENT_TYPE_EDEFAULT;
    requirementTypeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_TYPE, oldRequirementType, REQUIREMENT_TYPE_EDEFAULT, oldRequirementTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRequirementType()
  {
    return requirementTypeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Requirement getRequirement()
  {
    if (requirement != null && requirement.eIsProxy())
    {
      InternalEObject oldRequirement = (InternalEObject)requirement;
      requirement = (Requirement)eResolveProxy(oldRequirement);
      if (requirement != oldRequirement)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT, oldRequirement, requirement));
      }
    }
    return requirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Requirement basicGetRequirement()
  {
    return requirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRequirement(Requirement newRequirement)
  {
    Requirement oldRequirement = requirement;
    requirement = newRequirement;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT, oldRequirement, requirement));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RequirementsLink> getRequirementLinks()
  {
    if (requirementLinks == null)
    {
      requirementLinks = new EObjectContainmentEList<RequirementsLink>(RequirementsLink.class, this, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_LINKS);
    }
    return requirementLinks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Tactic getTactic()
  {
    return tactic;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetTactic(Tactic newTactic, NotificationChain msgs)
  {
    Tactic oldTactic = tactic;
    tactic = newTactic;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC, oldTactic, newTactic);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTactic(Tactic newTactic)
  {
    if (newTactic != tactic)
    {
      NotificationChain msgs = null;
      if (tactic != null)
        msgs = ((InternalEObject)tactic).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC, null, msgs);
      if (newTactic != null)
        msgs = ((InternalEObject)newTactic).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC, null, msgs);
      msgs = basicSetTactic(newTactic, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC, newTactic, newTactic));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_LINKS:
        return ((InternalEList<?>)getRequirementLinks()).basicRemove(otherEnd, msgs);
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC:
        return basicSetTactic(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__ASIL:
        return getAsil();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__DECOMPOSED_ASIL:
        return getDecomposedASIL();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_TYPE:
        return getRequirementType();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT:
        if (resolve) return getRequirement();
        return basicGetRequirement();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_LINKS:
        return getRequirementLinks();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC:
        return getTactic();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__ASIL:
   			setAsil((ASILEnum)newValue);
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__DECOMPOSED_ASIL:
   			setDecomposedASIL((ASILDecomposedEnum)newValue);
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_TYPE:
   			setRequirementType((RequirementTypeEnum)newValue);
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT:
   			setRequirement((Requirement)newValue);
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_LINKS:
        getRequirementLinks().clear();
        getRequirementLinks().addAll((Collection<? extends RequirementsLink>)newValue);
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC:
   			setTactic((Tactic)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__ASIL:
        unsetAsil();
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__DECOMPOSED_ASIL:
        unsetDecomposedASIL();
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_TYPE:
        unsetRequirementType();
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT:
        	setRequirement((Requirement)null);
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_LINKS:
        getRequirementLinks().clear();
        return;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC:
        	setTactic((Tactic)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__ASIL:
        return isSetAsil();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__DECOMPOSED_ASIL:
        return isSetDecomposedASIL();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_TYPE:
        return isSetRequirementType();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT:
        return requirement != null;
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__REQUIREMENT_LINKS:
        return requirementLinks != null && !requirementLinks.isEmpty();
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT__TACTIC:
        return tactic != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (asil: ");
    if (asilESet) result.append(asil); else result.append("<unset>");
    result.append(", decomposedASIL: ");
    if (decomposedASILESet) result.append(decomposedASIL); else result.append("<unset>");
    result.append(", requirementType: ");
    if (requirementTypeESet) result.append(requirementType); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //AbstractSafetyRequirementImpl
