/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.bswmodule.bswinterfaces.BswModuleEntry;

import autosar40.ecuresource.HwElement;

import autosar40.swcomponent.composition.SwComponentPrototype;

import java.util.Collection;

import org.eatop.eel.eastadl21.AnalysisFunctionPrototype;
import org.eatop.eel.eastadl21.DesignFunctionPrototype;
import org.eatop.eel.eastadl21.HardwareComponentPrototype;
import org.eatop.eel.eastadl21.VehicleFeature;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.AllocationTargets;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Allocation Targets</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingSWComponent <em>Satisfying SW Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingAnalysisFunction <em>Satisfying Analysis Function</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingHWComponent <em>Satisfying HW Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingBSWModule <em>Satisfying BSW Module</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingHWElement <em>Satisfying HW Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingFeature <em>Satisfying Feature</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AllocationTargetsImpl#getSatisfyingDesignFunction <em>Satisfying Design Function</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AllocationTargetsImpl extends IdentifiableImpl implements AllocationTargets
{
  /**
   * The cached value of the '{@link #getSatisfyingSWComponent() <em>Satisfying SW Component</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingSWComponent()
   * @generated
   * @ordered
   */
  protected EList<SwComponentPrototype> satisfyingSWComponent;

  /**
   * The cached value of the '{@link #getSatisfyingAnalysisFunction() <em>Satisfying Analysis Function</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingAnalysisFunction()
   * @generated
   * @ordered
   */
  protected EList<AnalysisFunctionPrototype> satisfyingAnalysisFunction;

  /**
   * The cached value of the '{@link #getSatisfyingHWComponent() <em>Satisfying HW Component</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingHWComponent()
   * @generated
   * @ordered
   */
  protected EList<HardwareComponentPrototype> satisfyingHWComponent;

  /**
   * The cached value of the '{@link #getSatisfyingBSWModule() <em>Satisfying BSW Module</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingBSWModule()
   * @generated
   * @ordered
   */
  protected EList<BswModuleEntry> satisfyingBSWModule;

  /**
   * The cached value of the '{@link #getSatisfyingHWElement() <em>Satisfying HW Element</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingHWElement()
   * @generated
   * @ordered
   */
  protected EList<HwElement> satisfyingHWElement;

  /**
   * The cached value of the '{@link #getSatisfyingFeature() <em>Satisfying Feature</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingFeature()
   * @generated
   * @ordered
   */
  protected EList<VehicleFeature> satisfyingFeature;

  /**
   * The cached value of the '{@link #getSatisfyingDesignFunction() <em>Satisfying Design Function</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingDesignFunction()
   * @generated
   * @ordered
   */
  protected EList<DesignFunctionPrototype> satisfyingDesignFunction;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AllocationTargetsImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAllocationTargets();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SwComponentPrototype> getSatisfyingSWComponent()
  {
    if (satisfyingSWComponent == null)
    {
      satisfyingSWComponent = new EObjectResolvingEList<SwComponentPrototype>(SwComponentPrototype.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_SW_COMPONENT);
    }
    return satisfyingSWComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AnalysisFunctionPrototype> getSatisfyingAnalysisFunction()
  {
    if (satisfyingAnalysisFunction == null)
    {
      satisfyingAnalysisFunction = new EObjectResolvingEList<AnalysisFunctionPrototype>(AnalysisFunctionPrototype.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_ANALYSIS_FUNCTION);
    }
    return satisfyingAnalysisFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HardwareComponentPrototype> getSatisfyingHWComponent()
  {
    if (satisfyingHWComponent == null)
    {
      satisfyingHWComponent = new EObjectResolvingEList<HardwareComponentPrototype>(HardwareComponentPrototype.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_COMPONENT);
    }
    return satisfyingHWComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<BswModuleEntry> getSatisfyingBSWModule()
  {
    if (satisfyingBSWModule == null)
    {
      satisfyingBSWModule = new EObjectResolvingEList<BswModuleEntry>(BswModuleEntry.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_BSW_MODULE);
    }
    return satisfyingBSWModule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HwElement> getSatisfyingHWElement()
  {
    if (satisfyingHWElement == null)
    {
      satisfyingHWElement = new EObjectResolvingEList<HwElement>(HwElement.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_ELEMENT);
    }
    return satisfyingHWElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<VehicleFeature> getSatisfyingFeature()
  {
    if (satisfyingFeature == null)
    {
      satisfyingFeature = new EObjectResolvingEList<VehicleFeature>(VehicleFeature.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_FEATURE);
    }
    return satisfyingFeature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<DesignFunctionPrototype> getSatisfyingDesignFunction()
  {
    if (satisfyingDesignFunction == null)
    {
      satisfyingDesignFunction = new EObjectResolvingEList<DesignFunctionPrototype>(DesignFunctionPrototype.class, this, Safe10Package.ALLOCATION_TARGETS__SATISFYING_DESIGN_FUNCTION);
    }
    return satisfyingDesignFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_SW_COMPONENT:
        return getSatisfyingSWComponent();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_ANALYSIS_FUNCTION:
        return getSatisfyingAnalysisFunction();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_COMPONENT:
        return getSatisfyingHWComponent();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_BSW_MODULE:
        return getSatisfyingBSWModule();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_ELEMENT:
        return getSatisfyingHWElement();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_FEATURE:
        return getSatisfyingFeature();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_DESIGN_FUNCTION:
        return getSatisfyingDesignFunction();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_SW_COMPONENT:
        getSatisfyingSWComponent().clear();
        getSatisfyingSWComponent().addAll((Collection<? extends SwComponentPrototype>)newValue);
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_ANALYSIS_FUNCTION:
        getSatisfyingAnalysisFunction().clear();
        getSatisfyingAnalysisFunction().addAll((Collection<? extends AnalysisFunctionPrototype>)newValue);
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_COMPONENT:
        getSatisfyingHWComponent().clear();
        getSatisfyingHWComponent().addAll((Collection<? extends HardwareComponentPrototype>)newValue);
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_BSW_MODULE:
        getSatisfyingBSWModule().clear();
        getSatisfyingBSWModule().addAll((Collection<? extends BswModuleEntry>)newValue);
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_ELEMENT:
        getSatisfyingHWElement().clear();
        getSatisfyingHWElement().addAll((Collection<? extends HwElement>)newValue);
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_FEATURE:
        getSatisfyingFeature().clear();
        getSatisfyingFeature().addAll((Collection<? extends VehicleFeature>)newValue);
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_DESIGN_FUNCTION:
        getSatisfyingDesignFunction().clear();
        getSatisfyingDesignFunction().addAll((Collection<? extends DesignFunctionPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_SW_COMPONENT:
        getSatisfyingSWComponent().clear();
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_ANALYSIS_FUNCTION:
        getSatisfyingAnalysisFunction().clear();
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_COMPONENT:
        getSatisfyingHWComponent().clear();
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_BSW_MODULE:
        getSatisfyingBSWModule().clear();
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_ELEMENT:
        getSatisfyingHWElement().clear();
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_FEATURE:
        getSatisfyingFeature().clear();
        return;
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_DESIGN_FUNCTION:
        getSatisfyingDesignFunction().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_SW_COMPONENT:
        return satisfyingSWComponent != null && !satisfyingSWComponent.isEmpty();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_ANALYSIS_FUNCTION:
        return satisfyingAnalysisFunction != null && !satisfyingAnalysisFunction.isEmpty();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_COMPONENT:
        return satisfyingHWComponent != null && !satisfyingHWComponent.isEmpty();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_BSW_MODULE:
        return satisfyingBSWModule != null && !satisfyingBSWModule.isEmpty();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_HW_ELEMENT:
        return satisfyingHWElement != null && !satisfyingHWElement.isEmpty();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_FEATURE:
        return satisfyingFeature != null && !satisfyingFeature.isEmpty();
      case Safe10Package.ALLOCATION_TARGETS__SATISFYING_DESIGN_FUNCTION:
        return satisfyingDesignFunction != null && !satisfyingDesignFunction.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //AllocationTargetsImpl
