/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.swcomponent.components.SwComponentType;

import autosar40.swcomponent.composition.SwComponentPrototype;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.AutosarAbstractComponentInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Abstract Component Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarAbstractComponentInstanceRefImpl#getBase <em>Base</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarAbstractComponentInstanceRefImpl#getContextComponent <em>Context Component</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AutosarAbstractComponentInstanceRefImpl extends AutosarInstanceRefImpl implements AutosarAbstractComponentInstanceRef
{
  /**
   * The cached value of the '{@link #getBase() <em>Base</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBase()
   * @generated
   * @ordered
   */
  protected SwComponentType base;

  /**
   * The cached value of the '{@link #getContextComponent() <em>Context Component</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContextComponent()
   * @generated
   * @ordered
   */
  protected EList<SwComponentPrototype> contextComponent;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarAbstractComponentInstanceRefImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarAbstractComponentInstanceRef();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SwComponentType getBase()
  {
    if (base != null && base.eIsProxy())
    {
      InternalEObject oldBase = (InternalEObject)base;
      base = (SwComponentType)eResolveProxy(oldBase);
      if (base != oldBase)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__BASE, oldBase, base));
      }
    }
    return base;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SwComponentType basicGetBase()
  {
    return base;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBase(SwComponentType newBase)
  {
    SwComponentType oldBase = base;
    base = newBase;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__BASE, oldBase, base));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SwComponentPrototype> getContextComponent()
  {
    if (contextComponent == null)
    {
      contextComponent = new EObjectResolvingEList<SwComponentPrototype>(SwComponentPrototype.class, this, Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__CONTEXT_COMPONENT);
    }
    return contextComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__BASE:
        if (resolve) return getBase();
        return basicGetBase();
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__CONTEXT_COMPONENT:
        return getContextComponent();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__BASE:
   			setBase((SwComponentType)newValue);
        return;
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__CONTEXT_COMPONENT:
        getContextComponent().clear();
        getContextComponent().addAll((Collection<? extends SwComponentPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__BASE:
        	setBase((SwComponentType)null);
        return;
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__CONTEXT_COMPONENT:
        getContextComponent().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__BASE:
        return base != null;
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF__CONTEXT_COMPONENT:
        return contextComponent != null && !contextComponent.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //AutosarAbstractComponentInstanceRefImpl
