/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.swcomponent.portinterface.ClientServerOperation;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarClientServerOperationInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Client Server Operation Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarClientServerOperationInstanceRefImpl#getTargetOperation <em>Target Operation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarClientServerOperationInstanceRefImpl extends AutosarAbstractPortInComponentInstanceRefImpl implements AutosarClientServerOperationInstanceRef
{
  /**
   * The cached value of the '{@link #getTargetOperation() <em>Target Operation</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetOperation()
   * @generated
   * @ordered
   */
  protected ClientServerOperation targetOperation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarClientServerOperationInstanceRefImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarClientServerOperationInstanceRef();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ClientServerOperation getTargetOperation()
  {
    if (targetOperation != null && targetOperation.eIsProxy())
    {
      InternalEObject oldTargetOperation = (InternalEObject)targetOperation;
      targetOperation = (ClientServerOperation)eResolveProxy(oldTargetOperation);
      if (targetOperation != oldTargetOperation)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF__TARGET_OPERATION, oldTargetOperation, targetOperation));
      }
    }
    return targetOperation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ClientServerOperation basicGetTargetOperation()
  {
    return targetOperation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetOperation(ClientServerOperation newTargetOperation)
  {
    ClientServerOperation oldTargetOperation = targetOperation;
    targetOperation = newTargetOperation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF__TARGET_OPERATION, oldTargetOperation, targetOperation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF__TARGET_OPERATION:
        if (resolve) return getTargetOperation();
        return basicGetTargetOperation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF__TARGET_OPERATION:
   			setTargetOperation((ClientServerOperation)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF__TARGET_OPERATION:
        	setTargetOperation((ClientServerOperation)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF__TARGET_OPERATION:
        return targetOperation != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarClientServerOperationInstanceRefImpl
