/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.swcomponent.composition.SwComponentPrototype;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Component In Composition Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarComponentInCompositionInstanceRefImpl#getTargetComponent <em>Target Component</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarComponentInCompositionInstanceRefImpl extends AutosarAbstractComponentInstanceRefImpl implements AutosarComponentInCompositionInstanceRef
{
  /**
   * The cached value of the '{@link #getTargetComponent() <em>Target Component</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetComponent()
   * @generated
   * @ordered
   */
  protected SwComponentPrototype targetComponent;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarComponentInCompositionInstanceRefImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarComponentInCompositionInstanceRef();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SwComponentPrototype getTargetComponent()
  {
    if (targetComponent != null && targetComponent.eIsProxy())
    {
      InternalEObject oldTargetComponent = (InternalEObject)targetComponent;
      targetComponent = (SwComponentPrototype)eResolveProxy(oldTargetComponent);
      if (targetComponent != oldTargetComponent)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_COMPONENT, oldTargetComponent, targetComponent));
      }
    }
    return targetComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SwComponentPrototype basicGetTargetComponent()
  {
    return targetComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetComponent(SwComponentPrototype newTargetComponent)
  {
    SwComponentPrototype oldTargetComponent = targetComponent;
    targetComponent = newTargetComponent;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_COMPONENT, oldTargetComponent, targetComponent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_COMPONENT:
        if (resolve) return getTargetComponent();
        return basicGetTargetComponent();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_COMPONENT:
   			setTargetComponent((SwComponentPrototype)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_COMPONENT:
        	setTargetComponent((SwComponentPrototype)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_COMPONENT:
        return targetComponent != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarComponentInCompositionInstanceRefImpl
