/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.commonstructure.modedeclaration.ModeDeclaration;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarContext;
import org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Context</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarContextImpl#getContext <em>Context</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarContextImpl#getModeDeclaration <em>Mode Declaration</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarContextImpl extends RangeCheckContextImpl implements AutosarContext
{
  /**
   * The cached value of the '{@link #getContext() <em>Context</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContext()
   * @generated
   * @ordered
   */
  protected AutosarModeInPortFromComponentInCompositionInstanceRef context;

  /**
   * The cached value of the '{@link #getModeDeclaration() <em>Mode Declaration</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getModeDeclaration()
   * @generated
   * @ordered
   */
  protected ModeDeclaration modeDeclaration;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarContextImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarContext();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarModeInPortFromComponentInCompositionInstanceRef getContext()
  {
    return context;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetContext(AutosarModeInPortFromComponentInCompositionInstanceRef newContext, NotificationChain msgs)
  {
    AutosarModeInPortFromComponentInCompositionInstanceRef oldContext = context;
    context = newContext;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CONTEXT__CONTEXT, oldContext, newContext);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setContext(AutosarModeInPortFromComponentInCompositionInstanceRef newContext)
  {
    if (newContext != context)
    {
      NotificationChain msgs = null;
      if (context != null)
        msgs = ((InternalEObject)context).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_CONTEXT__CONTEXT, null, msgs);
      if (newContext != null)
        msgs = ((InternalEObject)newContext).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_CONTEXT__CONTEXT, null, msgs);
      msgs = basicSetContext(newContext, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CONTEXT__CONTEXT, newContext, newContext));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModeDeclaration getModeDeclaration()
  {
    if (modeDeclaration != null && modeDeclaration.eIsProxy())
    {
      InternalEObject oldModeDeclaration = (InternalEObject)modeDeclaration;
      modeDeclaration = (ModeDeclaration)eResolveProxy(oldModeDeclaration);
      if (modeDeclaration != oldModeDeclaration)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_CONTEXT__MODE_DECLARATION, oldModeDeclaration, modeDeclaration));
      }
    }
    return modeDeclaration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModeDeclaration basicGetModeDeclaration()
  {
    return modeDeclaration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setModeDeclaration(ModeDeclaration newModeDeclaration)
  {
    ModeDeclaration oldModeDeclaration = modeDeclaration;
    modeDeclaration = newModeDeclaration;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CONTEXT__MODE_DECLARATION, oldModeDeclaration, modeDeclaration));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT__CONTEXT:
        return basicSetContext(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT__CONTEXT:
        return getContext();
      case Safe10Package.AUTOSAR_CONTEXT__MODE_DECLARATION:
        if (resolve) return getModeDeclaration();
        return basicGetModeDeclaration();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT__CONTEXT:
   			setContext((AutosarModeInPortFromComponentInCompositionInstanceRef)newValue);
        return;
      case Safe10Package.AUTOSAR_CONTEXT__MODE_DECLARATION:
   			setModeDeclaration((ModeDeclaration)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT__CONTEXT:
        	setContext((AutosarModeInPortFromComponentInCompositionInstanceRef)null);
        return;
      case Safe10Package.AUTOSAR_CONTEXT__MODE_DECLARATION:
        	setModeDeclaration((ModeDeclaration)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT__CONTEXT:
        return context != null;
      case Safe10Package.AUTOSAR_CONTEXT__MODE_DECLARATION:
        return modeDeclaration != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarContextImpl
