/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarGradientCheck;
import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Gradient Check</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarGradientCheckImpl#getObserved <em>Observed</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarGradientCheckImpl extends GradientCheckImpl implements AutosarGradientCheck
{
  /**
   * The cached value of the '{@link #getObserved() <em>Observed</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getObserved()
   * @generated
   * @ordered
   */
  protected AutosarVariableDataPrototypeInstanceRef observed;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarGradientCheckImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarGradientCheck();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarVariableDataPrototypeInstanceRef getObserved()
  {
    return observed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetObserved(AutosarVariableDataPrototypeInstanceRef newObserved, NotificationChain msgs)
  {
    AutosarVariableDataPrototypeInstanceRef oldObserved = observed;
    observed = newObserved;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED, oldObserved, newObserved);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setObserved(AutosarVariableDataPrototypeInstanceRef newObserved)
  {
    if (newObserved != observed)
    {
      NotificationChain msgs = null;
      if (observed != null)
        msgs = ((InternalEObject)observed).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED, null, msgs);
      if (newObserved != null)
        msgs = ((InternalEObject)newObserved).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED, null, msgs);
      msgs = basicSetObserved(newObserved, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED, newObserved, newObserved));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED:
        return basicSetObserved(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED:
        return getObserved();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED:
   			setObserved((AutosarVariableDataPrototypeInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED:
        	setObserved((AutosarVariableDataPrototypeInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_GRADIENT_CHECK__OBSERVED:
        return observed != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarGradientCheckImpl
