/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.ecuresource.HwElement;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.AutosarHardwareSafetyExtension;
import org.safe.metamodel.safe10.HWPartFailure;
import org.safe.metamodel.safe10.HWPartFailureAnalysis;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Hardware Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarHardwareSafetyExtensionImpl#getHardwarePartSafetyAnalysis <em>Hardware Part Safety Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarHardwareSafetyExtensionImpl#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarHardwareSafetyExtensionImpl#getRamdomHardwarePartFailure <em>Ramdom Hardware Part Failure</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarHardwareSafetyExtensionImpl extends AutosarSafetyExtensionImpl implements AutosarHardwareSafetyExtension
{
  /**
   * The cached value of the '{@link #getHardwarePartSafetyAnalysis() <em>Hardware Part Safety Analysis</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHardwarePartSafetyAnalysis()
   * @generated
   * @ordered
   */
  protected EList<HWPartFailureAnalysis> hardwarePartSafetyAnalysis;

  /**
   * The cached value of the '{@link #getScope() <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScope()
   * @generated
   * @ordered
   */
  protected HwElement scope;

  /**
   * The cached value of the '{@link #getRamdomHardwarePartFailure() <em>Ramdom Hardware Part Failure</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRamdomHardwarePartFailure()
   * @generated
   * @ordered
   */
  protected HWPartFailure ramdomHardwarePartFailure;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarHardwareSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarHardwareSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWPartFailureAnalysis> getHardwarePartSafetyAnalysis()
  {
    if (hardwarePartSafetyAnalysis == null)
    {
      hardwarePartSafetyAnalysis = new EObjectResolvingEList<HWPartFailureAnalysis>(HWPartFailureAnalysis.class, this, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__HARDWARE_PART_SAFETY_ANALYSIS);
    }
    return hardwarePartSafetyAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HwElement getScope()
  {
    if (scope != null && scope.eIsProxy())
    {
      InternalEObject oldScope = (InternalEObject)scope;
      scope = (HwElement)eResolveProxy(oldScope);
      if (scope != oldScope)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__SCOPE, oldScope, scope));
      }
    }
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HwElement basicGetScope()
  {
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScope(HwElement newScope)
  {
    HwElement oldScope = scope;
    scope = newScope;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__SCOPE, oldScope, scope));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailure getRamdomHardwarePartFailure()
  {
    if (ramdomHardwarePartFailure != null && ramdomHardwarePartFailure.eIsProxy())
    {
      InternalEObject oldRamdomHardwarePartFailure = (InternalEObject)ramdomHardwarePartFailure;
      ramdomHardwarePartFailure = (HWPartFailure)eResolveProxy(oldRamdomHardwarePartFailure);
      if (ramdomHardwarePartFailure != oldRamdomHardwarePartFailure)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE, oldRamdomHardwarePartFailure, ramdomHardwarePartFailure));
      }
    }
    return ramdomHardwarePartFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailure basicGetRamdomHardwarePartFailure()
  {
    return ramdomHardwarePartFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetRamdomHardwarePartFailure(HWPartFailure newRamdomHardwarePartFailure, NotificationChain msgs)
  {
    HWPartFailure oldRamdomHardwarePartFailure = ramdomHardwarePartFailure;
    ramdomHardwarePartFailure = newRamdomHardwarePartFailure;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE, oldRamdomHardwarePartFailure, newRamdomHardwarePartFailure);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRamdomHardwarePartFailure(HWPartFailure newRamdomHardwarePartFailure)
  {
    if (newRamdomHardwarePartFailure != ramdomHardwarePartFailure)
    {
      NotificationChain msgs = null;
      if (ramdomHardwarePartFailure != null)
        msgs = ((InternalEObject)ramdomHardwarePartFailure).eInverseRemove(this, Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3, HWPartFailure.class, msgs);
      if (newRamdomHardwarePartFailure != null)
        msgs = ((InternalEObject)newRamdomHardwarePartFailure).eInverseAdd(this, Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3, HWPartFailure.class, msgs);
      msgs = basicSetRamdomHardwarePartFailure(newRamdomHardwarePartFailure, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE, newRamdomHardwarePartFailure, newRamdomHardwarePartFailure));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE:
        if (ramdomHardwarePartFailure != null)
          msgs = ((InternalEObject)ramdomHardwarePartFailure).eInverseRemove(this, Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3, HWPartFailure.class, msgs);
        return basicSetRamdomHardwarePartFailure((HWPartFailure)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE:
        return basicSetRamdomHardwarePartFailure(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__HARDWARE_PART_SAFETY_ANALYSIS:
        return getHardwarePartSafetyAnalysis();
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__SCOPE:
        if (resolve) return getScope();
        return basicGetScope();
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE:
        if (resolve) return getRamdomHardwarePartFailure();
        return basicGetRamdomHardwarePartFailure();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__HARDWARE_PART_SAFETY_ANALYSIS:
        getHardwarePartSafetyAnalysis().clear();
        getHardwarePartSafetyAnalysis().addAll((Collection<? extends HWPartFailureAnalysis>)newValue);
        return;
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__SCOPE:
   			setScope((HwElement)newValue);
        return;
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE:
   			setRamdomHardwarePartFailure((HWPartFailure)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__HARDWARE_PART_SAFETY_ANALYSIS:
        getHardwarePartSafetyAnalysis().clear();
        return;
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__SCOPE:
        	setScope((HwElement)null);
        return;
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE:
        	setRamdomHardwarePartFailure((HWPartFailure)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__HARDWARE_PART_SAFETY_ANALYSIS:
        return hardwarePartSafetyAnalysis != null && !hardwarePartSafetyAnalysis.isEmpty();
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__SCOPE:
        return scope != null;
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE:
        return ramdomHardwarePartFailure != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarHardwareSafetyExtensionImpl
