/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.commonstructure.modedeclaration.ModeDeclarationGroupPrototype;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Mode In Port From Component In Composition Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarModeInPortFromComponentInCompositionInstanceRefImpl#getTargetModeGroup <em>Target Mode Group</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarModeInPortFromComponentInCompositionInstanceRefImpl extends AutosarAbstractPortInComponentInstanceRefImpl implements AutosarModeInPortFromComponentInCompositionInstanceRef
{
  /**
   * The cached value of the '{@link #getTargetModeGroup() <em>Target Mode Group</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetModeGroup()
   * @generated
   * @ordered
   */
  protected ModeDeclarationGroupPrototype targetModeGroup;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarModeInPortFromComponentInCompositionInstanceRefImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarModeInPortFromComponentInCompositionInstanceRef();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModeDeclarationGroupPrototype getTargetModeGroup()
  {
    if (targetModeGroup != null && targetModeGroup.eIsProxy())
    {
      InternalEObject oldTargetModeGroup = (InternalEObject)targetModeGroup;
      targetModeGroup = (ModeDeclarationGroupPrototype)eResolveProxy(oldTargetModeGroup);
      if (targetModeGroup != oldTargetModeGroup)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_MODE_GROUP, oldTargetModeGroup, targetModeGroup));
      }
    }
    return targetModeGroup;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModeDeclarationGroupPrototype basicGetTargetModeGroup()
  {
    return targetModeGroup;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetModeGroup(ModeDeclarationGroupPrototype newTargetModeGroup)
  {
    ModeDeclarationGroupPrototype oldTargetModeGroup = targetModeGroup;
    targetModeGroup = newTargetModeGroup;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_MODE_GROUP, oldTargetModeGroup, targetModeGroup));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_MODE_GROUP:
        if (resolve) return getTargetModeGroup();
        return basicGetTargetModeGroup();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_MODE_GROUP:
   			setTargetModeGroup((ModeDeclarationGroupPrototype)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_MODE_GROUP:
        	setTargetModeGroup((ModeDeclarationGroupPrototype)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF__TARGET_MODE_GROUP:
        return targetModeGroup != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarModeInPortFromComponentInCompositionInstanceRefImpl
