/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.swcomponent.datatype.dataprototypes.VariableDataPrototype;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Variable Data Prototype Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarVariableDataPrototypeInstanceRefImpl#getTargetDataElement <em>Target Data Element</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarVariableDataPrototypeInstanceRefImpl extends AutosarAbstractPortInComponentInstanceRefImpl implements AutosarVariableDataPrototypeInstanceRef
{
  /**
   * The cached value of the '{@link #getTargetDataElement() <em>Target Data Element</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetDataElement()
   * @generated
   * @ordered
   */
  protected VariableDataPrototype targetDataElement;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarVariableDataPrototypeInstanceRefImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarVariableDataPrototypeInstanceRef();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariableDataPrototype getTargetDataElement()
  {
    if (targetDataElement != null && targetDataElement.eIsProxy())
    {
      InternalEObject oldTargetDataElement = (InternalEObject)targetDataElement;
      targetDataElement = (VariableDataPrototype)eResolveProxy(oldTargetDataElement);
      if (targetDataElement != oldTargetDataElement)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF__TARGET_DATA_ELEMENT, oldTargetDataElement, targetDataElement));
      }
    }
    return targetDataElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariableDataPrototype basicGetTargetDataElement()
  {
    return targetDataElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetDataElement(VariableDataPrototype newTargetDataElement)
  {
    VariableDataPrototype oldTargetDataElement = targetDataElement;
    targetDataElement = newTargetDataElement;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF__TARGET_DATA_ELEMENT, oldTargetDataElement, targetDataElement));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF__TARGET_DATA_ELEMENT:
        if (resolve) return getTargetDataElement();
        return basicGetTargetDataElement();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF__TARGET_DATA_ELEMENT:
   			setTargetDataElement((VariableDataPrototype)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF__TARGET_DATA_ELEMENT:
        	setTargetDataElement((VariableDataPrototype)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF__TARGET_DATA_ELEMENT:
        return targetDataElement != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarVariableDataPrototypeInstanceRefImpl
