/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.CRCConfig;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CRC Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.CRCConfigImpl#getCheckValue <em>Check Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CRCConfigImpl#getCrcBits <em>Crc Bits</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CRCConfigImpl#getMagicValue <em>Magic Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CRCConfigImpl#getPolynomialBits <em>Polynomial Bits</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CRCConfigImpl#getStartValue <em>Start Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CRCConfigImpl#getXorValue <em>Xor Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CRCConfigImpl extends ExtendedEObjectImpl implements CRCConfig
{
  /**
   * The default value of the '{@link #getCheckValue() <em>Check Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCheckValue()
   * @generated
   * @ordered
   */
  protected static final Integer CHECK_VALUE_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getCheckValue() <em>Check Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCheckValue()
   * @generated
   * @ordered
   */
  protected Integer checkValue = CHECK_VALUE_EDEFAULT;

  /**
   * This is true if the Check Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean checkValueESet;

  /**
   * The default value of the '{@link #getCrcBits() <em>Crc Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCrcBits()
   * @generated
   * @ordered
   */
  protected static final Integer CRC_BITS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getCrcBits() <em>Crc Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCrcBits()
   * @generated
   * @ordered
   */
  protected Integer crcBits = CRC_BITS_EDEFAULT;

  /**
   * This is true if the Crc Bits attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean crcBitsESet;

  /**
   * The default value of the '{@link #getMagicValue() <em>Magic Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMagicValue()
   * @generated
   * @ordered
   */
  protected static final Integer MAGIC_VALUE_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getMagicValue() <em>Magic Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMagicValue()
   * @generated
   * @ordered
   */
  protected Integer magicValue = MAGIC_VALUE_EDEFAULT;

  /**
   * This is true if the Magic Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean magicValueESet;

  /**
   * The default value of the '{@link #getPolynomialBits() <em>Polynomial Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPolynomialBits()
   * @generated
   * @ordered
   */
  protected static final Integer POLYNOMIAL_BITS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getPolynomialBits() <em>Polynomial Bits</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPolynomialBits()
   * @generated
   * @ordered
   */
  protected Integer polynomialBits = POLYNOMIAL_BITS_EDEFAULT;

  /**
   * This is true if the Polynomial Bits attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean polynomialBitsESet;

  /**
   * The default value of the '{@link #getStartValue() <em>Start Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStartValue()
   * @generated
   * @ordered
   */
  protected static final Integer START_VALUE_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getStartValue() <em>Start Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStartValue()
   * @generated
   * @ordered
   */
  protected Integer startValue = START_VALUE_EDEFAULT;

  /**
   * This is true if the Start Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean startValueESet;

  /**
   * The default value of the '{@link #getXorValue() <em>Xor Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getXorValue()
   * @generated
   * @ordered
   */
  protected static final Integer XOR_VALUE_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getXorValue() <em>Xor Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getXorValue()
   * @generated
   * @ordered
   */
  protected Integer xorValue = XOR_VALUE_EDEFAULT;

  /**
   * This is true if the Xor Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean xorValueESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CRCConfigImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getCRCConfig();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getCheckValue()
  {
    return checkValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCheckValue(Integer newCheckValue)
  {
    Integer oldCheckValue = checkValue;
    checkValue = newCheckValue;
    boolean oldCheckValueESet = checkValueESet;
    checkValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CRC_CONFIG__CHECK_VALUE, oldCheckValue, checkValue, !oldCheckValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCheckValue()
  {
    Integer oldCheckValue = checkValue;
    boolean oldCheckValueESet = checkValueESet;
    checkValue = CHECK_VALUE_EDEFAULT;
    checkValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CRC_CONFIG__CHECK_VALUE, oldCheckValue, CHECK_VALUE_EDEFAULT, oldCheckValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCheckValue()
  {
    return checkValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getCrcBits()
  {
    return crcBits;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCrcBits(Integer newCrcBits)
  {
    Integer oldCrcBits = crcBits;
    crcBits = newCrcBits;
    boolean oldCrcBitsESet = crcBitsESet;
    crcBitsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CRC_CONFIG__CRC_BITS, oldCrcBits, crcBits, !oldCrcBitsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCrcBits()
  {
    Integer oldCrcBits = crcBits;
    boolean oldCrcBitsESet = crcBitsESet;
    crcBits = CRC_BITS_EDEFAULT;
    crcBitsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CRC_CONFIG__CRC_BITS, oldCrcBits, CRC_BITS_EDEFAULT, oldCrcBitsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCrcBits()
  {
    return crcBitsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getMagicValue()
  {
    return magicValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMagicValue(Integer newMagicValue)
  {
    Integer oldMagicValue = magicValue;
    magicValue = newMagicValue;
    boolean oldMagicValueESet = magicValueESet;
    magicValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CRC_CONFIG__MAGIC_VALUE, oldMagicValue, magicValue, !oldMagicValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMagicValue()
  {
    Integer oldMagicValue = magicValue;
    boolean oldMagicValueESet = magicValueESet;
    magicValue = MAGIC_VALUE_EDEFAULT;
    magicValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CRC_CONFIG__MAGIC_VALUE, oldMagicValue, MAGIC_VALUE_EDEFAULT, oldMagicValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMagicValue()
  {
    return magicValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getPolynomialBits()
  {
    return polynomialBits;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPolynomialBits(Integer newPolynomialBits)
  {
    Integer oldPolynomialBits = polynomialBits;
    polynomialBits = newPolynomialBits;
    boolean oldPolynomialBitsESet = polynomialBitsESet;
    polynomialBitsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CRC_CONFIG__POLYNOMIAL_BITS, oldPolynomialBits, polynomialBits, !oldPolynomialBitsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPolynomialBits()
  {
    Integer oldPolynomialBits = polynomialBits;
    boolean oldPolynomialBitsESet = polynomialBitsESet;
    polynomialBits = POLYNOMIAL_BITS_EDEFAULT;
    polynomialBitsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CRC_CONFIG__POLYNOMIAL_BITS, oldPolynomialBits, POLYNOMIAL_BITS_EDEFAULT, oldPolynomialBitsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPolynomialBits()
  {
    return polynomialBitsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getStartValue()
  {
    return startValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setStartValue(Integer newStartValue)
  {
    Integer oldStartValue = startValue;
    startValue = newStartValue;
    boolean oldStartValueESet = startValueESet;
    startValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CRC_CONFIG__START_VALUE, oldStartValue, startValue, !oldStartValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetStartValue()
  {
    Integer oldStartValue = startValue;
    boolean oldStartValueESet = startValueESet;
    startValue = START_VALUE_EDEFAULT;
    startValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CRC_CONFIG__START_VALUE, oldStartValue, START_VALUE_EDEFAULT, oldStartValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetStartValue()
  {
    return startValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getXorValue()
  {
    return xorValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setXorValue(Integer newXorValue)
  {
    Integer oldXorValue = xorValue;
    xorValue = newXorValue;
    boolean oldXorValueESet = xorValueESet;
    xorValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CRC_CONFIG__XOR_VALUE, oldXorValue, xorValue, !oldXorValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetXorValue()
  {
    Integer oldXorValue = xorValue;
    boolean oldXorValueESet = xorValueESet;
    xorValue = XOR_VALUE_EDEFAULT;
    xorValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CRC_CONFIG__XOR_VALUE, oldXorValue, XOR_VALUE_EDEFAULT, oldXorValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetXorValue()
  {
    return xorValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CRC_CONFIG__CHECK_VALUE:
        return getCheckValue();
      case Safe10Package.CRC_CONFIG__CRC_BITS:
        return getCrcBits();
      case Safe10Package.CRC_CONFIG__MAGIC_VALUE:
        return getMagicValue();
      case Safe10Package.CRC_CONFIG__POLYNOMIAL_BITS:
        return getPolynomialBits();
      case Safe10Package.CRC_CONFIG__START_VALUE:
        return getStartValue();
      case Safe10Package.CRC_CONFIG__XOR_VALUE:
        return getXorValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CRC_CONFIG__CHECK_VALUE:
   			setCheckValue((Integer)newValue);
        return;
      case Safe10Package.CRC_CONFIG__CRC_BITS:
   			setCrcBits((Integer)newValue);
        return;
      case Safe10Package.CRC_CONFIG__MAGIC_VALUE:
   			setMagicValue((Integer)newValue);
        return;
      case Safe10Package.CRC_CONFIG__POLYNOMIAL_BITS:
   			setPolynomialBits((Integer)newValue);
        return;
      case Safe10Package.CRC_CONFIG__START_VALUE:
   			setStartValue((Integer)newValue);
        return;
      case Safe10Package.CRC_CONFIG__XOR_VALUE:
   			setXorValue((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CRC_CONFIG__CHECK_VALUE:
        unsetCheckValue();
        return;
      case Safe10Package.CRC_CONFIG__CRC_BITS:
        unsetCrcBits();
        return;
      case Safe10Package.CRC_CONFIG__MAGIC_VALUE:
        unsetMagicValue();
        return;
      case Safe10Package.CRC_CONFIG__POLYNOMIAL_BITS:
        unsetPolynomialBits();
        return;
      case Safe10Package.CRC_CONFIG__START_VALUE:
        unsetStartValue();
        return;
      case Safe10Package.CRC_CONFIG__XOR_VALUE:
        unsetXorValue();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CRC_CONFIG__CHECK_VALUE:
        return isSetCheckValue();
      case Safe10Package.CRC_CONFIG__CRC_BITS:
        return isSetCrcBits();
      case Safe10Package.CRC_CONFIG__MAGIC_VALUE:
        return isSetMagicValue();
      case Safe10Package.CRC_CONFIG__POLYNOMIAL_BITS:
        return isSetPolynomialBits();
      case Safe10Package.CRC_CONFIG__START_VALUE:
        return isSetStartValue();
      case Safe10Package.CRC_CONFIG__XOR_VALUE:
        return isSetXorValue();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (checkValue: ");
    if (checkValueESet) result.append(checkValue); else result.append("<unset>");
    result.append(", crcBits: ");
    if (crcBitsESet) result.append(crcBits); else result.append("<unset>");
    result.append(", magicValue: ");
    if (magicValueESet) result.append(magicValue); else result.append("<unset>");
    result.append(", polynomialBits: ");
    if (polynomialBitsESet) result.append(polynomialBits); else result.append("<unset>");
    result.append(", startValue: ");
    if (startValueESet) result.append(startValue); else result.append("<unset>");
    result.append(", xorValue: ");
    if (xorValueESet) result.append(xorValue); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //CRCConfigImpl
