/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.CheckPoint;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Check Point</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.CheckPointImpl#getLowerTolerance <em>Lower Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CheckPointImpl#getMaxReport <em>Max Report</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CheckPointImpl#getUpperTolerance <em>Upper Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CheckPointImpl#getPeriod <em>Period</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CheckPointImpl extends IdentifiableImpl implements CheckPoint
{
  /**
   * The default value of the '{@link #getLowerTolerance() <em>Lower Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLowerTolerance()
   * @generated
   * @ordered
   */
  protected static final Double LOWER_TOLERANCE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLowerTolerance() <em>Lower Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLowerTolerance()
   * @generated
   * @ordered
   */
  protected Double lowerTolerance = LOWER_TOLERANCE_EDEFAULT;

  /**
   * This is true if the Lower Tolerance attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lowerToleranceESet;

  /**
   * The default value of the '{@link #getMaxReport() <em>Max Report</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMaxReport()
   * @generated
   * @ordered
   */
  protected static final Integer MAX_REPORT_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getMaxReport() <em>Max Report</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMaxReport()
   * @generated
   * @ordered
   */
  protected Integer maxReport = MAX_REPORT_EDEFAULT;

  /**
   * This is true if the Max Report attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean maxReportESet;

  /**
   * The default value of the '{@link #getUpperTolerance() <em>Upper Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUpperTolerance()
   * @generated
   * @ordered
   */
  protected static final Double UPPER_TOLERANCE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getUpperTolerance() <em>Upper Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUpperTolerance()
   * @generated
   * @ordered
   */
  protected Double upperTolerance = UPPER_TOLERANCE_EDEFAULT;

  /**
   * This is true if the Upper Tolerance attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean upperToleranceESet;

  /**
   * The default value of the '{@link #getPeriod() <em>Period</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPeriod()
   * @generated
   * @ordered
   */
  protected static final Integer PERIOD_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getPeriod() <em>Period</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPeriod()
   * @generated
   * @ordered
   */
  protected Integer period = PERIOD_EDEFAULT;

  /**
   * This is true if the Period attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean periodESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CheckPointImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getCheckPoint();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLowerTolerance()
  {
    return lowerTolerance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLowerTolerance(Double newLowerTolerance)
  {
    Double oldLowerTolerance = lowerTolerance;
    lowerTolerance = newLowerTolerance;
    boolean oldLowerToleranceESet = lowerToleranceESet;
    lowerToleranceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHECK_POINT__LOWER_TOLERANCE, oldLowerTolerance, lowerTolerance, !oldLowerToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLowerTolerance()
  {
    Double oldLowerTolerance = lowerTolerance;
    boolean oldLowerToleranceESet = lowerToleranceESet;
    lowerTolerance = LOWER_TOLERANCE_EDEFAULT;
    lowerToleranceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CHECK_POINT__LOWER_TOLERANCE, oldLowerTolerance, LOWER_TOLERANCE_EDEFAULT, oldLowerToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLowerTolerance()
  {
    return lowerToleranceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getMaxReport()
  {
    return maxReport;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMaxReport(Integer newMaxReport)
  {
    Integer oldMaxReport = maxReport;
    maxReport = newMaxReport;
    boolean oldMaxReportESet = maxReportESet;
    maxReportESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHECK_POINT__MAX_REPORT, oldMaxReport, maxReport, !oldMaxReportESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMaxReport()
  {
    Integer oldMaxReport = maxReport;
    boolean oldMaxReportESet = maxReportESet;
    maxReport = MAX_REPORT_EDEFAULT;
    maxReportESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CHECK_POINT__MAX_REPORT, oldMaxReport, MAX_REPORT_EDEFAULT, oldMaxReportESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMaxReport()
  {
    return maxReportESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getUpperTolerance()
  {
    return upperTolerance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUpperTolerance(Double newUpperTolerance)
  {
    Double oldUpperTolerance = upperTolerance;
    upperTolerance = newUpperTolerance;
    boolean oldUpperToleranceESet = upperToleranceESet;
    upperToleranceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHECK_POINT__UPPER_TOLERANCE, oldUpperTolerance, upperTolerance, !oldUpperToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetUpperTolerance()
  {
    Double oldUpperTolerance = upperTolerance;
    boolean oldUpperToleranceESet = upperToleranceESet;
    upperTolerance = UPPER_TOLERANCE_EDEFAULT;
    upperToleranceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CHECK_POINT__UPPER_TOLERANCE, oldUpperTolerance, UPPER_TOLERANCE_EDEFAULT, oldUpperToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUpperTolerance()
  {
    return upperToleranceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getPeriod()
  {
    return period;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPeriod(Integer newPeriod)
  {
    Integer oldPeriod = period;
    period = newPeriod;
    boolean oldPeriodESet = periodESet;
    periodESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHECK_POINT__PERIOD, oldPeriod, period, !oldPeriodESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPeriod()
  {
    Integer oldPeriod = period;
    boolean oldPeriodESet = periodESet;
    period = PERIOD_EDEFAULT;
    periodESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CHECK_POINT__PERIOD, oldPeriod, PERIOD_EDEFAULT, oldPeriodESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPeriod()
  {
    return periodESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CHECK_POINT__LOWER_TOLERANCE:
        return getLowerTolerance();
      case Safe10Package.CHECK_POINT__MAX_REPORT:
        return getMaxReport();
      case Safe10Package.CHECK_POINT__UPPER_TOLERANCE:
        return getUpperTolerance();
      case Safe10Package.CHECK_POINT__PERIOD:
        return getPeriod();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CHECK_POINT__LOWER_TOLERANCE:
   			setLowerTolerance((Double)newValue);
        return;
      case Safe10Package.CHECK_POINT__MAX_REPORT:
   			setMaxReport((Integer)newValue);
        return;
      case Safe10Package.CHECK_POINT__UPPER_TOLERANCE:
   			setUpperTolerance((Double)newValue);
        return;
      case Safe10Package.CHECK_POINT__PERIOD:
   			setPeriod((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHECK_POINT__LOWER_TOLERANCE:
        unsetLowerTolerance();
        return;
      case Safe10Package.CHECK_POINT__MAX_REPORT:
        unsetMaxReport();
        return;
      case Safe10Package.CHECK_POINT__UPPER_TOLERANCE:
        unsetUpperTolerance();
        return;
      case Safe10Package.CHECK_POINT__PERIOD:
        unsetPeriod();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHECK_POINT__LOWER_TOLERANCE:
        return isSetLowerTolerance();
      case Safe10Package.CHECK_POINT__MAX_REPORT:
        return isSetMaxReport();
      case Safe10Package.CHECK_POINT__UPPER_TOLERANCE:
        return isSetUpperTolerance();
      case Safe10Package.CHECK_POINT__PERIOD:
        return isSetPeriod();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (lowerTolerance: ");
    if (lowerToleranceESet) result.append(lowerTolerance); else result.append("<unset>");
    result.append(", maxReport: ");
    if (maxReportESet) result.append(maxReport); else result.append("<unset>");
    result.append(", upperTolerance: ");
    if (upperToleranceESet) result.append(upperTolerance); else result.append("<unset>");
    result.append(", period: ");
    if (periodESet) result.append(period); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //CheckPointImpl
