/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.ChromosomeCpuSelfTest;
import org.safe.metamodel.safe10.Component;
import org.safe.metamodel.safe10.Node;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Chromosome Cpu Self Test</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ChromosomeCpuSelfTestImpl#getSatisfiedBy <em>Satisfied By</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ChromosomeCpuSelfTestImpl#getChecks <em>Checks</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ChromosomeCpuSelfTestImpl extends CpuSelfTestImpl implements ChromosomeCpuSelfTest
{
  /**
   * The cached value of the '{@link #getSatisfiedBy() <em>Satisfied By</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfiedBy()
   * @generated
   * @ordered
   */
  protected Component satisfiedBy;

  /**
   * The cached value of the '{@link #getChecks() <em>Checks</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getChecks()
   * @generated
   * @ordered
   */
  protected Node checks;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ChromosomeCpuSelfTestImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getChromosomeCpuSelfTest();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Component getSatisfiedBy()
  {
    if (satisfiedBy != null && satisfiedBy.eIsProxy())
    {
      InternalEObject oldSatisfiedBy = (InternalEObject)satisfiedBy;
      satisfiedBy = (Component)eResolveProxy(oldSatisfiedBy);
      if (satisfiedBy != oldSatisfiedBy)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.CHROMOSOME_CPU_SELF_TEST__SATISFIED_BY, oldSatisfiedBy, satisfiedBy));
      }
    }
    return satisfiedBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Component basicGetSatisfiedBy()
  {
    return satisfiedBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSatisfiedBy(Component newSatisfiedBy)
  {
    Component oldSatisfiedBy = satisfiedBy;
    satisfiedBy = newSatisfiedBy;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHROMOSOME_CPU_SELF_TEST__SATISFIED_BY, oldSatisfiedBy, satisfiedBy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Node getChecks()
  {
    if (checks != null && checks.eIsProxy())
    {
      InternalEObject oldChecks = (InternalEObject)checks;
      checks = (Node)eResolveProxy(oldChecks);
      if (checks != oldChecks)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.CHROMOSOME_CPU_SELF_TEST__CHECKS, oldChecks, checks));
      }
    }
    return checks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Node basicGetChecks()
  {
    return checks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setChecks(Node newChecks)
  {
    Node oldChecks = checks;
    checks = newChecks;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHROMOSOME_CPU_SELF_TEST__CHECKS, oldChecks, checks));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__SATISFIED_BY:
        if (resolve) return getSatisfiedBy();
        return basicGetSatisfiedBy();
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__CHECKS:
        if (resolve) return getChecks();
        return basicGetChecks();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__SATISFIED_BY:
   			setSatisfiedBy((Component)newValue);
        return;
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__CHECKS:
   			setChecks((Node)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__SATISFIED_BY:
        	setSatisfiedBy((Component)null);
        return;
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__CHECKS:
        	setChecks((Node)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__SATISFIED_BY:
        return satisfiedBy != null;
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST__CHECKS:
        return checks != null;
    }
    return super.eIsSet(featureID);
  }

} //ChromosomeCpuSelfTestImpl
