/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.CodeGenerationConfiguration;
import org.safe.metamodel.safe10.ConfigParameter;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SoftwareSafetyRequirement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Code Generation Configuration</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.CodeGenerationConfigurationImpl#getFromRequirement <em>From Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CodeGenerationConfigurationImpl#getParams <em>Params</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CodeGenerationConfigurationImpl extends IdentifiableImpl implements CodeGenerationConfiguration
{
  /**
   * The cached value of the '{@link #getFromRequirement() <em>From Requirement</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFromRequirement()
   * @generated
   * @ordered
   */
  protected SoftwareSafetyRequirement fromRequirement;

  /**
   * The cached value of the '{@link #getParams() <em>Params</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParams()
   * @generated
   * @ordered
   */
  protected EList<ConfigParameter> params;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CodeGenerationConfigurationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getCodeGenerationConfiguration();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareSafetyRequirement getFromRequirement()
  {
    if (fromRequirement != null && fromRequirement.eIsProxy())
    {
      InternalEObject oldFromRequirement = (InternalEObject)fromRequirement;
      fromRequirement = (SoftwareSafetyRequirement)eResolveProxy(oldFromRequirement);
      if (fromRequirement != oldFromRequirement)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.CODE_GENERATION_CONFIGURATION__FROM_REQUIREMENT, oldFromRequirement, fromRequirement));
      }
    }
    return fromRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareSafetyRequirement basicGetFromRequirement()
  {
    return fromRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFromRequirement(SoftwareSafetyRequirement newFromRequirement)
  {
    SoftwareSafetyRequirement oldFromRequirement = fromRequirement;
    fromRequirement = newFromRequirement;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CODE_GENERATION_CONFIGURATION__FROM_REQUIREMENT, oldFromRequirement, fromRequirement));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ConfigParameter> getParams()
  {
    if (params == null)
    {
      params = new EObjectContainmentEList<ConfigParameter>(ConfigParameter.class, this, Safe10Package.CODE_GENERATION_CONFIGURATION__PARAMS);
    }
    return params;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.CODE_GENERATION_CONFIGURATION__PARAMS:
        return ((InternalEList<?>)getParams()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CODE_GENERATION_CONFIGURATION__FROM_REQUIREMENT:
        if (resolve) return getFromRequirement();
        return basicGetFromRequirement();
      case Safe10Package.CODE_GENERATION_CONFIGURATION__PARAMS:
        return getParams();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CODE_GENERATION_CONFIGURATION__FROM_REQUIREMENT:
   			setFromRequirement((SoftwareSafetyRequirement)newValue);
        return;
      case Safe10Package.CODE_GENERATION_CONFIGURATION__PARAMS:
        getParams().clear();
        getParams().addAll((Collection<? extends ConfigParameter>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CODE_GENERATION_CONFIGURATION__FROM_REQUIREMENT:
        	setFromRequirement((SoftwareSafetyRequirement)null);
        return;
      case Safe10Package.CODE_GENERATION_CONFIGURATION__PARAMS:
        getParams().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CODE_GENERATION_CONFIGURATION__FROM_REQUIREMENT:
        return fromRequirement != null;
      case Safe10Package.CODE_GENERATION_CONFIGURATION__PARAMS:
        return params != null && !params.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //CodeGenerationConfigurationImpl
