/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.ComponentPrototypeCRC;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Component Prototype CRC</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ComponentPrototypeCRCImpl#getChecks <em>Checks</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComponentPrototypeCRCImpl extends AutosarCRCImpl implements ComponentPrototypeCRC
{
  /**
   * The cached value of the '{@link #getChecks() <em>Checks</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getChecks()
   * @generated
   * @ordered
   */
  protected AutosarVariableDataPrototypeInstanceRef checks;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComponentPrototypeCRCImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getComponentPrototypeCRC();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarVariableDataPrototypeInstanceRef getChecks()
  {
    return checks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetChecks(AutosarVariableDataPrototypeInstanceRef newChecks, NotificationChain msgs)
  {
    AutosarVariableDataPrototypeInstanceRef oldChecks = checks;
    checks = newChecks;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS, oldChecks, newChecks);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setChecks(AutosarVariableDataPrototypeInstanceRef newChecks)
  {
    if (newChecks != checks)
    {
      NotificationChain msgs = null;
      if (checks != null)
        msgs = ((InternalEObject)checks).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS, null, msgs);
      if (newChecks != null)
        msgs = ((InternalEObject)newChecks).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS, null, msgs);
      msgs = basicSetChecks(newChecks, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS, newChecks, newChecks));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS:
        return basicSetChecks(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS:
        return getChecks();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS:
   			setChecks((AutosarVariableDataPrototypeInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS:
        	setChecks((AutosarVariableDataPrototypeInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.COMPONENT_PROTOTYPE_CRC__CHECKS:
        return checks != null;
    }
    return super.eIsSet(featureID);
  }

} //ComponentPrototypeCRCImpl
