/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.ContextRangeCheck;
import org.safe.metamodel.safe10.RangeCheckContext;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Context Range Check</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ContextRangeCheckImpl#getDefault <em>Default</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ContextRangeCheckImpl#getAdditional <em>Additional</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ContextRangeCheckImpl extends SoftwareSafetyRequirementImpl implements ContextRangeCheck
{
  /**
   * The cached value of the '{@link #getDefault() <em>Default</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDefault()
   * @generated
   * @ordered
   */
  protected RangeCheckContext default_;

  /**
   * The cached value of the '{@link #getAdditional() <em>Additional</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAdditional()
   * @generated
   * @ordered
   */
  protected EList<RangeCheckContext> additional;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ContextRangeCheckImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getContextRangeCheck();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RangeCheckContext getDefault()
  {
    return default_;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetDefault(RangeCheckContext newDefault, NotificationChain msgs)
  {
    RangeCheckContext oldDefault = default_;
    default_ = newDefault;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT, oldDefault, newDefault);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDefault(RangeCheckContext newDefault)
  {
    if (newDefault != default_)
    {
      NotificationChain msgs = null;
      if (default_ != null)
        msgs = ((InternalEObject)default_).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT, null, msgs);
      if (newDefault != null)
        msgs = ((InternalEObject)newDefault).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT, null, msgs);
      msgs = basicSetDefault(newDefault, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT, newDefault, newDefault));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RangeCheckContext> getAdditional()
  {
    if (additional == null)
    {
      additional = new EObjectContainmentEList<RangeCheckContext>(RangeCheckContext.class, this, Safe10Package.CONTEXT_RANGE_CHECK__ADDITIONAL);
    }
    return additional;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT:
        return basicSetDefault(null, msgs);
      case Safe10Package.CONTEXT_RANGE_CHECK__ADDITIONAL:
        return ((InternalEList<?>)getAdditional()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT:
        return getDefault();
      case Safe10Package.CONTEXT_RANGE_CHECK__ADDITIONAL:
        return getAdditional();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT:
   			setDefault((RangeCheckContext)newValue);
        return;
      case Safe10Package.CONTEXT_RANGE_CHECK__ADDITIONAL:
        getAdditional().clear();
        getAdditional().addAll((Collection<? extends RangeCheckContext>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT:
        	setDefault((RangeCheckContext)null);
        return;
      case Safe10Package.CONTEXT_RANGE_CHECK__ADDITIONAL:
        getAdditional().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONTEXT_RANGE_CHECK__DEFAULT:
        return default_ != null;
      case Safe10Package.CONTEXT_RANGE_CHECK__ADDITIONAL:
        return additional != null && !additional.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ContextRangeCheckImpl
