/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.ControllabilityReference;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Controllability Reference</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ControllabilityReferenceImpl#getTableOfValues <em>Table Of Values</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ControllabilityReferenceImpl#getFunction <em>Function</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ControllabilityReferenceImpl extends IdentifiableImpl implements ControllabilityReference
{
  /**
   * The default value of the '{@link #getTableOfValues() <em>Table Of Values</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTableOfValues()
   * @generated
   * @ordered
   */
  protected static final String TABLE_OF_VALUES_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getTableOfValues() <em>Table Of Values</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTableOfValues()
   * @generated
   * @ordered
   */
  protected String tableOfValues = TABLE_OF_VALUES_EDEFAULT;

  /**
   * This is true if the Table Of Values attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean tableOfValuesESet;

  /**
   * The default value of the '{@link #getFunction() <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFunction()
   * @generated
   * @ordered
   */
  protected static final String FUNCTION_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getFunction() <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFunction()
   * @generated
   * @ordered
   */
  protected String function = FUNCTION_EDEFAULT;

  /**
   * This is true if the Function attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean functionESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ControllabilityReferenceImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getControllabilityReference();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTableOfValues()
  {
    return tableOfValues;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTableOfValues(String newTableOfValues)
  {
    String oldTableOfValues = tableOfValues;
    tableOfValues = newTableOfValues;
    boolean oldTableOfValuesESet = tableOfValuesESet;
    tableOfValuesESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONTROLLABILITY_REFERENCE__TABLE_OF_VALUES, oldTableOfValues, tableOfValues, !oldTableOfValuesESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetTableOfValues()
  {
    String oldTableOfValues = tableOfValues;
    boolean oldTableOfValuesESet = tableOfValuesESet;
    tableOfValues = TABLE_OF_VALUES_EDEFAULT;
    tableOfValuesESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CONTROLLABILITY_REFERENCE__TABLE_OF_VALUES, oldTableOfValues, TABLE_OF_VALUES_EDEFAULT, oldTableOfValuesESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetTableOfValues()
  {
    return tableOfValuesESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getFunction()
  {
    return function;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFunction(String newFunction)
  {
    String oldFunction = function;
    function = newFunction;
    boolean oldFunctionESet = functionESet;
    functionESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONTROLLABILITY_REFERENCE__FUNCTION, oldFunction, function, !oldFunctionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFunction()
  {
    String oldFunction = function;
    boolean oldFunctionESet = functionESet;
    function = FUNCTION_EDEFAULT;
    functionESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CONTROLLABILITY_REFERENCE__FUNCTION, oldFunction, FUNCTION_EDEFAULT, oldFunctionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFunction()
  {
    return functionESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROLLABILITY_REFERENCE__TABLE_OF_VALUES:
        return getTableOfValues();
      case Safe10Package.CONTROLLABILITY_REFERENCE__FUNCTION:
        return getFunction();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROLLABILITY_REFERENCE__TABLE_OF_VALUES:
   			setTableOfValues((String)newValue);
        return;
      case Safe10Package.CONTROLLABILITY_REFERENCE__FUNCTION:
   			setFunction((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROLLABILITY_REFERENCE__TABLE_OF_VALUES:
        unsetTableOfValues();
        return;
      case Safe10Package.CONTROLLABILITY_REFERENCE__FUNCTION:
        unsetFunction();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROLLABILITY_REFERENCE__TABLE_OF_VALUES:
        return isSetTableOfValues();
      case Safe10Package.CONTROLLABILITY_REFERENCE__FUNCTION:
        return isSetFunction();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (tableOfValues: ");
    if (tableOfValuesESet) result.append(tableOfValues); else result.append("<unset>");
    result.append(", function: ");
    if (functionESet) result.append(function); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //ControllabilityReferenceImpl
