/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.CpuSelfTestConfig;
import org.safe.metamodel.safe10.CpuTestAlgorithmEnum;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Cpu Self Test Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.CpuSelfTestConfigImpl#getExecutionPeriodMs <em>Execution Period Ms</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CpuSelfTestConfigImpl#getExecuteInSegments <em>Execute In Segments</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CpuSelfTestConfigImpl#getNumSegments <em>Num Segments</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.CpuSelfTestConfigImpl#getAlgorithms <em>Algorithms</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CpuSelfTestConfigImpl extends IdentifiableImpl implements CpuSelfTestConfig
{
  /**
   * The default value of the '{@link #getExecutionPeriodMs() <em>Execution Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecutionPeriodMs()
   * @generated
   * @ordered
   */
  protected static final Integer EXECUTION_PERIOD_MS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getExecutionPeriodMs() <em>Execution Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecutionPeriodMs()
   * @generated
   * @ordered
   */
  protected Integer executionPeriodMs = EXECUTION_PERIOD_MS_EDEFAULT;

  /**
   * This is true if the Execution Period Ms attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean executionPeriodMsESet;

  /**
   * The default value of the '{@link #getExecuteInSegments() <em>Execute In Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecuteInSegments()
   * @generated
   * @ordered
   */
  protected static final Boolean EXECUTE_IN_SEGMENTS_EDEFAULT = Boolean.FALSE;

  /**
   * The cached value of the '{@link #getExecuteInSegments() <em>Execute In Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecuteInSegments()
   * @generated
   * @ordered
   */
  protected Boolean executeInSegments = EXECUTE_IN_SEGMENTS_EDEFAULT;

  /**
   * This is true if the Execute In Segments attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean executeInSegmentsESet;

  /**
   * The default value of the '{@link #getNumSegments() <em>Num Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNumSegments()
   * @generated
   * @ordered
   */
  protected static final Integer NUM_SEGMENTS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getNumSegments() <em>Num Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNumSegments()
   * @generated
   * @ordered
   */
  protected Integer numSegments = NUM_SEGMENTS_EDEFAULT;

  /**
   * This is true if the Num Segments attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean numSegmentsESet;

  /**
   * The default value of the '{@link #getAlgorithms() <em>Algorithms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAlgorithms()
   * @generated
   * @ordered
   */
  protected static final CpuTestAlgorithmEnum ALGORITHMS_EDEFAULT = CpuTestAlgorithmEnum.LIMITED_NUMBER_OF_WALKING_PATTERNS;

  /**
   * The cached value of the '{@link #getAlgorithms() <em>Algorithms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAlgorithms()
   * @generated
   * @ordered
   */
  protected CpuTestAlgorithmEnum algorithms = ALGORITHMS_EDEFAULT;

  /**
   * This is true if the Algorithms attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean algorithmsESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CpuSelfTestConfigImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getCpuSelfTestConfig();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getExecutionPeriodMs()
  {
    return executionPeriodMs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExecutionPeriodMs(Integer newExecutionPeriodMs)
  {
    Integer oldExecutionPeriodMs = executionPeriodMs;
    executionPeriodMs = newExecutionPeriodMs;
    boolean oldExecutionPeriodMsESet = executionPeriodMsESet;
    executionPeriodMsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTION_PERIOD_MS, oldExecutionPeriodMs, executionPeriodMs, !oldExecutionPeriodMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetExecutionPeriodMs()
  {
    Integer oldExecutionPeriodMs = executionPeriodMs;
    boolean oldExecutionPeriodMsESet = executionPeriodMsESet;
    executionPeriodMs = EXECUTION_PERIOD_MS_EDEFAULT;
    executionPeriodMsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTION_PERIOD_MS, oldExecutionPeriodMs, EXECUTION_PERIOD_MS_EDEFAULT, oldExecutionPeriodMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetExecutionPeriodMs()
  {
    return executionPeriodMsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean getExecuteInSegments()
  {
    return executeInSegments;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExecuteInSegments(Boolean newExecuteInSegments)
  {
    Boolean oldExecuteInSegments = executeInSegments;
    executeInSegments = newExecuteInSegments;
    boolean oldExecuteInSegmentsESet = executeInSegmentsESet;
    executeInSegmentsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTE_IN_SEGMENTS, oldExecuteInSegments, executeInSegments, !oldExecuteInSegmentsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetExecuteInSegments()
  {
    Boolean oldExecuteInSegments = executeInSegments;
    boolean oldExecuteInSegmentsESet = executeInSegmentsESet;
    executeInSegments = EXECUTE_IN_SEGMENTS_EDEFAULT;
    executeInSegmentsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTE_IN_SEGMENTS, oldExecuteInSegments, EXECUTE_IN_SEGMENTS_EDEFAULT, oldExecuteInSegmentsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetExecuteInSegments()
  {
    return executeInSegmentsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getNumSegments()
  {
    return numSegments;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNumSegments(Integer newNumSegments)
  {
    Integer oldNumSegments = numSegments;
    numSegments = newNumSegments;
    boolean oldNumSegmentsESet = numSegmentsESet;
    numSegmentsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CPU_SELF_TEST_CONFIG__NUM_SEGMENTS, oldNumSegments, numSegments, !oldNumSegmentsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetNumSegments()
  {
    Integer oldNumSegments = numSegments;
    boolean oldNumSegmentsESet = numSegmentsESet;
    numSegments = NUM_SEGMENTS_EDEFAULT;
    numSegmentsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CPU_SELF_TEST_CONFIG__NUM_SEGMENTS, oldNumSegments, NUM_SEGMENTS_EDEFAULT, oldNumSegmentsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetNumSegments()
  {
    return numSegmentsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CpuTestAlgorithmEnum getAlgorithms()
  {
    return algorithms;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setAlgorithms(CpuTestAlgorithmEnum newAlgorithms)
  {
    CpuTestAlgorithmEnum oldAlgorithms = algorithms;
    algorithms = newAlgorithms == null ? ALGORITHMS_EDEFAULT : newAlgorithms;
    boolean oldAlgorithmsESet = algorithmsESet;
    algorithmsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CPU_SELF_TEST_CONFIG__ALGORITHMS, oldAlgorithms, algorithms, !oldAlgorithmsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetAlgorithms()
  {
    CpuTestAlgorithmEnum oldAlgorithms = algorithms;
    boolean oldAlgorithmsESet = algorithmsESet;
    algorithms = ALGORITHMS_EDEFAULT;
    algorithmsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CPU_SELF_TEST_CONFIG__ALGORITHMS, oldAlgorithms, ALGORITHMS_EDEFAULT, oldAlgorithmsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetAlgorithms()
  {
    return algorithmsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTION_PERIOD_MS:
        return getExecutionPeriodMs();
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTE_IN_SEGMENTS:
        return getExecuteInSegments();
      case Safe10Package.CPU_SELF_TEST_CONFIG__NUM_SEGMENTS:
        return getNumSegments();
      case Safe10Package.CPU_SELF_TEST_CONFIG__ALGORITHMS:
        return getAlgorithms();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTION_PERIOD_MS:
   			setExecutionPeriodMs((Integer)newValue);
        return;
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTE_IN_SEGMENTS:
   			setExecuteInSegments((Boolean)newValue);
        return;
      case Safe10Package.CPU_SELF_TEST_CONFIG__NUM_SEGMENTS:
   			setNumSegments((Integer)newValue);
        return;
      case Safe10Package.CPU_SELF_TEST_CONFIG__ALGORITHMS:
   			setAlgorithms((CpuTestAlgorithmEnum)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTION_PERIOD_MS:
        unsetExecutionPeriodMs();
        return;
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTE_IN_SEGMENTS:
        unsetExecuteInSegments();
        return;
      case Safe10Package.CPU_SELF_TEST_CONFIG__NUM_SEGMENTS:
        unsetNumSegments();
        return;
      case Safe10Package.CPU_SELF_TEST_CONFIG__ALGORITHMS:
        unsetAlgorithms();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTION_PERIOD_MS:
        return isSetExecutionPeriodMs();
      case Safe10Package.CPU_SELF_TEST_CONFIG__EXECUTE_IN_SEGMENTS:
        return isSetExecuteInSegments();
      case Safe10Package.CPU_SELF_TEST_CONFIG__NUM_SEGMENTS:
        return isSetNumSegments();
      case Safe10Package.CPU_SELF_TEST_CONFIG__ALGORITHMS:
        return isSetAlgorithms();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (executionPeriodMs: ");
    if (executionPeriodMsESet) result.append(executionPeriodMs); else result.append("<unset>");
    result.append(", executeInSegments: ");
    if (executeInSegmentsESet) result.append(executeInSegments); else result.append("<unset>");
    result.append(", numSegments: ");
    if (numSegmentsESet) result.append(numSegments); else result.append("<unset>");
    result.append(", algorithms: ");
    if (algorithmsESet) result.append(algorithms); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //CpuSelfTestConfigImpl
