/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AbstractErrorBehavior;
import org.safe.metamodel.safe10.ErrorBehaviorMapping;
import org.safe.metamodel.safe10.ErrorModelInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Error Behavior Mapping</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorBehaviorMappingImpl#getErrorModel <em>Error Model</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorBehaviorMappingImpl#getErrorBehavior <em>Error Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ErrorBehaviorMappingImpl extends IdentifiableImpl implements ErrorBehaviorMapping
{
  /**
   * The cached value of the '{@link #getErrorModel() <em>Error Model</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModel()
   * @generated
   * @ordered
   */
  protected EList<ErrorModelInstanceRef> errorModel;

  /**
   * The cached value of the '{@link #getErrorBehavior() <em>Error Behavior</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorBehavior()
   * @generated
   * @ordered
   */
  protected AbstractErrorBehavior errorBehavior;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ErrorBehaviorMappingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getErrorBehaviorMapping();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorModelInstanceRef> getErrorModel()
  {
    if (errorModel == null)
    {
      errorModel = new EObjectContainmentEList<ErrorModelInstanceRef>(ErrorModelInstanceRef.class, this, Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_MODEL);
    }
    return errorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AbstractErrorBehavior getErrorBehavior()
  {
    if (errorBehavior != null && errorBehavior.eIsProxy())
    {
      InternalEObject oldErrorBehavior = (InternalEObject)errorBehavior;
      errorBehavior = (AbstractErrorBehavior)eResolveProxy(oldErrorBehavior);
      if (errorBehavior != oldErrorBehavior)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_BEHAVIOR, oldErrorBehavior, errorBehavior));
      }
    }
    return errorBehavior;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AbstractErrorBehavior basicGetErrorBehavior()
  {
    return errorBehavior;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setErrorBehavior(AbstractErrorBehavior newErrorBehavior)
  {
    AbstractErrorBehavior oldErrorBehavior = errorBehavior;
    errorBehavior = newErrorBehavior;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_BEHAVIOR, oldErrorBehavior, errorBehavior));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_MODEL:
        return ((InternalEList<?>)getErrorModel()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_MODEL:
        return getErrorModel();
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_BEHAVIOR:
        if (resolve) return getErrorBehavior();
        return basicGetErrorBehavior();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_MODEL:
        getErrorModel().clear();
        getErrorModel().addAll((Collection<? extends ErrorModelInstanceRef>)newValue);
        return;
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_BEHAVIOR:
   			setErrorBehavior((AbstractErrorBehavior)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_MODEL:
        getErrorModel().clear();
        return;
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_BEHAVIOR:
        	setErrorBehavior((AbstractErrorBehavior)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_MODEL:
        return errorModel != null && !errorModel.isEmpty();
      case Safe10Package.ERROR_BEHAVIOR_MAPPING__ERROR_BEHAVIOR:
        return errorBehavior != null;
    }
    return super.eIsSet(featureID);
  }

} //ErrorBehaviorMappingImpl
