/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.ErrorBehaviorMapping;
import org.safe.metamodel.safe10.ErrorModelMapping;
import org.safe.metamodel.safe10.MalfunctionMapping;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Error Model Mapping</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelMappingImpl#getErrorBehaviorMapping <em>Error Behavior Mapping</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelMappingImpl#getMalfunctionMapping <em>Malfunction Mapping</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ErrorModelMappingImpl extends IdentifiableImpl implements ErrorModelMapping
{
  /**
   * The cached value of the '{@link #getErrorBehaviorMapping() <em>Error Behavior Mapping</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorBehaviorMapping()
   * @generated
   * @ordered
   */
  protected EList<ErrorBehaviorMapping> errorBehaviorMapping;

  /**
   * The cached value of the '{@link #getMalfunctionMapping() <em>Malfunction Mapping</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunctionMapping()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionMapping> malfunctionMapping;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ErrorModelMappingImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getErrorModelMapping();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorBehaviorMapping> getErrorBehaviorMapping()
  {
    if (errorBehaviorMapping == null)
    {
      errorBehaviorMapping = new EObjectContainmentEList<ErrorBehaviorMapping>(ErrorBehaviorMapping.class, this, Safe10Package.ERROR_MODEL_MAPPING__ERROR_BEHAVIOR_MAPPING);
    }
    return errorBehaviorMapping;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionMapping> getMalfunctionMapping()
  {
    if (malfunctionMapping == null)
    {
      malfunctionMapping = new EObjectContainmentEList<MalfunctionMapping>(MalfunctionMapping.class, this, Safe10Package.ERROR_MODEL_MAPPING__MALFUNCTION_MAPPING);
    }
    return malfunctionMapping;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_MAPPING__ERROR_BEHAVIOR_MAPPING:
        return ((InternalEList<?>)getErrorBehaviorMapping()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL_MAPPING__MALFUNCTION_MAPPING:
        return ((InternalEList<?>)getMalfunctionMapping()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_MAPPING__ERROR_BEHAVIOR_MAPPING:
        return getErrorBehaviorMapping();
      case Safe10Package.ERROR_MODEL_MAPPING__MALFUNCTION_MAPPING:
        return getMalfunctionMapping();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_MAPPING__ERROR_BEHAVIOR_MAPPING:
        getErrorBehaviorMapping().clear();
        getErrorBehaviorMapping().addAll((Collection<? extends ErrorBehaviorMapping>)newValue);
        return;
      case Safe10Package.ERROR_MODEL_MAPPING__MALFUNCTION_MAPPING:
        getMalfunctionMapping().clear();
        getMalfunctionMapping().addAll((Collection<? extends MalfunctionMapping>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_MAPPING__ERROR_BEHAVIOR_MAPPING:
        getErrorBehaviorMapping().clear();
        return;
      case Safe10Package.ERROR_MODEL_MAPPING__MALFUNCTION_MAPPING:
        getMalfunctionMapping().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_MAPPING__ERROR_BEHAVIOR_MAPPING:
        return errorBehaviorMapping != null && !errorBehaviorMapping.isEmpty();
      case Safe10Package.ERROR_MODEL_MAPPING__MALFUNCTION_MAPPING:
        return malfunctionMapping != null && !malfunctionMapping.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ErrorModelMappingImpl
