/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.ErrorModelKind;
import org.safe.metamodel.safe10.ErrorModelPrototype;
import org.safe.metamodel.safe10.ErrorModelType;
import org.safe.metamodel.safe10.FaultFailurePropagationLink;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.QuantitativeErrorModel;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Error Model Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getErrorModelKind <em>Error Model Kind</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getGenericDescription <em>Generic Description</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getFaultFailureConnector <em>Fault Failure Connector</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getPart <em>Part</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getQuantitativeInformation <em>Quantitative Information</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getExternalFault <em>External Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelTypeImpl#getExternalFailure <em>External Failure</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ErrorModelTypeImpl extends TraceableSpecificationImpl implements ErrorModelType
{
  /**
   * The default value of the '{@link #getErrorModelKind() <em>Error Model Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModelKind()
   * @generated
   * @ordered
   */
  protected static final ErrorModelKind ERROR_MODEL_KIND_EDEFAULT = ErrorModelKind.ASSUMPTION;

  /**
   * The cached value of the '{@link #getErrorModelKind() <em>Error Model Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModelKind()
   * @generated
   * @ordered
   */
  protected ErrorModelKind errorModelKind = ERROR_MODEL_KIND_EDEFAULT;

  /**
   * This is true if the Error Model Kind attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean errorModelKindESet;

  /**
   * The default value of the '{@link #getGenericDescription() <em>Generic Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGenericDescription()
   * @generated
   * @ordered
   */
  protected static final String GENERIC_DESCRIPTION_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getGenericDescription() <em>Generic Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGenericDescription()
   * @generated
   * @ordered
   */
  protected String genericDescription = GENERIC_DESCRIPTION_EDEFAULT;

  /**
   * This is true if the Generic Description attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean genericDescriptionESet;

  /**
   * The cached value of the '{@link #getFaultFailureConnector() <em>Fault Failure Connector</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFaultFailureConnector()
   * @generated
   * @ordered
   */
  protected EList<FaultFailurePropagationLink> faultFailureConnector;

  /**
   * The cached value of the '{@link #getPart() <em>Part</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPart()
   * @generated
   * @ordered
   */
  protected EList<ErrorModelPrototype> part;

  /**
   * The cached value of the '{@link #getQuantitativeInformation() <em>Quantitative Information</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQuantitativeInformation()
   * @generated
   * @ordered
   */
  protected QuantitativeErrorModel quantitativeInformation;

  /**
   * The cached value of the '{@link #getExternalFault() <em>External Fault</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalFault()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> externalFault;

  /**
   * The cached value of the '{@link #getExternalFailure() <em>External Failure</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalFailure()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> externalFailure;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ErrorModelTypeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getErrorModelType();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelKind getErrorModelKind()
  {
    return errorModelKind;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setErrorModelKind(ErrorModelKind newErrorModelKind)
  {
    ErrorModelKind oldErrorModelKind = errorModelKind;
    errorModelKind = newErrorModelKind == null ? ERROR_MODEL_KIND_EDEFAULT : newErrorModelKind;
    boolean oldErrorModelKindESet = errorModelKindESet;
    errorModelKindESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ERROR_MODEL_TYPE__ERROR_MODEL_KIND, oldErrorModelKind, errorModelKind, !oldErrorModelKindESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetErrorModelKind()
  {
    ErrorModelKind oldErrorModelKind = errorModelKind;
    boolean oldErrorModelKindESet = errorModelKindESet;
    errorModelKind = ERROR_MODEL_KIND_EDEFAULT;
    errorModelKindESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.ERROR_MODEL_TYPE__ERROR_MODEL_KIND, oldErrorModelKind, ERROR_MODEL_KIND_EDEFAULT, oldErrorModelKindESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetErrorModelKind()
  {
    return errorModelKindESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getGenericDescription()
  {
    return genericDescription;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setGenericDescription(String newGenericDescription)
  {
    String oldGenericDescription = genericDescription;
    genericDescription = newGenericDescription;
    boolean oldGenericDescriptionESet = genericDescriptionESet;
    genericDescriptionESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ERROR_MODEL_TYPE__GENERIC_DESCRIPTION, oldGenericDescription, genericDescription, !oldGenericDescriptionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetGenericDescription()
  {
    String oldGenericDescription = genericDescription;
    boolean oldGenericDescriptionESet = genericDescriptionESet;
    genericDescription = GENERIC_DESCRIPTION_EDEFAULT;
    genericDescriptionESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.ERROR_MODEL_TYPE__GENERIC_DESCRIPTION, oldGenericDescription, GENERIC_DESCRIPTION_EDEFAULT, oldGenericDescriptionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetGenericDescription()
  {
    return genericDescriptionESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FaultFailurePropagationLink> getFaultFailureConnector()
  {
    if (faultFailureConnector == null)
    {
      faultFailureConnector = new EObjectContainmentEList<FaultFailurePropagationLink>(FaultFailurePropagationLink.class, this, Safe10Package.ERROR_MODEL_TYPE__FAULT_FAILURE_CONNECTOR);
    }
    return faultFailureConnector;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorModelPrototype> getPart()
  {
    if (part == null)
    {
      part = new EObjectContainmentEList<ErrorModelPrototype>(ErrorModelPrototype.class, this, Safe10Package.ERROR_MODEL_TYPE__PART);
    }
    return part;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public QuantitativeErrorModel getQuantitativeInformation()
  {
    return quantitativeInformation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetQuantitativeInformation(QuantitativeErrorModel newQuantitativeInformation, NotificationChain msgs)
  {
    QuantitativeErrorModel oldQuantitativeInformation = quantitativeInformation;
    quantitativeInformation = newQuantitativeInformation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION, oldQuantitativeInformation, newQuantitativeInformation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setQuantitativeInformation(QuantitativeErrorModel newQuantitativeInformation)
  {
    if (newQuantitativeInformation != quantitativeInformation)
    {
      NotificationChain msgs = null;
      if (quantitativeInformation != null)
        msgs = ((InternalEObject)quantitativeInformation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION, null, msgs);
      if (newQuantitativeInformation != null)
        msgs = ((InternalEObject)newQuantitativeInformation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION, null, msgs);
      msgs = basicSetQuantitativeInformation(newQuantitativeInformation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION, newQuantitativeInformation, newQuantitativeInformation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getExternalFault()
  {
    if (externalFault == null)
    {
      externalFault = new EObjectContainmentEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAULT);
    }
    return externalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getExternalFailure()
  {
    if (externalFailure == null)
    {
      externalFailure = new EObjectContainmentEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAILURE);
    }
    return externalFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_TYPE__FAULT_FAILURE_CONNECTOR:
        return ((InternalEList<?>)getFaultFailureConnector()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL_TYPE__PART:
        return ((InternalEList<?>)getPart()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION:
        return basicSetQuantitativeInformation(null, msgs);
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAULT:
        return ((InternalEList<?>)getExternalFault()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAILURE:
        return ((InternalEList<?>)getExternalFailure()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_TYPE__ERROR_MODEL_KIND:
        return getErrorModelKind();
      case Safe10Package.ERROR_MODEL_TYPE__GENERIC_DESCRIPTION:
        return getGenericDescription();
      case Safe10Package.ERROR_MODEL_TYPE__FAULT_FAILURE_CONNECTOR:
        return getFaultFailureConnector();
      case Safe10Package.ERROR_MODEL_TYPE__PART:
        return getPart();
      case Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION:
        return getQuantitativeInformation();
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAULT:
        return getExternalFault();
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAILURE:
        return getExternalFailure();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_TYPE__ERROR_MODEL_KIND:
   			setErrorModelKind((ErrorModelKind)newValue);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__GENERIC_DESCRIPTION:
   			setGenericDescription((String)newValue);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__FAULT_FAILURE_CONNECTOR:
        getFaultFailureConnector().clear();
        getFaultFailureConnector().addAll((Collection<? extends FaultFailurePropagationLink>)newValue);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__PART:
        getPart().clear();
        getPart().addAll((Collection<? extends ErrorModelPrototype>)newValue);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION:
   			setQuantitativeInformation((QuantitativeErrorModel)newValue);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAULT:
        getExternalFault().clear();
        getExternalFault().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAILURE:
        getExternalFailure().clear();
        getExternalFailure().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_TYPE__ERROR_MODEL_KIND:
        unsetErrorModelKind();
        return;
      case Safe10Package.ERROR_MODEL_TYPE__GENERIC_DESCRIPTION:
        unsetGenericDescription();
        return;
      case Safe10Package.ERROR_MODEL_TYPE__FAULT_FAILURE_CONNECTOR:
        getFaultFailureConnector().clear();
        return;
      case Safe10Package.ERROR_MODEL_TYPE__PART:
        getPart().clear();
        return;
      case Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION:
        	setQuantitativeInformation((QuantitativeErrorModel)null);
        return;
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAULT:
        getExternalFault().clear();
        return;
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAILURE:
        getExternalFailure().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL_TYPE__ERROR_MODEL_KIND:
        return isSetErrorModelKind();
      case Safe10Package.ERROR_MODEL_TYPE__GENERIC_DESCRIPTION:
        return isSetGenericDescription();
      case Safe10Package.ERROR_MODEL_TYPE__FAULT_FAILURE_CONNECTOR:
        return faultFailureConnector != null && !faultFailureConnector.isEmpty();
      case Safe10Package.ERROR_MODEL_TYPE__PART:
        return part != null && !part.isEmpty();
      case Safe10Package.ERROR_MODEL_TYPE__QUANTITATIVE_INFORMATION:
        return quantitativeInformation != null;
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAULT:
        return externalFault != null && !externalFault.isEmpty();
      case Safe10Package.ERROR_MODEL_TYPE__EXTERNAL_FAILURE:
        return externalFailure != null && !externalFailure.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (errorModelKind: ");
    if (errorModelKindESet) result.append(errorModelKind); else result.append("<unset>");
    result.append(", genericDescription: ");
    if (genericDescriptionESet) result.append(genericDescription); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //ErrorModelTypeImpl
