/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.FailureLogicFormula;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Failure Logic Formula</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureLogicFormulaImpl#getExternalFailure <em>External Failure</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureLogicFormulaImpl#getProcessFault <em>Process Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureLogicFormulaImpl#getInternalFault <em>Internal Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureLogicFormulaImpl#getExternalFault <em>External Fault</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FailureLogicFormulaImpl extends FormulaExpressionImpl implements FailureLogicFormula
{
  /**
   * The cached value of the '{@link #getExternalFailure() <em>External Failure</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalFailure()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype externalFailure;

  /**
   * The cached value of the '{@link #getProcessFault() <em>Process Fault</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProcessFault()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype processFault;

  /**
   * The cached value of the '{@link #getInternalFault() <em>Internal Fault</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInternalFault()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype internalFault;

  /**
   * The cached value of the '{@link #getExternalFault() <em>External Fault</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalFault()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype externalFault;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FailureLogicFormulaImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getFailureLogicFormula();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getExternalFailure()
  {
    if (externalFailure != null && externalFailure.eIsProxy())
    {
      InternalEObject oldExternalFailure = (InternalEObject)externalFailure;
      externalFailure = (MalfunctionPrototype)eResolveProxy(oldExternalFailure);
      if (externalFailure != oldExternalFailure)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAILURE, oldExternalFailure, externalFailure));
      }
    }
    return externalFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetExternalFailure()
  {
    return externalFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExternalFailure(MalfunctionPrototype newExternalFailure)
  {
    MalfunctionPrototype oldExternalFailure = externalFailure;
    externalFailure = newExternalFailure;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAILURE, oldExternalFailure, externalFailure));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getProcessFault()
  {
    if (processFault != null && processFault.eIsProxy())
    {
      InternalEObject oldProcessFault = (InternalEObject)processFault;
      processFault = (MalfunctionPrototype)eResolveProxy(oldProcessFault);
      if (processFault != oldProcessFault)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.FAILURE_LOGIC_FORMULA__PROCESS_FAULT, oldProcessFault, processFault));
      }
    }
    return processFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetProcessFault()
  {
    return processFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setProcessFault(MalfunctionPrototype newProcessFault)
  {
    MalfunctionPrototype oldProcessFault = processFault;
    processFault = newProcessFault;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_LOGIC_FORMULA__PROCESS_FAULT, oldProcessFault, processFault));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getInternalFault()
  {
    if (internalFault != null && internalFault.eIsProxy())
    {
      InternalEObject oldInternalFault = (InternalEObject)internalFault;
      internalFault = (MalfunctionPrototype)eResolveProxy(oldInternalFault);
      if (internalFault != oldInternalFault)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.FAILURE_LOGIC_FORMULA__INTERNAL_FAULT, oldInternalFault, internalFault));
      }
    }
    return internalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetInternalFault()
  {
    return internalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInternalFault(MalfunctionPrototype newInternalFault)
  {
    MalfunctionPrototype oldInternalFault = internalFault;
    internalFault = newInternalFault;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_LOGIC_FORMULA__INTERNAL_FAULT, oldInternalFault, internalFault));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getExternalFault()
  {
    if (externalFault != null && externalFault.eIsProxy())
    {
      InternalEObject oldExternalFault = (InternalEObject)externalFault;
      externalFault = (MalfunctionPrototype)eResolveProxy(oldExternalFault);
      if (externalFault != oldExternalFault)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAULT, oldExternalFault, externalFault));
      }
    }
    return externalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetExternalFault()
  {
    return externalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExternalFault(MalfunctionPrototype newExternalFault)
  {
    MalfunctionPrototype oldExternalFault = externalFault;
    externalFault = newExternalFault;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAULT, oldExternalFault, externalFault));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAILURE:
        if (resolve) return getExternalFailure();
        return basicGetExternalFailure();
      case Safe10Package.FAILURE_LOGIC_FORMULA__PROCESS_FAULT:
        if (resolve) return getProcessFault();
        return basicGetProcessFault();
      case Safe10Package.FAILURE_LOGIC_FORMULA__INTERNAL_FAULT:
        if (resolve) return getInternalFault();
        return basicGetInternalFault();
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAULT:
        if (resolve) return getExternalFault();
        return basicGetExternalFault();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAILURE:
   			setExternalFailure((MalfunctionPrototype)newValue);
        return;
      case Safe10Package.FAILURE_LOGIC_FORMULA__PROCESS_FAULT:
   			setProcessFault((MalfunctionPrototype)newValue);
        return;
      case Safe10Package.FAILURE_LOGIC_FORMULA__INTERNAL_FAULT:
   			setInternalFault((MalfunctionPrototype)newValue);
        return;
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAULT:
   			setExternalFault((MalfunctionPrototype)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAILURE:
        	setExternalFailure((MalfunctionPrototype)null);
        return;
      case Safe10Package.FAILURE_LOGIC_FORMULA__PROCESS_FAULT:
        	setProcessFault((MalfunctionPrototype)null);
        return;
      case Safe10Package.FAILURE_LOGIC_FORMULA__INTERNAL_FAULT:
        	setInternalFault((MalfunctionPrototype)null);
        return;
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAULT:
        	setExternalFault((MalfunctionPrototype)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAILURE:
        return externalFailure != null;
      case Safe10Package.FAILURE_LOGIC_FORMULA__PROCESS_FAULT:
        return processFault != null;
      case Safe10Package.FAILURE_LOGIC_FORMULA__INTERNAL_FAULT:
        return internalFault != null;
      case Safe10Package.FAILURE_LOGIC_FORMULA__EXTERNAL_FAULT:
        return externalFault != null;
    }
    return super.eIsSet(featureID);
  }

} //FailureLogicFormulaImpl
