/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.FailureRate;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Failure Rate</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureRateImpl#getLambda <em>Lambda</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureRateImpl#getRationalScalingFactor <em>Rational Scaling Factor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureRateImpl#getScalingFactor <em>Scaling Factor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureRateImpl#getSource <em>Source</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FailureRateImpl#getMalfunction <em>Malfunction</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class FailureRateImpl extends ExtendedEObjectImpl implements FailureRate
{
  /**
   * The default value of the '{@link #getLambda() <em>Lambda</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambda()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambda() <em>Lambda</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambda()
   * @generated
   * @ordered
   */
  protected Double lambda = LAMBDA_EDEFAULT;

  /**
   * This is true if the Lambda attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaESet;

  /**
   * The default value of the '{@link #getRationalScalingFactor() <em>Rational Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationalScalingFactor()
   * @generated
   * @ordered
   */
  protected static final String RATIONAL_SCALING_FACTOR_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getRationalScalingFactor() <em>Rational Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationalScalingFactor()
   * @generated
   * @ordered
   */
  protected String rationalScalingFactor = RATIONAL_SCALING_FACTOR_EDEFAULT;

  /**
   * This is true if the Rational Scaling Factor attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean rationalScalingFactorESet;

  /**
   * The default value of the '{@link #getScalingFactor() <em>Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScalingFactor()
   * @generated
   * @ordered
   */
  protected static final Double SCALING_FACTOR_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getScalingFactor() <em>Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScalingFactor()
   * @generated
   * @ordered
   */
  protected Double scalingFactor = SCALING_FACTOR_EDEFAULT;

  /**
   * This is true if the Scaling Factor attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean scalingFactorESet;

  /**
   * The default value of the '{@link #getSource() <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSource()
   * @generated
   * @ordered
   */
  protected static final String SOURCE_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getSource() <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSource()
   * @generated
   * @ordered
   */
  protected String source = SOURCE_EDEFAULT;

  /**
   * This is true if the Source attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean sourceESet;

  /**
   * The cached value of the '{@link #getMalfunction() <em>Malfunction</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunction()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype malfunction;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FailureRateImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getFailureRate();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambda()
  {
    return lambda;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambda(Double newLambda)
  {
    Double oldLambda = lambda;
    lambda = newLambda;
    boolean oldLambdaESet = lambdaESet;
    lambdaESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_RATE__LAMBDA, oldLambda, lambda, !oldLambdaESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambda()
  {
    Double oldLambda = lambda;
    boolean oldLambdaESet = lambdaESet;
    lambda = LAMBDA_EDEFAULT;
    lambdaESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.FAILURE_RATE__LAMBDA, oldLambda, LAMBDA_EDEFAULT, oldLambdaESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambda()
  {
    return lambdaESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRationalScalingFactor()
  {
    return rationalScalingFactor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRationalScalingFactor(String newRationalScalingFactor)
  {
    String oldRationalScalingFactor = rationalScalingFactor;
    rationalScalingFactor = newRationalScalingFactor;
    boolean oldRationalScalingFactorESet = rationalScalingFactorESet;
    rationalScalingFactorESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_RATE__RATIONAL_SCALING_FACTOR, oldRationalScalingFactor, rationalScalingFactor, !oldRationalScalingFactorESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRationalScalingFactor()
  {
    String oldRationalScalingFactor = rationalScalingFactor;
    boolean oldRationalScalingFactorESet = rationalScalingFactorESet;
    rationalScalingFactor = RATIONAL_SCALING_FACTOR_EDEFAULT;
    rationalScalingFactorESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.FAILURE_RATE__RATIONAL_SCALING_FACTOR, oldRationalScalingFactor, RATIONAL_SCALING_FACTOR_EDEFAULT, oldRationalScalingFactorESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRationalScalingFactor()
  {
    return rationalScalingFactorESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getScalingFactor()
  {
    return scalingFactor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScalingFactor(Double newScalingFactor)
  {
    Double oldScalingFactor = scalingFactor;
    scalingFactor = newScalingFactor;
    boolean oldScalingFactorESet = scalingFactorESet;
    scalingFactorESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_RATE__SCALING_FACTOR, oldScalingFactor, scalingFactor, !oldScalingFactorESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetScalingFactor()
  {
    Double oldScalingFactor = scalingFactor;
    boolean oldScalingFactorESet = scalingFactorESet;
    scalingFactor = SCALING_FACTOR_EDEFAULT;
    scalingFactorESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.FAILURE_RATE__SCALING_FACTOR, oldScalingFactor, SCALING_FACTOR_EDEFAULT, oldScalingFactorESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetScalingFactor()
  {
    return scalingFactorESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSource()
  {
    return source;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSource(String newSource)
  {
    String oldSource = source;
    source = newSource;
    boolean oldSourceESet = sourceESet;
    sourceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_RATE__SOURCE, oldSource, source, !oldSourceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSource()
  {
    String oldSource = source;
    boolean oldSourceESet = sourceESet;
    source = SOURCE_EDEFAULT;
    sourceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.FAILURE_RATE__SOURCE, oldSource, SOURCE_EDEFAULT, oldSourceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSource()
  {
    return sourceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getMalfunction()
  {
    if (malfunction != null && malfunction.eIsProxy())
    {
      InternalEObject oldMalfunction = (InternalEObject)malfunction;
      malfunction = (MalfunctionPrototype)eResolveProxy(oldMalfunction);
      if (malfunction != oldMalfunction)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.FAILURE_RATE__MALFUNCTION, oldMalfunction, malfunction));
      }
    }
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetMalfunction()
  {
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMalfunction(MalfunctionPrototype newMalfunction)
  {
    MalfunctionPrototype oldMalfunction = malfunction;
    malfunction = newMalfunction;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAILURE_RATE__MALFUNCTION, oldMalfunction, malfunction));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_RATE__LAMBDA:
        return getLambda();
      case Safe10Package.FAILURE_RATE__RATIONAL_SCALING_FACTOR:
        return getRationalScalingFactor();
      case Safe10Package.FAILURE_RATE__SCALING_FACTOR:
        return getScalingFactor();
      case Safe10Package.FAILURE_RATE__SOURCE:
        return getSource();
      case Safe10Package.FAILURE_RATE__MALFUNCTION:
        if (resolve) return getMalfunction();
        return basicGetMalfunction();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_RATE__LAMBDA:
   			setLambda((Double)newValue);
        return;
      case Safe10Package.FAILURE_RATE__RATIONAL_SCALING_FACTOR:
   			setRationalScalingFactor((String)newValue);
        return;
      case Safe10Package.FAILURE_RATE__SCALING_FACTOR:
   			setScalingFactor((Double)newValue);
        return;
      case Safe10Package.FAILURE_RATE__SOURCE:
   			setSource((String)newValue);
        return;
      case Safe10Package.FAILURE_RATE__MALFUNCTION:
   			setMalfunction((MalfunctionPrototype)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_RATE__LAMBDA:
        unsetLambda();
        return;
      case Safe10Package.FAILURE_RATE__RATIONAL_SCALING_FACTOR:
        unsetRationalScalingFactor();
        return;
      case Safe10Package.FAILURE_RATE__SCALING_FACTOR:
        unsetScalingFactor();
        return;
      case Safe10Package.FAILURE_RATE__SOURCE:
        unsetSource();
        return;
      case Safe10Package.FAILURE_RATE__MALFUNCTION:
        	setMalfunction((MalfunctionPrototype)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FAILURE_RATE__LAMBDA:
        return isSetLambda();
      case Safe10Package.FAILURE_RATE__RATIONAL_SCALING_FACTOR:
        return isSetRationalScalingFactor();
      case Safe10Package.FAILURE_RATE__SCALING_FACTOR:
        return isSetScalingFactor();
      case Safe10Package.FAILURE_RATE__SOURCE:
        return isSetSource();
      case Safe10Package.FAILURE_RATE__MALFUNCTION:
        return malfunction != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (lambda: ");
    if (lambdaESet) result.append(lambda); else result.append("<unset>");
    result.append(", rationalScalingFactor: ");
    if (rationalScalingFactorESet) result.append(rationalScalingFactor); else result.append("<unset>");
    result.append(", scalingFactor: ");
    if (scalingFactorESet) result.append(scalingFactor); else result.append("<unset>");
    result.append(", source: ");
    if (sourceESet) result.append(source); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //FailureRateImpl
