/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.Filter;
import org.safe.metamodel.safe10.FilterExpression;
import org.safe.metamodel.safe10.FilterParameter;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Filter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.FilterImpl#getValue <em>Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FilterImpl#getCurrent <em>Current</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FilterImpl#getPrevious <em>Previous</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FilterImpl extends SoftwareSafetyRequirementImpl implements Filter
{
  /**
   * The cached value of the '{@link #getValue() <em>Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected FilterExpression value;

  /**
   * The cached value of the '{@link #getCurrent() <em>Current</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCurrent()
   * @generated
   * @ordered
   */
  protected FilterParameter current;

  /**
   * The cached value of the '{@link #getPrevious() <em>Previous</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPrevious()
   * @generated
   * @ordered
   */
  protected EList<FilterParameter> previous;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FilterImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getFilter();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterExpression getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetValue(FilterExpression newValue, NotificationChain msgs)
  {
    FilterExpression oldValue = value;
    value = newValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.FILTER__VALUE, oldValue, newValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setValue(FilterExpression newValue)
  {
    if (newValue != value)
    {
      NotificationChain msgs = null;
      if (value != null)
        msgs = ((InternalEObject)value).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.FILTER__VALUE, null, msgs);
      if (newValue != null)
        msgs = ((InternalEObject)newValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.FILTER__VALUE, null, msgs);
      msgs = basicSetValue(newValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FILTER__VALUE, newValue, newValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterParameter getCurrent()
  {
    return current;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCurrent(FilterParameter newCurrent, NotificationChain msgs)
  {
    FilterParameter oldCurrent = current;
    current = newCurrent;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.FILTER__CURRENT, oldCurrent, newCurrent);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCurrent(FilterParameter newCurrent)
  {
    if (newCurrent != current)
    {
      NotificationChain msgs = null;
      if (current != null)
        msgs = ((InternalEObject)current).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.FILTER__CURRENT, null, msgs);
      if (newCurrent != null)
        msgs = ((InternalEObject)newCurrent).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.FILTER__CURRENT, null, msgs);
      msgs = basicSetCurrent(newCurrent, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FILTER__CURRENT, newCurrent, newCurrent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FilterParameter> getPrevious()
  {
    if (previous == null)
    {
      previous = new EObjectContainmentEList<FilterParameter>(FilterParameter.class, this, Safe10Package.FILTER__PREVIOUS);
    }
    return previous;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.FILTER__VALUE:
        return basicSetValue(null, msgs);
      case Safe10Package.FILTER__CURRENT:
        return basicSetCurrent(null, msgs);
      case Safe10Package.FILTER__PREVIOUS:
        return ((InternalEList<?>)getPrevious()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.FILTER__VALUE:
        return getValue();
      case Safe10Package.FILTER__CURRENT:
        return getCurrent();
      case Safe10Package.FILTER__PREVIOUS:
        return getPrevious();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.FILTER__VALUE:
   			setValue((FilterExpression)newValue);
        return;
      case Safe10Package.FILTER__CURRENT:
   			setCurrent((FilterParameter)newValue);
        return;
      case Safe10Package.FILTER__PREVIOUS:
        getPrevious().clear();
        getPrevious().addAll((Collection<? extends FilterParameter>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FILTER__VALUE:
        	setValue((FilterExpression)null);
        return;
      case Safe10Package.FILTER__CURRENT:
        	setCurrent((FilterParameter)null);
        return;
      case Safe10Package.FILTER__PREVIOUS:
        getPrevious().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FILTER__VALUE:
        return value != null;
      case Safe10Package.FILTER__CURRENT:
        return current != null;
      case Safe10Package.FILTER__PREVIOUS:
        return previous != null && !previous.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //FilterImpl
