/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Functional Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.FunctionalSafetyRequirementImpl#getIsSafetyGoal <em>Is Safety Goal</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FunctionalSafetyRequirementImpl extends AbstractSafetyRequirementImpl implements FunctionalSafetyRequirement
{
  /**
   * The default value of the '{@link #getIsSafetyGoal() <em>Is Safety Goal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsSafetyGoal()
   * @generated
   * @ordered
   */
  protected static final Boolean IS_SAFETY_GOAL_EDEFAULT = Boolean.FALSE;

  /**
   * The cached value of the '{@link #getIsSafetyGoal() <em>Is Safety Goal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIsSafetyGoal()
   * @generated
   * @ordered
   */
  protected Boolean isSafetyGoal = IS_SAFETY_GOAL_EDEFAULT;

  /**
   * This is true if the Is Safety Goal attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean isSafetyGoalESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FunctionalSafetyRequirementImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getFunctionalSafetyRequirement();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean getIsSafetyGoal()
  {
    return isSafetyGoal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setIsSafetyGoal(Boolean newIsSafetyGoal)
  {
    Boolean oldIsSafetyGoal = isSafetyGoal;
    isSafetyGoal = newIsSafetyGoal;
    boolean oldIsSafetyGoalESet = isSafetyGoalESet;
    isSafetyGoalESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT__IS_SAFETY_GOAL, oldIsSafetyGoal, isSafetyGoal, !oldIsSafetyGoalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetIsSafetyGoal()
  {
    Boolean oldIsSafetyGoal = isSafetyGoal;
    boolean oldIsSafetyGoalESet = isSafetyGoalESet;
    isSafetyGoal = IS_SAFETY_GOAL_EDEFAULT;
    isSafetyGoalESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT__IS_SAFETY_GOAL, oldIsSafetyGoal, IS_SAFETY_GOAL_EDEFAULT, oldIsSafetyGoalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetIsSafetyGoal()
  {
    return isSafetyGoalESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT__IS_SAFETY_GOAL:
        return getIsSafetyGoal();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT__IS_SAFETY_GOAL:
   			setIsSafetyGoal((Boolean)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT__IS_SAFETY_GOAL:
        unsetIsSafetyGoal();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT__IS_SAFETY_GOAL:
        return isSetIsSafetyGoal();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (isSafetyGoal: ");
    if (isSafetyGoalESet) result.append(isSafetyGoal); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //FunctionalSafetyRequirementImpl
