/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.AbstractSafetyRequirement;
import org.safe.metamodel.safe10.Assumption;
import org.safe.metamodel.safe10.Context;
import org.safe.metamodel.safe10.Goal;
import org.safe.metamodel.safe10.Justification;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Solution;
import org.safe.metamodel.safe10.Strategy;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Goal</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getRequirement <em>Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getJustification <em>Justification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getAssumption <em>Assumption</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getInContextOf <em>In Context Of</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getSolution <em>Solution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getSupportedBy <em>Supported By</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GoalImpl#getStrategy <em>Strategy</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class GoalImpl extends ExtendedEObjectImpl implements Goal
{
  /**
   * The cached value of the '{@link #getRequirement() <em>Requirement</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirement()
   * @generated
   * @ordered
   */
  protected EList<AbstractSafetyRequirement> requirement;

  /**
   * The cached value of the '{@link #getJustification() <em>Justification</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getJustification()
   * @generated
   * @ordered
   */
  protected EList<Justification> justification;

  /**
   * The cached value of the '{@link #getAssumption() <em>Assumption</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAssumption()
   * @generated
   * @ordered
   */
  protected EList<Assumption> assumption;

  /**
   * The cached value of the '{@link #getInContextOf() <em>In Context Of</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInContextOf()
   * @generated
   * @ordered
   */
  protected EList<Context> inContextOf;

  /**
   * The cached value of the '{@link #getSolution() <em>Solution</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSolution()
   * @generated
   * @ordered
   */
  protected EList<Solution> solution;

  /**
   * The cached value of the '{@link #getSupportedBy() <em>Supported By</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSupportedBy()
   * @generated
   * @ordered
   */
  protected EList<Goal> supportedBy;

  /**
   * The cached value of the '{@link #getStrategy() <em>Strategy</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStrategy()
   * @generated
   * @ordered
   */
  protected Strategy strategy;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GoalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getGoal();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AbstractSafetyRequirement> getRequirement()
  {
    if (requirement == null)
    {
      requirement = new EObjectContainmentEList<AbstractSafetyRequirement>(AbstractSafetyRequirement.class, this, Safe10Package.GOAL__REQUIREMENT);
    }
    return requirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Justification> getJustification()
  {
    if (justification == null)
    {
      justification = new EObjectResolvingEList<Justification>(Justification.class, this, Safe10Package.GOAL__JUSTIFICATION);
    }
    return justification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Assumption> getAssumption()
  {
    if (assumption == null)
    {
      assumption = new EObjectResolvingEList<Assumption>(Assumption.class, this, Safe10Package.GOAL__ASSUMPTION);
    }
    return assumption;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Context> getInContextOf()
  {
    if (inContextOf == null)
    {
      inContextOf = new EObjectResolvingEList<Context>(Context.class, this, Safe10Package.GOAL__IN_CONTEXT_OF);
    }
    return inContextOf;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Solution> getSolution()
  {
    if (solution == null)
    {
      solution = new EObjectResolvingEList<Solution>(Solution.class, this, Safe10Package.GOAL__SOLUTION);
    }
    return solution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Goal> getSupportedBy()
  {
    if (supportedBy == null)
    {
      supportedBy = new EObjectResolvingEList<Goal>(Goal.class, this, Safe10Package.GOAL__SUPPORTED_BY);
    }
    return supportedBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Strategy getStrategy()
  {
    if (strategy != null && strategy.eIsProxy())
    {
      InternalEObject oldStrategy = (InternalEObject)strategy;
      strategy = (Strategy)eResolveProxy(oldStrategy);
      if (strategy != oldStrategy)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.GOAL__STRATEGY, oldStrategy, strategy));
      }
    }
    return strategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Strategy basicGetStrategy()
  {
    return strategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setStrategy(Strategy newStrategy)
  {
    Strategy oldStrategy = strategy;
    strategy = newStrategy;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.GOAL__STRATEGY, oldStrategy, strategy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.GOAL__REQUIREMENT:
        return ((InternalEList<?>)getRequirement()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.GOAL__REQUIREMENT:
        return getRequirement();
      case Safe10Package.GOAL__JUSTIFICATION:
        return getJustification();
      case Safe10Package.GOAL__ASSUMPTION:
        return getAssumption();
      case Safe10Package.GOAL__IN_CONTEXT_OF:
        return getInContextOf();
      case Safe10Package.GOAL__SOLUTION:
        return getSolution();
      case Safe10Package.GOAL__SUPPORTED_BY:
        return getSupportedBy();
      case Safe10Package.GOAL__STRATEGY:
        if (resolve) return getStrategy();
        return basicGetStrategy();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.GOAL__REQUIREMENT:
        getRequirement().clear();
        getRequirement().addAll((Collection<? extends AbstractSafetyRequirement>)newValue);
        return;
      case Safe10Package.GOAL__JUSTIFICATION:
        getJustification().clear();
        getJustification().addAll((Collection<? extends Justification>)newValue);
        return;
      case Safe10Package.GOAL__ASSUMPTION:
        getAssumption().clear();
        getAssumption().addAll((Collection<? extends Assumption>)newValue);
        return;
      case Safe10Package.GOAL__IN_CONTEXT_OF:
        getInContextOf().clear();
        getInContextOf().addAll((Collection<? extends Context>)newValue);
        return;
      case Safe10Package.GOAL__SOLUTION:
        getSolution().clear();
        getSolution().addAll((Collection<? extends Solution>)newValue);
        return;
      case Safe10Package.GOAL__SUPPORTED_BY:
        getSupportedBy().clear();
        getSupportedBy().addAll((Collection<? extends Goal>)newValue);
        return;
      case Safe10Package.GOAL__STRATEGY:
   			setStrategy((Strategy)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.GOAL__REQUIREMENT:
        getRequirement().clear();
        return;
      case Safe10Package.GOAL__JUSTIFICATION:
        getJustification().clear();
        return;
      case Safe10Package.GOAL__ASSUMPTION:
        getAssumption().clear();
        return;
      case Safe10Package.GOAL__IN_CONTEXT_OF:
        getInContextOf().clear();
        return;
      case Safe10Package.GOAL__SOLUTION:
        getSolution().clear();
        return;
      case Safe10Package.GOAL__SUPPORTED_BY:
        getSupportedBy().clear();
        return;
      case Safe10Package.GOAL__STRATEGY:
        	setStrategy((Strategy)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.GOAL__REQUIREMENT:
        return requirement != null && !requirement.isEmpty();
      case Safe10Package.GOAL__JUSTIFICATION:
        return justification != null && !justification.isEmpty();
      case Safe10Package.GOAL__ASSUMPTION:
        return assumption != null && !assumption.isEmpty();
      case Safe10Package.GOAL__IN_CONTEXT_OF:
        return inContextOf != null && !inContextOf.isEmpty();
      case Safe10Package.GOAL__SOLUTION:
        return solution != null && !solution.isEmpty();
      case Safe10Package.GOAL__SUPPORTED_BY:
        return supportedBy != null && !supportedBy.isEmpty();
      case Safe10Package.GOAL__STRATEGY:
        return strategy != null;
    }
    return super.eIsSet(featureID);
  }

} //GoalImpl
