/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.GradientCheck;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Gradient Check</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.GradientCheckImpl#getMaxLimit <em>Max Limit</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GradientCheckImpl#getMaxTolerance <em>Max Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GradientCheckImpl#getMinLimit <em>Min Limit</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.GradientCheckImpl#getMinTolerance <em>Min Tolerance</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class GradientCheckImpl extends SoftwareSafetyRequirementImpl implements GradientCheck
{
  /**
   * The default value of the '{@link #getMaxLimit() <em>Max Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMaxLimit()
   * @generated
   * @ordered
   */
  protected static final Double MAX_LIMIT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getMaxLimit() <em>Max Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMaxLimit()
   * @generated
   * @ordered
   */
  protected Double maxLimit = MAX_LIMIT_EDEFAULT;

  /**
   * This is true if the Max Limit attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean maxLimitESet;

  /**
   * The default value of the '{@link #getMaxTolerance() <em>Max Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMaxTolerance()
   * @generated
   * @ordered
   */
  protected static final Double MAX_TOLERANCE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getMaxTolerance() <em>Max Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMaxTolerance()
   * @generated
   * @ordered
   */
  protected Double maxTolerance = MAX_TOLERANCE_EDEFAULT;

  /**
   * This is true if the Max Tolerance attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean maxToleranceESet;

  /**
   * The default value of the '{@link #getMinLimit() <em>Min Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMinLimit()
   * @generated
   * @ordered
   */
  protected static final Double MIN_LIMIT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getMinLimit() <em>Min Limit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMinLimit()
   * @generated
   * @ordered
   */
  protected Double minLimit = MIN_LIMIT_EDEFAULT;

  /**
   * This is true if the Min Limit attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean minLimitESet;

  /**
   * The default value of the '{@link #getMinTolerance() <em>Min Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMinTolerance()
   * @generated
   * @ordered
   */
  protected static final Double MIN_TOLERANCE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getMinTolerance() <em>Min Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMinTolerance()
   * @generated
   * @ordered
   */
  protected Double minTolerance = MIN_TOLERANCE_EDEFAULT;

  /**
   * This is true if the Min Tolerance attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean minToleranceESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GradientCheckImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getGradientCheck();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getMaxLimit()
  {
    return maxLimit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMaxLimit(Double newMaxLimit)
  {
    Double oldMaxLimit = maxLimit;
    maxLimit = newMaxLimit;
    boolean oldMaxLimitESet = maxLimitESet;
    maxLimitESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.GRADIENT_CHECK__MAX_LIMIT, oldMaxLimit, maxLimit, !oldMaxLimitESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMaxLimit()
  {
    Double oldMaxLimit = maxLimit;
    boolean oldMaxLimitESet = maxLimitESet;
    maxLimit = MAX_LIMIT_EDEFAULT;
    maxLimitESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.GRADIENT_CHECK__MAX_LIMIT, oldMaxLimit, MAX_LIMIT_EDEFAULT, oldMaxLimitESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMaxLimit()
  {
    return maxLimitESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getMaxTolerance()
  {
    return maxTolerance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMaxTolerance(Double newMaxTolerance)
  {
    Double oldMaxTolerance = maxTolerance;
    maxTolerance = newMaxTolerance;
    boolean oldMaxToleranceESet = maxToleranceESet;
    maxToleranceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.GRADIENT_CHECK__MAX_TOLERANCE, oldMaxTolerance, maxTolerance, !oldMaxToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMaxTolerance()
  {
    Double oldMaxTolerance = maxTolerance;
    boolean oldMaxToleranceESet = maxToleranceESet;
    maxTolerance = MAX_TOLERANCE_EDEFAULT;
    maxToleranceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.GRADIENT_CHECK__MAX_TOLERANCE, oldMaxTolerance, MAX_TOLERANCE_EDEFAULT, oldMaxToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMaxTolerance()
  {
    return maxToleranceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getMinLimit()
  {
    return minLimit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMinLimit(Double newMinLimit)
  {
    Double oldMinLimit = minLimit;
    minLimit = newMinLimit;
    boolean oldMinLimitESet = minLimitESet;
    minLimitESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.GRADIENT_CHECK__MIN_LIMIT, oldMinLimit, minLimit, !oldMinLimitESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMinLimit()
  {
    Double oldMinLimit = minLimit;
    boolean oldMinLimitESet = minLimitESet;
    minLimit = MIN_LIMIT_EDEFAULT;
    minLimitESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.GRADIENT_CHECK__MIN_LIMIT, oldMinLimit, MIN_LIMIT_EDEFAULT, oldMinLimitESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMinLimit()
  {
    return minLimitESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getMinTolerance()
  {
    return minTolerance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMinTolerance(Double newMinTolerance)
  {
    Double oldMinTolerance = minTolerance;
    minTolerance = newMinTolerance;
    boolean oldMinToleranceESet = minToleranceESet;
    minToleranceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.GRADIENT_CHECK__MIN_TOLERANCE, oldMinTolerance, minTolerance, !oldMinToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMinTolerance()
  {
    Double oldMinTolerance = minTolerance;
    boolean oldMinToleranceESet = minToleranceESet;
    minTolerance = MIN_TOLERANCE_EDEFAULT;
    minToleranceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.GRADIENT_CHECK__MIN_TOLERANCE, oldMinTolerance, MIN_TOLERANCE_EDEFAULT, oldMinToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMinTolerance()
  {
    return minToleranceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.GRADIENT_CHECK__MAX_LIMIT:
        return getMaxLimit();
      case Safe10Package.GRADIENT_CHECK__MAX_TOLERANCE:
        return getMaxTolerance();
      case Safe10Package.GRADIENT_CHECK__MIN_LIMIT:
        return getMinLimit();
      case Safe10Package.GRADIENT_CHECK__MIN_TOLERANCE:
        return getMinTolerance();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.GRADIENT_CHECK__MAX_LIMIT:
   			setMaxLimit((Double)newValue);
        return;
      case Safe10Package.GRADIENT_CHECK__MAX_TOLERANCE:
   			setMaxTolerance((Double)newValue);
        return;
      case Safe10Package.GRADIENT_CHECK__MIN_LIMIT:
   			setMinLimit((Double)newValue);
        return;
      case Safe10Package.GRADIENT_CHECK__MIN_TOLERANCE:
   			setMinTolerance((Double)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.GRADIENT_CHECK__MAX_LIMIT:
        unsetMaxLimit();
        return;
      case Safe10Package.GRADIENT_CHECK__MAX_TOLERANCE:
        unsetMaxTolerance();
        return;
      case Safe10Package.GRADIENT_CHECK__MIN_LIMIT:
        unsetMinLimit();
        return;
      case Safe10Package.GRADIENT_CHECK__MIN_TOLERANCE:
        unsetMinTolerance();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.GRADIENT_CHECK__MAX_LIMIT:
        return isSetMaxLimit();
      case Safe10Package.GRADIENT_CHECK__MAX_TOLERANCE:
        return isSetMaxTolerance();
      case Safe10Package.GRADIENT_CHECK__MIN_LIMIT:
        return isSetMinLimit();
      case Safe10Package.GRADIENT_CHECK__MIN_TOLERANCE:
        return isSetMinTolerance();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (maxLimit: ");
    if (maxLimitESet) result.append(maxLimit); else result.append("<unset>");
    result.append(", maxTolerance: ");
    if (maxToleranceESet) result.append(maxTolerance); else result.append("<unset>");
    result.append(", minLimit: ");
    if (minLimitESet) result.append(minLimit); else result.append("<unset>");
    result.append(", minTolerance: ");
    if (minToleranceESet) result.append(minTolerance); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //GradientCheckImpl
