/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWComponentPrototypeScope;
import org.safe.metamodel.safe10.HWFault;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.HwComponentScopeInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Component Prototype Scope</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentPrototypeScopeImpl#getSafetyRelated <em>Safety Related</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentPrototypeScopeImpl#getNameWasNotSet_0 <em>Name Was Not Set 0</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentPrototypeScopeImpl#getHwFaultCharacterization <em>Hw Fault Characterization</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentPrototypeScopeImpl#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWComponentPrototypeScopeImpl extends ExtendedEObjectImpl implements HWComponentPrototypeScope
{
  /**
   * The default value of the '{@link #getSafetyRelated() <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyRelated()
   * @generated
   * @ordered
   */
  protected static final Boolean SAFETY_RELATED_EDEFAULT = Boolean.FALSE;

  /**
   * The cached value of the '{@link #getSafetyRelated() <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyRelated()
   * @generated
   * @ordered
   */
  protected Boolean safetyRelated = SAFETY_RELATED_EDEFAULT;

  /**
   * This is true if the Safety Related attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean safetyRelatedESet;

  /**
   * The cached value of the '{@link #getNameWasNotSet_0() <em>Name Was Not Set 0</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameWasNotSet_0()
   * @generated
   * @ordered
   */
  protected HardwareFailureAnalysis nameWasNotSet_0;

  /**
   * The cached value of the '{@link #getHwFaultCharacterization() <em>Hw Fault Characterization</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFaultCharacterization()
   * @generated
   * @ordered
   */
  protected EList<HWFault> hwFaultCharacterization;

  /**
   * The cached value of the '{@link #getScope() <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScope()
   * @generated
   * @ordered
   */
  protected HwComponentScopeInstanceRef scope;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWComponentPrototypeScopeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWComponentPrototypeScope();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean getSafetyRelated()
  {
    return safetyRelated;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSafetyRelated(Boolean newSafetyRelated)
  {
    Boolean oldSafetyRelated = safetyRelated;
    safetyRelated = newSafetyRelated;
    boolean oldSafetyRelatedESet = safetyRelatedESet;
    safetyRelatedESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SAFETY_RELATED, oldSafetyRelated, safetyRelated, !oldSafetyRelatedESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSafetyRelated()
  {
    Boolean oldSafetyRelated = safetyRelated;
    boolean oldSafetyRelatedESet = safetyRelatedESet;
    safetyRelated = SAFETY_RELATED_EDEFAULT;
    safetyRelatedESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SAFETY_RELATED, oldSafetyRelated, SAFETY_RELATED_EDEFAULT, oldSafetyRelatedESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSafetyRelated()
  {
    return safetyRelatedESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareFailureAnalysis getNameWasNotSet_0()
  {
    if (nameWasNotSet_0 != null && nameWasNotSet_0.eIsProxy())
    {
      InternalEObject oldNameWasNotSet_0 = (InternalEObject)nameWasNotSet_0;
      nameWasNotSet_0 = (HardwareFailureAnalysis)eResolveProxy(oldNameWasNotSet_0);
      if (nameWasNotSet_0 != oldNameWasNotSet_0)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0, oldNameWasNotSet_0, nameWasNotSet_0));
      }
    }
    return nameWasNotSet_0;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareFailureAnalysis basicGetNameWasNotSet_0()
  {
    return nameWasNotSet_0;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetNameWasNotSet_0(HardwareFailureAnalysis newNameWasNotSet_0, NotificationChain msgs)
  {
    HardwareFailureAnalysis oldNameWasNotSet_0 = nameWasNotSet_0;
    nameWasNotSet_0 = newNameWasNotSet_0;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0, oldNameWasNotSet_0, newNameWasNotSet_0);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameWasNotSet_0(HardwareFailureAnalysis newNameWasNotSet_0)
  {
    if (newNameWasNotSet_0 != nameWasNotSet_0)
    {
      NotificationChain msgs = null;
      if (nameWasNotSet_0 != null)
        msgs = ((InternalEObject)nameWasNotSet_0).eInverseRemove(this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE, HardwareFailureAnalysis.class, msgs);
      if (newNameWasNotSet_0 != null)
        msgs = ((InternalEObject)newNameWasNotSet_0).eInverseAdd(this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE, HardwareFailureAnalysis.class, msgs);
      msgs = basicSetNameWasNotSet_0(newNameWasNotSet_0, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0, newNameWasNotSet_0, newNameWasNotSet_0));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWFault> getHwFaultCharacterization()
  {
    if (hwFaultCharacterization == null)
    {
      hwFaultCharacterization = new EObjectResolvingEList<HWFault>(HWFault.class, this, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__HW_FAULT_CHARACTERIZATION);
    }
    return hwFaultCharacterization;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HwComponentScopeInstanceRef getScope()
  {
    if (scope != null && scope.eIsProxy())
    {
      InternalEObject oldScope = (InternalEObject)scope;
      scope = (HwComponentScopeInstanceRef)eResolveProxy(oldScope);
      if (scope != oldScope)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE, oldScope, scope));
      }
    }
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HwComponentScopeInstanceRef basicGetScope()
  {
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetScope(HwComponentScopeInstanceRef newScope, NotificationChain msgs)
  {
    HwComponentScopeInstanceRef oldScope = scope;
    scope = newScope;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE, oldScope, newScope);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScope(HwComponentScopeInstanceRef newScope)
  {
    if (newScope != scope)
    {
      NotificationChain msgs = null;
      if (scope != null)
        msgs = ((InternalEObject)scope).eInverseRemove(this, Safe10Package.HW_COMPONENT_SCOPE_INSTANCE_REF__NAME_WAS_NOT_SET_1, HwComponentScopeInstanceRef.class, msgs);
      if (newScope != null)
        msgs = ((InternalEObject)newScope).eInverseAdd(this, Safe10Package.HW_COMPONENT_SCOPE_INSTANCE_REF__NAME_WAS_NOT_SET_1, HwComponentScopeInstanceRef.class, msgs);
      msgs = basicSetScope(newScope, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE, newScope, newScope));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0:
        if (nameWasNotSet_0 != null)
          msgs = ((InternalEObject)nameWasNotSet_0).eInverseRemove(this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE, HardwareFailureAnalysis.class, msgs);
        return basicSetNameWasNotSet_0((HardwareFailureAnalysis)otherEnd, msgs);
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE:
        if (scope != null)
          msgs = ((InternalEObject)scope).eInverseRemove(this, Safe10Package.HW_COMPONENT_SCOPE_INSTANCE_REF__NAME_WAS_NOT_SET_1, HwComponentScopeInstanceRef.class, msgs);
        return basicSetScope((HwComponentScopeInstanceRef)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0:
        return basicSetNameWasNotSet_0(null, msgs);
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE:
        return basicSetScope(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
        return getSafetyRelated();
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0:
        if (resolve) return getNameWasNotSet_0();
        return basicGetNameWasNotSet_0();
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__HW_FAULT_CHARACTERIZATION:
        return getHwFaultCharacterization();
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE:
        if (resolve) return getScope();
        return basicGetScope();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
   			setSafetyRelated((Boolean)newValue);
        return;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0:
   			setNameWasNotSet_0((HardwareFailureAnalysis)newValue);
        return;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__HW_FAULT_CHARACTERIZATION:
        getHwFaultCharacterization().clear();
        getHwFaultCharacterization().addAll((Collection<? extends HWFault>)newValue);
        return;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE:
   			setScope((HwComponentScopeInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
        unsetSafetyRelated();
        return;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0:
        	setNameWasNotSet_0((HardwareFailureAnalysis)null);
        return;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__HW_FAULT_CHARACTERIZATION:
        getHwFaultCharacterization().clear();
        return;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE:
        	setScope((HwComponentScopeInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
        return isSetSafetyRelated();
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0:
        return nameWasNotSet_0 != null;
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__HW_FAULT_CHARACTERIZATION:
        return hwFaultCharacterization != null && !hwFaultCharacterization.isEmpty();
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__SCOPE:
        return scope != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (safetyRelated: ");
    if (safetyRelatedESet) result.append(safetyRelated); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWComponentPrototypeScopeImpl
