/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart;
import org.safe.metamodel.safe10.HWLambdaPartFormula;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Component Quantified FM From Part</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentQuantifiedFMFromPartImpl#getLambdaFailureMode <em>Lambda Failure Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentQuantifiedFMFromPartImpl#getFailureLogic <em>Failure Logic</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWComponentQuantifiedFMFromPartImpl#getHwCQFMlambdaFailureModeValue <em>Hw CQF Mlambda Failure Mode Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWComponentQuantifiedFMFromPartImpl extends IdentifiableImpl implements HWComponentQuantifiedFMFromPart
{
  /**
   * The default value of the '{@link #getLambdaFailureMode() <em>Lambda Failure Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaFailureMode()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_FAILURE_MODE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambdaFailureMode() <em>Lambda Failure Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaFailureMode()
   * @generated
   * @ordered
   */
  protected Double lambdaFailureMode = LAMBDA_FAILURE_MODE_EDEFAULT;

  /**
   * This is true if the Lambda Failure Mode attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaFailureModeESet;

  /**
   * The default value of the '{@link #getFailureLogic() <em>Failure Logic</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureLogic()
   * @generated
   * @ordered
   */
  protected static final String FAILURE_LOGIC_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getFailureLogic() <em>Failure Logic</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureLogic()
   * @generated
   * @ordered
   */
  protected String failureLogic = FAILURE_LOGIC_EDEFAULT;

  /**
   * This is true if the Failure Logic attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean failureLogicESet;

  /**
   * The cached value of the '{@link #getHwCQFMlambdaFailureModeValue() <em>Hw CQF Mlambda Failure Mode Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwCQFMlambdaFailureModeValue()
   * @generated
   * @ordered
   */
  protected HWLambdaPartFormula hwCQFMlambdaFailureModeValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWComponentQuantifiedFMFromPartImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWComponentQuantifiedFMFromPart();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambdaFailureMode()
  {
    return lambdaFailureMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambdaFailureMode(Double newLambdaFailureMode)
  {
    Double oldLambdaFailureMode = lambdaFailureMode;
    lambdaFailureMode = newLambdaFailureMode;
    boolean oldLambdaFailureModeESet = lambdaFailureModeESet;
    lambdaFailureModeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__LAMBDA_FAILURE_MODE, oldLambdaFailureMode, lambdaFailureMode, !oldLambdaFailureModeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambdaFailureMode()
  {
    Double oldLambdaFailureMode = lambdaFailureMode;
    boolean oldLambdaFailureModeESet = lambdaFailureModeESet;
    lambdaFailureMode = LAMBDA_FAILURE_MODE_EDEFAULT;
    lambdaFailureModeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__LAMBDA_FAILURE_MODE, oldLambdaFailureMode, LAMBDA_FAILURE_MODE_EDEFAULT, oldLambdaFailureModeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambdaFailureMode()
  {
    return lambdaFailureModeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getFailureLogic()
  {
    return failureLogic;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFailureLogic(String newFailureLogic)
  {
    String oldFailureLogic = failureLogic;
    failureLogic = newFailureLogic;
    boolean oldFailureLogicESet = failureLogicESet;
    failureLogicESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__FAILURE_LOGIC, oldFailureLogic, failureLogic, !oldFailureLogicESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFailureLogic()
  {
    String oldFailureLogic = failureLogic;
    boolean oldFailureLogicESet = failureLogicESet;
    failureLogic = FAILURE_LOGIC_EDEFAULT;
    failureLogicESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__FAILURE_LOGIC, oldFailureLogic, FAILURE_LOGIC_EDEFAULT, oldFailureLogicESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFailureLogic()
  {
    return failureLogicESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLambdaPartFormula getHwCQFMlambdaFailureModeValue()
  {
    return hwCQFMlambdaFailureModeValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwCQFMlambdaFailureModeValue(HWLambdaPartFormula newHwCQFMlambdaFailureModeValue, NotificationChain msgs)
  {
    HWLambdaPartFormula oldHwCQFMlambdaFailureModeValue = hwCQFMlambdaFailureModeValue;
    hwCQFMlambdaFailureModeValue = newHwCQFMlambdaFailureModeValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE, oldHwCQFMlambdaFailureModeValue, newHwCQFMlambdaFailureModeValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwCQFMlambdaFailureModeValue(HWLambdaPartFormula newHwCQFMlambdaFailureModeValue)
  {
    if (newHwCQFMlambdaFailureModeValue != hwCQFMlambdaFailureModeValue)
    {
      NotificationChain msgs = null;
      if (hwCQFMlambdaFailureModeValue != null)
        msgs = ((InternalEObject)hwCQFMlambdaFailureModeValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE, null, msgs);
      if (newHwCQFMlambdaFailureModeValue != null)
        msgs = ((InternalEObject)newHwCQFMlambdaFailureModeValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE, null, msgs);
      msgs = basicSetHwCQFMlambdaFailureModeValue(newHwCQFMlambdaFailureModeValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE, newHwCQFMlambdaFailureModeValue, newHwCQFMlambdaFailureModeValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE:
        return basicSetHwCQFMlambdaFailureModeValue(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__LAMBDA_FAILURE_MODE:
        return getLambdaFailureMode();
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__FAILURE_LOGIC:
        return getFailureLogic();
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE:
        return getHwCQFMlambdaFailureModeValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__LAMBDA_FAILURE_MODE:
   			setLambdaFailureMode((Double)newValue);
        return;
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__FAILURE_LOGIC:
   			setFailureLogic((String)newValue);
        return;
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE:
   			setHwCQFMlambdaFailureModeValue((HWLambdaPartFormula)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__LAMBDA_FAILURE_MODE:
        unsetLambdaFailureMode();
        return;
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__FAILURE_LOGIC:
        unsetFailureLogic();
        return;
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE:
        	setHwCQFMlambdaFailureModeValue((HWLambdaPartFormula)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__LAMBDA_FAILURE_MODE:
        return isSetLambdaFailureMode();
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__FAILURE_LOGIC:
        return isSetFailureLogic();
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART__HW_CQF_MLAMBDA_FAILURE_MODE_VALUE:
        return hwCQFMlambdaFailureModeValue != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (lambdaFailureMode: ");
    if (lambdaFailureModeESet) result.append(lambdaFailureMode); else result.append("<unset>");
    result.append(", failureLogic: ");
    if (failureLogicESet) result.append(failureLogic); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWComponentQuantifiedFMFromPartImpl
