/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HWFMSingleContributionFormula;
import org.safe.metamodel.safe10.HWFailureMode;
import org.safe.metamodel.safe10.HWFailureRate;
import org.safe.metamodel.safe10.HWFault;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HWFM Single Contribution Formula</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionFormulaImpl#getFailureRateDistribution <em>Failure Rate Distribution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionFormulaImpl#getHwFaultTypeValue <em>Hw Fault Type Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionFormulaImpl#getHwFailureRateValue <em>Hw Failure Rate Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWFMSingleContributionFormulaImpl extends FormulaDocumentationImpl implements HWFMSingleContributionFormula
{
  /**
   * The cached value of the '{@link #getFailureRateDistribution() <em>Failure Rate Distribution</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureRateDistribution()
   * @generated
   * @ordered
   */
  protected HWFailureMode failureRateDistribution;

  /**
   * The cached value of the '{@link #getHwFaultTypeValue() <em>Hw Fault Type Value</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFaultTypeValue()
   * @generated
   * @ordered
   */
  protected HWFault hwFaultTypeValue;

  /**
   * The cached value of the '{@link #getHwFailureRateValue() <em>Hw Failure Rate Value</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFailureRateValue()
   * @generated
   * @ordered
   */
  protected HWFailureRate hwFailureRateValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWFMSingleContributionFormulaImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWFMSingleContributionFormula();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureMode getFailureRateDistribution()
  {
    if (failureRateDistribution != null && failureRateDistribution.eIsProxy())
    {
      InternalEObject oldFailureRateDistribution = (InternalEObject)failureRateDistribution;
      failureRateDistribution = (HWFailureMode)eResolveProxy(oldFailureRateDistribution);
      if (failureRateDistribution != oldFailureRateDistribution)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__FAILURE_RATE_DISTRIBUTION, oldFailureRateDistribution, failureRateDistribution));
      }
    }
    return failureRateDistribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureMode basicGetFailureRateDistribution()
  {
    return failureRateDistribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFailureRateDistribution(HWFailureMode newFailureRateDistribution)
  {
    HWFailureMode oldFailureRateDistribution = failureRateDistribution;
    failureRateDistribution = newFailureRateDistribution;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__FAILURE_RATE_DISTRIBUTION, oldFailureRateDistribution, failureRateDistribution));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFault getHwFaultTypeValue()
  {
    if (hwFaultTypeValue != null && hwFaultTypeValue.eIsProxy())
    {
      InternalEObject oldHwFaultTypeValue = (InternalEObject)hwFaultTypeValue;
      hwFaultTypeValue = (HWFault)eResolveProxy(oldHwFaultTypeValue);
      if (hwFaultTypeValue != oldHwFaultTypeValue)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAULT_TYPE_VALUE, oldHwFaultTypeValue, hwFaultTypeValue));
      }
    }
    return hwFaultTypeValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFault basicGetHwFaultTypeValue()
  {
    return hwFaultTypeValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwFaultTypeValue(HWFault newHwFaultTypeValue)
  {
    HWFault oldHwFaultTypeValue = hwFaultTypeValue;
    hwFaultTypeValue = newHwFaultTypeValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAULT_TYPE_VALUE, oldHwFaultTypeValue, hwFaultTypeValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureRate getHwFailureRateValue()
  {
    if (hwFailureRateValue != null && hwFailureRateValue.eIsProxy())
    {
      InternalEObject oldHwFailureRateValue = (InternalEObject)hwFailureRateValue;
      hwFailureRateValue = (HWFailureRate)eResolveProxy(oldHwFailureRateValue);
      if (hwFailureRateValue != oldHwFailureRateValue)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAILURE_RATE_VALUE, oldHwFailureRateValue, hwFailureRateValue));
      }
    }
    return hwFailureRateValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureRate basicGetHwFailureRateValue()
  {
    return hwFailureRateValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwFailureRateValue(HWFailureRate newHwFailureRateValue)
  {
    HWFailureRate oldHwFailureRateValue = hwFailureRateValue;
    hwFailureRateValue = newHwFailureRateValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAILURE_RATE_VALUE, oldHwFailureRateValue, hwFailureRateValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__FAILURE_RATE_DISTRIBUTION:
        if (resolve) return getFailureRateDistribution();
        return basicGetFailureRateDistribution();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAULT_TYPE_VALUE:
        if (resolve) return getHwFaultTypeValue();
        return basicGetHwFaultTypeValue();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAILURE_RATE_VALUE:
        if (resolve) return getHwFailureRateValue();
        return basicGetHwFailureRateValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__FAILURE_RATE_DISTRIBUTION:
   			setFailureRateDistribution((HWFailureMode)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAULT_TYPE_VALUE:
   			setHwFaultTypeValue((HWFault)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAILURE_RATE_VALUE:
   			setHwFailureRateValue((HWFailureRate)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__FAILURE_RATE_DISTRIBUTION:
        	setFailureRateDistribution((HWFailureMode)null);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAULT_TYPE_VALUE:
        	setHwFaultTypeValue((HWFault)null);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAILURE_RATE_VALUE:
        	setHwFailureRateValue((HWFailureRate)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__FAILURE_RATE_DISTRIBUTION:
        return failureRateDistribution != null;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAULT_TYPE_VALUE:
        return hwFaultTypeValue != null;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA__HW_FAILURE_RATE_VALUE:
        return hwFailureRateValue != null;
    }
    return super.eIsSet(featureID);
  }

} //HWFMSingleContributionFormulaImpl
