/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HWFailureMode;
import org.safe.metamodel.safe10.Identifiable;
import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Failure Mode</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFailureModeImpl#getCategory <em>Category</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFailureModeImpl#getUuid <em>Uuid</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFailureModeImpl#getAllocatedFailureRateDistribution <em>Allocated Failure Rate Distribution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFailureModeImpl#getFailureModeType <em>Failure Mode Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFailureModeImpl#getPotentialCause <em>Potential Cause</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWFailureModeImpl extends ReferrableImpl implements HWFailureMode
{
  /**
   * The default value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected static final String CATEGORY_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected String category = CATEGORY_EDEFAULT;

  /**
   * This is true if the Category attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean categoryESet;

  /**
   * The default value of the '{@link #getUuid() <em>Uuid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUuid()
   * @generated
   * @ordered
   */
  protected static final String UUID_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getUuid() <em>Uuid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUuid()
   * @generated
   * @ordered
   */
  protected String uuid = UUID_EDEFAULT;

  /**
   * This is true if the Uuid attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean uuidESet;

  /**
   * The default value of the '{@link #getAllocatedFailureRateDistribution() <em>Allocated Failure Rate Distribution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAllocatedFailureRateDistribution()
   * @generated
   * @ordered
   */
  protected static final Double ALLOCATED_FAILURE_RATE_DISTRIBUTION_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getAllocatedFailureRateDistribution() <em>Allocated Failure Rate Distribution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAllocatedFailureRateDistribution()
   * @generated
   * @ordered
   */
  protected Double allocatedFailureRateDistribution = ALLOCATED_FAILURE_RATE_DISTRIBUTION_EDEFAULT;

  /**
   * This is true if the Allocated Failure Rate Distribution attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean allocatedFailureRateDistributionESet;

  /**
   * The default value of the '{@link #getFailureModeType() <em>Failure Mode Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureModeType()
   * @generated
   * @ordered
   */
  protected static final String FAILURE_MODE_TYPE_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getFailureModeType() <em>Failure Mode Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureModeType()
   * @generated
   * @ordered
   */
  protected String failureModeType = FAILURE_MODE_TYPE_EDEFAULT;

  /**
   * This is true if the Failure Mode Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean failureModeTypeESet;

  /**
   * The default value of the '{@link #getPotentialCause() <em>Potential Cause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPotentialCause()
   * @generated
   * @ordered
   */
  protected static final String POTENTIAL_CAUSE_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getPotentialCause() <em>Potential Cause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPotentialCause()
   * @generated
   * @ordered
   */
  protected String potentialCause = POTENTIAL_CAUSE_EDEFAULT;

  /**
   * This is true if the Potential Cause attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean potentialCauseESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWFailureModeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWFailureMode();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCategory()
  {
    return category;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCategory(String newCategory)
  {
    String oldCategory = category;
    category = newCategory;
    boolean oldCategoryESet = categoryESet;
    categoryESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_FAILURE_MODE__CATEGORY, oldCategory, category, !oldCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCategory()
  {
    String oldCategory = category;
    boolean oldCategoryESet = categoryESet;
    category = CATEGORY_EDEFAULT;
    categoryESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_FAILURE_MODE__CATEGORY, oldCategory, CATEGORY_EDEFAULT, oldCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCategory()
  {
    return categoryESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUuid()
  {
    return uuid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUuid(String newUuid)
  {
    String oldUuid = uuid;
    uuid = newUuid;
    boolean oldUuidESet = uuidESet;
    uuidESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_FAILURE_MODE__UUID, oldUuid, uuid, !oldUuidESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetUuid()
  {
    String oldUuid = uuid;
    boolean oldUuidESet = uuidESet;
    uuid = UUID_EDEFAULT;
    uuidESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_FAILURE_MODE__UUID, oldUuid, UUID_EDEFAULT, oldUuidESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUuid()
  {
    return uuidESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getAllocatedFailureRateDistribution()
  {
    return allocatedFailureRateDistribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setAllocatedFailureRateDistribution(Double newAllocatedFailureRateDistribution)
  {
    Double oldAllocatedFailureRateDistribution = allocatedFailureRateDistribution;
    allocatedFailureRateDistribution = newAllocatedFailureRateDistribution;
    boolean oldAllocatedFailureRateDistributionESet = allocatedFailureRateDistributionESet;
    allocatedFailureRateDistributionESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_FAILURE_MODE__ALLOCATED_FAILURE_RATE_DISTRIBUTION, oldAllocatedFailureRateDistribution, allocatedFailureRateDistribution, !oldAllocatedFailureRateDistributionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetAllocatedFailureRateDistribution()
  {
    Double oldAllocatedFailureRateDistribution = allocatedFailureRateDistribution;
    boolean oldAllocatedFailureRateDistributionESet = allocatedFailureRateDistributionESet;
    allocatedFailureRateDistribution = ALLOCATED_FAILURE_RATE_DISTRIBUTION_EDEFAULT;
    allocatedFailureRateDistributionESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_FAILURE_MODE__ALLOCATED_FAILURE_RATE_DISTRIBUTION, oldAllocatedFailureRateDistribution, ALLOCATED_FAILURE_RATE_DISTRIBUTION_EDEFAULT, oldAllocatedFailureRateDistributionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetAllocatedFailureRateDistribution()
  {
    return allocatedFailureRateDistributionESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getFailureModeType()
  {
    return failureModeType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFailureModeType(String newFailureModeType)
  {
    String oldFailureModeType = failureModeType;
    failureModeType = newFailureModeType;
    boolean oldFailureModeTypeESet = failureModeTypeESet;
    failureModeTypeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_FAILURE_MODE__FAILURE_MODE_TYPE, oldFailureModeType, failureModeType, !oldFailureModeTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFailureModeType()
  {
    String oldFailureModeType = failureModeType;
    boolean oldFailureModeTypeESet = failureModeTypeESet;
    failureModeType = FAILURE_MODE_TYPE_EDEFAULT;
    failureModeTypeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_FAILURE_MODE__FAILURE_MODE_TYPE, oldFailureModeType, FAILURE_MODE_TYPE_EDEFAULT, oldFailureModeTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFailureModeType()
  {
    return failureModeTypeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPotentialCause()
  {
    return potentialCause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPotentialCause(String newPotentialCause)
  {
    String oldPotentialCause = potentialCause;
    potentialCause = newPotentialCause;
    boolean oldPotentialCauseESet = potentialCauseESet;
    potentialCauseESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_FAILURE_MODE__POTENTIAL_CAUSE, oldPotentialCause, potentialCause, !oldPotentialCauseESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPotentialCause()
  {
    String oldPotentialCause = potentialCause;
    boolean oldPotentialCauseESet = potentialCauseESet;
    potentialCause = POTENTIAL_CAUSE_EDEFAULT;
    potentialCauseESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_FAILURE_MODE__POTENTIAL_CAUSE, oldPotentialCause, POTENTIAL_CAUSE_EDEFAULT, oldPotentialCauseESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPotentialCause()
  {
    return potentialCauseESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_FAILURE_MODE__CATEGORY:
        return getCategory();
      case Safe10Package.HW_FAILURE_MODE__UUID:
        return getUuid();
      case Safe10Package.HW_FAILURE_MODE__ALLOCATED_FAILURE_RATE_DISTRIBUTION:
        return getAllocatedFailureRateDistribution();
      case Safe10Package.HW_FAILURE_MODE__FAILURE_MODE_TYPE:
        return getFailureModeType();
      case Safe10Package.HW_FAILURE_MODE__POTENTIAL_CAUSE:
        return getPotentialCause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_FAILURE_MODE__CATEGORY:
   			setCategory((String)newValue);
        return;
      case Safe10Package.HW_FAILURE_MODE__UUID:
   			setUuid((String)newValue);
        return;
      case Safe10Package.HW_FAILURE_MODE__ALLOCATED_FAILURE_RATE_DISTRIBUTION:
   			setAllocatedFailureRateDistribution((Double)newValue);
        return;
      case Safe10Package.HW_FAILURE_MODE__FAILURE_MODE_TYPE:
   			setFailureModeType((String)newValue);
        return;
      case Safe10Package.HW_FAILURE_MODE__POTENTIAL_CAUSE:
   			setPotentialCause((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_FAILURE_MODE__CATEGORY:
        unsetCategory();
        return;
      case Safe10Package.HW_FAILURE_MODE__UUID:
        unsetUuid();
        return;
      case Safe10Package.HW_FAILURE_MODE__ALLOCATED_FAILURE_RATE_DISTRIBUTION:
        unsetAllocatedFailureRateDistribution();
        return;
      case Safe10Package.HW_FAILURE_MODE__FAILURE_MODE_TYPE:
        unsetFailureModeType();
        return;
      case Safe10Package.HW_FAILURE_MODE__POTENTIAL_CAUSE:
        unsetPotentialCause();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_FAILURE_MODE__CATEGORY:
        return isSetCategory();
      case Safe10Package.HW_FAILURE_MODE__UUID:
        return isSetUuid();
      case Safe10Package.HW_FAILURE_MODE__ALLOCATED_FAILURE_RATE_DISTRIBUTION:
        return isSetAllocatedFailureRateDistribution();
      case Safe10Package.HW_FAILURE_MODE__FAILURE_MODE_TYPE:
        return isSetFailureModeType();
      case Safe10Package.HW_FAILURE_MODE__POTENTIAL_CAUSE:
        return isSetPotentialCause();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == Identifiable.class)
    {
      switch (derivedFeatureID)
      {
        case Safe10Package.HW_FAILURE_MODE__CATEGORY: return Safe10Package.IDENTIFIABLE__CATEGORY;
        case Safe10Package.HW_FAILURE_MODE__UUID: return Safe10Package.IDENTIFIABLE__UUID;
        default: return -1;
      }
    }
    if (baseClass == MalfunctionType.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == Identifiable.class)
    {
      switch (baseFeatureID)
      {
        case Safe10Package.IDENTIFIABLE__CATEGORY: return Safe10Package.HW_FAILURE_MODE__CATEGORY;
        case Safe10Package.IDENTIFIABLE__UUID: return Safe10Package.HW_FAILURE_MODE__UUID;
        default: return -1;
      }
    }
    if (baseClass == MalfunctionType.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (category: ");
    if (categoryESet) result.append(category); else result.append("<unset>");
    result.append(", uuid: ");
    if (uuidESet) result.append(uuid); else result.append("<unset>");
    result.append(", allocatedFailureRateDistribution: ");
    if (allocatedFailureRateDistributionESet) result.append(allocatedFailureRateDistribution); else result.append("<unset>");
    result.append(", failureModeType: ");
    if (failureModeTypeESet) result.append(failureModeType); else result.append("<unset>");
    result.append(", potentialCause: ");
    if (potentialCauseESet) result.append(potentialCause); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWFailureModeImpl
