/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.HWLambdaPartFormula;
import org.safe.metamodel.safe10.HWPartFailureMode;
import org.safe.metamodel.safe10.HWPartFailureRate;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Lambda Part Formula</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWLambdaPartFormulaImpl#getHwPartFailureRateValue <em>Hw Part Failure Rate Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWLambdaPartFormulaImpl#getFailureRateDistributionValue <em>Failure Rate Distribution Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWLambdaPartFormulaImpl extends FormulaDocumentationImpl implements HWLambdaPartFormula
{
  /**
   * The cached value of the '{@link #getHwPartFailureRateValue() <em>Hw Part Failure Rate Value</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwPartFailureRateValue()
   * @generated
   * @ordered
   */
  protected EList<HWPartFailureRate> hwPartFailureRateValue;

  /**
   * The cached value of the '{@link #getFailureRateDistributionValue() <em>Failure Rate Distribution Value</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureRateDistributionValue()
   * @generated
   * @ordered
   */
  protected EList<HWPartFailureMode> failureRateDistributionValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWLambdaPartFormulaImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWLambdaPartFormula();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWPartFailureRate> getHwPartFailureRateValue()
  {
    if (hwPartFailureRateValue == null)
    {
      hwPartFailureRateValue = new EObjectResolvingEList<HWPartFailureRate>(HWPartFailureRate.class, this, Safe10Package.HW_LAMBDA_PART_FORMULA__HW_PART_FAILURE_RATE_VALUE);
    }
    return hwPartFailureRateValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWPartFailureMode> getFailureRateDistributionValue()
  {
    if (failureRateDistributionValue == null)
    {
      failureRateDistributionValue = new EObjectResolvingEList<HWPartFailureMode>(HWPartFailureMode.class, this, Safe10Package.HW_LAMBDA_PART_FORMULA__FAILURE_RATE_DISTRIBUTION_VALUE);
    }
    return failureRateDistributionValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LAMBDA_PART_FORMULA__HW_PART_FAILURE_RATE_VALUE:
        return getHwPartFailureRateValue();
      case Safe10Package.HW_LAMBDA_PART_FORMULA__FAILURE_RATE_DISTRIBUTION_VALUE:
        return getFailureRateDistributionValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LAMBDA_PART_FORMULA__HW_PART_FAILURE_RATE_VALUE:
        getHwPartFailureRateValue().clear();
        getHwPartFailureRateValue().addAll((Collection<? extends HWPartFailureRate>)newValue);
        return;
      case Safe10Package.HW_LAMBDA_PART_FORMULA__FAILURE_RATE_DISTRIBUTION_VALUE:
        getFailureRateDistributionValue().clear();
        getFailureRateDistributionValue().addAll((Collection<? extends HWPartFailureMode>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LAMBDA_PART_FORMULA__HW_PART_FAILURE_RATE_VALUE:
        getHwPartFailureRateValue().clear();
        return;
      case Safe10Package.HW_LAMBDA_PART_FORMULA__FAILURE_RATE_DISTRIBUTION_VALUE:
        getFailureRateDistributionValue().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LAMBDA_PART_FORMULA__HW_PART_FAILURE_RATE_VALUE:
        return hwPartFailureRateValue != null && !hwPartFailureRateValue.isEmpty();
      case Safe10Package.HW_LAMBDA_PART_FORMULA__FAILURE_RATE_DISTRIBUTION_VALUE:
        return failureRateDistributionValue != null && !failureRateDistributionValue.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //HWLambdaPartFormulaImpl
