/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWLatentFaultMetric;
import org.safe.metamodel.safe10.HWLatentFaultMetricFormula;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Latent Fault Metric</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWLatentFaultMetricImpl#getCalculatedValue <em>Calculated Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWLatentFaultMetricImpl#getLfmCalculatedValue <em>Lfm Calculated Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWLatentFaultMetricImpl extends ExtendedEObjectImpl implements HWLatentFaultMetric
{
  /**
   * The default value of the '{@link #getCalculatedValue() <em>Calculated Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCalculatedValue()
   * @generated
   * @ordered
   */
  protected static final Double CALCULATED_VALUE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getCalculatedValue() <em>Calculated Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCalculatedValue()
   * @generated
   * @ordered
   */
  protected Double calculatedValue = CALCULATED_VALUE_EDEFAULT;

  /**
   * This is true if the Calculated Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean calculatedValueESet;

  /**
   * The cached value of the '{@link #getLfmCalculatedValue() <em>Lfm Calculated Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLfmCalculatedValue()
   * @generated
   * @ordered
   */
  protected HWLatentFaultMetricFormula lfmCalculatedValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWLatentFaultMetricImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWLatentFaultMetric();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getCalculatedValue()
  {
    return calculatedValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCalculatedValue(Double newCalculatedValue)
  {
    Double oldCalculatedValue = calculatedValue;
    calculatedValue = newCalculatedValue;
    boolean oldCalculatedValueESet = calculatedValueESet;
    calculatedValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_LATENT_FAULT_METRIC__CALCULATED_VALUE, oldCalculatedValue, calculatedValue, !oldCalculatedValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCalculatedValue()
  {
    Double oldCalculatedValue = calculatedValue;
    boolean oldCalculatedValueESet = calculatedValueESet;
    calculatedValue = CALCULATED_VALUE_EDEFAULT;
    calculatedValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_LATENT_FAULT_METRIC__CALCULATED_VALUE, oldCalculatedValue, CALCULATED_VALUE_EDEFAULT, oldCalculatedValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCalculatedValue()
  {
    return calculatedValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLatentFaultMetricFormula getLfmCalculatedValue()
  {
    return lfmCalculatedValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetLfmCalculatedValue(HWLatentFaultMetricFormula newLfmCalculatedValue, NotificationChain msgs)
  {
    HWLatentFaultMetricFormula oldLfmCalculatedValue = lfmCalculatedValue;
    lfmCalculatedValue = newLfmCalculatedValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE, oldLfmCalculatedValue, newLfmCalculatedValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLfmCalculatedValue(HWLatentFaultMetricFormula newLfmCalculatedValue)
  {
    if (newLfmCalculatedValue != lfmCalculatedValue)
    {
      NotificationChain msgs = null;
      if (lfmCalculatedValue != null)
        msgs = ((InternalEObject)lfmCalculatedValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE, null, msgs);
      if (newLfmCalculatedValue != null)
        msgs = ((InternalEObject)newLfmCalculatedValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE, null, msgs);
      msgs = basicSetLfmCalculatedValue(newLfmCalculatedValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE, newLfmCalculatedValue, newLfmCalculatedValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE:
        return basicSetLfmCalculatedValue(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LATENT_FAULT_METRIC__CALCULATED_VALUE:
        return getCalculatedValue();
      case Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE:
        return getLfmCalculatedValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LATENT_FAULT_METRIC__CALCULATED_VALUE:
   			setCalculatedValue((Double)newValue);
        return;
      case Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE:
   			setLfmCalculatedValue((HWLatentFaultMetricFormula)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LATENT_FAULT_METRIC__CALCULATED_VALUE:
        unsetCalculatedValue();
        return;
      case Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE:
        	setLfmCalculatedValue((HWLatentFaultMetricFormula)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_LATENT_FAULT_METRIC__CALCULATED_VALUE:
        return isSetCalculatedValue();
      case Safe10Package.HW_LATENT_FAULT_METRIC__LFM_CALCULATED_VALUE:
        return lfmCalculatedValue != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (calculatedValue: ");
    if (calculatedValueESet) result.append(calculatedValue); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWLatentFaultMetricImpl
