/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWPartFailureMode;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Part Failure Mode</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureModeImpl#getPartFailureModeType <em>Part Failure Mode Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureModeImpl#getFailureRateDistribution <em>Failure Rate Distribution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureModeImpl#getPartPotentialCause <em>Part Potential Cause</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWPartFailureModeImpl extends ExtendedEObjectImpl implements HWPartFailureMode
{
  /**
   * The default value of the '{@link #getPartFailureModeType() <em>Part Failure Mode Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPartFailureModeType()
   * @generated
   * @ordered
   */
  protected static final String PART_FAILURE_MODE_TYPE_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getPartFailureModeType() <em>Part Failure Mode Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPartFailureModeType()
   * @generated
   * @ordered
   */
  protected String partFailureModeType = PART_FAILURE_MODE_TYPE_EDEFAULT;

  /**
   * This is true if the Part Failure Mode Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean partFailureModeTypeESet;

  /**
   * The default value of the '{@link #getFailureRateDistribution() <em>Failure Rate Distribution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureRateDistribution()
   * @generated
   * @ordered
   */
  protected static final Integer FAILURE_RATE_DISTRIBUTION_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getFailureRateDistribution() <em>Failure Rate Distribution</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureRateDistribution()
   * @generated
   * @ordered
   */
  protected Integer failureRateDistribution = FAILURE_RATE_DISTRIBUTION_EDEFAULT;

  /**
   * This is true if the Failure Rate Distribution attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean failureRateDistributionESet;

  /**
   * The default value of the '{@link #getPartPotentialCause() <em>Part Potential Cause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPartPotentialCause()
   * @generated
   * @ordered
   */
  protected static final String PART_POTENTIAL_CAUSE_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getPartPotentialCause() <em>Part Potential Cause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPartPotentialCause()
   * @generated
   * @ordered
   */
  protected String partPotentialCause = PART_POTENTIAL_CAUSE_EDEFAULT;

  /**
   * This is true if the Part Potential Cause attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean partPotentialCauseESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWPartFailureModeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWPartFailureMode();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPartFailureModeType()
  {
    return partFailureModeType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPartFailureModeType(String newPartFailureModeType)
  {
    String oldPartFailureModeType = partFailureModeType;
    partFailureModeType = newPartFailureModeType;
    boolean oldPartFailureModeTypeESet = partFailureModeTypeESet;
    partFailureModeTypeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE_MODE__PART_FAILURE_MODE_TYPE, oldPartFailureModeType, partFailureModeType, !oldPartFailureModeTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPartFailureModeType()
  {
    String oldPartFailureModeType = partFailureModeType;
    boolean oldPartFailureModeTypeESet = partFailureModeTypeESet;
    partFailureModeType = PART_FAILURE_MODE_TYPE_EDEFAULT;
    partFailureModeTypeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_PART_FAILURE_MODE__PART_FAILURE_MODE_TYPE, oldPartFailureModeType, PART_FAILURE_MODE_TYPE_EDEFAULT, oldPartFailureModeTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPartFailureModeType()
  {
    return partFailureModeTypeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getFailureRateDistribution()
  {
    return failureRateDistribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFailureRateDistribution(Integer newFailureRateDistribution)
  {
    Integer oldFailureRateDistribution = failureRateDistribution;
    failureRateDistribution = newFailureRateDistribution;
    boolean oldFailureRateDistributionESet = failureRateDistributionESet;
    failureRateDistributionESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE_MODE__FAILURE_RATE_DISTRIBUTION, oldFailureRateDistribution, failureRateDistribution, !oldFailureRateDistributionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFailureRateDistribution()
  {
    Integer oldFailureRateDistribution = failureRateDistribution;
    boolean oldFailureRateDistributionESet = failureRateDistributionESet;
    failureRateDistribution = FAILURE_RATE_DISTRIBUTION_EDEFAULT;
    failureRateDistributionESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_PART_FAILURE_MODE__FAILURE_RATE_DISTRIBUTION, oldFailureRateDistribution, FAILURE_RATE_DISTRIBUTION_EDEFAULT, oldFailureRateDistributionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFailureRateDistribution()
  {
    return failureRateDistributionESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPartPotentialCause()
  {
    return partPotentialCause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPartPotentialCause(String newPartPotentialCause)
  {
    String oldPartPotentialCause = partPotentialCause;
    partPotentialCause = newPartPotentialCause;
    boolean oldPartPotentialCauseESet = partPotentialCauseESet;
    partPotentialCauseESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE_MODE__PART_POTENTIAL_CAUSE, oldPartPotentialCause, partPotentialCause, !oldPartPotentialCauseESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPartPotentialCause()
  {
    String oldPartPotentialCause = partPotentialCause;
    boolean oldPartPotentialCauseESet = partPotentialCauseESet;
    partPotentialCause = PART_POTENTIAL_CAUSE_EDEFAULT;
    partPotentialCauseESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_PART_FAILURE_MODE__PART_POTENTIAL_CAUSE, oldPartPotentialCause, PART_POTENTIAL_CAUSE_EDEFAULT, oldPartPotentialCauseESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPartPotentialCause()
  {
    return partPotentialCauseESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_MODE__PART_FAILURE_MODE_TYPE:
        return getPartFailureModeType();
      case Safe10Package.HW_PART_FAILURE_MODE__FAILURE_RATE_DISTRIBUTION:
        return getFailureRateDistribution();
      case Safe10Package.HW_PART_FAILURE_MODE__PART_POTENTIAL_CAUSE:
        return getPartPotentialCause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_MODE__PART_FAILURE_MODE_TYPE:
   			setPartFailureModeType((String)newValue);
        return;
      case Safe10Package.HW_PART_FAILURE_MODE__FAILURE_RATE_DISTRIBUTION:
   			setFailureRateDistribution((Integer)newValue);
        return;
      case Safe10Package.HW_PART_FAILURE_MODE__PART_POTENTIAL_CAUSE:
   			setPartPotentialCause((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_MODE__PART_FAILURE_MODE_TYPE:
        unsetPartFailureModeType();
        return;
      case Safe10Package.HW_PART_FAILURE_MODE__FAILURE_RATE_DISTRIBUTION:
        unsetFailureRateDistribution();
        return;
      case Safe10Package.HW_PART_FAILURE_MODE__PART_POTENTIAL_CAUSE:
        unsetPartPotentialCause();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_MODE__PART_FAILURE_MODE_TYPE:
        return isSetPartFailureModeType();
      case Safe10Package.HW_PART_FAILURE_MODE__FAILURE_RATE_DISTRIBUTION:
        return isSetFailureRateDistribution();
      case Safe10Package.HW_PART_FAILURE_MODE__PART_POTENTIAL_CAUSE:
        return isSetPartPotentialCause();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (partFailureModeType: ");
    if (partFailureModeTypeESet) result.append(partFailureModeType); else result.append("<unset>");
    result.append(", FailureRateDistribution: ");
    if (failureRateDistributionESet) result.append(failureRateDistribution); else result.append("<unset>");
    result.append(", partPotentialCause: ");
    if (partPotentialCauseESet) result.append(partPotentialCause); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWPartFailureModeImpl
