/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWFailureClassContainer;
import org.safe.metamodel.safe10.HWPMHF;
import org.safe.metamodel.safe10.HWProbabilisticValue;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Probabilistic Value</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWProbabilisticValueImpl#getHwFailureClassContainer <em>Hw Failure Class Container</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWProbabilisticValueImpl#getHwPMHF <em>Hw PMHF</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class HWProbabilisticValueImpl extends ExtendedEObjectImpl implements HWProbabilisticValue
{
  /**
   * The cached value of the '{@link #getHwFailureClassContainer() <em>Hw Failure Class Container</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFailureClassContainer()
   * @generated
   * @ordered
   */
  protected HWFailureClassContainer hwFailureClassContainer;

  /**
   * The cached value of the '{@link #getHwPMHF() <em>Hw PMHF</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwPMHF()
   * @generated
   * @ordered
   */
  protected HWPMHF hwPMHF;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWProbabilisticValueImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWProbabilisticValue();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureClassContainer getHwFailureClassContainer()
  {
    return hwFailureClassContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwFailureClassContainer(HWFailureClassContainer newHwFailureClassContainer, NotificationChain msgs)
  {
    HWFailureClassContainer oldHwFailureClassContainer = hwFailureClassContainer;
    hwFailureClassContainer = newHwFailureClassContainer;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER, oldHwFailureClassContainer, newHwFailureClassContainer);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwFailureClassContainer(HWFailureClassContainer newHwFailureClassContainer)
  {
    if (newHwFailureClassContainer != hwFailureClassContainer)
    {
      NotificationChain msgs = null;
      if (hwFailureClassContainer != null)
        msgs = ((InternalEObject)hwFailureClassContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER, null, msgs);
      if (newHwFailureClassContainer != null)
        msgs = ((InternalEObject)newHwFailureClassContainer).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER, null, msgs);
      msgs = basicSetHwFailureClassContainer(newHwFailureClassContainer, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER, newHwFailureClassContainer, newHwFailureClassContainer));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPMHF getHwPMHF()
  {
    return hwPMHF;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwPMHF(HWPMHF newHwPMHF, NotificationChain msgs)
  {
    HWPMHF oldHwPMHF = hwPMHF;
    hwPMHF = newHwPMHF;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF, oldHwPMHF, newHwPMHF);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwPMHF(HWPMHF newHwPMHF)
  {
    if (newHwPMHF != hwPMHF)
    {
      NotificationChain msgs = null;
      if (hwPMHF != null)
        msgs = ((InternalEObject)hwPMHF).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF, null, msgs);
      if (newHwPMHF != null)
        msgs = ((InternalEObject)newHwPMHF).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF, null, msgs);
      msgs = basicSetHwPMHF(newHwPMHF, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF, newHwPMHF, newHwPMHF));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER:
        return basicSetHwFailureClassContainer(null, msgs);
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF:
        return basicSetHwPMHF(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER:
        return getHwFailureClassContainer();
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF:
        return getHwPMHF();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER:
   			setHwFailureClassContainer((HWFailureClassContainer)newValue);
        return;
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF:
   			setHwPMHF((HWPMHF)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER:
        	setHwFailureClassContainer((HWFailureClassContainer)null);
        return;
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF:
        	setHwPMHF((HWPMHF)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_FAILURE_CLASS_CONTAINER:
        return hwFailureClassContainer != null;
      case Safe10Package.HW_PROBABILISTIC_VALUE__HW_PMHF:
        return hwPMHF != null;
    }
    return super.eIsSet(featureID);
  }

} //HWProbabilisticValueImpl
