/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HWArchitecturalMetrics;
import org.safe.metamodel.safe10.HWProbabilisticValue;
import org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Quantitative Failure Analysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWQuantitativeFailureAnalysisImpl#getHwArchitecturalMetrics <em>Hw Architectural Metrics</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWQuantitativeFailureAnalysisImpl#getHwProbalisticValue <em>Hw Probalistic Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWQuantitativeFailureAnalysisImpl#getNameWasNotSet_5 <em>Name Was Not Set 5</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWQuantitativeFailureAnalysisImpl extends IdentifiableImpl implements HWQuantitativeFailureAnalysis
{
  /**
   * The cached value of the '{@link #getHwArchitecturalMetrics() <em>Hw Architectural Metrics</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwArchitecturalMetrics()
   * @generated
   * @ordered
   */
  protected HWArchitecturalMetrics hwArchitecturalMetrics;

  /**
   * The cached value of the '{@link #getHwProbalisticValue() <em>Hw Probalistic Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwProbalisticValue()
   * @generated
   * @ordered
   */
  protected HWProbabilisticValue hwProbalisticValue;

  /**
   * The cached value of the '{@link #getNameWasNotSet_5() <em>Name Was Not Set 5</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameWasNotSet_5()
   * @generated
   * @ordered
   */
  protected HardwareFailureAnalysis nameWasNotSet_5;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWQuantitativeFailureAnalysisImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWQuantitativeFailureAnalysis();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWArchitecturalMetrics getHwArchitecturalMetrics()
  {
    return hwArchitecturalMetrics;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwArchitecturalMetrics(HWArchitecturalMetrics newHwArchitecturalMetrics, NotificationChain msgs)
  {
    HWArchitecturalMetrics oldHwArchitecturalMetrics = hwArchitecturalMetrics;
    hwArchitecturalMetrics = newHwArchitecturalMetrics;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS, oldHwArchitecturalMetrics, newHwArchitecturalMetrics);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwArchitecturalMetrics(HWArchitecturalMetrics newHwArchitecturalMetrics)
  {
    if (newHwArchitecturalMetrics != hwArchitecturalMetrics)
    {
      NotificationChain msgs = null;
      if (hwArchitecturalMetrics != null)
        msgs = ((InternalEObject)hwArchitecturalMetrics).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS, null, msgs);
      if (newHwArchitecturalMetrics != null)
        msgs = ((InternalEObject)newHwArchitecturalMetrics).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS, null, msgs);
      msgs = basicSetHwArchitecturalMetrics(newHwArchitecturalMetrics, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS, newHwArchitecturalMetrics, newHwArchitecturalMetrics));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWProbabilisticValue getHwProbalisticValue()
  {
    return hwProbalisticValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwProbalisticValue(HWProbabilisticValue newHwProbalisticValue, NotificationChain msgs)
  {
    HWProbabilisticValue oldHwProbalisticValue = hwProbalisticValue;
    hwProbalisticValue = newHwProbalisticValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE, oldHwProbalisticValue, newHwProbalisticValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwProbalisticValue(HWProbabilisticValue newHwProbalisticValue)
  {
    if (newHwProbalisticValue != hwProbalisticValue)
    {
      NotificationChain msgs = null;
      if (hwProbalisticValue != null)
        msgs = ((InternalEObject)hwProbalisticValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE, null, msgs);
      if (newHwProbalisticValue != null)
        msgs = ((InternalEObject)newHwProbalisticValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE, null, msgs);
      msgs = basicSetHwProbalisticValue(newHwProbalisticValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE, newHwProbalisticValue, newHwProbalisticValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareFailureAnalysis getNameWasNotSet_5()
  {
    if (nameWasNotSet_5 != null && nameWasNotSet_5.eIsProxy())
    {
      InternalEObject oldNameWasNotSet_5 = (InternalEObject)nameWasNotSet_5;
      nameWasNotSet_5 = (HardwareFailureAnalysis)eResolveProxy(oldNameWasNotSet_5);
      if (nameWasNotSet_5 != oldNameWasNotSet_5)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5, oldNameWasNotSet_5, nameWasNotSet_5));
      }
    }
    return nameWasNotSet_5;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareFailureAnalysis basicGetNameWasNotSet_5()
  {
    return nameWasNotSet_5;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetNameWasNotSet_5(HardwareFailureAnalysis newNameWasNotSet_5, NotificationChain msgs)
  {
    HardwareFailureAnalysis oldNameWasNotSet_5 = nameWasNotSet_5;
    nameWasNotSet_5 = newNameWasNotSet_5;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5, oldNameWasNotSet_5, newNameWasNotSet_5);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameWasNotSet_5(HardwareFailureAnalysis newNameWasNotSet_5)
  {
    if (newNameWasNotSet_5 != nameWasNotSet_5)
    {
      NotificationChain msgs = null;
      if (nameWasNotSet_5 != null)
        msgs = ((InternalEObject)nameWasNotSet_5).eInverseRemove(this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS, HardwareFailureAnalysis.class, msgs);
      if (newNameWasNotSet_5 != null)
        msgs = ((InternalEObject)newNameWasNotSet_5).eInverseAdd(this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS, HardwareFailureAnalysis.class, msgs);
      msgs = basicSetNameWasNotSet_5(newNameWasNotSet_5, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5, newNameWasNotSet_5, newNameWasNotSet_5));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5:
        if (nameWasNotSet_5 != null)
          msgs = ((InternalEObject)nameWasNotSet_5).eInverseRemove(this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS, HardwareFailureAnalysis.class, msgs);
        return basicSetNameWasNotSet_5((HardwareFailureAnalysis)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS:
        return basicSetHwArchitecturalMetrics(null, msgs);
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE:
        return basicSetHwProbalisticValue(null, msgs);
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5:
        return basicSetNameWasNotSet_5(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS:
        return getHwArchitecturalMetrics();
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE:
        return getHwProbalisticValue();
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5:
        if (resolve) return getNameWasNotSet_5();
        return basicGetNameWasNotSet_5();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS:
   			setHwArchitecturalMetrics((HWArchitecturalMetrics)newValue);
        return;
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE:
   			setHwProbalisticValue((HWProbabilisticValue)newValue);
        return;
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5:
   			setNameWasNotSet_5((HardwareFailureAnalysis)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS:
        	setHwArchitecturalMetrics((HWArchitecturalMetrics)null);
        return;
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE:
        	setHwProbalisticValue((HWProbabilisticValue)null);
        return;
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5:
        	setNameWasNotSet_5((HardwareFailureAnalysis)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_ARCHITECTURAL_METRICS:
        return hwArchitecturalMetrics != null;
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__HW_PROBALISTIC_VALUE:
        return hwProbalisticValue != null;
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5:
        return nameWasNotSet_5 != null;
    }
    return super.eIsSet(featureID);
  }

} //HWQuantitativeFailureAnalysisImpl
