/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.HWFMSingleContribution;
import org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Single Point Fault Metric Formula</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWSinglePointFaultMetricFormulaImpl#getLambdaValue <em>Lambda Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWSinglePointFaultMetricFormulaImpl extends FormulaDocumentationImpl implements HWSinglePointFaultMetricFormula
{
  /**
   * The cached value of the '{@link #getLambdaValue() <em>Lambda Value</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaValue()
   * @generated
   * @ordered
   */
  protected EList<HWFMSingleContribution> lambdaValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWSinglePointFaultMetricFormulaImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWSinglePointFaultMetricFormula();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWFMSingleContribution> getLambdaValue()
  {
    if (lambdaValue == null)
    {
      lambdaValue = new EObjectResolvingEList<HWFMSingleContribution>(HWFMSingleContribution.class, this, Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA__LAMBDA_VALUE);
    }
    return lambdaValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA__LAMBDA_VALUE:
        return getLambdaValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA__LAMBDA_VALUE:
        getLambdaValue().clear();
        getLambdaValue().addAll((Collection<? extends HWFMSingleContribution>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA__LAMBDA_VALUE:
        getLambdaValue().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA__LAMBDA_VALUE:
        return lambdaValue != null && !lambdaValue.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //HWSinglePointFaultMetricFormulaImpl
