/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.Handle;
import org.safe.metamodel.safe10.HandlingType;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Situation;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Handle</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HandleImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HandleImpl#getHandledSituation <em>Handled Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HandleImpl#getErrorSituation <em>Error Situation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HandleImpl extends TacticImpl implements Handle
{
  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final HandlingType TYPE_EDEFAULT = HandlingType.CONTROL;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected HandlingType type = TYPE_EDEFAULT;

  /**
   * This is true if the Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean typeESet;

  /**
   * The cached value of the '{@link #getHandledSituation() <em>Handled Situation</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHandledSituation()
   * @generated
   * @ordered
   */
  protected Situation handledSituation;

  /**
   * The cached value of the '{@link #getErrorSituation() <em>Error Situation</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorSituation()
   * @generated
   * @ordered
   */
  protected EList<Situation> errorSituation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HandleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHandle();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HandlingType getType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(HandlingType newType)
  {
    HandlingType oldType = type;
    type = newType == null ? TYPE_EDEFAULT : newType;
    boolean oldTypeESet = typeESet;
    typeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HANDLE__TYPE, oldType, type, !oldTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetType()
  {
    HandlingType oldType = type;
    boolean oldTypeESet = typeESet;
    type = TYPE_EDEFAULT;
    typeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HANDLE__TYPE, oldType, TYPE_EDEFAULT, oldTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetType()
  {
    return typeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Situation getHandledSituation()
  {
    if (handledSituation != null && handledSituation.eIsProxy())
    {
      InternalEObject oldHandledSituation = (InternalEObject)handledSituation;
      handledSituation = (Situation)eResolveProxy(oldHandledSituation);
      if (handledSituation != oldHandledSituation)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HANDLE__HANDLED_SITUATION, oldHandledSituation, handledSituation));
      }
    }
    return handledSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Situation basicGetHandledSituation()
  {
    return handledSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHandledSituation(Situation newHandledSituation)
  {
    Situation oldHandledSituation = handledSituation;
    handledSituation = newHandledSituation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HANDLE__HANDLED_SITUATION, oldHandledSituation, handledSituation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Situation> getErrorSituation()
  {
    if (errorSituation == null)
    {
      errorSituation = new EObjectContainmentEList<Situation>(Situation.class, this, Safe10Package.HANDLE__ERROR_SITUATION);
    }
    return errorSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HANDLE__ERROR_SITUATION:
        return ((InternalEList<?>)getErrorSituation()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HANDLE__TYPE:
        return getType();
      case Safe10Package.HANDLE__HANDLED_SITUATION:
        if (resolve) return getHandledSituation();
        return basicGetHandledSituation();
      case Safe10Package.HANDLE__ERROR_SITUATION:
        return getErrorSituation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HANDLE__TYPE:
   			setType((HandlingType)newValue);
        return;
      case Safe10Package.HANDLE__HANDLED_SITUATION:
   			setHandledSituation((Situation)newValue);
        return;
      case Safe10Package.HANDLE__ERROR_SITUATION:
        getErrorSituation().clear();
        getErrorSituation().addAll((Collection<? extends Situation>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HANDLE__TYPE:
        unsetType();
        return;
      case Safe10Package.HANDLE__HANDLED_SITUATION:
        	setHandledSituation((Situation)null);
        return;
      case Safe10Package.HANDLE__ERROR_SITUATION:
        getErrorSituation().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HANDLE__TYPE:
        return isSetType();
      case Safe10Package.HANDLE__HANDLED_SITUATION:
        return handledSituation != null;
      case Safe10Package.HANDLE__ERROR_SITUATION:
        return errorSituation != null && !errorSituation.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (type: ");
    if (typeESet) result.append(type); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HandleImpl
