/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HWFailureMode;
import org.safe.metamodel.safe10.HWFailureRate;
import org.safe.metamodel.safe10.HardwareComponentFailure;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hardware Component Failure</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareComponentFailureImpl#getHwFailureRate <em>Hw Failure Rate</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareComponentFailureImpl#getHwFailureMode <em>Hw Failure Mode</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class HardwareComponentFailureImpl extends IdentifiableImpl implements HardwareComponentFailure
{
  /**
   * The cached value of the '{@link #getHwFailureRate() <em>Hw Failure Rate</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFailureRate()
   * @generated
   * @ordered
   */
  protected HWFailureRate hwFailureRate;

  /**
   * The cached value of the '{@link #getHwFailureMode() <em>Hw Failure Mode</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFailureMode()
   * @generated
   * @ordered
   */
  protected EList<HWFailureMode> hwFailureMode;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HardwareComponentFailureImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHardwareComponentFailure();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureRate getHwFailureRate()
  {
    return hwFailureRate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwFailureRate(HWFailureRate newHwFailureRate, NotificationChain msgs)
  {
    HWFailureRate oldHwFailureRate = hwFailureRate;
    hwFailureRate = newHwFailureRate;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE, oldHwFailureRate, newHwFailureRate);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwFailureRate(HWFailureRate newHwFailureRate)
  {
    if (newHwFailureRate != hwFailureRate)
    {
      NotificationChain msgs = null;
      if (hwFailureRate != null)
        msgs = ((InternalEObject)hwFailureRate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE, null, msgs);
      if (newHwFailureRate != null)
        msgs = ((InternalEObject)newHwFailureRate).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE, null, msgs);
      msgs = basicSetHwFailureRate(newHwFailureRate, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE, newHwFailureRate, newHwFailureRate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWFailureMode> getHwFailureMode()
  {
    if (hwFailureMode == null)
    {
      hwFailureMode = new EObjectContainmentEList<HWFailureMode>(HWFailureMode.class, this, Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_MODE);
    }
    return hwFailureMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE:
        return basicSetHwFailureRate(null, msgs);
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_MODE:
        return ((InternalEList<?>)getHwFailureMode()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE:
        return getHwFailureRate();
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_MODE:
        return getHwFailureMode();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE:
   			setHwFailureRate((HWFailureRate)newValue);
        return;
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_MODE:
        getHwFailureMode().clear();
        getHwFailureMode().addAll((Collection<? extends HWFailureMode>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE:
        	setHwFailureRate((HWFailureRate)null);
        return;
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_MODE:
        getHwFailureMode().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_RATE:
        return hwFailureRate != null;
      case Safe10Package.HARDWARE_COMPONENT_FAILURE__HW_FAILURE_MODE:
        return hwFailureMode != null && !hwFailureMode.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //HardwareComponentFailureImpl
