/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eatop.eel.eastadl21.FunctionConnector;
import org.eatop.eel.eastadl21.FunctionPort;
import org.eatop.eel.eastadl21.HardwarePin;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HSIElementCategory;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hardware Software Interface Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSoftwareInterfaceElementImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSoftwareInterfaceElementImpl#getRationale <em>Rationale</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSoftwareInterfaceElementImpl#getHardwarePin <em>Hardware Pin</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSoftwareInterfaceElementImpl#getBasicSoftwareFunctionPort <em>Basic Software Function Port</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSoftwareInterfaceElementImpl#getConnector <em>Connector</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HardwareSoftwareInterfaceElementImpl extends IdentifiableImpl implements HardwareSoftwareInterfaceElement
{
  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final HSIElementCategory TYPE_EDEFAULT = HSIElementCategory.VOLATILE_MEMORY;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected HSIElementCategory type = TYPE_EDEFAULT;

  /**
   * This is true if the Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean typeESet;

  /**
   * The default value of the '{@link #getRationale() <em>Rationale</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationale()
   * @generated
   * @ordered
   */
  protected static final String RATIONALE_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getRationale() <em>Rationale</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationale()
   * @generated
   * @ordered
   */
  protected String rationale = RATIONALE_EDEFAULT;

  /**
   * This is true if the Rationale attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean rationaleESet;

  /**
   * The cached value of the '{@link #getHardwarePin() <em>Hardware Pin</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHardwarePin()
   * @generated
   * @ordered
   */
  protected HardwarePin hardwarePin;

  /**
   * The cached value of the '{@link #getBasicSoftwareFunctionPort() <em>Basic Software Function Port</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBasicSoftwareFunctionPort()
   * @generated
   * @ordered
   */
  protected FunctionPort basicSoftwareFunctionPort;

  /**
   * The cached value of the '{@link #getConnector() <em>Connector</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConnector()
   * @generated
   * @ordered
   */
  protected FunctionConnector connector;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HardwareSoftwareInterfaceElementImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHardwareSoftwareInterfaceElement();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HSIElementCategory getType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(HSIElementCategory newType)
  {
    HSIElementCategory oldType = type;
    type = newType == null ? TYPE_EDEFAULT : newType;
    boolean oldTypeESet = typeESet;
    typeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__TYPE, oldType, type, !oldTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetType()
  {
    HSIElementCategory oldType = type;
    boolean oldTypeESet = typeESet;
    type = TYPE_EDEFAULT;
    typeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__TYPE, oldType, TYPE_EDEFAULT, oldTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetType()
  {
    return typeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRationale()
  {
    return rationale;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRationale(String newRationale)
  {
    String oldRationale = rationale;
    rationale = newRationale;
    boolean oldRationaleESet = rationaleESet;
    rationaleESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__RATIONALE, oldRationale, rationale, !oldRationaleESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRationale()
  {
    String oldRationale = rationale;
    boolean oldRationaleESet = rationaleESet;
    rationale = RATIONALE_EDEFAULT;
    rationaleESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__RATIONALE, oldRationale, RATIONALE_EDEFAULT, oldRationaleESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRationale()
  {
    return rationaleESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwarePin getHardwarePin()
  {
    if (hardwarePin != null && hardwarePin.eIsProxy())
    {
      InternalEObject oldHardwarePin = (InternalEObject)hardwarePin;
      hardwarePin = (HardwarePin)eResolveProxy(oldHardwarePin);
      if (hardwarePin != oldHardwarePin)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__HARDWARE_PIN, oldHardwarePin, hardwarePin));
      }
    }
    return hardwarePin;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwarePin basicGetHardwarePin()
  {
    return hardwarePin;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHardwarePin(HardwarePin newHardwarePin)
  {
    HardwarePin oldHardwarePin = hardwarePin;
    hardwarePin = newHardwarePin;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__HARDWARE_PIN, oldHardwarePin, hardwarePin));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionPort getBasicSoftwareFunctionPort()
  {
    if (basicSoftwareFunctionPort != null && basicSoftwareFunctionPort.eIsProxy())
    {
      InternalEObject oldBasicSoftwareFunctionPort = (InternalEObject)basicSoftwareFunctionPort;
      basicSoftwareFunctionPort = (FunctionPort)eResolveProxy(oldBasicSoftwareFunctionPort);
      if (basicSoftwareFunctionPort != oldBasicSoftwareFunctionPort)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__BASIC_SOFTWARE_FUNCTION_PORT, oldBasicSoftwareFunctionPort, basicSoftwareFunctionPort));
      }
    }
    return basicSoftwareFunctionPort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionPort basicGetBasicSoftwareFunctionPort()
  {
    return basicSoftwareFunctionPort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBasicSoftwareFunctionPort(FunctionPort newBasicSoftwareFunctionPort)
  {
    FunctionPort oldBasicSoftwareFunctionPort = basicSoftwareFunctionPort;
    basicSoftwareFunctionPort = newBasicSoftwareFunctionPort;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__BASIC_SOFTWARE_FUNCTION_PORT, oldBasicSoftwareFunctionPort, basicSoftwareFunctionPort));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionConnector getConnector()
  {
    if (connector != null && connector.eIsProxy())
    {
      InternalEObject oldConnector = (InternalEObject)connector;
      connector = (FunctionConnector)eResolveProxy(oldConnector);
      if (connector != oldConnector)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__CONNECTOR, oldConnector, connector));
      }
    }
    return connector;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionConnector basicGetConnector()
  {
    return connector;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setConnector(FunctionConnector newConnector)
  {
    FunctionConnector oldConnector = connector;
    connector = newConnector;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__CONNECTOR, oldConnector, connector));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__TYPE:
        return getType();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__RATIONALE:
        return getRationale();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__HARDWARE_PIN:
        if (resolve) return getHardwarePin();
        return basicGetHardwarePin();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__BASIC_SOFTWARE_FUNCTION_PORT:
        if (resolve) return getBasicSoftwareFunctionPort();
        return basicGetBasicSoftwareFunctionPort();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__CONNECTOR:
        if (resolve) return getConnector();
        return basicGetConnector();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__TYPE:
   			setType((HSIElementCategory)newValue);
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__RATIONALE:
   			setRationale((String)newValue);
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__HARDWARE_PIN:
   			setHardwarePin((HardwarePin)newValue);
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__BASIC_SOFTWARE_FUNCTION_PORT:
   			setBasicSoftwareFunctionPort((FunctionPort)newValue);
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__CONNECTOR:
   			setConnector((FunctionConnector)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__TYPE:
        unsetType();
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__RATIONALE:
        unsetRationale();
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__HARDWARE_PIN:
        	setHardwarePin((HardwarePin)null);
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__BASIC_SOFTWARE_FUNCTION_PORT:
        	setBasicSoftwareFunctionPort((FunctionPort)null);
        return;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__CONNECTOR:
        	setConnector((FunctionConnector)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__TYPE:
        return isSetType();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__RATIONALE:
        return isSetRationale();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__HARDWARE_PIN:
        return hardwarePin != null;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__BASIC_SOFTWARE_FUNCTION_PORT:
        return basicSoftwareFunctionPort != null;
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT__CONNECTOR:
        return connector != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (type: ");
    if (typeESet) result.append(type); else result.append("<unset>");
    result.append(", rationale: ");
    if (rationaleESet) result.append(rationale); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HardwareSoftwareInterfaceElementImpl
