/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HeartbeatConfig;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Heartbeat Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HeartbeatConfigImpl#getPeriodMs <em>Period Ms</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HeartbeatConfigImpl#getDeadlineMs <em>Deadline Ms</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HeartbeatConfigImpl extends IdentifiableImpl implements HeartbeatConfig
{
  /**
   * The default value of the '{@link #getPeriodMs() <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPeriodMs()
   * @generated
   * @ordered
   */
  protected static final Integer PERIOD_MS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getPeriodMs() <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPeriodMs()
   * @generated
   * @ordered
   */
  protected Integer periodMs = PERIOD_MS_EDEFAULT;

  /**
   * This is true if the Period Ms attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean periodMsESet;

  /**
   * The default value of the '{@link #getDeadlineMs() <em>Deadline Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDeadlineMs()
   * @generated
   * @ordered
   */
  protected static final Integer DEADLINE_MS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getDeadlineMs() <em>Deadline Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDeadlineMs()
   * @generated
   * @ordered
   */
  protected Integer deadlineMs = DEADLINE_MS_EDEFAULT;

  /**
   * This is true if the Deadline Ms attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean deadlineMsESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HeartbeatConfigImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHeartbeatConfig();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getPeriodMs()
  {
    return periodMs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPeriodMs(Integer newPeriodMs)
  {
    Integer oldPeriodMs = periodMs;
    periodMs = newPeriodMs;
    boolean oldPeriodMsESet = periodMsESet;
    periodMsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HEARTBEAT_CONFIG__PERIOD_MS, oldPeriodMs, periodMs, !oldPeriodMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPeriodMs()
  {
    Integer oldPeriodMs = periodMs;
    boolean oldPeriodMsESet = periodMsESet;
    periodMs = PERIOD_MS_EDEFAULT;
    periodMsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HEARTBEAT_CONFIG__PERIOD_MS, oldPeriodMs, PERIOD_MS_EDEFAULT, oldPeriodMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPeriodMs()
  {
    return periodMsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getDeadlineMs()
  {
    return deadlineMs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDeadlineMs(Integer newDeadlineMs)
  {
    Integer oldDeadlineMs = deadlineMs;
    deadlineMs = newDeadlineMs;
    boolean oldDeadlineMsESet = deadlineMsESet;
    deadlineMsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HEARTBEAT_CONFIG__DEADLINE_MS, oldDeadlineMs, deadlineMs, !oldDeadlineMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetDeadlineMs()
  {
    Integer oldDeadlineMs = deadlineMs;
    boolean oldDeadlineMsESet = deadlineMsESet;
    deadlineMs = DEADLINE_MS_EDEFAULT;
    deadlineMsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HEARTBEAT_CONFIG__DEADLINE_MS, oldDeadlineMs, DEADLINE_MS_EDEFAULT, oldDeadlineMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetDeadlineMs()
  {
    return deadlineMsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HEARTBEAT_CONFIG__PERIOD_MS:
        return getPeriodMs();
      case Safe10Package.HEARTBEAT_CONFIG__DEADLINE_MS:
        return getDeadlineMs();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HEARTBEAT_CONFIG__PERIOD_MS:
   			setPeriodMs((Integer)newValue);
        return;
      case Safe10Package.HEARTBEAT_CONFIG__DEADLINE_MS:
   			setDeadlineMs((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HEARTBEAT_CONFIG__PERIOD_MS:
        unsetPeriodMs();
        return;
      case Safe10Package.HEARTBEAT_CONFIG__DEADLINE_MS:
        unsetDeadlineMs();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HEARTBEAT_CONFIG__PERIOD_MS:
        return isSetPeriodMs();
      case Safe10Package.HEARTBEAT_CONFIG__DEADLINE_MS:
        return isSetDeadlineMs();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (periodMs: ");
    if (periodMsESet) result.append(periodMs); else result.append("<unset>");
    result.append(", deadlineMs: ");
    if (deadlineMsESet) result.append(deadlineMs); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HeartbeatConfigImpl
