/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.Requirement;
import org.eatop.eel.eastadl21.VehicleFeature;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.DevelopmentCategory;
import org.safe.metamodel.safe10.Item;
import org.safe.metamodel.safe10.ItemFunctionDescription;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.OperatingMode;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeState;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Item</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getDevelopmentCategory <em>Development Category</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getPossibleItemMalfunction <em>Possible Item Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getOtherItem <em>Other Item</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getOperationalSituation <em>Operational Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getFeature <em>Feature</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getLegalRequirements <em>Legal Requirements</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getItemFunction <em>Item Function</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getOperatingMode <em>Operating Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ItemImpl#getSafeState <em>Safe State</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ItemImpl extends IdentifiableImpl implements Item
{
  /**
   * The default value of the '{@link #getDevelopmentCategory() <em>Development Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDevelopmentCategory()
   * @generated
   * @ordered
   */
  protected static final DevelopmentCategory DEVELOPMENT_CATEGORY_EDEFAULT = DevelopmentCategory.NEW_ITEM_DEVELOPMENT;

  /**
   * The cached value of the '{@link #getDevelopmentCategory() <em>Development Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDevelopmentCategory()
   * @generated
   * @ordered
   */
  protected DevelopmentCategory developmentCategory = DEVELOPMENT_CATEGORY_EDEFAULT;

  /**
   * This is true if the Development Category attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean developmentCategoryESet;

  /**
   * The cached value of the '{@link #getPossibleItemMalfunction() <em>Possible Item Malfunction</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPossibleItemMalfunction()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> possibleItemMalfunction;

  /**
   * The cached value of the '{@link #getOtherItem() <em>Other Item</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOtherItem()
   * @generated
   * @ordered
   */
  protected EList<Item> otherItem;

  /**
   * The cached value of the '{@link #getOperationalSituation() <em>Operational Situation</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperationalSituation()
   * @generated
   * @ordered
   */
  protected EList<OperationalSituation> operationalSituation;

  /**
   * The cached value of the '{@link #getFeature() <em>Feature</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFeature()
   * @generated
   * @ordered
   */
  protected EList<VehicleFeature> feature;

  /**
   * The cached value of the '{@link #getLegalRequirements() <em>Legal Requirements</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLegalRequirements()
   * @generated
   * @ordered
   */
  protected EList<Requirement> legalRequirements;

  /**
   * The cached value of the '{@link #getItemFunction() <em>Item Function</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getItemFunction()
   * @generated
   * @ordered
   */
  protected EList<ItemFunctionDescription> itemFunction;

  /**
   * The cached value of the '{@link #getOperatingMode() <em>Operating Mode</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperatingMode()
   * @generated
   * @ordered
   */
  protected EList<OperatingMode> operatingMode;

  /**
   * The cached value of the '{@link #getSafeState() <em>Safe State</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafeState()
   * @generated
   * @ordered
   */
  protected EList<SafeState> safeState;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ItemImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getItem();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DevelopmentCategory getDevelopmentCategory()
  {
    return developmentCategory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDevelopmentCategory(DevelopmentCategory newDevelopmentCategory)
  {
    DevelopmentCategory oldDevelopmentCategory = developmentCategory;
    developmentCategory = newDevelopmentCategory == null ? DEVELOPMENT_CATEGORY_EDEFAULT : newDevelopmentCategory;
    boolean oldDevelopmentCategoryESet = developmentCategoryESet;
    developmentCategoryESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ITEM__DEVELOPMENT_CATEGORY, oldDevelopmentCategory, developmentCategory, !oldDevelopmentCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetDevelopmentCategory()
  {
    DevelopmentCategory oldDevelopmentCategory = developmentCategory;
    boolean oldDevelopmentCategoryESet = developmentCategoryESet;
    developmentCategory = DEVELOPMENT_CATEGORY_EDEFAULT;
    developmentCategoryESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.ITEM__DEVELOPMENT_CATEGORY, oldDevelopmentCategory, DEVELOPMENT_CATEGORY_EDEFAULT, oldDevelopmentCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetDevelopmentCategory()
  {
    return developmentCategoryESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getPossibleItemMalfunction()
  {
    if (possibleItemMalfunction == null)
    {
      possibleItemMalfunction = new EObjectContainmentEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION);
    }
    return possibleItemMalfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Item> getOtherItem()
  {
    if (otherItem == null)
    {
      otherItem = new EObjectResolvingEList<Item>(Item.class, this, Safe10Package.ITEM__OTHER_ITEM);
    }
    return otherItem;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<OperationalSituation> getOperationalSituation()
  {
    if (operationalSituation == null)
    {
      operationalSituation = new EObjectResolvingEList<OperationalSituation>(OperationalSituation.class, this, Safe10Package.ITEM__OPERATIONAL_SITUATION);
    }
    return operationalSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<VehicleFeature> getFeature()
  {
    if (feature == null)
    {
      feature = new EObjectResolvingEList<VehicleFeature>(VehicleFeature.class, this, Safe10Package.ITEM__FEATURE);
    }
    return feature;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Requirement> getLegalRequirements()
  {
    if (legalRequirements == null)
    {
      legalRequirements = new EObjectResolvingEList<Requirement>(Requirement.class, this, Safe10Package.ITEM__LEGAL_REQUIREMENTS);
    }
    return legalRequirements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ItemFunctionDescription> getItemFunction()
  {
    if (itemFunction == null)
    {
      itemFunction = new EObjectContainmentEList<ItemFunctionDescription>(ItemFunctionDescription.class, this, Safe10Package.ITEM__ITEM_FUNCTION);
    }
    return itemFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<OperatingMode> getOperatingMode()
  {
    if (operatingMode == null)
    {
      operatingMode = new EObjectContainmentEList<OperatingMode>(OperatingMode.class, this, Safe10Package.ITEM__OPERATING_MODE);
    }
    return operatingMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SafeState> getSafeState()
  {
    if (safeState == null)
    {
      safeState = new EObjectContainmentEList<SafeState>(SafeState.class, this, Safe10Package.ITEM__SAFE_STATE);
    }
    return safeState;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION:
        return ((InternalEList<?>)getPossibleItemMalfunction()).basicRemove(otherEnd, msgs);
      case Safe10Package.ITEM__ITEM_FUNCTION:
        return ((InternalEList<?>)getItemFunction()).basicRemove(otherEnd, msgs);
      case Safe10Package.ITEM__OPERATING_MODE:
        return ((InternalEList<?>)getOperatingMode()).basicRemove(otherEnd, msgs);
      case Safe10Package.ITEM__SAFE_STATE:
        return ((InternalEList<?>)getSafeState()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ITEM__DEVELOPMENT_CATEGORY:
        return getDevelopmentCategory();
      case Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION:
        return getPossibleItemMalfunction();
      case Safe10Package.ITEM__OTHER_ITEM:
        return getOtherItem();
      case Safe10Package.ITEM__OPERATIONAL_SITUATION:
        return getOperationalSituation();
      case Safe10Package.ITEM__FEATURE:
        return getFeature();
      case Safe10Package.ITEM__LEGAL_REQUIREMENTS:
        return getLegalRequirements();
      case Safe10Package.ITEM__ITEM_FUNCTION:
        return getItemFunction();
      case Safe10Package.ITEM__OPERATING_MODE:
        return getOperatingMode();
      case Safe10Package.ITEM__SAFE_STATE:
        return getSafeState();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ITEM__DEVELOPMENT_CATEGORY:
   			setDevelopmentCategory((DevelopmentCategory)newValue);
        return;
      case Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION:
        getPossibleItemMalfunction().clear();
        getPossibleItemMalfunction().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
      case Safe10Package.ITEM__OTHER_ITEM:
        getOtherItem().clear();
        getOtherItem().addAll((Collection<? extends Item>)newValue);
        return;
      case Safe10Package.ITEM__OPERATIONAL_SITUATION:
        getOperationalSituation().clear();
        getOperationalSituation().addAll((Collection<? extends OperationalSituation>)newValue);
        return;
      case Safe10Package.ITEM__FEATURE:
        getFeature().clear();
        getFeature().addAll((Collection<? extends VehicleFeature>)newValue);
        return;
      case Safe10Package.ITEM__LEGAL_REQUIREMENTS:
        getLegalRequirements().clear();
        getLegalRequirements().addAll((Collection<? extends Requirement>)newValue);
        return;
      case Safe10Package.ITEM__ITEM_FUNCTION:
        getItemFunction().clear();
        getItemFunction().addAll((Collection<? extends ItemFunctionDescription>)newValue);
        return;
      case Safe10Package.ITEM__OPERATING_MODE:
        getOperatingMode().clear();
        getOperatingMode().addAll((Collection<? extends OperatingMode>)newValue);
        return;
      case Safe10Package.ITEM__SAFE_STATE:
        getSafeState().clear();
        getSafeState().addAll((Collection<? extends SafeState>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ITEM__DEVELOPMENT_CATEGORY:
        unsetDevelopmentCategory();
        return;
      case Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION:
        getPossibleItemMalfunction().clear();
        return;
      case Safe10Package.ITEM__OTHER_ITEM:
        getOtherItem().clear();
        return;
      case Safe10Package.ITEM__OPERATIONAL_SITUATION:
        getOperationalSituation().clear();
        return;
      case Safe10Package.ITEM__FEATURE:
        getFeature().clear();
        return;
      case Safe10Package.ITEM__LEGAL_REQUIREMENTS:
        getLegalRequirements().clear();
        return;
      case Safe10Package.ITEM__ITEM_FUNCTION:
        getItemFunction().clear();
        return;
      case Safe10Package.ITEM__OPERATING_MODE:
        getOperatingMode().clear();
        return;
      case Safe10Package.ITEM__SAFE_STATE:
        getSafeState().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ITEM__DEVELOPMENT_CATEGORY:
        return isSetDevelopmentCategory();
      case Safe10Package.ITEM__POSSIBLE_ITEM_MALFUNCTION:
        return possibleItemMalfunction != null && !possibleItemMalfunction.isEmpty();
      case Safe10Package.ITEM__OTHER_ITEM:
        return otherItem != null && !otherItem.isEmpty();
      case Safe10Package.ITEM__OPERATIONAL_SITUATION:
        return operationalSituation != null && !operationalSituation.isEmpty();
      case Safe10Package.ITEM__FEATURE:
        return feature != null && !feature.isEmpty();
      case Safe10Package.ITEM__LEGAL_REQUIREMENTS:
        return legalRequirements != null && !legalRequirements.isEmpty();
      case Safe10Package.ITEM__ITEM_FUNCTION:
        return itemFunction != null && !itemFunction.isEmpty();
      case Safe10Package.ITEM__OPERATING_MODE:
        return operatingMode != null && !operatingMode.isEmpty();
      case Safe10Package.ITEM__SAFE_STATE:
        return safeState != null && !safeState.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (developmentCategory: ");
    if (developmentCategoryESet) result.append(developmentCategory); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //ItemImpl
