/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.ErrorModelPrototype;
import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Malfunction Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.MalfunctionInstanceRefImpl#getMalfunction <em>Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.MalfunctionInstanceRefImpl#getErrorModelPrototype <em>Error Model Prototype</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MalfunctionInstanceRefImpl extends ExtendedEObjectImpl implements MalfunctionInstanceRef
{
  /**
   * The cached value of the '{@link #getMalfunction() <em>Malfunction</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunction()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype malfunction;

  /**
   * The cached value of the '{@link #getErrorModelPrototype() <em>Error Model Prototype</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModelPrototype()
   * @generated
   * @ordered
   */
  protected EList<ErrorModelPrototype> errorModelPrototype;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MalfunctionInstanceRefImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getMalfunctionInstanceRef();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getMalfunction()
  {
    if (malfunction != null && malfunction.eIsProxy())
    {
      InternalEObject oldMalfunction = (InternalEObject)malfunction;
      malfunction = (MalfunctionPrototype)eResolveProxy(oldMalfunction);
      if (malfunction != oldMalfunction)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.MALFUNCTION_INSTANCE_REF__MALFUNCTION, oldMalfunction, malfunction));
      }
    }
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetMalfunction()
  {
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMalfunction(MalfunctionPrototype newMalfunction)
  {
    MalfunctionPrototype oldMalfunction = malfunction;
    malfunction = newMalfunction;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.MALFUNCTION_INSTANCE_REF__MALFUNCTION, oldMalfunction, malfunction));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorModelPrototype> getErrorModelPrototype()
  {
    if (errorModelPrototype == null)
    {
      errorModelPrototype = new EObjectResolvingEList<ErrorModelPrototype>(ErrorModelPrototype.class, this, Safe10Package.MALFUNCTION_INSTANCE_REF__ERROR_MODEL_PROTOTYPE);
    }
    return errorModelPrototype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_INSTANCE_REF__MALFUNCTION:
        if (resolve) return getMalfunction();
        return basicGetMalfunction();
      case Safe10Package.MALFUNCTION_INSTANCE_REF__ERROR_MODEL_PROTOTYPE:
        return getErrorModelPrototype();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_INSTANCE_REF__MALFUNCTION:
   			setMalfunction((MalfunctionPrototype)newValue);
        return;
      case Safe10Package.MALFUNCTION_INSTANCE_REF__ERROR_MODEL_PROTOTYPE:
        getErrorModelPrototype().clear();
        getErrorModelPrototype().addAll((Collection<? extends ErrorModelPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_INSTANCE_REF__MALFUNCTION:
        	setMalfunction((MalfunctionPrototype)null);
        return;
      case Safe10Package.MALFUNCTION_INSTANCE_REF__ERROR_MODEL_PROTOTYPE:
        getErrorModelPrototype().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_INSTANCE_REF__MALFUNCTION:
        return malfunction != null;
      case Safe10Package.MALFUNCTION_INSTANCE_REF__ERROR_MODEL_PROTOTYPE:
        return errorModelPrototype != null && !errorModelPrototype.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //MalfunctionInstanceRefImpl
