/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Malfunction Prototype</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.MalfunctionPrototypeImpl#getGenericDescription <em>Generic Description</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.MalfunctionPrototypeImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MalfunctionPrototypeImpl extends IdentifiableImpl implements MalfunctionPrototype
{
  /**
   * The default value of the '{@link #getGenericDescription() <em>Generic Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGenericDescription()
   * @generated
   * @ordered
   */
  protected static final String GENERIC_DESCRIPTION_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getGenericDescription() <em>Generic Description</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGenericDescription()
   * @generated
   * @ordered
   */
  protected String genericDescription = GENERIC_DESCRIPTION_EDEFAULT;

  /**
   * This is true if the Generic Description attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean genericDescriptionESet;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected MalfunctionType type;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MalfunctionPrototypeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getMalfunctionPrototype();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getGenericDescription()
  {
    return genericDescription;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setGenericDescription(String newGenericDescription)
  {
    String oldGenericDescription = genericDescription;
    genericDescription = newGenericDescription;
    boolean oldGenericDescriptionESet = genericDescriptionESet;
    genericDescriptionESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.MALFUNCTION_PROTOTYPE__GENERIC_DESCRIPTION, oldGenericDescription, genericDescription, !oldGenericDescriptionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetGenericDescription()
  {
    String oldGenericDescription = genericDescription;
    boolean oldGenericDescriptionESet = genericDescriptionESet;
    genericDescription = GENERIC_DESCRIPTION_EDEFAULT;
    genericDescriptionESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.MALFUNCTION_PROTOTYPE__GENERIC_DESCRIPTION, oldGenericDescription, GENERIC_DESCRIPTION_EDEFAULT, oldGenericDescriptionESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetGenericDescription()
  {
    return genericDescriptionESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionType getType()
  {
    if (type != null && type.eIsProxy())
    {
      InternalEObject oldType = (InternalEObject)type;
      type = (MalfunctionType)eResolveProxy(oldType);
      if (type != oldType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.MALFUNCTION_PROTOTYPE__TYPE, oldType, type));
      }
    }
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionType basicGetType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(MalfunctionType newType)
  {
    MalfunctionType oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.MALFUNCTION_PROTOTYPE__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_PROTOTYPE__GENERIC_DESCRIPTION:
        return getGenericDescription();
      case Safe10Package.MALFUNCTION_PROTOTYPE__TYPE:
        if (resolve) return getType();
        return basicGetType();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_PROTOTYPE__GENERIC_DESCRIPTION:
   			setGenericDescription((String)newValue);
        return;
      case Safe10Package.MALFUNCTION_PROTOTYPE__TYPE:
   			setType((MalfunctionType)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_PROTOTYPE__GENERIC_DESCRIPTION:
        unsetGenericDescription();
        return;
      case Safe10Package.MALFUNCTION_PROTOTYPE__TYPE:
        	setType((MalfunctionType)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MALFUNCTION_PROTOTYPE__GENERIC_DESCRIPTION:
        return isSetGenericDescription();
      case Safe10Package.MALFUNCTION_PROTOTYPE__TYPE:
        return type != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (genericDescription: ");
    if (genericDescriptionESet) result.append(genericDescription); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //MalfunctionPrototypeImpl
