/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.OperatingMode;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Operating Mode</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.OperatingModeImpl#getSafetyRelated <em>Safety Related</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class OperatingModeImpl extends IdentifiableImpl implements OperatingMode
{
  /**
   * The default value of the '{@link #getSafetyRelated() <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyRelated()
   * @generated
   * @ordered
   */
  protected static final Boolean SAFETY_RELATED_EDEFAULT = Boolean.FALSE;

  /**
   * The cached value of the '{@link #getSafetyRelated() <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyRelated()
   * @generated
   * @ordered
   */
  protected Boolean safetyRelated = SAFETY_RELATED_EDEFAULT;

  /**
   * This is true if the Safety Related attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean safetyRelatedESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OperatingModeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getOperatingMode();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean getSafetyRelated()
  {
    return safetyRelated;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSafetyRelated(Boolean newSafetyRelated)
  {
    Boolean oldSafetyRelated = safetyRelated;
    safetyRelated = newSafetyRelated;
    boolean oldSafetyRelatedESet = safetyRelatedESet;
    safetyRelatedESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.OPERATING_MODE__SAFETY_RELATED, oldSafetyRelated, safetyRelated, !oldSafetyRelatedESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSafetyRelated()
  {
    Boolean oldSafetyRelated = safetyRelated;
    boolean oldSafetyRelatedESet = safetyRelatedESet;
    safetyRelated = SAFETY_RELATED_EDEFAULT;
    safetyRelatedESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.OPERATING_MODE__SAFETY_RELATED, oldSafetyRelated, SAFETY_RELATED_EDEFAULT, oldSafetyRelatedESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSafetyRelated()
  {
    return safetyRelatedESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATING_MODE__SAFETY_RELATED:
        return getSafetyRelated();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATING_MODE__SAFETY_RELATED:
   			setSafetyRelated((Boolean)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATING_MODE__SAFETY_RELATED:
        unsetSafetyRelated();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATING_MODE__SAFETY_RELATED:
        return isSetSafetyRelated();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (safetyRelated: ");
    if (safetyRelatedESet) result.append(safetyRelated); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //OperatingModeImpl
