/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.DiagnosticCoverageContextEnum;
import org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum;
import org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Quantified Diagnostic Coverage Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedDiagnosticCoveragePropertyImpl#getFaultType <em>Fault Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedDiagnosticCoveragePropertyImpl#getDcValue <em>Dc Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedDiagnosticCoveragePropertyImpl#getContext <em>Context</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class QuantifiedDiagnosticCoveragePropertyImpl extends ExtendedEObjectImpl implements QuantifiedDiagnosticCoverageProperty
{
  /**
   * The default value of the '{@link #getFaultType() <em>Fault Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFaultType()
   * @generated
   * @ordered
   */
  protected static final DiagnosticCoverageTypeEnum FAULT_TYPE_EDEFAULT = DiagnosticCoverageTypeEnum.RESIDUAL_FAULT;

  /**
   * The cached value of the '{@link #getFaultType() <em>Fault Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFaultType()
   * @generated
   * @ordered
   */
  protected DiagnosticCoverageTypeEnum faultType = FAULT_TYPE_EDEFAULT;

  /**
   * This is true if the Fault Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean faultTypeESet;

  /**
   * The default value of the '{@link #getDcValue() <em>Dc Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDcValue()
   * @generated
   * @ordered
   */
  protected static final Double DC_VALUE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getDcValue() <em>Dc Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDcValue()
   * @generated
   * @ordered
   */
  protected Double dcValue = DC_VALUE_EDEFAULT;

  /**
   * This is true if the Dc Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean dcValueESet;

  /**
   * The default value of the '{@link #getContext() <em>Context</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContext()
   * @generated
   * @ordered
   */
  protected static final DiagnosticCoverageContextEnum CONTEXT_EDEFAULT = DiagnosticCoverageContextEnum.HW;

  /**
   * The cached value of the '{@link #getContext() <em>Context</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContext()
   * @generated
   * @ordered
   */
  protected DiagnosticCoverageContextEnum context = CONTEXT_EDEFAULT;

  /**
   * This is true if the Context attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean contextESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected QuantifiedDiagnosticCoveragePropertyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getQuantifiedDiagnosticCoverageProperty();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DiagnosticCoverageTypeEnum getFaultType()
  {
    return faultType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFaultType(DiagnosticCoverageTypeEnum newFaultType)
  {
    DiagnosticCoverageTypeEnum oldFaultType = faultType;
    faultType = newFaultType == null ? FAULT_TYPE_EDEFAULT : newFaultType;
    boolean oldFaultTypeESet = faultTypeESet;
    faultTypeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE, oldFaultType, faultType, !oldFaultTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFaultType()
  {
    DiagnosticCoverageTypeEnum oldFaultType = faultType;
    boolean oldFaultTypeESet = faultTypeESet;
    faultType = FAULT_TYPE_EDEFAULT;
    faultTypeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE, oldFaultType, FAULT_TYPE_EDEFAULT, oldFaultTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFaultType()
  {
    return faultTypeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getDcValue()
  {
    return dcValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDcValue(Double newDcValue)
  {
    Double oldDcValue = dcValue;
    dcValue = newDcValue;
    boolean oldDcValueESet = dcValueESet;
    dcValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE, oldDcValue, dcValue, !oldDcValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetDcValue()
  {
    Double oldDcValue = dcValue;
    boolean oldDcValueESet = dcValueESet;
    dcValue = DC_VALUE_EDEFAULT;
    dcValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE, oldDcValue, DC_VALUE_EDEFAULT, oldDcValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetDcValue()
  {
    return dcValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DiagnosticCoverageContextEnum getContext()
  {
    return context;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setContext(DiagnosticCoverageContextEnum newContext)
  {
    DiagnosticCoverageContextEnum oldContext = context;
    context = newContext == null ? CONTEXT_EDEFAULT : newContext;
    boolean oldContextESet = contextESet;
    contextESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT, oldContext, context, !oldContextESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetContext()
  {
    DiagnosticCoverageContextEnum oldContext = context;
    boolean oldContextESet = contextESet;
    context = CONTEXT_EDEFAULT;
    contextESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT, oldContext, CONTEXT_EDEFAULT, oldContextESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetContext()
  {
    return contextESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE:
        return getFaultType();
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE:
        return getDcValue();
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT:
        return getContext();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE:
   			setFaultType((DiagnosticCoverageTypeEnum)newValue);
        return;
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE:
   			setDcValue((Double)newValue);
        return;
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT:
   			setContext((DiagnosticCoverageContextEnum)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE:
        unsetFaultType();
        return;
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE:
        unsetDcValue();
        return;
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT:
        unsetContext();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE:
        return isSetFaultType();
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE:
        return isSetDcValue();
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT:
        return isSetContext();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (faultType: ");
    if (faultTypeESet) result.append(faultType); else result.append("<unset>");
    result.append(", dcValue: ");
    if (dcValueESet) result.append(dcValue); else result.append("<unset>");
    result.append(", context: ");
    if (contextESet) result.append(context); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //QuantifiedDiagnosticCoveragePropertyImpl
