/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWFaultMetricsEnum;
import org.safe.metamodel.safe10.QuantifiedHWProperty;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Quantified HW Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedHWPropertyImpl#getMetric <em>Metric</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedHWPropertyImpl#getRational <em>Rational</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedHWPropertyImpl#getUnit <em>Unit</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantifiedHWPropertyImpl#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class QuantifiedHWPropertyImpl extends ExtendedEObjectImpl implements QuantifiedHWProperty
{
  /**
   * The default value of the '{@link #getMetric() <em>Metric</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetric()
   * @generated
   * @ordered
   */
  protected static final HWFaultMetricsEnum METRIC_EDEFAULT = HWFaultMetricsEnum.SINGLE_POINT_FAULT;

  /**
   * The cached value of the '{@link #getMetric() <em>Metric</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetric()
   * @generated
   * @ordered
   */
  protected HWFaultMetricsEnum metric = METRIC_EDEFAULT;

  /**
   * This is true if the Metric attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean metricESet;

  /**
   * The default value of the '{@link #getRational() <em>Rational</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRational()
   * @generated
   * @ordered
   */
  protected static final String RATIONAL_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getRational() <em>Rational</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRational()
   * @generated
   * @ordered
   */
  protected String rational = RATIONAL_EDEFAULT;

  /**
   * This is true if the Rational attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean rationalESet;

  /**
   * The default value of the '{@link #getUnit() <em>Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUnit()
   * @generated
   * @ordered
   */
  protected static final String UNIT_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getUnit() <em>Unit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUnit()
   * @generated
   * @ordered
   */
  protected String unit = UNIT_EDEFAULT;

  /**
   * This is true if the Unit attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean unitESet;

  /**
   * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected static final Double VALUE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected Double value = VALUE_EDEFAULT;

  /**
   * This is true if the Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean valueESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected QuantifiedHWPropertyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getQuantifiedHWProperty();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFaultMetricsEnum getMetric()
  {
    return metric;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMetric(HWFaultMetricsEnum newMetric)
  {
    HWFaultMetricsEnum oldMetric = metric;
    metric = newMetric == null ? METRIC_EDEFAULT : newMetric;
    boolean oldMetricESet = metricESet;
    metricESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_HW_PROPERTY__METRIC, oldMetric, metric, !oldMetricESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMetric()
  {
    HWFaultMetricsEnum oldMetric = metric;
    boolean oldMetricESet = metricESet;
    metric = METRIC_EDEFAULT;
    metricESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_HW_PROPERTY__METRIC, oldMetric, METRIC_EDEFAULT, oldMetricESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMetric()
  {
    return metricESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRational()
  {
    return rational;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRational(String newRational)
  {
    String oldRational = rational;
    rational = newRational;
    boolean oldRationalESet = rationalESet;
    rationalESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_HW_PROPERTY__RATIONAL, oldRational, rational, !oldRationalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRational()
  {
    String oldRational = rational;
    boolean oldRationalESet = rationalESet;
    rational = RATIONAL_EDEFAULT;
    rationalESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_HW_PROPERTY__RATIONAL, oldRational, RATIONAL_EDEFAULT, oldRationalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRational()
  {
    return rationalESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUnit()
  {
    return unit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUnit(String newUnit)
  {
    String oldUnit = unit;
    unit = newUnit;
    boolean oldUnitESet = unitESet;
    unitESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_HW_PROPERTY__UNIT, oldUnit, unit, !oldUnitESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetUnit()
  {
    String oldUnit = unit;
    boolean oldUnitESet = unitESet;
    unit = UNIT_EDEFAULT;
    unitESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_HW_PROPERTY__UNIT, oldUnit, UNIT_EDEFAULT, oldUnitESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUnit()
  {
    return unitESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setValue(Double newValue)
  {
    Double oldValue = value;
    value = newValue;
    boolean oldValueESet = valueESet;
    valueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.QUANTIFIED_HW_PROPERTY__VALUE, oldValue, value, !oldValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetValue()
  {
    Double oldValue = value;
    boolean oldValueESet = valueESet;
    value = VALUE_EDEFAULT;
    valueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.QUANTIFIED_HW_PROPERTY__VALUE, oldValue, VALUE_EDEFAULT, oldValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetValue()
  {
    return valueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_HW_PROPERTY__METRIC:
        return getMetric();
      case Safe10Package.QUANTIFIED_HW_PROPERTY__RATIONAL:
        return getRational();
      case Safe10Package.QUANTIFIED_HW_PROPERTY__UNIT:
        return getUnit();
      case Safe10Package.QUANTIFIED_HW_PROPERTY__VALUE:
        return getValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_HW_PROPERTY__METRIC:
   			setMetric((HWFaultMetricsEnum)newValue);
        return;
      case Safe10Package.QUANTIFIED_HW_PROPERTY__RATIONAL:
   			setRational((String)newValue);
        return;
      case Safe10Package.QUANTIFIED_HW_PROPERTY__UNIT:
   			setUnit((String)newValue);
        return;
      case Safe10Package.QUANTIFIED_HW_PROPERTY__VALUE:
   			setValue((Double)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_HW_PROPERTY__METRIC:
        unsetMetric();
        return;
      case Safe10Package.QUANTIFIED_HW_PROPERTY__RATIONAL:
        unsetRational();
        return;
      case Safe10Package.QUANTIFIED_HW_PROPERTY__UNIT:
        unsetUnit();
        return;
      case Safe10Package.QUANTIFIED_HW_PROPERTY__VALUE:
        unsetValue();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTIFIED_HW_PROPERTY__METRIC:
        return isSetMetric();
      case Safe10Package.QUANTIFIED_HW_PROPERTY__RATIONAL:
        return isSetRational();
      case Safe10Package.QUANTIFIED_HW_PROPERTY__UNIT:
        return isSetUnit();
      case Safe10Package.QUANTIFIED_HW_PROPERTY__VALUE:
        return isSetValue();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (metric: ");
    if (metricESet) result.append(metric); else result.append("<unset>");
    result.append(", rational: ");
    if (rationalESet) result.append(rational); else result.append("<unset>");
    result.append(", unit: ");
    if (unitESet) result.append(unit); else result.append("<unset>");
    result.append(", value: ");
    if (valueESet) result.append(value); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //QuantifiedHWPropertyImpl
