/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.FailureRate;
import org.safe.metamodel.safe10.QuantitativeErrorModel;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Quantitative Error Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.QuantitativeErrorModelImpl#getFailureRate <em>Failure Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class QuantitativeErrorModelImpl extends IdentifiableImpl implements QuantitativeErrorModel
{
  /**
   * The cached value of the '{@link #getFailureRate() <em>Failure Rate</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureRate()
   * @generated
   * @ordered
   */
  protected EList<FailureRate> failureRate;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected QuantitativeErrorModelImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getQuantitativeErrorModel();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FailureRate> getFailureRate()
  {
    if (failureRate == null)
    {
      failureRate = new EObjectContainmentEList<FailureRate>(FailureRate.class, this, Safe10Package.QUANTITATIVE_ERROR_MODEL__FAILURE_RATE);
    }
    return failureRate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTITATIVE_ERROR_MODEL__FAILURE_RATE:
        return ((InternalEList<?>)getFailureRate()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTITATIVE_ERROR_MODEL__FAILURE_RATE:
        return getFailureRate();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTITATIVE_ERROR_MODEL__FAILURE_RATE:
        getFailureRate().clear();
        getFailureRate().addAll((Collection<? extends FailureRate>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTITATIVE_ERROR_MODEL__FAILURE_RATE:
        getFailureRate().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.QUANTITATIVE_ERROR_MODEL__FAILURE_RATE:
        return failureRate != null && !failureRate.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //QuantitativeErrorModelImpl
