/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.AbstractSafetyRequirement;
import org.safe.metamodel.safe10.RequirementsLink;
import org.safe.metamodel.safe10.RequirementsLinkTypeEnum;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Requirements Link</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.RequirementsLinkImpl#getRequirementsLinkType <em>Requirements Link Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.RequirementsLinkImpl#getLinkedRequirement <em>Linked Requirement</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RequirementsLinkImpl extends ExtendedEObjectImpl implements RequirementsLink
{
  /**
   * The default value of the '{@link #getRequirementsLinkType() <em>Requirements Link Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirementsLinkType()
   * @generated
   * @ordered
   */
  protected static final RequirementsLinkTypeEnum REQUIREMENTS_LINK_TYPE_EDEFAULT = RequirementsLinkTypeEnum.COVERS;

  /**
   * The cached value of the '{@link #getRequirementsLinkType() <em>Requirements Link Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirementsLinkType()
   * @generated
   * @ordered
   */
  protected RequirementsLinkTypeEnum requirementsLinkType = REQUIREMENTS_LINK_TYPE_EDEFAULT;

  /**
   * This is true if the Requirements Link Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean requirementsLinkTypeESet;

  /**
   * The cached value of the '{@link #getLinkedRequirement() <em>Linked Requirement</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLinkedRequirement()
   * @generated
   * @ordered
   */
  protected EList<AbstractSafetyRequirement> linkedRequirement;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RequirementsLinkImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getRequirementsLink();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RequirementsLinkTypeEnum getRequirementsLinkType()
  {
    return requirementsLinkType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRequirementsLinkType(RequirementsLinkTypeEnum newRequirementsLinkType)
  {
    RequirementsLinkTypeEnum oldRequirementsLinkType = requirementsLinkType;
    requirementsLinkType = newRequirementsLinkType == null ? REQUIREMENTS_LINK_TYPE_EDEFAULT : newRequirementsLinkType;
    boolean oldRequirementsLinkTypeESet = requirementsLinkTypeESet;
    requirementsLinkTypeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.REQUIREMENTS_LINK__REQUIREMENTS_LINK_TYPE, oldRequirementsLinkType, requirementsLinkType, !oldRequirementsLinkTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRequirementsLinkType()
  {
    RequirementsLinkTypeEnum oldRequirementsLinkType = requirementsLinkType;
    boolean oldRequirementsLinkTypeESet = requirementsLinkTypeESet;
    requirementsLinkType = REQUIREMENTS_LINK_TYPE_EDEFAULT;
    requirementsLinkTypeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.REQUIREMENTS_LINK__REQUIREMENTS_LINK_TYPE, oldRequirementsLinkType, REQUIREMENTS_LINK_TYPE_EDEFAULT, oldRequirementsLinkTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRequirementsLinkType()
  {
    return requirementsLinkTypeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AbstractSafetyRequirement> getLinkedRequirement()
  {
    if (linkedRequirement == null)
    {
      linkedRequirement = new EObjectResolvingEList<AbstractSafetyRequirement>(AbstractSafetyRequirement.class, this, Safe10Package.REQUIREMENTS_LINK__LINKED_REQUIREMENT);
    }
    return linkedRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.REQUIREMENTS_LINK__REQUIREMENTS_LINK_TYPE:
        return getRequirementsLinkType();
      case Safe10Package.REQUIREMENTS_LINK__LINKED_REQUIREMENT:
        return getLinkedRequirement();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.REQUIREMENTS_LINK__REQUIREMENTS_LINK_TYPE:
   			setRequirementsLinkType((RequirementsLinkTypeEnum)newValue);
        return;
      case Safe10Package.REQUIREMENTS_LINK__LINKED_REQUIREMENT:
        getLinkedRequirement().clear();
        getLinkedRequirement().addAll((Collection<? extends AbstractSafetyRequirement>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.REQUIREMENTS_LINK__REQUIREMENTS_LINK_TYPE:
        unsetRequirementsLinkType();
        return;
      case Safe10Package.REQUIREMENTS_LINK__LINKED_REQUIREMENT:
        getLinkedRequirement().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.REQUIREMENTS_LINK__REQUIREMENTS_LINK_TYPE:
        return isSetRequirementsLinkType();
      case Safe10Package.REQUIREMENTS_LINK__LINKED_REQUIREMENT:
        return linkedRequirement != null && !linkedRequirement.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (requirementsLinkType: ");
    if (requirementsLinkTypeESet) result.append(requirementsLinkType); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //RequirementsLinkImpl
