/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.commonstructure.internalbehavior.ExecutableEntity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.RunnableEntitySequenceElement;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Runnable Entity Sequence Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.RunnableEntitySequenceElementImpl#getNextElement <em>Next Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.RunnableEntitySequenceElementImpl#getExecutableEntity <em>Executable Entity</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RunnableEntitySequenceElementImpl extends IdentifiableImpl implements RunnableEntitySequenceElement
{
  /**
   * The cached value of the '{@link #getNextElement() <em>Next Element</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNextElement()
   * @generated
   * @ordered
   */
  protected RunnableEntitySequenceElement nextElement;

  /**
   * The cached value of the '{@link #getExecutableEntity() <em>Executable Entity</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecutableEntity()
   * @generated
   * @ordered
   */
  protected ExecutableEntity executableEntity;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RunnableEntitySequenceElementImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getRunnableEntitySequenceElement();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RunnableEntitySequenceElement getNextElement()
  {
    if (nextElement != null && nextElement.eIsProxy())
    {
      InternalEObject oldNextElement = (InternalEObject)nextElement;
      nextElement = (RunnableEntitySequenceElement)eResolveProxy(oldNextElement);
      if (nextElement != oldNextElement)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__NEXT_ELEMENT, oldNextElement, nextElement));
      }
    }
    return nextElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RunnableEntitySequenceElement basicGetNextElement()
  {
    return nextElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNextElement(RunnableEntitySequenceElement newNextElement)
  {
    RunnableEntitySequenceElement oldNextElement = nextElement;
    nextElement = newNextElement;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__NEXT_ELEMENT, oldNextElement, nextElement));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExecutableEntity getExecutableEntity()
  {
    if (executableEntity != null && executableEntity.eIsProxy())
    {
      InternalEObject oldExecutableEntity = (InternalEObject)executableEntity;
      executableEntity = (ExecutableEntity)eResolveProxy(oldExecutableEntity);
      if (executableEntity != oldExecutableEntity)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__EXECUTABLE_ENTITY, oldExecutableEntity, executableEntity));
      }
    }
    return executableEntity;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExecutableEntity basicGetExecutableEntity()
  {
    return executableEntity;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExecutableEntity(ExecutableEntity newExecutableEntity)
  {
    ExecutableEntity oldExecutableEntity = executableEntity;
    executableEntity = newExecutableEntity;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__EXECUTABLE_ENTITY, oldExecutableEntity, executableEntity));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__NEXT_ELEMENT:
        if (resolve) return getNextElement();
        return basicGetNextElement();
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__EXECUTABLE_ENTITY:
        if (resolve) return getExecutableEntity();
        return basicGetExecutableEntity();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__NEXT_ELEMENT:
   			setNextElement((RunnableEntitySequenceElement)newValue);
        return;
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__EXECUTABLE_ENTITY:
   			setExecutableEntity((ExecutableEntity)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__NEXT_ELEMENT:
        	setNextElement((RunnableEntitySequenceElement)null);
        return;
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__EXECUTABLE_ENTITY:
        	setExecutableEntity((ExecutableEntity)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__NEXT_ELEMENT:
        return nextElement != null;
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT__EXECUTABLE_ENTITY:
        return executableEntity != null;
    }
    return super.eIsSet(featureID);
  }

} //RunnableEntitySequenceElementImpl
