/**
 */
package org.safe.metamodel.safe10.impl;

import java.net.URI;
import java.net.URL;

import javax.xml.datatype.XMLGregorianCalendar;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.safe.metamodel.safe10.ASILDecomposedEnum;
import org.safe.metamodel.safe10.ASILEnum;
import org.safe.metamodel.safe10.AUTOSARRunnableEntitySequenceConstraint;
import org.safe.metamodel.safe10.AUTOSARSequenceConstraint;
import org.safe.metamodel.safe10.Actor;
import org.safe.metamodel.safe10.ActuatorError;
import org.safe.metamodel.safe10.ActuatorErrorDetection;
import org.safe.metamodel.safe10.ActuatorMonitor;
import org.safe.metamodel.safe10.AlivenessCheckpointTooEarly;
import org.safe.metamodel.safe10.AlivenessCheckpointTooLate;
import org.safe.metamodel.safe10.AlivenessCheckpointTooOften;
import org.safe.metamodel.safe10.AlivenessMonitor;
import org.safe.metamodel.safe10.AllocationTargets;
import org.safe.metamodel.safe10.AnalysisReport;
import org.safe.metamodel.safe10.Application;
import org.safe.metamodel.safe10.Assumption;
import org.safe.metamodel.safe10.AutosarActuatorMonitor;
import org.safe.metamodel.safe10.AutosarAlivenessMonitor;
import org.safe.metamodel.safe10.AutosarCRC;
import org.safe.metamodel.safe10.AutosarCheckPoint;
import org.safe.metamodel.safe10.AutosarClientServerOperationInstanceRef;
import org.safe.metamodel.safe10.AutosarComparison;
import org.safe.metamodel.safe10.AutosarComparisonParam;
import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarContext;
import org.safe.metamodel.safe10.AutosarContextRangeCheck;
import org.safe.metamodel.safe10.AutosarEvaluationFunction;
import org.safe.metamodel.safe10.AutosarGradientCheck;
import org.safe.metamodel.safe10.AutosarHardwareSafetyExtension;
import org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarPortInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarSystemSafetyExtension;
import org.safe.metamodel.safe10.AutosarUndefinedInstanceRef;
import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.AutosarVfbSafetyExtension;
import org.safe.metamodel.safe10.Avoid;
import org.safe.metamodel.safe10.BooleanConfigParameterValue;
import org.safe.metamodel.safe10.CHROMOSOMEHealthMonitorNotification;
import org.safe.metamodel.safe10.CRC;
import org.safe.metamodel.safe10.CRCConfig;
import org.safe.metamodel.safe10.CRCErrorDetection;
import org.safe.metamodel.safe10.CRCFailed;
import org.safe.metamodel.safe10.CheckPoint;
import org.safe.metamodel.safe10.ChromosomeApplicationHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeApplicationSafetyExtension;
import org.safe.metamodel.safe10.ChromosomeComparison;
import org.safe.metamodel.safe10.ChromosomeComparisonParameter;
import org.safe.metamodel.safe10.ChromosomeComponentModeCondition;
import org.safe.metamodel.safe10.ChromosomeCpuSelfTest;
import org.safe.metamodel.safe10.ChromosomeErrorEventCondition;
import org.safe.metamodel.safe10.ChromosomeErrorHandler;
import org.safe.metamodel.safe10.ChromosomeHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeHeartbeatReceiver;
import org.safe.metamodel.safe10.ChromosomeHeartbeatSender;
import org.safe.metamodel.safe10.ChromosomeMemoryTest;
import org.safe.metamodel.safe10.ChromosomeNodeHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeSystemSafetyExtension;
import org.safe.metamodel.safe10.ChromosomeVoter;
import org.safe.metamodel.safe10.ChromosomeVoterParameter;
import org.safe.metamodel.safe10.CodeGenerationConfiguration;
import org.safe.metamodel.safe10.Comparison;
import org.safe.metamodel.safe10.ComparisonDetection;
import org.safe.metamodel.safe10.ComparisonFalse;
import org.safe.metamodel.safe10.ComparisonOperationEnum;
import org.safe.metamodel.safe10.ComparisonParameter;
import org.safe.metamodel.safe10.ComparisonTrue;
import org.safe.metamodel.safe10.Component;
import org.safe.metamodel.safe10.ComponentModeInstanceRef;
import org.safe.metamodel.safe10.ComponentPrototypeCRC;
import org.safe.metamodel.safe10.ConfigParameter;
import org.safe.metamodel.safe10.ConfigParameterValue;
import org.safe.metamodel.safe10.ConstantComparisonParameter;
import org.safe.metamodel.safe10.Context;
import org.safe.metamodel.safe10.ContextParameter;
import org.safe.metamodel.safe10.ContextRangeCheck;
import org.safe.metamodel.safe10.ContextRangeCheckDetection;
import org.safe.metamodel.safe10.ControlFlowError;
import org.safe.metamodel.safe10.ControlFlowErrorDetection;
import org.safe.metamodel.safe10.ControlFlowMonitor;
import org.safe.metamodel.safe10.ControlFlowPolicy;
import org.safe.metamodel.safe10.ControllabilityClassKind;
import org.safe.metamodel.safe10.ControllabilityReference;
import org.safe.metamodel.safe10.CpuSelfTest;
import org.safe.metamodel.safe10.CpuSelfTestConfig;
import org.safe.metamodel.safe10.CpuSelfTestDetection;
import org.safe.metamodel.safe10.CpuSelfTestFailed;
import org.safe.metamodel.safe10.CpuTestAlgorithmEnum;
import org.safe.metamodel.safe10.DesignLevelSafetyExtension;
import org.safe.metamodel.safe10.DesignSpecification;
import org.safe.metamodel.safe10.Detect;
import org.safe.metamodel.safe10.DevelopmentCategory;
import org.safe.metamodel.safe10.DiagnosticCoverageContextEnum;
import org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum;
import org.safe.metamodel.safe10.EMPAnalysis;
import org.safe.metamodel.safe10.EMPBswModule;
import org.safe.metamodel.safe10.EMPDesign;
import org.safe.metamodel.safe10.EMPHwComponent;
import org.safe.metamodel.safe10.EMPReference;
import org.safe.metamodel.safe10.EMPSwComponent;
import org.safe.metamodel.safe10.EMTypeAnalysis;
import org.safe.metamodel.safe10.EMTypeApplicationEnvironment;
import org.safe.metamodel.safe10.EMTypeBswModule;
import org.safe.metamodel.safe10.EMTypeDesign;
import org.safe.metamodel.safe10.EMTypeHwComponent;
import org.safe.metamodel.safe10.EMTypeSwComponent;
import org.safe.metamodel.safe10.EastADLErrorBehavior;
import org.safe.metamodel.safe10.ErrorBehaviorKind;
import org.safe.metamodel.safe10.ErrorBehaviorMapping;
import org.safe.metamodel.safe10.ErrorModel;
import org.safe.metamodel.safe10.ErrorModelInstanceRef;
import org.safe.metamodel.safe10.ErrorModelKind;
import org.safe.metamodel.safe10.ErrorModelMapping;
import org.safe.metamodel.safe10.ErrorModelPrototype;
import org.safe.metamodel.safe10.ErrorModelPrototype_analysisFunctionTarget;
import org.safe.metamodel.safe10.ErrorModelPrototype_designFunctionTarget;
import org.safe.metamodel.safe10.ErrorModelPrototype_hwTarget;
import org.safe.metamodel.safe10.ErrorModelType;
import org.safe.metamodel.safe10.EvaluationFunction;
import org.safe.metamodel.safe10.ExposureClassKind;
import org.safe.metamodel.safe10.FMEAReport;
import org.safe.metamodel.safe10.FailureLogicFormula;
import org.safe.metamodel.safe10.FaultFailurePort_functionTarget;
import org.safe.metamodel.safe10.FaultFailurePort_hwPinTarget;
import org.safe.metamodel.safe10.FaultFailurePort_hwPortTarget;
import org.safe.metamodel.safe10.FaultFailurePropagationLink;
import org.safe.metamodel.safe10.FieldTestProtocol;
import org.safe.metamodel.safe10.Filter;
import org.safe.metamodel.safe10.FilterBasedHandling;
import org.safe.metamodel.safe10.FilterError;
import org.safe.metamodel.safe10.FilterExpression;
import org.safe.metamodel.safe10.FilterParameter;
import org.safe.metamodel.safe10.FloatConfigParameterValue;
import org.safe.metamodel.safe10.FunctionBehaviorKind;
import org.safe.metamodel.safe10.FunctionalSafetyExtension;
import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Goal;
import org.safe.metamodel.safe10.GradientCheck;
import org.safe.metamodel.safe10.GradientCheckDetection;
import org.safe.metamodel.safe10.GradientTooHigh;
import org.safe.metamodel.safe10.GradientTooLow;
import org.safe.metamodel.safe10.HSIElementCategory;
import org.safe.metamodel.safe10.HWComponentPrototypeScope;
import org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart;
import org.safe.metamodel.safe10.HWElementFailureRateClass;
import org.safe.metamodel.safe10.HWElementPrototypeScope;
import org.safe.metamodel.safe10.HWElementScopeInstanceRef;
import org.safe.metamodel.safe10.HWFMSingleContribution;
import org.safe.metamodel.safe10.HWFMSingleContributionFormula;
import org.safe.metamodel.safe10.HWFailureClassContainer;
import org.safe.metamodel.safe10.HWFailureClassContributionFormula;
import org.safe.metamodel.safe10.HWFailureMode;
import org.safe.metamodel.safe10.HWFailureRate;
import org.safe.metamodel.safe10.HWFault;
import org.safe.metamodel.safe10.HWFaultMetricsEnum;
import org.safe.metamodel.safe10.HWLFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWLambdaPartFormula;
import org.safe.metamodel.safe10.HWLatentFaultMetric;
import org.safe.metamodel.safe10.HWLatentFaultMetricFormula;
import org.safe.metamodel.safe10.HWMultiplePointFaultEnum;
import org.safe.metamodel.safe10.HWPMHF;
import org.safe.metamodel.safe10.HWPMHFFormula;
import org.safe.metamodel.safe10.HWPartFailure;
import org.safe.metamodel.safe10.HWPartFailureAnalysis;
import org.safe.metamodel.safe10.HWPartFailureMode;
import org.safe.metamodel.safe10.HWPartFailureRate;
import org.safe.metamodel.safe10.HWPointFaultEnum;
import org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis;
import org.safe.metamodel.safe10.HWRFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWSPFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWSinglePointFaultMetric;
import org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula;
import org.safe.metamodel.safe10.HWTargetValuesPMHFEnum;
import org.safe.metamodel.safe10.HWValuesFailureRateClassEnum;
import org.safe.metamodel.safe10.Handle;
import org.safe.metamodel.safe10.HandlingType;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.HardwareSafetyExtension;
import org.safe.metamodel.safe10.HardwareSafetyRequirement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification;
import org.safe.metamodel.safe10.Hazard;
import org.safe.metamodel.safe10.HazardandRiskSafetyExtension;
import org.safe.metamodel.safe10.HazardousEvent;
import org.safe.metamodel.safe10.HealthMonitor;
import org.safe.metamodel.safe10.HealthMonitorErrorCondition;
import org.safe.metamodel.safe10.HealthMonitoring;
import org.safe.metamodel.safe10.HeartBeatDeadlineMissed;
import org.safe.metamodel.safe10.HeartBeatDetection;
import org.safe.metamodel.safe10.Heartbeat;
import org.safe.metamodel.safe10.HeartbeatConfig;
import org.safe.metamodel.safe10.HeartbeatReceiver;
import org.safe.metamodel.safe10.HeartbeatSender;
import org.safe.metamodel.safe10.HwComponentScopeInstanceRef;
import org.safe.metamodel.safe10.IdentifierConfigParameterValue;
import org.safe.metamodel.safe10.ImplementationSafetyExtension;
import org.safe.metamodel.safe10.InputBlock;
import org.safe.metamodel.safe10.IntegerConfigParameterValue;
import org.safe.metamodel.safe10.InterfaceCRC;
import org.safe.metamodel.safe10.Item;
import org.safe.metamodel.safe10.ItemFunctionDescription;
import org.safe.metamodel.safe10.Justification;
import org.safe.metamodel.safe10.MFPFunctionPort;
import org.safe.metamodel.safe10.MFPHardwarePin;
import org.safe.metamodel.safe10.MFPHardwarePort;
import org.safe.metamodel.safe10.MFPOperation;
import org.safe.metamodel.safe10.MFPSwcPort;
import org.safe.metamodel.safe10.MFPVariable;
import org.safe.metamodel.safe10.MTComposite;
import org.safe.metamodel.safe10.MTCompositeElementPrototype;
import org.safe.metamodel.safe10.MTPrimitive;
import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.MalfunctionMapping;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.MemoryRange;
import org.safe.metamodel.safe10.MemorySelfTest;
import org.safe.metamodel.safe10.MemorySelfTestConfig;
import org.safe.metamodel.safe10.MemorySelfTestFailed;
import org.safe.metamodel.safe10.MemorySelfTesting;
import org.safe.metamodel.safe10.MemoryTestAlgorithmsEnum;
import org.safe.metamodel.safe10.MultiLevelSafetyExtension;
import org.safe.metamodel.safe10.NativeErrorBehavior;
import org.safe.metamodel.safe10.Node;
import org.safe.metamodel.safe10.OperatingMode;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.OutputBlock;
import org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty;
import org.safe.metamodel.safe10.QuantifiedHWProperty;
import org.safe.metamodel.safe10.QuantitativeErrorModel;
import org.safe.metamodel.safe10.RangeCheckContext;
import org.safe.metamodel.safe10.RequirementTypeEnum;
import org.safe.metamodel.safe10.RequirementsLink;
import org.safe.metamodel.safe10.RequirementsLinkTypeEnum;
import org.safe.metamodel.safe10.Restrictable;
import org.safe.metamodel.safe10.Restriction;
import org.safe.metamodel.safe10.RiskDescription;
import org.safe.metamodel.safe10.RunnableEntitySequenceElement;
import org.safe.metamodel.safe10.SAFE;
import org.safe.metamodel.safe10.SAFEPackage;
import org.safe.metamodel.safe10.Safe10Factory;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeElementType;
import org.safe.metamodel.safe10.SafeState;
import org.safe.metamodel.safe10.SafetyCase;
import org.safe.metamodel.safe10.SafetyConcept;
import org.safe.metamodel.safe10.Satisfy;
import org.safe.metamodel.safe10.SeverityClassKind;
import org.safe.metamodel.safe10.SoftwareAlivenessDetection;
import org.safe.metamodel.safe10.SoftwareSafetyExtension;
import org.safe.metamodel.safe10.SoftwareSafetyRequirement;
import org.safe.metamodel.safe10.Solution;
import org.safe.metamodel.safe10.Strategy;
import org.safe.metamodel.safe10.StringConfigParameterValue;
import org.safe.metamodel.safe10.TargetValuesLFMetricEnum;
import org.safe.metamodel.safe10.TargetValuesSPFMetricEnum;
import org.safe.metamodel.safe10.TechnicalSafetyRequirement;
import org.safe.metamodel.safe10.TestProtocol;
import org.safe.metamodel.safe10.Topic;
import org.safe.metamodel.safe10.UnitTestProtocol;
import org.safe.metamodel.safe10.ValueAboveRange;
import org.safe.metamodel.safe10.ValueBelowRange;
import org.safe.metamodel.safe10.Variant;
import org.safe.metamodel.safe10.VariantDescriptionMode;
import org.safe.metamodel.safe10.Verify;
import org.safe.metamodel.safe10.Voter;
import org.safe.metamodel.safe10.VoterActivationSchemeEnum;
import org.safe.metamodel.safe10.VoterConfig;
import org.safe.metamodel.safe10.VoterNoConsensus;
import org.safe.metamodel.safe10.VoterParameter;
import org.safe.metamodel.safe10.VoterValueMismatch;
import org.safe.metamodel.safe10.Voting;
import org.safe.metamodel.safe10.VotingAlgorithmEnum;
import org.safe.metamodel.safe10.WarningAndDegradation;
import org.safe.metamodel.safe10.WarningAndDegradationHandle;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Safe10FactoryImpl extends EFactoryImpl implements Safe10Factory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static Safe10Factory init()
  {
    try
    {
      Safe10Factory theSafe10Factory = (Safe10Factory)EPackage.Registry.INSTANCE.getEFactory("http://safe-project.eu/1.0.1"); 
      if (theSafe10Factory != null)
      {
        return theSafe10Factory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new Safe10FactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Safe10FactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case Safe10Package.FILTER_EXPRESSION: return createFilterExpression();
      case Safe10Package.APPLICATION: return createApplication();
      case Safe10Package.COMPONENT: return createComponent();
      case Safe10Package.COMPONENT_MODE_INSTANCE_REF: return createComponentModeInstanceRef();
      case Safe10Package.NODE: return createNode();
      case Safe10Package.SYSTEM: return createSystem();
      case Safe10Package.TOPIC: return createTopic();
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION: return createMultiLevelSafetyExtension();
      case Safe10Package.FUNCTIONAL_SAFETY_EXTENSION: return createFunctionalSafetyExtension();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION: return createHazardandRiskSafetyExtension();
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION: return createAutosarHardwareSafetyExtension();
      case Safe10Package.AUTOSAR_SYSTEM_SAFETY_EXTENSION: return createAutosarSystemSafetyExtension();
      case Safe10Package.AUTOSAR_VFB_SAFETY_EXTENSION: return createAutosarVfbSafetyExtension();
      case Safe10Package.CHROMOSOME_APPLICATION_SAFETY_EXTENSION: return createChromosomeApplicationSafetyExtension();
      case Safe10Package.CHROMOSOME_SYSTEM_SAFETY_EXTENSION: return createChromosomeSystemSafetyExtension();
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION: return createImplementationSafetyExtension();
      case Safe10Package.DESIGN_LEVEL_SAFETY_EXTENSION: return createDesignLevelSafetyExtension();
      case Safe10Package.HARDWARE_SAFETY_EXTENSION: return createHardwareSafetyExtension();
      case Safe10Package.SOFTWARE_SAFETY_EXTENSION: return createSoftwareSafetyExtension();
      case Safe10Package.SAFE: return createSAFE();
      case Safe10Package.SAFE_PACKAGE: return createSAFEPackage();
      case Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF: return createAutosarClientServerOperationInstanceRef();
      case Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF: return createAutosarComponentInCompositionInstanceRef();
      case Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF: return createAutosarModeInPortFromComponentInCompositionInstanceRef();
      case Safe10Package.AUTOSAR_PORT_IN_COMPOSITION_INSTANCE_REF: return createAutosarPortInCompositionInstanceRef();
      case Safe10Package.AUTOSAR_UNDEFINED_INSTANCE_REF: return createAutosarUndefinedInstanceRef();
      case Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF: return createAutosarVariableDataPrototypeInstanceRef();
      case Safe10Package.RESTRICTABLE: return createRestrictable();
      case Safe10Package.RESTRICTION: return createRestriction();
      case Safe10Package.VARIANT: return createVariant();
      case Safe10Package.ERROR_MODEL: return createErrorModel();
      case Safe10Package.ERROR_MODEL_INSTANCE_REF: return createErrorModelInstanceRef();
      case Safe10Package.ERROR_MODEL_PROTOTYPE_ANALYSIS_FUNCTION_TARGET: return createErrorModelPrototype_analysisFunctionTarget();
      case Safe10Package.ERROR_MODEL_PROTOTYPE_DESIGN_FUNCTION_TARGET: return createErrorModelPrototype_designFunctionTarget();
      case Safe10Package.ERROR_MODEL_PROTOTYPE_HW_TARGET: return createErrorModelPrototype_hwTarget();
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET: return createFaultFailurePort_functionTarget();
      case Safe10Package.FAULT_FAILURE_PORT_HW_PIN_TARGET: return createFaultFailurePort_hwPinTarget();
      case Safe10Package.FAULT_FAILURE_PORT_HW_PORT_TARGET: return createFaultFailurePort_hwPortTarget();
      case Safe10Package.MALFUNCTION_INSTANCE_REF: return createMalfunctionInstanceRef();
      case Safe10Package.EAST_ADL_ERROR_BEHAVIOR: return createEastADLErrorBehavior();
      case Safe10Package.FAILURE_LOGIC_FORMULA: return createFailureLogicFormula();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR: return createNativeErrorBehavior();
      case Safe10Package.EMP_ANALYSIS: return createEMPAnalysis();
      case Safe10Package.EMP_BSW_MODULE: return createEMPBswModule();
      case Safe10Package.EMP_DESIGN: return createEMPDesign();
      case Safe10Package.EMP_HW_COMPONENT: return createEMPHwComponent();
      case Safe10Package.EMP_REFERENCE: return createEMPReference();
      case Safe10Package.EMP_SW_COMPONENT: return createEMPSwComponent();
      case Safe10Package.EM_TYPE_ANALYSIS: return createEMTypeAnalysis();
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT: return createEMTypeApplicationEnvironment();
      case Safe10Package.EM_TYPE_BSW_MODULE: return createEMTypeBswModule();
      case Safe10Package.EM_TYPE_DESIGN: return createEMTypeDesign();
      case Safe10Package.EM_TYPE_HW_COMPONENT: return createEMTypeHwComponent();
      case Safe10Package.EM_TYPE_SW_COMPONENT: return createEMTypeSwComponent();
      case Safe10Package.ERROR_MODEL_PROTOTYPE: return createErrorModelPrototype();
      case Safe10Package.ERROR_MODEL_TYPE: return createErrorModelType();
      case Safe10Package.FAULT_FAILURE_PROPAGATION_LINK: return createFaultFailurePropagationLink();
      case Safe10Package.QUANTITATIVE_ERROR_MODEL: return createQuantitativeErrorModel();
      case Safe10Package.MALFUNCTION_PROTOTYPE: return createMalfunctionPrototype();
      case Safe10Package.MALFUNCTION_TYPE: return createMalfunctionType();
      case Safe10Package.MFP_FUNCTION_PORT: return createMFPFunctionPort();
      case Safe10Package.MFP_HARDWARE_PIN: return createMFPHardwarePin();
      case Safe10Package.MFP_HARDWARE_PORT: return createMFPHardwarePort();
      case Safe10Package.MFP_OPERATION: return createMFPOperation();
      case Safe10Package.MFP_SWC_PORT: return createMFPSwcPort();
      case Safe10Package.MFP_VARIABLE: return createMFPVariable();
      case Safe10Package.MT_COMPOSITE: return createMTComposite();
      case Safe10Package.MT_COMPOSITE_ELEMENT_PROTOTYPE: return createMTCompositeElementPrototype();
      case Safe10Package.MT_PRIMITIVE: return createMTPrimitive();
      case Safe10Package.ERROR_BEHAVIOR_MAPPING: return createErrorBehaviorMapping();
      case Safe10Package.ERROR_MODEL_MAPPING: return createErrorModelMapping();
      case Safe10Package.MALFUNCTION_MAPPING: return createMalfunctionMapping();
      case Safe10Package.HW_FAILURE_CLASS_CONTRIBUTION_FORMULA: return createHWFailureClassContributionFormula();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA: return createHWFMSingleContributionFormula();
      case Safe10Package.HW_LAMBDA_PART_FORMULA: return createHWLambdaPartFormula();
      case Safe10Package.HW_LATENT_FAULT_METRIC_FORMULA: return createHWLatentFaultMetricFormula();
      case Safe10Package.HWPMHF_FORMULA: return createHWPMHFFormula();
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA: return createHWSinglePointFaultMetricFormula();
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS: return createHardwareFailureAnalysis();
      case Safe10Package.HW_FAILURE_RATE: return createHWFailureRate();
      case Safe10Package.HW_FAILURE_MODE: return createHWFailureMode();
      case Safe10Package.HW_FAULT: return createHWFault();
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE: return createHWComponentPrototypeScope();
      case Safe10Package.HW_COMPONENT_SCOPE_INSTANCE_REF: return createHwComponentScopeInstanceRef();
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART: return createHWComponentQuantifiedFMFromPart();
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE: return createHWElementPrototypeScope();
      case Safe10Package.HW_PART_FAILURE: return createHWPartFailure();
      case Safe10Package.HW_PART_FAILURE_ANALYSIS: return createHWPartFailureAnalysis();
      case Safe10Package.HW_PART_FAILURE_MODE: return createHWPartFailureMode();
      case Safe10Package.HW_PART_FAILURE_RATE: return createHWPartFailureRate();
      case Safe10Package.HW_ELEMENT_SCOPE_INSTANCE_REF: return createHWElementScopeInstanceRef();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION: return createHWFMSingleContribution();
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS: return createHWQuantitativeFailureAnalysis();
      case Safe10Package.HW_LATENT_FAULT_METRIC: return createHWLatentFaultMetric();
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC: return createHWSinglePointFaultMetric();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS: return createHWElementFailureRateClass();
      case Safe10Package.HW_FAILURE_CLASS_CONTAINER: return createHWFailureClassContainer();
      case Safe10Package.HWPMHF: return createHWPMHF();
      case Safe10Package.ACTOR: return createActor();
      case Safe10Package.CONTROLLABILITY_REFERENCE: return createControllabilityReference();
      case Safe10Package.HAZARD: return createHazard();
      case Safe10Package.HAZARDOUS_EVENT: return createHazardousEvent();
      case Safe10Package.ITEM: return createItem();
      case Safe10Package.ITEM_FUNCTION_DESCRIPTION: return createItemFunctionDescription();
      case Safe10Package.OPERATING_MODE: return createOperatingMode();
      case Safe10Package.OPERATIONAL_SITUATION: return createOperationalSituation();
      case Safe10Package.RISK_DESCRIPTION: return createRiskDescription();
      case Safe10Package.SAFE_STATE: return createSafeState();
      case Safe10Package.ALLOCATION_TARGETS: return createAllocationTargets();
      case Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT: return createFunctionalSafetyRequirement();
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT: return createHardwareSafetyRequirement();
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY: return createQuantifiedDiagnosticCoverageProperty();
      case Safe10Package.QUANTIFIED_HW_PROPERTY: return createQuantifiedHWProperty();
      case Safe10Package.REQUIREMENTS_LINK: return createRequirementsLink();
      case Safe10Package.SAFETY_CONCEPT: return createSafetyConcept();
      case Safe10Package.SATISFY: return createSatisfy();
      case Safe10Package.SOFTWARE_SAFETY_REQUIREMENT: return createSoftwareSafetyRequirement();
      case Safe10Package.TECHNICAL_SAFETY_REQUIREMENT: return createTechnicalSafetyRequirement();
      case Safe10Package.VERIFY: return createVerify();
      case Safe10Package.WARNING_AND_DEGRADATION: return createWarningAndDegradation();
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE: return createWarningAndDegradationHandle();
      case Safe10Package.ASSUMPTION: return createAssumption();
      case Safe10Package.CONTEXT: return createContext();
      case Safe10Package.GOAL: return createGoal();
      case Safe10Package.JUSTIFICATION: return createJustification();
      case Safe10Package.SAFETY_CASE: return createSafetyCase();
      case Safe10Package.SOLUTION: return createSolution();
      case Safe10Package.STRATEGY: return createStrategy();
      case Safe10Package.ANALYSIS_REPORT: return createAnalysisReport();
      case Safe10Package.DESIGN_SPECIFICATION: return createDesignSpecification();
      case Safe10Package.FIELD_TEST_PROTOCOL: return createFieldTestProtocol();
      case Safe10Package.FMEA_REPORT: return createFMEAReport();
      case Safe10Package.TEST_PROTOCOL: return createTestProtocol();
      case Safe10Package.UNIT_TEST_PROTOCOL: return createUnitTestProtocol();
      case Safe10Package.AVOID: return createAvoid();
      case Safe10Package.DETECT: return createDetect();
      case Safe10Package.HANDLE: return createHandle();
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT: return createAUTOSARRunnableEntitySequenceConstraint();
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT: return createAUTOSARSequenceConstraint();
      case Safe10Package.CONTROL_FLOW_ERROR: return createControlFlowError();
      case Safe10Package.CONTROL_FLOW_ERROR_DETECTION: return createControlFlowErrorDetection();
      case Safe10Package.CONTROL_FLOW_MONITOR: return createControlFlowMonitor();
      case Safe10Package.INPUT_BLOCK: return createInputBlock();
      case Safe10Package.OUTPUT_BLOCK: return createOutputBlock();
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT: return createRunnableEntitySequenceElement();
      case Safe10Package.ALIVENESS_CHECKPOINT_TOO_EARLY: return createAlivenessCheckpointTooEarly();
      case Safe10Package.ALIVENESS_CHECKPOINT_TOO_LATE: return createAlivenessCheckpointTooLate();
      case Safe10Package.ALIVENESS_CHECKPOINT_TOO_OFTEN: return createAlivenessCheckpointTooOften();
      case Safe10Package.ALIVENESS_MONITOR: return createAlivenessMonitor();
      case Safe10Package.AUTOSAR_ALIVENESS_MONITOR: return createAutosarAlivenessMonitor();
      case Safe10Package.AUTOSAR_CHECK_POINT: return createAutosarCheckPoint();
      case Safe10Package.CHECK_POINT: return createCheckPoint();
      case Safe10Package.SOFTWARE_ALIVENESS_DETECTION: return createSoftwareAlivenessDetection();
      case Safe10Package.ACTUATOR_ERROR: return createActuatorError();
      case Safe10Package.ACTUATOR_ERROR_DETECTION: return createActuatorErrorDetection();
      case Safe10Package.ACTUATOR_MONITOR: return createActuatorMonitor();
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR: return createAutosarActuatorMonitor();
      case Safe10Package.AUTOSAR_EVALUATION_FUNCTION: return createAutosarEvaluationFunction();
      case Safe10Package.EVALUATION_FUNCTION: return createEvaluationFunction();
      case Safe10Package.AUTOSAR_CRC: return createAutosarCRC();
      case Safe10Package.COMPONENT_PROTOTYPE_CRC: return createComponentPrototypeCRC();
      case Safe10Package.CRC: return createCRC();
      case Safe10Package.CRC_CONFIG: return createCRCConfig();
      case Safe10Package.CRC_ERROR_DETECTION: return createCRCErrorDetection();
      case Safe10Package.CRC_FAILED: return createCRCFailed();
      case Safe10Package.INTERFACE_CRC: return createInterfaceCRC();
      case Safe10Package.AUTOSAR_COMPARISON: return createAutosarComparison();
      case Safe10Package.AUTOSAR_COMPARISON_PARAM: return createAutosarComparisonParam();
      case Safe10Package.CHROMOSOME_COMPARISON: return createChromosomeComparison();
      case Safe10Package.CHROMOSOME_COMPARISON_PARAMETER: return createChromosomeComparisonParameter();
      case Safe10Package.COMPARISON: return createComparison();
      case Safe10Package.COMPARISON_DETECTION: return createComparisonDetection();
      case Safe10Package.COMPARISON_FALSE: return createComparisonFalse();
      case Safe10Package.COMPARISON_PARAMETER: return createComparisonParameter();
      case Safe10Package.COMPARISON_TRUE: return createComparisonTrue();
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER: return createConstantComparisonParameter();
      case Safe10Package.AUTOSAR_CONTEXT: return createAutosarContext();
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK: return createAutosarContextRangeCheck();
      case Safe10Package.CONTEXT_PARAMETER: return createContextParameter();
      case Safe10Package.CONTEXT_RANGE_CHECK: return createContextRangeCheck();
      case Safe10Package.CONTEXT_RANGE_CHECK_DETECTION: return createContextRangeCheckDetection();
      case Safe10Package.RANGE_CHECK_CONTEXT: return createRangeCheckContext();
      case Safe10Package.VALUE_ABOVE_RANGE: return createValueAboveRange();
      case Safe10Package.VALUE_BELOW_RANGE: return createValueBelowRange();
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST: return createChromosomeCpuSelfTest();
      case Safe10Package.CPU_SELF_TEST: return createCpuSelfTest();
      case Safe10Package.CPU_SELF_TEST_CONFIG: return createCpuSelfTestConfig();
      case Safe10Package.CPU_SELF_TEST_DETECTION: return createCpuSelfTestDetection();
      case Safe10Package.CPU_SELF_TEST_FAILED: return createCpuSelfTestFailed();
      case Safe10Package.FILTER: return createFilter();
      case Safe10Package.FILTER_BASED_HANDLING: return createFilterBasedHandling();
      case Safe10Package.FILTER_ERROR: return createFilterError();
      case Safe10Package.FILTER_PARAMETER: return createFilterParameter();
      case Safe10Package.AUTOSAR_GRADIENT_CHECK: return createAutosarGradientCheck();
      case Safe10Package.GRADIENT_CHECK: return createGradientCheck();
      case Safe10Package.GRADIENT_CHECK_DETECTION: return createGradientCheckDetection();
      case Safe10Package.GRADIENT_TOO_HIGH: return createGradientTooHigh();
      case Safe10Package.GRADIENT_TOO_LOW: return createGradientTooLow();
      case Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR: return createChromosomeApplicationHealthMonitor();
      case Safe10Package.CHROMOSOME_COMPONENT_MODE_CONDITION: return createChromosomeComponentModeCondition();
      case Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION: return createChromosomeErrorEventCondition();
      case Safe10Package.CHROMOSOME_ERROR_HANDLER: return createChromosomeErrorHandler();
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR: return createChromosomeHealthMonitor();
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION: return createCHROMOSOMEHealthMonitorNotification();
      case Safe10Package.CHROMOSOME_NODE_HEALTH_MONITOR: return createChromosomeNodeHealthMonitor();
      case Safe10Package.HEALTH_MONITOR: return createHealthMonitor();
      case Safe10Package.HEALTH_MONITOR_ERROR_CONDITION: return createHealthMonitorErrorCondition();
      case Safe10Package.HEALTH_MONITORING: return createHealthMonitoring();
      case Safe10Package.CHROMOSOME_HEARTBEAT_RECEIVER: return createChromosomeHeartbeatReceiver();
      case Safe10Package.CHROMOSOME_HEARTBEAT_SENDER: return createChromosomeHeartbeatSender();
      case Safe10Package.HEARTBEAT: return createHeartbeat();
      case Safe10Package.HEARTBEAT_CONFIG: return createHeartbeatConfig();
      case Safe10Package.HEART_BEAT_DEADLINE_MISSED: return createHeartBeatDeadlineMissed();
      case Safe10Package.HEART_BEAT_DETECTION: return createHeartBeatDetection();
      case Safe10Package.HEARTBEAT_RECEIVER: return createHeartbeatReceiver();
      case Safe10Package.HEARTBEAT_SENDER: return createHeartbeatSender();
      case Safe10Package.CHROMOSOME_MEMORY_TEST: return createChromosomeMemoryTest();
      case Safe10Package.MEMORY_RANGE: return createMemoryRange();
      case Safe10Package.MEMORY_SELF_TEST: return createMemorySelfTest();
      case Safe10Package.MEMORY_SELF_TEST_CONFIG: return createMemorySelfTestConfig();
      case Safe10Package.MEMORY_SELF_TEST_FAILED: return createMemorySelfTestFailed();
      case Safe10Package.MEMORY_SELF_TESTING: return createMemorySelfTesting();
      case Safe10Package.CHROMOSOME_VOTER: return createChromosomeVoter();
      case Safe10Package.CHROMOSOME_VOTER_PARAMETER: return createChromosomeVoterParameter();
      case Safe10Package.VOTER: return createVoter();
      case Safe10Package.VOTER_CONFIG: return createVoterConfig();
      case Safe10Package.VOTER_NO_CONSENSUS: return createVoterNoConsensus();
      case Safe10Package.VOTER_PARAMETER: return createVoterParameter();
      case Safe10Package.VOTER_VALUE_MISMATCH: return createVoterValueMismatch();
      case Safe10Package.VOTING: return createVoting();
      case Safe10Package.BOOLEAN_CONFIG_PARAMETER_VALUE: return createBooleanConfigParameterValue();
      case Safe10Package.CODE_GENERATION_CONFIGURATION: return createCodeGenerationConfiguration();
      case Safe10Package.CONFIG_PARAMETER: return createConfigParameter();
      case Safe10Package.CONFIG_PARAMETER_VALUE: return createConfigParameterValue();
      case Safe10Package.FLOAT_CONFIG_PARAMETER_VALUE: return createFloatConfigParameterValue();
      case Safe10Package.IDENTIFIER_CONFIG_PARAMETER_VALUE: return createIdentifierConfigParameterValue();
      case Safe10Package.INTEGER_CONFIG_PARAMETER_VALUE: return createIntegerConfigParameterValue();
      case Safe10Package.STRING_CONFIG_PARAMETER_VALUE: return createStringConfigParameterValue();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT: return createHardwareSoftwareInterfaceElement();
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION: return createHardwareSoftwareInterfaceSpecification();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case Safe10Package.ASIL_DECOMPOSED_ENUM:
        return createASILDecomposedEnumFromString(eDataType, initialValue);
      case Safe10Package.ASIL_ENUM:
        return createASILEnumFromString(eDataType, initialValue);
      case Safe10Package.DEVELOPMENT_CATEGORY:
        return createDevelopmentCategoryFromString(eDataType, initialValue);
      case Safe10Package.FUNCTION_BEHAVIOR_KIND:
        return createFunctionBehaviorKindFromString(eDataType, initialValue);
      case Safe10Package.SAFE_ELEMENT_TYPE:
        return createSafeElementTypeFromString(eDataType, initialValue);
      case Safe10Package.VARIANT_DESCRIPTION_MODE:
        return createVariantDescriptionModeFromString(eDataType, initialValue);
      case Safe10Package.ERROR_BEHAVIOR_KIND:
        return createErrorBehaviorKindFromString(eDataType, initialValue);
      case Safe10Package.ERROR_MODEL_KIND:
        return createErrorModelKindFromString(eDataType, initialValue);
      case Safe10Package.HW_MULTIPLE_POINT_FAULT_ENUM:
        return createHWMultiplePointFaultEnumFromString(eDataType, initialValue);
      case Safe10Package.HW_POINT_FAULT_ENUM:
        return createHWPointFaultEnumFromString(eDataType, initialValue);
      case Safe10Package.TARGET_VALUES_LF_METRIC_ENUM:
        return createTargetValuesLFMetricEnumFromString(eDataType, initialValue);
      case Safe10Package.TARGET_VALUES_SPF_METRIC_ENUM:
        return createTargetValuesSPFMetricEnumFromString(eDataType, initialValue);
      case Safe10Package.HWLF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return createHWLFTargetFailureRateClassEnumFromString(eDataType, initialValue);
      case Safe10Package.HWRF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return createHWRFTargetFailureRateClassEnumFromString(eDataType, initialValue);
      case Safe10Package.HWSPF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return createHWSPFTargetFailureRateClassEnumFromString(eDataType, initialValue);
      case Safe10Package.HW_TARGET_VALUES_PMHF_ENUM:
        return createHWTargetValuesPMHFEnumFromString(eDataType, initialValue);
      case Safe10Package.HW_VALUES_FAILURE_RATE_CLASS_ENUM:
        return createHWValuesFailureRateClassEnumFromString(eDataType, initialValue);
      case Safe10Package.CONTROLLABILITY_CLASS_KIND:
        return createControllabilityClassKindFromString(eDataType, initialValue);
      case Safe10Package.EXPOSURE_CLASS_KIND:
        return createExposureClassKindFromString(eDataType, initialValue);
      case Safe10Package.SEVERITY_CLASS_KIND:
        return createSeverityClassKindFromString(eDataType, initialValue);
      case Safe10Package.DIAGNOSTIC_COVERAGE_CONTEXT_ENUM:
        return createDiagnosticCoverageContextEnumFromString(eDataType, initialValue);
      case Safe10Package.DIAGNOSTIC_COVERAGE_TYPE_ENUM:
        return createDiagnosticCoverageTypeEnumFromString(eDataType, initialValue);
      case Safe10Package.HW_FAULT_METRICS_ENUM:
        return createHWFaultMetricsEnumFromString(eDataType, initialValue);
      case Safe10Package.REQUIREMENTS_LINK_TYPE_ENUM:
        return createRequirementsLinkTypeEnumFromString(eDataType, initialValue);
      case Safe10Package.REQUIREMENT_TYPE_ENUM:
        return createRequirementTypeEnumFromString(eDataType, initialValue);
      case Safe10Package.HANDLING_TYPE:
        return createHandlingTypeFromString(eDataType, initialValue);
      case Safe10Package.CONTROL_FLOW_POLICY:
        return createControlFlowPolicyFromString(eDataType, initialValue);
      case Safe10Package.COMPARISON_OPERATION_ENUM:
        return createComparisonOperationEnumFromString(eDataType, initialValue);
      case Safe10Package.CPU_TEST_ALGORITHM_ENUM:
        return createCpuTestAlgorithmEnumFromString(eDataType, initialValue);
      case Safe10Package.MEMORY_TEST_ALGORITHMS_ENUM:
        return createMemoryTestAlgorithmsEnumFromString(eDataType, initialValue);
      case Safe10Package.VOTER_ACTIVATION_SCHEME_ENUM:
        return createVoterActivationSchemeEnumFromString(eDataType, initialValue);
      case Safe10Package.VOTING_ALGORITHM_ENUM:
        return createVotingAlgorithmEnumFromString(eDataType, initialValue);
      case Safe10Package.HSI_ELEMENT_CATEGORY:
        return createHSIElementCategoryFromString(eDataType, initialValue);
      case Safe10Package.BOOLEAN:
        return createBooleanFromString(eDataType, initialValue);
      case Safe10Package.DATE:
        return createDateFromString(eDataType, initialValue);
      case Safe10Package.FLOAT:
        return createFloatFromString(eDataType, initialValue);
      case Safe10Package.IDENTIFIER:
        return createIdentifierFromString(eDataType, initialValue);
      case Safe10Package.INTEGER:
        return createIntegerFromString(eDataType, initialValue);
      case Safe10Package.NUMERICAL:
        return createNumericalFromString(eDataType, initialValue);
      case Safe10Package.STRING:
        return createStringFromString(eDataType, initialValue);
      case Safe10Package.URI_STRING:
        return createUriStringFromString(eDataType, initialValue);
      case Safe10Package.URL_STRING:
        return createUrlStringFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case Safe10Package.ASIL_DECOMPOSED_ENUM:
        return convertASILDecomposedEnumToString(eDataType, instanceValue);
      case Safe10Package.ASIL_ENUM:
        return convertASILEnumToString(eDataType, instanceValue);
      case Safe10Package.DEVELOPMENT_CATEGORY:
        return convertDevelopmentCategoryToString(eDataType, instanceValue);
      case Safe10Package.FUNCTION_BEHAVIOR_KIND:
        return convertFunctionBehaviorKindToString(eDataType, instanceValue);
      case Safe10Package.SAFE_ELEMENT_TYPE:
        return convertSafeElementTypeToString(eDataType, instanceValue);
      case Safe10Package.VARIANT_DESCRIPTION_MODE:
        return convertVariantDescriptionModeToString(eDataType, instanceValue);
      case Safe10Package.ERROR_BEHAVIOR_KIND:
        return convertErrorBehaviorKindToString(eDataType, instanceValue);
      case Safe10Package.ERROR_MODEL_KIND:
        return convertErrorModelKindToString(eDataType, instanceValue);
      case Safe10Package.HW_MULTIPLE_POINT_FAULT_ENUM:
        return convertHWMultiplePointFaultEnumToString(eDataType, instanceValue);
      case Safe10Package.HW_POINT_FAULT_ENUM:
        return convertHWPointFaultEnumToString(eDataType, instanceValue);
      case Safe10Package.TARGET_VALUES_LF_METRIC_ENUM:
        return convertTargetValuesLFMetricEnumToString(eDataType, instanceValue);
      case Safe10Package.TARGET_VALUES_SPF_METRIC_ENUM:
        return convertTargetValuesSPFMetricEnumToString(eDataType, instanceValue);
      case Safe10Package.HWLF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return convertHWLFTargetFailureRateClassEnumToString(eDataType, instanceValue);
      case Safe10Package.HWRF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return convertHWRFTargetFailureRateClassEnumToString(eDataType, instanceValue);
      case Safe10Package.HWSPF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return convertHWSPFTargetFailureRateClassEnumToString(eDataType, instanceValue);
      case Safe10Package.HW_TARGET_VALUES_PMHF_ENUM:
        return convertHWTargetValuesPMHFEnumToString(eDataType, instanceValue);
      case Safe10Package.HW_VALUES_FAILURE_RATE_CLASS_ENUM:
        return convertHWValuesFailureRateClassEnumToString(eDataType, instanceValue);
      case Safe10Package.CONTROLLABILITY_CLASS_KIND:
        return convertControllabilityClassKindToString(eDataType, instanceValue);
      case Safe10Package.EXPOSURE_CLASS_KIND:
        return convertExposureClassKindToString(eDataType, instanceValue);
      case Safe10Package.SEVERITY_CLASS_KIND:
        return convertSeverityClassKindToString(eDataType, instanceValue);
      case Safe10Package.DIAGNOSTIC_COVERAGE_CONTEXT_ENUM:
        return convertDiagnosticCoverageContextEnumToString(eDataType, instanceValue);
      case Safe10Package.DIAGNOSTIC_COVERAGE_TYPE_ENUM:
        return convertDiagnosticCoverageTypeEnumToString(eDataType, instanceValue);
      case Safe10Package.HW_FAULT_METRICS_ENUM:
        return convertHWFaultMetricsEnumToString(eDataType, instanceValue);
      case Safe10Package.REQUIREMENTS_LINK_TYPE_ENUM:
        return convertRequirementsLinkTypeEnumToString(eDataType, instanceValue);
      case Safe10Package.REQUIREMENT_TYPE_ENUM:
        return convertRequirementTypeEnumToString(eDataType, instanceValue);
      case Safe10Package.HANDLING_TYPE:
        return convertHandlingTypeToString(eDataType, instanceValue);
      case Safe10Package.CONTROL_FLOW_POLICY:
        return convertControlFlowPolicyToString(eDataType, instanceValue);
      case Safe10Package.COMPARISON_OPERATION_ENUM:
        return convertComparisonOperationEnumToString(eDataType, instanceValue);
      case Safe10Package.CPU_TEST_ALGORITHM_ENUM:
        return convertCpuTestAlgorithmEnumToString(eDataType, instanceValue);
      case Safe10Package.MEMORY_TEST_ALGORITHMS_ENUM:
        return convertMemoryTestAlgorithmsEnumToString(eDataType, instanceValue);
      case Safe10Package.VOTER_ACTIVATION_SCHEME_ENUM:
        return convertVoterActivationSchemeEnumToString(eDataType, instanceValue);
      case Safe10Package.VOTING_ALGORITHM_ENUM:
        return convertVotingAlgorithmEnumToString(eDataType, instanceValue);
      case Safe10Package.HSI_ELEMENT_CATEGORY:
        return convertHSIElementCategoryToString(eDataType, instanceValue);
      case Safe10Package.BOOLEAN:
        return convertBooleanToString(eDataType, instanceValue);
      case Safe10Package.DATE:
        return convertDateToString(eDataType, instanceValue);
      case Safe10Package.FLOAT:
        return convertFloatToString(eDataType, instanceValue);
      case Safe10Package.IDENTIFIER:
        return convertIdentifierToString(eDataType, instanceValue);
      case Safe10Package.INTEGER:
        return convertIntegerToString(eDataType, instanceValue);
      case Safe10Package.NUMERICAL:
        return convertNumericalToString(eDataType, instanceValue);
      case Safe10Package.STRING:
        return convertStringToString(eDataType, instanceValue);
      case Safe10Package.URI_STRING:
        return convertUriStringToString(eDataType, instanceValue);
      case Safe10Package.URL_STRING:
        return convertUrlStringToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterExpression createFilterExpression()
  {
    FilterExpressionImpl filterExpression = new FilterExpressionImpl();
    return filterExpression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application createApplication()
  {
    ApplicationImpl application = new ApplicationImpl();
    return application;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Component createComponent()
  {
    ComponentImpl component = new ComponentImpl();
    return component;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComponentModeInstanceRef createComponentModeInstanceRef()
  {
    ComponentModeInstanceRefImpl componentModeInstanceRef = new ComponentModeInstanceRefImpl();
    return componentModeInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Node createNode()
  {
    NodeImpl node = new NodeImpl();
    return node;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public org.safe.metamodel.safe10.System createSystem()
  {
    SystemImpl system = new SystemImpl();
    return system;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Topic createTopic()
  {
    TopicImpl topic = new TopicImpl();
    return topic;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MultiLevelSafetyExtension createMultiLevelSafetyExtension()
  {
    MultiLevelSafetyExtensionImpl multiLevelSafetyExtension = new MultiLevelSafetyExtensionImpl();
    return multiLevelSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionalSafetyExtension createFunctionalSafetyExtension()
  {
    FunctionalSafetyExtensionImpl functionalSafetyExtension = new FunctionalSafetyExtensionImpl();
    return functionalSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HazardandRiskSafetyExtension createHazardandRiskSafetyExtension()
  {
    HazardandRiskSafetyExtensionImpl hazardandRiskSafetyExtension = new HazardandRiskSafetyExtensionImpl();
    return hazardandRiskSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarHardwareSafetyExtension createAutosarHardwareSafetyExtension()
  {
    AutosarHardwareSafetyExtensionImpl autosarHardwareSafetyExtension = new AutosarHardwareSafetyExtensionImpl();
    return autosarHardwareSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarSystemSafetyExtension createAutosarSystemSafetyExtension()
  {
    AutosarSystemSafetyExtensionImpl autosarSystemSafetyExtension = new AutosarSystemSafetyExtensionImpl();
    return autosarSystemSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarVfbSafetyExtension createAutosarVfbSafetyExtension()
  {
    AutosarVfbSafetyExtensionImpl autosarVfbSafetyExtension = new AutosarVfbSafetyExtensionImpl();
    return autosarVfbSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeApplicationSafetyExtension createChromosomeApplicationSafetyExtension()
  {
    ChromosomeApplicationSafetyExtensionImpl chromosomeApplicationSafetyExtension = new ChromosomeApplicationSafetyExtensionImpl();
    return chromosomeApplicationSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeSystemSafetyExtension createChromosomeSystemSafetyExtension()
  {
    ChromosomeSystemSafetyExtensionImpl chromosomeSystemSafetyExtension = new ChromosomeSystemSafetyExtensionImpl();
    return chromosomeSystemSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ImplementationSafetyExtension createImplementationSafetyExtension()
  {
    ImplementationSafetyExtensionImpl implementationSafetyExtension = new ImplementationSafetyExtensionImpl();
    return implementationSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DesignLevelSafetyExtension createDesignLevelSafetyExtension()
  {
    DesignLevelSafetyExtensionImpl designLevelSafetyExtension = new DesignLevelSafetyExtensionImpl();
    return designLevelSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareSafetyExtension createHardwareSafetyExtension()
  {
    HardwareSafetyExtensionImpl hardwareSafetyExtension = new HardwareSafetyExtensionImpl();
    return hardwareSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareSafetyExtension createSoftwareSafetyExtension()
  {
    SoftwareSafetyExtensionImpl softwareSafetyExtension = new SoftwareSafetyExtensionImpl();
    return softwareSafetyExtension;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SAFE createSAFE()
  {
    SAFEImpl safe = new SAFEImpl();
    return safe;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SAFEPackage createSAFEPackage()
  {
    SAFEPackageImpl safePackage = new SAFEPackageImpl();
    return safePackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarClientServerOperationInstanceRef createAutosarClientServerOperationInstanceRef()
  {
    AutosarClientServerOperationInstanceRefImpl autosarClientServerOperationInstanceRef = new AutosarClientServerOperationInstanceRefImpl();
    return autosarClientServerOperationInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarComponentInCompositionInstanceRef createAutosarComponentInCompositionInstanceRef()
  {
    AutosarComponentInCompositionInstanceRefImpl autosarComponentInCompositionInstanceRef = new AutosarComponentInCompositionInstanceRefImpl();
    return autosarComponentInCompositionInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarModeInPortFromComponentInCompositionInstanceRef createAutosarModeInPortFromComponentInCompositionInstanceRef()
  {
    AutosarModeInPortFromComponentInCompositionInstanceRefImpl autosarModeInPortFromComponentInCompositionInstanceRef = new AutosarModeInPortFromComponentInCompositionInstanceRefImpl();
    return autosarModeInPortFromComponentInCompositionInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarPortInCompositionInstanceRef createAutosarPortInCompositionInstanceRef()
  {
    AutosarPortInCompositionInstanceRefImpl autosarPortInCompositionInstanceRef = new AutosarPortInCompositionInstanceRefImpl();
    return autosarPortInCompositionInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarUndefinedInstanceRef createAutosarUndefinedInstanceRef()
  {
    AutosarUndefinedInstanceRefImpl autosarUndefinedInstanceRef = new AutosarUndefinedInstanceRefImpl();
    return autosarUndefinedInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarVariableDataPrototypeInstanceRef createAutosarVariableDataPrototypeInstanceRef()
  {
    AutosarVariableDataPrototypeInstanceRefImpl autosarVariableDataPrototypeInstanceRef = new AutosarVariableDataPrototypeInstanceRefImpl();
    return autosarVariableDataPrototypeInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Restrictable createRestrictable()
  {
    RestrictableImpl restrictable = new RestrictableImpl();
    return restrictable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Restriction createRestriction()
  {
    RestrictionImpl restriction = new RestrictionImpl();
    return restriction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Variant createVariant()
  {
    VariantImpl variant = new VariantImpl();
    return variant;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModel createErrorModel()
  {
    ErrorModelImpl errorModel = new ErrorModelImpl();
    return errorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelInstanceRef createErrorModelInstanceRef()
  {
    ErrorModelInstanceRefImpl errorModelInstanceRef = new ErrorModelInstanceRefImpl();
    return errorModelInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelPrototype_analysisFunctionTarget createErrorModelPrototype_analysisFunctionTarget()
  {
    ErrorModelPrototype_analysisFunctionTargetImpl errorModelPrototype_analysisFunctionTarget = new ErrorModelPrototype_analysisFunctionTargetImpl();
    return errorModelPrototype_analysisFunctionTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelPrototype_designFunctionTarget createErrorModelPrototype_designFunctionTarget()
  {
    ErrorModelPrototype_designFunctionTargetImpl errorModelPrototype_designFunctionTarget = new ErrorModelPrototype_designFunctionTargetImpl();
    return errorModelPrototype_designFunctionTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelPrototype_hwTarget createErrorModelPrototype_hwTarget()
  {
    ErrorModelPrototype_hwTargetImpl errorModelPrototype_hwTarget = new ErrorModelPrototype_hwTargetImpl();
    return errorModelPrototype_hwTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FaultFailurePort_functionTarget createFaultFailurePort_functionTarget()
  {
    FaultFailurePort_functionTargetImpl faultFailurePort_functionTarget = new FaultFailurePort_functionTargetImpl();
    return faultFailurePort_functionTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FaultFailurePort_hwPinTarget createFaultFailurePort_hwPinTarget()
  {
    FaultFailurePort_hwPinTargetImpl faultFailurePort_hwPinTarget = new FaultFailurePort_hwPinTargetImpl();
    return faultFailurePort_hwPinTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FaultFailurePort_hwPortTarget createFaultFailurePort_hwPortTarget()
  {
    FaultFailurePort_hwPortTargetImpl faultFailurePort_hwPortTarget = new FaultFailurePort_hwPortTargetImpl();
    return faultFailurePort_hwPortTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionInstanceRef createMalfunctionInstanceRef()
  {
    MalfunctionInstanceRefImpl malfunctionInstanceRef = new MalfunctionInstanceRefImpl();
    return malfunctionInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EastADLErrorBehavior createEastADLErrorBehavior()
  {
    EastADLErrorBehaviorImpl eastADLErrorBehavior = new EastADLErrorBehaviorImpl();
    return eastADLErrorBehavior;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FailureLogicFormula createFailureLogicFormula()
  {
    FailureLogicFormulaImpl failureLogicFormula = new FailureLogicFormulaImpl();
    return failureLogicFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NativeErrorBehavior createNativeErrorBehavior()
  {
    NativeErrorBehaviorImpl nativeErrorBehavior = new NativeErrorBehaviorImpl();
    return nativeErrorBehavior;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMPAnalysis createEMPAnalysis()
  {
    EMPAnalysisImpl empAnalysis = new EMPAnalysisImpl();
    return empAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMPBswModule createEMPBswModule()
  {
    EMPBswModuleImpl empBswModule = new EMPBswModuleImpl();
    return empBswModule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMPDesign createEMPDesign()
  {
    EMPDesignImpl empDesign = new EMPDesignImpl();
    return empDesign;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMPHwComponent createEMPHwComponent()
  {
    EMPHwComponentImpl empHwComponent = new EMPHwComponentImpl();
    return empHwComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMPReference createEMPReference()
  {
    EMPReferenceImpl empReference = new EMPReferenceImpl();
    return empReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMPSwComponent createEMPSwComponent()
  {
    EMPSwComponentImpl empSwComponent = new EMPSwComponentImpl();
    return empSwComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMTypeAnalysis createEMTypeAnalysis()
  {
    EMTypeAnalysisImpl emTypeAnalysis = new EMTypeAnalysisImpl();
    return emTypeAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMTypeApplicationEnvironment createEMTypeApplicationEnvironment()
  {
    EMTypeApplicationEnvironmentImpl emTypeApplicationEnvironment = new EMTypeApplicationEnvironmentImpl();
    return emTypeApplicationEnvironment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMTypeBswModule createEMTypeBswModule()
  {
    EMTypeBswModuleImpl emTypeBswModule = new EMTypeBswModuleImpl();
    return emTypeBswModule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMTypeDesign createEMTypeDesign()
  {
    EMTypeDesignImpl emTypeDesign = new EMTypeDesignImpl();
    return emTypeDesign;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMTypeHwComponent createEMTypeHwComponent()
  {
    EMTypeHwComponentImpl emTypeHwComponent = new EMTypeHwComponentImpl();
    return emTypeHwComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EMTypeSwComponent createEMTypeSwComponent()
  {
    EMTypeSwComponentImpl emTypeSwComponent = new EMTypeSwComponentImpl();
    return emTypeSwComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelPrototype createErrorModelPrototype()
  {
    ErrorModelPrototypeImpl errorModelPrototype = new ErrorModelPrototypeImpl();
    return errorModelPrototype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelType createErrorModelType()
  {
    ErrorModelTypeImpl errorModelType = new ErrorModelTypeImpl();
    return errorModelType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FaultFailurePropagationLink createFaultFailurePropagationLink()
  {
    FaultFailurePropagationLinkImpl faultFailurePropagationLink = new FaultFailurePropagationLinkImpl();
    return faultFailurePropagationLink;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public QuantitativeErrorModel createQuantitativeErrorModel()
  {
    QuantitativeErrorModelImpl quantitativeErrorModel = new QuantitativeErrorModelImpl();
    return quantitativeErrorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype createMalfunctionPrototype()
  {
    MalfunctionPrototypeImpl malfunctionPrototype = new MalfunctionPrototypeImpl();
    return malfunctionPrototype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionType createMalfunctionType()
  {
    MalfunctionTypeImpl malfunctionType = new MalfunctionTypeImpl();
    return malfunctionType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MFPFunctionPort createMFPFunctionPort()
  {
    MFPFunctionPortImpl mfpFunctionPort = new MFPFunctionPortImpl();
    return mfpFunctionPort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MFPHardwarePin createMFPHardwarePin()
  {
    MFPHardwarePinImpl mfpHardwarePin = new MFPHardwarePinImpl();
    return mfpHardwarePin;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MFPHardwarePort createMFPHardwarePort()
  {
    MFPHardwarePortImpl mfpHardwarePort = new MFPHardwarePortImpl();
    return mfpHardwarePort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MFPOperation createMFPOperation()
  {
    MFPOperationImpl mfpOperation = new MFPOperationImpl();
    return mfpOperation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MFPSwcPort createMFPSwcPort()
  {
    MFPSwcPortImpl mfpSwcPort = new MFPSwcPortImpl();
    return mfpSwcPort;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MFPVariable createMFPVariable()
  {
    MFPVariableImpl mfpVariable = new MFPVariableImpl();
    return mfpVariable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MTComposite createMTComposite()
  {
    MTCompositeImpl mtComposite = new MTCompositeImpl();
    return mtComposite;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MTCompositeElementPrototype createMTCompositeElementPrototype()
  {
    MTCompositeElementPrototypeImpl mtCompositeElementPrototype = new MTCompositeElementPrototypeImpl();
    return mtCompositeElementPrototype;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MTPrimitive createMTPrimitive()
  {
    MTPrimitiveImpl mtPrimitive = new MTPrimitiveImpl();
    return mtPrimitive;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorBehaviorMapping createErrorBehaviorMapping()
  {
    ErrorBehaviorMappingImpl errorBehaviorMapping = new ErrorBehaviorMappingImpl();
    return errorBehaviorMapping;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelMapping createErrorModelMapping()
  {
    ErrorModelMappingImpl errorModelMapping = new ErrorModelMappingImpl();
    return errorModelMapping;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionMapping createMalfunctionMapping()
  {
    MalfunctionMappingImpl malfunctionMapping = new MalfunctionMappingImpl();
    return malfunctionMapping;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureClassContributionFormula createHWFailureClassContributionFormula()
  {
    HWFailureClassContributionFormulaImpl hwFailureClassContributionFormula = new HWFailureClassContributionFormulaImpl();
    return hwFailureClassContributionFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFMSingleContributionFormula createHWFMSingleContributionFormula()
  {
    HWFMSingleContributionFormulaImpl hwfmSingleContributionFormula = new HWFMSingleContributionFormulaImpl();
    return hwfmSingleContributionFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLambdaPartFormula createHWLambdaPartFormula()
  {
    HWLambdaPartFormulaImpl hwLambdaPartFormula = new HWLambdaPartFormulaImpl();
    return hwLambdaPartFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLatentFaultMetricFormula createHWLatentFaultMetricFormula()
  {
    HWLatentFaultMetricFormulaImpl hwLatentFaultMetricFormula = new HWLatentFaultMetricFormulaImpl();
    return hwLatentFaultMetricFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPMHFFormula createHWPMHFFormula()
  {
    HWPMHFFormulaImpl hwpmhfFormula = new HWPMHFFormulaImpl();
    return hwpmhfFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWSinglePointFaultMetricFormula createHWSinglePointFaultMetricFormula()
  {
    HWSinglePointFaultMetricFormulaImpl hwSinglePointFaultMetricFormula = new HWSinglePointFaultMetricFormulaImpl();
    return hwSinglePointFaultMetricFormula;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareFailureAnalysis createHardwareFailureAnalysis()
  {
    HardwareFailureAnalysisImpl hardwareFailureAnalysis = new HardwareFailureAnalysisImpl();
    return hardwareFailureAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureRate createHWFailureRate()
  {
    HWFailureRateImpl hwFailureRate = new HWFailureRateImpl();
    return hwFailureRate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureMode createHWFailureMode()
  {
    HWFailureModeImpl hwFailureMode = new HWFailureModeImpl();
    return hwFailureMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFault createHWFault()
  {
    HWFaultImpl hwFault = new HWFaultImpl();
    return hwFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWComponentPrototypeScope createHWComponentPrototypeScope()
  {
    HWComponentPrototypeScopeImpl hwComponentPrototypeScope = new HWComponentPrototypeScopeImpl();
    return hwComponentPrototypeScope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HwComponentScopeInstanceRef createHwComponentScopeInstanceRef()
  {
    HwComponentScopeInstanceRefImpl hwComponentScopeInstanceRef = new HwComponentScopeInstanceRefImpl();
    return hwComponentScopeInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWComponentQuantifiedFMFromPart createHWComponentQuantifiedFMFromPart()
  {
    HWComponentQuantifiedFMFromPartImpl hwComponentQuantifiedFMFromPart = new HWComponentQuantifiedFMFromPartImpl();
    return hwComponentQuantifiedFMFromPart;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWElementPrototypeScope createHWElementPrototypeScope()
  {
    HWElementPrototypeScopeImpl hwElementPrototypeScope = new HWElementPrototypeScopeImpl();
    return hwElementPrototypeScope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailure createHWPartFailure()
  {
    HWPartFailureImpl hwPartFailure = new HWPartFailureImpl();
    return hwPartFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailureAnalysis createHWPartFailureAnalysis()
  {
    HWPartFailureAnalysisImpl hwPartFailureAnalysis = new HWPartFailureAnalysisImpl();
    return hwPartFailureAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailureMode createHWPartFailureMode()
  {
    HWPartFailureModeImpl hwPartFailureMode = new HWPartFailureModeImpl();
    return hwPartFailureMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailureRate createHWPartFailureRate()
  {
    HWPartFailureRateImpl hwPartFailureRate = new HWPartFailureRateImpl();
    return hwPartFailureRate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWElementScopeInstanceRef createHWElementScopeInstanceRef()
  {
    HWElementScopeInstanceRefImpl hwElementScopeInstanceRef = new HWElementScopeInstanceRefImpl();
    return hwElementScopeInstanceRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFMSingleContribution createHWFMSingleContribution()
  {
    HWFMSingleContributionImpl hwfmSingleContribution = new HWFMSingleContributionImpl();
    return hwfmSingleContribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWQuantitativeFailureAnalysis createHWQuantitativeFailureAnalysis()
  {
    HWQuantitativeFailureAnalysisImpl hwQuantitativeFailureAnalysis = new HWQuantitativeFailureAnalysisImpl();
    return hwQuantitativeFailureAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLatentFaultMetric createHWLatentFaultMetric()
  {
    HWLatentFaultMetricImpl hwLatentFaultMetric = new HWLatentFaultMetricImpl();
    return hwLatentFaultMetric;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWSinglePointFaultMetric createHWSinglePointFaultMetric()
  {
    HWSinglePointFaultMetricImpl hwSinglePointFaultMetric = new HWSinglePointFaultMetricImpl();
    return hwSinglePointFaultMetric;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWElementFailureRateClass createHWElementFailureRateClass()
  {
    HWElementFailureRateClassImpl hwElementFailureRateClass = new HWElementFailureRateClassImpl();
    return hwElementFailureRateClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureClassContainer createHWFailureClassContainer()
  {
    HWFailureClassContainerImpl hwFailureClassContainer = new HWFailureClassContainerImpl();
    return hwFailureClassContainer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPMHF createHWPMHF()
  {
    HWPMHFImpl hwpmhf = new HWPMHFImpl();
    return hwpmhf;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Actor createActor()
  {
    ActorImpl actor = new ActorImpl();
    return actor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControllabilityReference createControllabilityReference()
  {
    ControllabilityReferenceImpl controllabilityReference = new ControllabilityReferenceImpl();
    return controllabilityReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Hazard createHazard()
  {
    HazardImpl hazard = new HazardImpl();
    return hazard;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HazardousEvent createHazardousEvent()
  {
    HazardousEventImpl hazardousEvent = new HazardousEventImpl();
    return hazardousEvent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Item createItem()
  {
    ItemImpl item = new ItemImpl();
    return item;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ItemFunctionDescription createItemFunctionDescription()
  {
    ItemFunctionDescriptionImpl itemFunctionDescription = new ItemFunctionDescriptionImpl();
    return itemFunctionDescription;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OperatingMode createOperatingMode()
  {
    OperatingModeImpl operatingMode = new OperatingModeImpl();
    return operatingMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OperationalSituation createOperationalSituation()
  {
    OperationalSituationImpl operationalSituation = new OperationalSituationImpl();
    return operationalSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RiskDescription createRiskDescription()
  {
    RiskDescriptionImpl riskDescription = new RiskDescriptionImpl();
    return riskDescription;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SafeState createSafeState()
  {
    SafeStateImpl safeState = new SafeStateImpl();
    return safeState;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AllocationTargets createAllocationTargets()
  {
    AllocationTargetsImpl allocationTargets = new AllocationTargetsImpl();
    return allocationTargets;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionalSafetyRequirement createFunctionalSafetyRequirement()
  {
    FunctionalSafetyRequirementImpl functionalSafetyRequirement = new FunctionalSafetyRequirementImpl();
    return functionalSafetyRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareSafetyRequirement createHardwareSafetyRequirement()
  {
    HardwareSafetyRequirementImpl hardwareSafetyRequirement = new HardwareSafetyRequirementImpl();
    return hardwareSafetyRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public QuantifiedDiagnosticCoverageProperty createQuantifiedDiagnosticCoverageProperty()
  {
    QuantifiedDiagnosticCoveragePropertyImpl quantifiedDiagnosticCoverageProperty = new QuantifiedDiagnosticCoveragePropertyImpl();
    return quantifiedDiagnosticCoverageProperty;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public QuantifiedHWProperty createQuantifiedHWProperty()
  {
    QuantifiedHWPropertyImpl quantifiedHWProperty = new QuantifiedHWPropertyImpl();
    return quantifiedHWProperty;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RequirementsLink createRequirementsLink()
  {
    RequirementsLinkImpl requirementsLink = new RequirementsLinkImpl();
    return requirementsLink;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SafetyConcept createSafetyConcept()
  {
    SafetyConceptImpl safetyConcept = new SafetyConceptImpl();
    return safetyConcept;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Satisfy createSatisfy()
  {
    SatisfyImpl satisfy = new SatisfyImpl();
    return satisfy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareSafetyRequirement createSoftwareSafetyRequirement()
  {
    SoftwareSafetyRequirementImpl softwareSafetyRequirement = new SoftwareSafetyRequirementImpl();
    return softwareSafetyRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TechnicalSafetyRequirement createTechnicalSafetyRequirement()
  {
    TechnicalSafetyRequirementImpl technicalSafetyRequirement = new TechnicalSafetyRequirementImpl();
    return technicalSafetyRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Verify createVerify()
  {
    VerifyImpl verify = new VerifyImpl();
    return verify;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WarningAndDegradation createWarningAndDegradation()
  {
    WarningAndDegradationImpl warningAndDegradation = new WarningAndDegradationImpl();
    return warningAndDegradation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WarningAndDegradationHandle createWarningAndDegradationHandle()
  {
    WarningAndDegradationHandleImpl warningAndDegradationHandle = new WarningAndDegradationHandleImpl();
    return warningAndDegradationHandle;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Assumption createAssumption()
  {
    AssumptionImpl assumption = new AssumptionImpl();
    return assumption;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Context createContext()
  {
    ContextImpl context = new ContextImpl();
    return context;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Goal createGoal()
  {
    GoalImpl goal = new GoalImpl();
    return goal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Justification createJustification()
  {
    JustificationImpl justification = new JustificationImpl();
    return justification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SafetyCase createSafetyCase()
  {
    SafetyCaseImpl safetyCase = new SafetyCaseImpl();
    return safetyCase;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Solution createSolution()
  {
    SolutionImpl solution = new SolutionImpl();
    return solution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Strategy createStrategy()
  {
    StrategyImpl strategy = new StrategyImpl();
    return strategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AnalysisReport createAnalysisReport()
  {
    AnalysisReportImpl analysisReport = new AnalysisReportImpl();
    return analysisReport;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DesignSpecification createDesignSpecification()
  {
    DesignSpecificationImpl designSpecification = new DesignSpecificationImpl();
    return designSpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FieldTestProtocol createFieldTestProtocol()
  {
    FieldTestProtocolImpl fieldTestProtocol = new FieldTestProtocolImpl();
    return fieldTestProtocol;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FMEAReport createFMEAReport()
  {
    FMEAReportImpl fmeaReport = new FMEAReportImpl();
    return fmeaReport;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TestProtocol createTestProtocol()
  {
    TestProtocolImpl testProtocol = new TestProtocolImpl();
    return testProtocol;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UnitTestProtocol createUnitTestProtocol()
  {
    UnitTestProtocolImpl unitTestProtocol = new UnitTestProtocolImpl();
    return unitTestProtocol;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Avoid createAvoid()
  {
    AvoidImpl avoid = new AvoidImpl();
    return avoid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Detect createDetect()
  {
    DetectImpl detect = new DetectImpl();
    return detect;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Handle createHandle()
  {
    HandleImpl handle = new HandleImpl();
    return handle;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AUTOSARRunnableEntitySequenceConstraint createAUTOSARRunnableEntitySequenceConstraint()
  {
    AUTOSARRunnableEntitySequenceConstraintImpl autosarRunnableEntitySequenceConstraint = new AUTOSARRunnableEntitySequenceConstraintImpl();
    return autosarRunnableEntitySequenceConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AUTOSARSequenceConstraint createAUTOSARSequenceConstraint()
  {
    AUTOSARSequenceConstraintImpl autosarSequenceConstraint = new AUTOSARSequenceConstraintImpl();
    return autosarSequenceConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControlFlowError createControlFlowError()
  {
    ControlFlowErrorImpl controlFlowError = new ControlFlowErrorImpl();
    return controlFlowError;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControlFlowErrorDetection createControlFlowErrorDetection()
  {
    ControlFlowErrorDetectionImpl controlFlowErrorDetection = new ControlFlowErrorDetectionImpl();
    return controlFlowErrorDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControlFlowMonitor createControlFlowMonitor()
  {
    ControlFlowMonitorImpl controlFlowMonitor = new ControlFlowMonitorImpl();
    return controlFlowMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InputBlock createInputBlock()
  {
    InputBlockImpl inputBlock = new InputBlockImpl();
    return inputBlock;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OutputBlock createOutputBlock()
  {
    OutputBlockImpl outputBlock = new OutputBlockImpl();
    return outputBlock;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RunnableEntitySequenceElement createRunnableEntitySequenceElement()
  {
    RunnableEntitySequenceElementImpl runnableEntitySequenceElement = new RunnableEntitySequenceElementImpl();
    return runnableEntitySequenceElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AlivenessCheckpointTooEarly createAlivenessCheckpointTooEarly()
  {
    AlivenessCheckpointTooEarlyImpl alivenessCheckpointTooEarly = new AlivenessCheckpointTooEarlyImpl();
    return alivenessCheckpointTooEarly;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AlivenessCheckpointTooLate createAlivenessCheckpointTooLate()
  {
    AlivenessCheckpointTooLateImpl alivenessCheckpointTooLate = new AlivenessCheckpointTooLateImpl();
    return alivenessCheckpointTooLate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AlivenessCheckpointTooOften createAlivenessCheckpointTooOften()
  {
    AlivenessCheckpointTooOftenImpl alivenessCheckpointTooOften = new AlivenessCheckpointTooOftenImpl();
    return alivenessCheckpointTooOften;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AlivenessMonitor createAlivenessMonitor()
  {
    AlivenessMonitorImpl alivenessMonitor = new AlivenessMonitorImpl();
    return alivenessMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarAlivenessMonitor createAutosarAlivenessMonitor()
  {
    AutosarAlivenessMonitorImpl autosarAlivenessMonitor = new AutosarAlivenessMonitorImpl();
    return autosarAlivenessMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarCheckPoint createAutosarCheckPoint()
  {
    AutosarCheckPointImpl autosarCheckPoint = new AutosarCheckPointImpl();
    return autosarCheckPoint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CheckPoint createCheckPoint()
  {
    CheckPointImpl checkPoint = new CheckPointImpl();
    return checkPoint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftwareAlivenessDetection createSoftwareAlivenessDetection()
  {
    SoftwareAlivenessDetectionImpl softwareAlivenessDetection = new SoftwareAlivenessDetectionImpl();
    return softwareAlivenessDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ActuatorError createActuatorError()
  {
    ActuatorErrorImpl actuatorError = new ActuatorErrorImpl();
    return actuatorError;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ActuatorErrorDetection createActuatorErrorDetection()
  {
    ActuatorErrorDetectionImpl actuatorErrorDetection = new ActuatorErrorDetectionImpl();
    return actuatorErrorDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ActuatorMonitor createActuatorMonitor()
  {
    ActuatorMonitorImpl actuatorMonitor = new ActuatorMonitorImpl();
    return actuatorMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarActuatorMonitor createAutosarActuatorMonitor()
  {
    AutosarActuatorMonitorImpl autosarActuatorMonitor = new AutosarActuatorMonitorImpl();
    return autosarActuatorMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarEvaluationFunction createAutosarEvaluationFunction()
  {
    AutosarEvaluationFunctionImpl autosarEvaluationFunction = new AutosarEvaluationFunctionImpl();
    return autosarEvaluationFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EvaluationFunction createEvaluationFunction()
  {
    EvaluationFunctionImpl evaluationFunction = new EvaluationFunctionImpl();
    return evaluationFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarCRC createAutosarCRC()
  {
    AutosarCRCImpl autosarCRC = new AutosarCRCImpl();
    return autosarCRC;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComponentPrototypeCRC createComponentPrototypeCRC()
  {
    ComponentPrototypeCRCImpl componentPrototypeCRC = new ComponentPrototypeCRCImpl();
    return componentPrototypeCRC;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CRC createCRC()
  {
    CRCImpl crc = new CRCImpl();
    return crc;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CRCConfig createCRCConfig()
  {
    CRCConfigImpl crcConfig = new CRCConfigImpl();
    return crcConfig;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CRCErrorDetection createCRCErrorDetection()
  {
    CRCErrorDetectionImpl crcErrorDetection = new CRCErrorDetectionImpl();
    return crcErrorDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CRCFailed createCRCFailed()
  {
    CRCFailedImpl crcFailed = new CRCFailedImpl();
    return crcFailed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InterfaceCRC createInterfaceCRC()
  {
    InterfaceCRCImpl interfaceCRC = new InterfaceCRCImpl();
    return interfaceCRC;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarComparison createAutosarComparison()
  {
    AutosarComparisonImpl autosarComparison = new AutosarComparisonImpl();
    return autosarComparison;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarComparisonParam createAutosarComparisonParam()
  {
    AutosarComparisonParamImpl autosarComparisonParam = new AutosarComparisonParamImpl();
    return autosarComparisonParam;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeComparison createChromosomeComparison()
  {
    ChromosomeComparisonImpl chromosomeComparison = new ChromosomeComparisonImpl();
    return chromosomeComparison;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeComparisonParameter createChromosomeComparisonParameter()
  {
    ChromosomeComparisonParameterImpl chromosomeComparisonParameter = new ChromosomeComparisonParameterImpl();
    return chromosomeComparisonParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Comparison createComparison()
  {
    ComparisonImpl comparison = new ComparisonImpl();
    return comparison;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonDetection createComparisonDetection()
  {
    ComparisonDetectionImpl comparisonDetection = new ComparisonDetectionImpl();
    return comparisonDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonFalse createComparisonFalse()
  {
    ComparisonFalseImpl comparisonFalse = new ComparisonFalseImpl();
    return comparisonFalse;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter createComparisonParameter()
  {
    ComparisonParameterImpl comparisonParameter = new ComparisonParameterImpl();
    return comparisonParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonTrue createComparisonTrue()
  {
    ComparisonTrueImpl comparisonTrue = new ComparisonTrueImpl();
    return comparisonTrue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConstantComparisonParameter createConstantComparisonParameter()
  {
    ConstantComparisonParameterImpl constantComparisonParameter = new ConstantComparisonParameterImpl();
    return constantComparisonParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarContext createAutosarContext()
  {
    AutosarContextImpl autosarContext = new AutosarContextImpl();
    return autosarContext;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarContextRangeCheck createAutosarContextRangeCheck()
  {
    AutosarContextRangeCheckImpl autosarContextRangeCheck = new AutosarContextRangeCheckImpl();
    return autosarContextRangeCheck;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ContextParameter createContextParameter()
  {
    ContextParameterImpl contextParameter = new ContextParameterImpl();
    return contextParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ContextRangeCheck createContextRangeCheck()
  {
    ContextRangeCheckImpl contextRangeCheck = new ContextRangeCheckImpl();
    return contextRangeCheck;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ContextRangeCheckDetection createContextRangeCheckDetection()
  {
    ContextRangeCheckDetectionImpl contextRangeCheckDetection = new ContextRangeCheckDetectionImpl();
    return contextRangeCheckDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RangeCheckContext createRangeCheckContext()
  {
    RangeCheckContextImpl rangeCheckContext = new RangeCheckContextImpl();
    return rangeCheckContext;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValueAboveRange createValueAboveRange()
  {
    ValueAboveRangeImpl valueAboveRange = new ValueAboveRangeImpl();
    return valueAboveRange;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValueBelowRange createValueBelowRange()
  {
    ValueBelowRangeImpl valueBelowRange = new ValueBelowRangeImpl();
    return valueBelowRange;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeCpuSelfTest createChromosomeCpuSelfTest()
  {
    ChromosomeCpuSelfTestImpl chromosomeCpuSelfTest = new ChromosomeCpuSelfTestImpl();
    return chromosomeCpuSelfTest;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CpuSelfTest createCpuSelfTest()
  {
    CpuSelfTestImpl cpuSelfTest = new CpuSelfTestImpl();
    return cpuSelfTest;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CpuSelfTestConfig createCpuSelfTestConfig()
  {
    CpuSelfTestConfigImpl cpuSelfTestConfig = new CpuSelfTestConfigImpl();
    return cpuSelfTestConfig;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CpuSelfTestDetection createCpuSelfTestDetection()
  {
    CpuSelfTestDetectionImpl cpuSelfTestDetection = new CpuSelfTestDetectionImpl();
    return cpuSelfTestDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CpuSelfTestFailed createCpuSelfTestFailed()
  {
    CpuSelfTestFailedImpl cpuSelfTestFailed = new CpuSelfTestFailedImpl();
    return cpuSelfTestFailed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Filter createFilter()
  {
    FilterImpl filter = new FilterImpl();
    return filter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterBasedHandling createFilterBasedHandling()
  {
    FilterBasedHandlingImpl filterBasedHandling = new FilterBasedHandlingImpl();
    return filterBasedHandling;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterError createFilterError()
  {
    FilterErrorImpl filterError = new FilterErrorImpl();
    return filterError;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterParameter createFilterParameter()
  {
    FilterParameterImpl filterParameter = new FilterParameterImpl();
    return filterParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarGradientCheck createAutosarGradientCheck()
  {
    AutosarGradientCheckImpl autosarGradientCheck = new AutosarGradientCheckImpl();
    return autosarGradientCheck;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GradientCheck createGradientCheck()
  {
    GradientCheckImpl gradientCheck = new GradientCheckImpl();
    return gradientCheck;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GradientCheckDetection createGradientCheckDetection()
  {
    GradientCheckDetectionImpl gradientCheckDetection = new GradientCheckDetectionImpl();
    return gradientCheckDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GradientTooHigh createGradientTooHigh()
  {
    GradientTooHighImpl gradientTooHigh = new GradientTooHighImpl();
    return gradientTooHigh;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GradientTooLow createGradientTooLow()
  {
    GradientTooLowImpl gradientTooLow = new GradientTooLowImpl();
    return gradientTooLow;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeApplicationHealthMonitor createChromosomeApplicationHealthMonitor()
  {
    ChromosomeApplicationHealthMonitorImpl chromosomeApplicationHealthMonitor = new ChromosomeApplicationHealthMonitorImpl();
    return chromosomeApplicationHealthMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeComponentModeCondition createChromosomeComponentModeCondition()
  {
    ChromosomeComponentModeConditionImpl chromosomeComponentModeCondition = new ChromosomeComponentModeConditionImpl();
    return chromosomeComponentModeCondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeErrorEventCondition createChromosomeErrorEventCondition()
  {
    ChromosomeErrorEventConditionImpl chromosomeErrorEventCondition = new ChromosomeErrorEventConditionImpl();
    return chromosomeErrorEventCondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeErrorHandler createChromosomeErrorHandler()
  {
    ChromosomeErrorHandlerImpl chromosomeErrorHandler = new ChromosomeErrorHandlerImpl();
    return chromosomeErrorHandler;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeHealthMonitor createChromosomeHealthMonitor()
  {
    ChromosomeHealthMonitorImpl chromosomeHealthMonitor = new ChromosomeHealthMonitorImpl();
    return chromosomeHealthMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CHROMOSOMEHealthMonitorNotification createCHROMOSOMEHealthMonitorNotification()
  {
    CHROMOSOMEHealthMonitorNotificationImpl chromosomeHealthMonitorNotification = new CHROMOSOMEHealthMonitorNotificationImpl();
    return chromosomeHealthMonitorNotification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeNodeHealthMonitor createChromosomeNodeHealthMonitor()
  {
    ChromosomeNodeHealthMonitorImpl chromosomeNodeHealthMonitor = new ChromosomeNodeHealthMonitorImpl();
    return chromosomeNodeHealthMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HealthMonitor createHealthMonitor()
  {
    HealthMonitorImpl healthMonitor = new HealthMonitorImpl();
    return healthMonitor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HealthMonitorErrorCondition createHealthMonitorErrorCondition()
  {
    HealthMonitorErrorConditionImpl healthMonitorErrorCondition = new HealthMonitorErrorConditionImpl();
    return healthMonitorErrorCondition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HealthMonitoring createHealthMonitoring()
  {
    HealthMonitoringImpl healthMonitoring = new HealthMonitoringImpl();
    return healthMonitoring;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeHeartbeatReceiver createChromosomeHeartbeatReceiver()
  {
    ChromosomeHeartbeatReceiverImpl chromosomeHeartbeatReceiver = new ChromosomeHeartbeatReceiverImpl();
    return chromosomeHeartbeatReceiver;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeHeartbeatSender createChromosomeHeartbeatSender()
  {
    ChromosomeHeartbeatSenderImpl chromosomeHeartbeatSender = new ChromosomeHeartbeatSenderImpl();
    return chromosomeHeartbeatSender;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Heartbeat createHeartbeat()
  {
    HeartbeatImpl heartbeat = new HeartbeatImpl();
    return heartbeat;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeartbeatConfig createHeartbeatConfig()
  {
    HeartbeatConfigImpl heartbeatConfig = new HeartbeatConfigImpl();
    return heartbeatConfig;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeartBeatDeadlineMissed createHeartBeatDeadlineMissed()
  {
    HeartBeatDeadlineMissedImpl heartBeatDeadlineMissed = new HeartBeatDeadlineMissedImpl();
    return heartBeatDeadlineMissed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeartBeatDetection createHeartBeatDetection()
  {
    HeartBeatDetectionImpl heartBeatDetection = new HeartBeatDetectionImpl();
    return heartBeatDetection;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeartbeatReceiver createHeartbeatReceiver()
  {
    HeartbeatReceiverImpl heartbeatReceiver = new HeartbeatReceiverImpl();
    return heartbeatReceiver;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HeartbeatSender createHeartbeatSender()
  {
    HeartbeatSenderImpl heartbeatSender = new HeartbeatSenderImpl();
    return heartbeatSender;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeMemoryTest createChromosomeMemoryTest()
  {
    ChromosomeMemoryTestImpl chromosomeMemoryTest = new ChromosomeMemoryTestImpl();
    return chromosomeMemoryTest;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemoryRange createMemoryRange()
  {
    MemoryRangeImpl memoryRange = new MemoryRangeImpl();
    return memoryRange;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemorySelfTest createMemorySelfTest()
  {
    MemorySelfTestImpl memorySelfTest = new MemorySelfTestImpl();
    return memorySelfTest;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemorySelfTestConfig createMemorySelfTestConfig()
  {
    MemorySelfTestConfigImpl memorySelfTestConfig = new MemorySelfTestConfigImpl();
    return memorySelfTestConfig;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemorySelfTestFailed createMemorySelfTestFailed()
  {
    MemorySelfTestFailedImpl memorySelfTestFailed = new MemorySelfTestFailedImpl();
    return memorySelfTestFailed;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemorySelfTesting createMemorySelfTesting()
  {
    MemorySelfTestingImpl memorySelfTesting = new MemorySelfTestingImpl();
    return memorySelfTesting;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeVoter createChromosomeVoter()
  {
    ChromosomeVoterImpl chromosomeVoter = new ChromosomeVoterImpl();
    return chromosomeVoter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChromosomeVoterParameter createChromosomeVoterParameter()
  {
    ChromosomeVoterParameterImpl chromosomeVoterParameter = new ChromosomeVoterParameterImpl();
    return chromosomeVoterParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Voter createVoter()
  {
    VoterImpl voter = new VoterImpl();
    return voter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VoterConfig createVoterConfig()
  {
    VoterConfigImpl voterConfig = new VoterConfigImpl();
    return voterConfig;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VoterNoConsensus createVoterNoConsensus()
  {
    VoterNoConsensusImpl voterNoConsensus = new VoterNoConsensusImpl();
    return voterNoConsensus;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VoterParameter createVoterParameter()
  {
    VoterParameterImpl voterParameter = new VoterParameterImpl();
    return voterParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VoterValueMismatch createVoterValueMismatch()
  {
    VoterValueMismatchImpl voterValueMismatch = new VoterValueMismatchImpl();
    return voterValueMismatch;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Voting createVoting()
  {
    VotingImpl voting = new VotingImpl();
    return voting;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public BooleanConfigParameterValue createBooleanConfigParameterValue()
  {
    BooleanConfigParameterValueImpl booleanConfigParameterValue = new BooleanConfigParameterValueImpl();
    return booleanConfigParameterValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CodeGenerationConfiguration createCodeGenerationConfiguration()
  {
    CodeGenerationConfigurationImpl codeGenerationConfiguration = new CodeGenerationConfigurationImpl();
    return codeGenerationConfiguration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigParameter createConfigParameter()
  {
    ConfigParameterImpl configParameter = new ConfigParameterImpl();
    return configParameter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigParameterValue createConfigParameterValue()
  {
    ConfigParameterValueImpl configParameterValue = new ConfigParameterValueImpl();
    return configParameterValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FloatConfigParameterValue createFloatConfigParameterValue()
  {
    FloatConfigParameterValueImpl floatConfigParameterValue = new FloatConfigParameterValueImpl();
    return floatConfigParameterValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IdentifierConfigParameterValue createIdentifierConfigParameterValue()
  {
    IdentifierConfigParameterValueImpl identifierConfigParameterValue = new IdentifierConfigParameterValueImpl();
    return identifierConfigParameterValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IntegerConfigParameterValue createIntegerConfigParameterValue()
  {
    IntegerConfigParameterValueImpl integerConfigParameterValue = new IntegerConfigParameterValueImpl();
    return integerConfigParameterValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StringConfigParameterValue createStringConfigParameterValue()
  {
    StringConfigParameterValueImpl stringConfigParameterValue = new StringConfigParameterValueImpl();
    return stringConfigParameterValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareSoftwareInterfaceElement createHardwareSoftwareInterfaceElement()
  {
    HardwareSoftwareInterfaceElementImpl hardwareSoftwareInterfaceElement = new HardwareSoftwareInterfaceElementImpl();
    return hardwareSoftwareInterfaceElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareSoftwareInterfaceSpecification createHardwareSoftwareInterfaceSpecification()
  {
    HardwareSoftwareInterfaceSpecificationImpl hardwareSoftwareInterfaceSpecification = new HardwareSoftwareInterfaceSpecificationImpl();
    return hardwareSoftwareInterfaceSpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ASILDecomposedEnum createASILDecomposedEnumFromString(EDataType eDataType, String initialValue)
  {
    ASILDecomposedEnum result = ASILDecomposedEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertASILDecomposedEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ASILEnum createASILEnumFromString(EDataType eDataType, String initialValue)
  {
    ASILEnum result = ASILEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertASILEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DevelopmentCategory createDevelopmentCategoryFromString(EDataType eDataType, String initialValue)
  {
    DevelopmentCategory result = DevelopmentCategory.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDevelopmentCategoryToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionBehaviorKind createFunctionBehaviorKindFromString(EDataType eDataType, String initialValue)
  {
    FunctionBehaviorKind result = FunctionBehaviorKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertFunctionBehaviorKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SafeElementType createSafeElementTypeFromString(EDataType eDataType, String initialValue)
  {
    SafeElementType result = SafeElementType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertSafeElementTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariantDescriptionMode createVariantDescriptionModeFromString(EDataType eDataType, String initialValue)
  {
    VariantDescriptionMode result = VariantDescriptionMode.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertVariantDescriptionModeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorBehaviorKind createErrorBehaviorKindFromString(EDataType eDataType, String initialValue)
  {
    ErrorBehaviorKind result = ErrorBehaviorKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertErrorBehaviorKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelKind createErrorModelKindFromString(EDataType eDataType, String initialValue)
  {
    ErrorModelKind result = ErrorModelKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertErrorModelKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWMultiplePointFaultEnum createHWMultiplePointFaultEnumFromString(EDataType eDataType, String initialValue)
  {
    HWMultiplePointFaultEnum result = HWMultiplePointFaultEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWMultiplePointFaultEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPointFaultEnum createHWPointFaultEnumFromString(EDataType eDataType, String initialValue)
  {
    HWPointFaultEnum result = HWPointFaultEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWPointFaultEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TargetValuesLFMetricEnum createTargetValuesLFMetricEnumFromString(EDataType eDataType, String initialValue)
  {
    TargetValuesLFMetricEnum result = TargetValuesLFMetricEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertTargetValuesLFMetricEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TargetValuesSPFMetricEnum createTargetValuesSPFMetricEnumFromString(EDataType eDataType, String initialValue)
  {
    TargetValuesSPFMetricEnum result = TargetValuesSPFMetricEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertTargetValuesSPFMetricEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLFTargetFailureRateClassEnum createHWLFTargetFailureRateClassEnumFromString(EDataType eDataType, String initialValue)
  {
    HWLFTargetFailureRateClassEnum result = HWLFTargetFailureRateClassEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWLFTargetFailureRateClassEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWRFTargetFailureRateClassEnum createHWRFTargetFailureRateClassEnumFromString(EDataType eDataType, String initialValue)
  {
    HWRFTargetFailureRateClassEnum result = HWRFTargetFailureRateClassEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWRFTargetFailureRateClassEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWSPFTargetFailureRateClassEnum createHWSPFTargetFailureRateClassEnumFromString(EDataType eDataType, String initialValue)
  {
    HWSPFTargetFailureRateClassEnum result = HWSPFTargetFailureRateClassEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWSPFTargetFailureRateClassEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWTargetValuesPMHFEnum createHWTargetValuesPMHFEnumFromString(EDataType eDataType, String initialValue)
  {
    HWTargetValuesPMHFEnum result = HWTargetValuesPMHFEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWTargetValuesPMHFEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWValuesFailureRateClassEnum createHWValuesFailureRateClassEnumFromString(EDataType eDataType, String initialValue)
  {
    HWValuesFailureRateClassEnum result = HWValuesFailureRateClassEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWValuesFailureRateClassEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControllabilityClassKind createControllabilityClassKindFromString(EDataType eDataType, String initialValue)
  {
    ControllabilityClassKind result = ControllabilityClassKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertControllabilityClassKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExposureClassKind createExposureClassKindFromString(EDataType eDataType, String initialValue)
  {
    ExposureClassKind result = ExposureClassKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertExposureClassKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SeverityClassKind createSeverityClassKindFromString(EDataType eDataType, String initialValue)
  {
    SeverityClassKind result = SeverityClassKind.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertSeverityClassKindToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DiagnosticCoverageContextEnum createDiagnosticCoverageContextEnumFromString(EDataType eDataType, String initialValue)
  {
    DiagnosticCoverageContextEnum result = DiagnosticCoverageContextEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDiagnosticCoverageContextEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DiagnosticCoverageTypeEnum createDiagnosticCoverageTypeEnumFromString(EDataType eDataType, String initialValue)
  {
    DiagnosticCoverageTypeEnum result = DiagnosticCoverageTypeEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDiagnosticCoverageTypeEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFaultMetricsEnum createHWFaultMetricsEnumFromString(EDataType eDataType, String initialValue)
  {
    HWFaultMetricsEnum result = HWFaultMetricsEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHWFaultMetricsEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RequirementsLinkTypeEnum createRequirementsLinkTypeEnumFromString(EDataType eDataType, String initialValue)
  {
    RequirementsLinkTypeEnum result = RequirementsLinkTypeEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertRequirementsLinkTypeEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RequirementTypeEnum createRequirementTypeEnumFromString(EDataType eDataType, String initialValue)
  {
    RequirementTypeEnum result = RequirementTypeEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertRequirementTypeEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HandlingType createHandlingTypeFromString(EDataType eDataType, String initialValue)
  {
    HandlingType result = HandlingType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHandlingTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControlFlowPolicy createControlFlowPolicyFromString(EDataType eDataType, String initialValue)
  {
    ControlFlowPolicy result = ControlFlowPolicy.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertControlFlowPolicyToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonOperationEnum createComparisonOperationEnumFromString(EDataType eDataType, String initialValue)
  {
    ComparisonOperationEnum result = ComparisonOperationEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertComparisonOperationEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CpuTestAlgorithmEnum createCpuTestAlgorithmEnumFromString(EDataType eDataType, String initialValue)
  {
    CpuTestAlgorithmEnum result = CpuTestAlgorithmEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertCpuTestAlgorithmEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemoryTestAlgorithmsEnum createMemoryTestAlgorithmsEnumFromString(EDataType eDataType, String initialValue)
  {
    MemoryTestAlgorithmsEnum result = MemoryTestAlgorithmsEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertMemoryTestAlgorithmsEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VoterActivationSchemeEnum createVoterActivationSchemeEnumFromString(EDataType eDataType, String initialValue)
  {
    VoterActivationSchemeEnum result = VoterActivationSchemeEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertVoterActivationSchemeEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VotingAlgorithmEnum createVotingAlgorithmEnumFromString(EDataType eDataType, String initialValue)
  {
    VotingAlgorithmEnum result = VotingAlgorithmEnum.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertVotingAlgorithmEnumToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HSIElementCategory createHSIElementCategoryFromString(EDataType eDataType, String initialValue)
  {
    HSIElementCategory result = HSIElementCategory.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHSIElementCategoryToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean createBooleanFromString(EDataType eDataType, String initialValue)
  {
    return (Boolean)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertBooleanToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public XMLGregorianCalendar createDateFromString(EDataType eDataType, String initialValue)
  {
    return (XMLGregorianCalendar)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDateToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double createFloatFromString(EDataType eDataType, String initialValue)
  {
    return (Double)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertFloatToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String createIdentifierFromString(EDataType eDataType, String initialValue)
  {
    return (String)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertIdentifierToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer createIntegerFromString(EDataType eDataType, String initialValue)
  {
    return (Integer)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertIntegerToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String createNumericalFromString(EDataType eDataType, String initialValue)
  {
    return (String)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertNumericalToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String createStringFromString(EDataType eDataType, String initialValue)
  {
    return (String)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertStringToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public URI createUriStringFromString(EDataType eDataType, String initialValue)
  {
    return (URI)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertUriStringToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public URL createUrlStringFromString(EDataType eDataType, String initialValue)
  {
    return (URL)super.createFromString(eDataType, initialValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertUrlStringToString(EDataType eDataType, Object instanceValue)
  {
    return super.convertToString(eDataType, instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Safe10Package getSafe10Package()
  {
    return (Safe10Package)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static Safe10Package getPackage()
  {
    return Safe10Package.eINSTANCE;
  }

} //Safe10FactoryImpl
