/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.AbstractSafetyRequirement;
import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafetyConcept;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Safety Concept</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyConceptImpl#getEmergencyOperationTimeInterval <em>Emergency Operation Time Interval</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyConceptImpl#getFaultTolerantTimeInterval <em>Fault Tolerant Time Interval</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyConceptImpl#getSafetyGoal <em>Safety Goal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyConceptImpl#getRequirements <em>Requirements</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SafetyConceptImpl extends AbstractSafetyRequirementImpl implements SafetyConcept
{
  /**
   * The default value of the '{@link #getEmergencyOperationTimeInterval() <em>Emergency Operation Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEmergencyOperationTimeInterval()
   * @generated
   * @ordered
   */
  protected static final Integer EMERGENCY_OPERATION_TIME_INTERVAL_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getEmergencyOperationTimeInterval() <em>Emergency Operation Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEmergencyOperationTimeInterval()
   * @generated
   * @ordered
   */
  protected Integer emergencyOperationTimeInterval = EMERGENCY_OPERATION_TIME_INTERVAL_EDEFAULT;

  /**
   * This is true if the Emergency Operation Time Interval attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean emergencyOperationTimeIntervalESet;

  /**
   * The default value of the '{@link #getFaultTolerantTimeInterval() <em>Fault Tolerant Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFaultTolerantTimeInterval()
   * @generated
   * @ordered
   */
  protected static final Integer FAULT_TOLERANT_TIME_INTERVAL_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getFaultTolerantTimeInterval() <em>Fault Tolerant Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFaultTolerantTimeInterval()
   * @generated
   * @ordered
   */
  protected Integer faultTolerantTimeInterval = FAULT_TOLERANT_TIME_INTERVAL_EDEFAULT;

  /**
   * This is true if the Fault Tolerant Time Interval attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean faultTolerantTimeIntervalESet;

  /**
   * The cached value of the '{@link #getSafetyGoal() <em>Safety Goal</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyGoal()
   * @generated
   * @ordered
   */
  protected EList<FunctionalSafetyRequirement> safetyGoal;

  /**
   * The cached value of the '{@link #getRequirements() <em>Requirements</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirements()
   * @generated
   * @ordered
   */
  protected EList<AbstractSafetyRequirement> requirements;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SafetyConceptImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getSafetyConcept();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getEmergencyOperationTimeInterval()
  {
    return emergencyOperationTimeInterval;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEmergencyOperationTimeInterval(Integer newEmergencyOperationTimeInterval)
  {
    Integer oldEmergencyOperationTimeInterval = emergencyOperationTimeInterval;
    emergencyOperationTimeInterval = newEmergencyOperationTimeInterval;
    boolean oldEmergencyOperationTimeIntervalESet = emergencyOperationTimeIntervalESet;
    emergencyOperationTimeIntervalESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.SAFETY_CONCEPT__EMERGENCY_OPERATION_TIME_INTERVAL, oldEmergencyOperationTimeInterval, emergencyOperationTimeInterval, !oldEmergencyOperationTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetEmergencyOperationTimeInterval()
  {
    Integer oldEmergencyOperationTimeInterval = emergencyOperationTimeInterval;
    boolean oldEmergencyOperationTimeIntervalESet = emergencyOperationTimeIntervalESet;
    emergencyOperationTimeInterval = EMERGENCY_OPERATION_TIME_INTERVAL_EDEFAULT;
    emergencyOperationTimeIntervalESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.SAFETY_CONCEPT__EMERGENCY_OPERATION_TIME_INTERVAL, oldEmergencyOperationTimeInterval, EMERGENCY_OPERATION_TIME_INTERVAL_EDEFAULT, oldEmergencyOperationTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetEmergencyOperationTimeInterval()
  {
    return emergencyOperationTimeIntervalESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getFaultTolerantTimeInterval()
  {
    return faultTolerantTimeInterval;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFaultTolerantTimeInterval(Integer newFaultTolerantTimeInterval)
  {
    Integer oldFaultTolerantTimeInterval = faultTolerantTimeInterval;
    faultTolerantTimeInterval = newFaultTolerantTimeInterval;
    boolean oldFaultTolerantTimeIntervalESet = faultTolerantTimeIntervalESet;
    faultTolerantTimeIntervalESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.SAFETY_CONCEPT__FAULT_TOLERANT_TIME_INTERVAL, oldFaultTolerantTimeInterval, faultTolerantTimeInterval, !oldFaultTolerantTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFaultTolerantTimeInterval()
  {
    Integer oldFaultTolerantTimeInterval = faultTolerantTimeInterval;
    boolean oldFaultTolerantTimeIntervalESet = faultTolerantTimeIntervalESet;
    faultTolerantTimeInterval = FAULT_TOLERANT_TIME_INTERVAL_EDEFAULT;
    faultTolerantTimeIntervalESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.SAFETY_CONCEPT__FAULT_TOLERANT_TIME_INTERVAL, oldFaultTolerantTimeInterval, FAULT_TOLERANT_TIME_INTERVAL_EDEFAULT, oldFaultTolerantTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFaultTolerantTimeInterval()
  {
    return faultTolerantTimeIntervalESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FunctionalSafetyRequirement> getSafetyGoal()
  {
    if (safetyGoal == null)
    {
      safetyGoal = new EObjectResolvingEList<FunctionalSafetyRequirement>(FunctionalSafetyRequirement.class, this, Safe10Package.SAFETY_CONCEPT__SAFETY_GOAL);
    }
    return safetyGoal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AbstractSafetyRequirement> getRequirements()
  {
    if (requirements == null)
    {
      requirements = new EObjectResolvingEList<AbstractSafetyRequirement>(AbstractSafetyRequirement.class, this, Safe10Package.SAFETY_CONCEPT__REQUIREMENTS);
    }
    return requirements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CONCEPT__EMERGENCY_OPERATION_TIME_INTERVAL:
        return getEmergencyOperationTimeInterval();
      case Safe10Package.SAFETY_CONCEPT__FAULT_TOLERANT_TIME_INTERVAL:
        return getFaultTolerantTimeInterval();
      case Safe10Package.SAFETY_CONCEPT__SAFETY_GOAL:
        return getSafetyGoal();
      case Safe10Package.SAFETY_CONCEPT__REQUIREMENTS:
        return getRequirements();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CONCEPT__EMERGENCY_OPERATION_TIME_INTERVAL:
   			setEmergencyOperationTimeInterval((Integer)newValue);
        return;
      case Safe10Package.SAFETY_CONCEPT__FAULT_TOLERANT_TIME_INTERVAL:
   			setFaultTolerantTimeInterval((Integer)newValue);
        return;
      case Safe10Package.SAFETY_CONCEPT__SAFETY_GOAL:
        getSafetyGoal().clear();
        getSafetyGoal().addAll((Collection<? extends FunctionalSafetyRequirement>)newValue);
        return;
      case Safe10Package.SAFETY_CONCEPT__REQUIREMENTS:
        getRequirements().clear();
        getRequirements().addAll((Collection<? extends AbstractSafetyRequirement>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CONCEPT__EMERGENCY_OPERATION_TIME_INTERVAL:
        unsetEmergencyOperationTimeInterval();
        return;
      case Safe10Package.SAFETY_CONCEPT__FAULT_TOLERANT_TIME_INTERVAL:
        unsetFaultTolerantTimeInterval();
        return;
      case Safe10Package.SAFETY_CONCEPT__SAFETY_GOAL:
        getSafetyGoal().clear();
        return;
      case Safe10Package.SAFETY_CONCEPT__REQUIREMENTS:
        getRequirements().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CONCEPT__EMERGENCY_OPERATION_TIME_INTERVAL:
        return isSetEmergencyOperationTimeInterval();
      case Safe10Package.SAFETY_CONCEPT__FAULT_TOLERANT_TIME_INTERVAL:
        return isSetFaultTolerantTimeInterval();
      case Safe10Package.SAFETY_CONCEPT__SAFETY_GOAL:
        return safetyGoal != null && !safetyGoal.isEmpty();
      case Safe10Package.SAFETY_CONCEPT__REQUIREMENTS:
        return requirements != null && !requirements.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (emergencyOperationTimeInterval: ");
    if (emergencyOperationTimeIntervalESet) result.append(emergencyOperationTimeInterval); else result.append("<unset>");
    result.append(", faultTolerantTimeInterval: ");
    if (faultTolerantTimeIntervalESet) result.append(faultTolerantTimeInterval); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //SafetyConceptImpl
