/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.ErrorModel;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SingleLevelSafetyExtension;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Single Level Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.SingleLevelSafetyExtensionImpl#getErrorModel <em>Error Model</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class SingleLevelSafetyExtensionImpl extends SafetyExtensionImpl implements SingleLevelSafetyExtension
{
  /**
   * The cached value of the '{@link #getErrorModel() <em>Error Model</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModel()
   * @generated
   * @ordered
   */
  protected EList<ErrorModel> errorModel;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SingleLevelSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getSingleLevelSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorModel> getErrorModel()
  {
    if (errorModel == null)
    {
      errorModel = new EObjectContainmentEList<ErrorModel>(ErrorModel.class, this, Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION__ERROR_MODEL);
    }
    return errorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION__ERROR_MODEL:
        return ((InternalEList<?>)getErrorModel()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION__ERROR_MODEL:
        return getErrorModel();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION__ERROR_MODEL:
        getErrorModel().clear();
        getErrorModel().addAll((Collection<? extends ErrorModel>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION__ERROR_MODEL:
        getErrorModel().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION__ERROR_MODEL:
        return errorModel != null && !errorModel.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //SingleLevelSafetyExtensionImpl
