/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Tactic;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tactic</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.TacticImpl#getMalfunction <em>Malfunction</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class TacticImpl extends IdentifiableImpl implements Tactic
{
  /**
   * The cached value of the '{@link #getMalfunction() <em>Malfunction</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunction()
   * @generated
   * @ordered
   */
  protected MalfunctionInstanceRef malfunction;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TacticImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getTactic();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionInstanceRef getMalfunction()
  {
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMalfunction(MalfunctionInstanceRef newMalfunction, NotificationChain msgs)
  {
    MalfunctionInstanceRef oldMalfunction = malfunction;
    malfunction = newMalfunction;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.TACTIC__MALFUNCTION, oldMalfunction, newMalfunction);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMalfunction(MalfunctionInstanceRef newMalfunction)
  {
    if (newMalfunction != malfunction)
    {
      NotificationChain msgs = null;
      if (malfunction != null)
        msgs = ((InternalEObject)malfunction).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.TACTIC__MALFUNCTION, null, msgs);
      if (newMalfunction != null)
        msgs = ((InternalEObject)newMalfunction).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.TACTIC__MALFUNCTION, null, msgs);
      msgs = basicSetMalfunction(newMalfunction, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.TACTIC__MALFUNCTION, newMalfunction, newMalfunction));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.TACTIC__MALFUNCTION:
        return basicSetMalfunction(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.TACTIC__MALFUNCTION:
        return getMalfunction();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.TACTIC__MALFUNCTION:
   			setMalfunction((MalfunctionInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.TACTIC__MALFUNCTION:
        	setMalfunction((MalfunctionInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.TACTIC__MALFUNCTION:
        return malfunction != null;
    }
    return super.eIsSet(featureID);
  }

} //TacticImpl
