/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.Identifiable;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Variant;
import org.safe.metamodel.safe10.VariantDescriptionMode;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Variant</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.VariantImpl#getOrigin <em>Origin</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.VariantImpl#getDescriptionMode <em>Description Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.VariantImpl#getExcludedElements <em>Excluded Elements</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.VariantImpl#getIncludedElements <em>Included Elements</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class VariantImpl extends PackageableElementImpl implements Variant
{
  /**
   * The default value of the '{@link #getOrigin() <em>Origin</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOrigin()
   * @generated
   * @ordered
   */
  protected static final String ORIGIN_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getOrigin() <em>Origin</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOrigin()
   * @generated
   * @ordered
   */
  protected String origin = ORIGIN_EDEFAULT;

  /**
   * This is true if the Origin attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean originESet;

  /**
   * The default value of the '{@link #getDescriptionMode() <em>Description Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescriptionMode()
   * @generated
   * @ordered
   */
  protected static final VariantDescriptionMode DESCRIPTION_MODE_EDEFAULT = VariantDescriptionMode.INCLUDED_ELEMENTS;

  /**
   * The cached value of the '{@link #getDescriptionMode() <em>Description Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDescriptionMode()
   * @generated
   * @ordered
   */
  protected VariantDescriptionMode descriptionMode = DESCRIPTION_MODE_EDEFAULT;

  /**
   * This is true if the Description Mode attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean descriptionModeESet;

  /**
   * The cached value of the '{@link #getExcludedElements() <em>Excluded Elements</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExcludedElements()
   * @generated
   * @ordered
   */
  protected EList<Identifiable> excludedElements;

  /**
   * The cached value of the '{@link #getIncludedElements() <em>Included Elements</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIncludedElements()
   * @generated
   * @ordered
   */
  protected EList<Identifiable> includedElements;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected VariantImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getVariant();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getOrigin()
  {
    return origin;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOrigin(String newOrigin)
  {
    String oldOrigin = origin;
    origin = newOrigin;
    boolean oldOriginESet = originESet;
    originESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.VARIANT__ORIGIN, oldOrigin, origin, !oldOriginESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetOrigin()
  {
    String oldOrigin = origin;
    boolean oldOriginESet = originESet;
    origin = ORIGIN_EDEFAULT;
    originESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.VARIANT__ORIGIN, oldOrigin, ORIGIN_EDEFAULT, oldOriginESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetOrigin()
  {
    return originESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariantDescriptionMode getDescriptionMode()
  {
    return descriptionMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDescriptionMode(VariantDescriptionMode newDescriptionMode)
  {
    VariantDescriptionMode oldDescriptionMode = descriptionMode;
    descriptionMode = newDescriptionMode == null ? DESCRIPTION_MODE_EDEFAULT : newDescriptionMode;
    boolean oldDescriptionModeESet = descriptionModeESet;
    descriptionModeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.VARIANT__DESCRIPTION_MODE, oldDescriptionMode, descriptionMode, !oldDescriptionModeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetDescriptionMode()
  {
    VariantDescriptionMode oldDescriptionMode = descriptionMode;
    boolean oldDescriptionModeESet = descriptionModeESet;
    descriptionMode = DESCRIPTION_MODE_EDEFAULT;
    descriptionModeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.VARIANT__DESCRIPTION_MODE, oldDescriptionMode, DESCRIPTION_MODE_EDEFAULT, oldDescriptionModeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetDescriptionMode()
  {
    return descriptionModeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Identifiable> getExcludedElements()
  {
    if (excludedElements == null)
    {
      excludedElements = new EObjectResolvingEList<Identifiable>(Identifiable.class, this, Safe10Package.VARIANT__EXCLUDED_ELEMENTS);
    }
    return excludedElements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Identifiable> getIncludedElements()
  {
    if (includedElements == null)
    {
      includedElements = new EObjectResolvingEList<Identifiable>(Identifiable.class, this, Safe10Package.VARIANT__INCLUDED_ELEMENTS);
    }
    return includedElements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.VARIANT__ORIGIN:
        return getOrigin();
      case Safe10Package.VARIANT__DESCRIPTION_MODE:
        return getDescriptionMode();
      case Safe10Package.VARIANT__EXCLUDED_ELEMENTS:
        return getExcludedElements();
      case Safe10Package.VARIANT__INCLUDED_ELEMENTS:
        return getIncludedElements();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.VARIANT__ORIGIN:
   			setOrigin((String)newValue);
        return;
      case Safe10Package.VARIANT__DESCRIPTION_MODE:
   			setDescriptionMode((VariantDescriptionMode)newValue);
        return;
      case Safe10Package.VARIANT__EXCLUDED_ELEMENTS:
        getExcludedElements().clear();
        getExcludedElements().addAll((Collection<? extends Identifiable>)newValue);
        return;
      case Safe10Package.VARIANT__INCLUDED_ELEMENTS:
        getIncludedElements().clear();
        getIncludedElements().addAll((Collection<? extends Identifiable>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.VARIANT__ORIGIN:
        unsetOrigin();
        return;
      case Safe10Package.VARIANT__DESCRIPTION_MODE:
        unsetDescriptionMode();
        return;
      case Safe10Package.VARIANT__EXCLUDED_ELEMENTS:
        getExcludedElements().clear();
        return;
      case Safe10Package.VARIANT__INCLUDED_ELEMENTS:
        getIncludedElements().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.VARIANT__ORIGIN:
        return isSetOrigin();
      case Safe10Package.VARIANT__DESCRIPTION_MODE:
        return isSetDescriptionMode();
      case Safe10Package.VARIANT__EXCLUDED_ELEMENTS:
        return excludedElements != null && !excludedElements.isEmpty();
      case Safe10Package.VARIANT__INCLUDED_ELEMENTS:
        return includedElements != null && !includedElements.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (origin: ");
    if (originESet) result.append(origin); else result.append("<unset>");
    result.append(", descriptionMode: ");
    if (descriptionModeESet) result.append(descriptionMode); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //VariantImpl
