/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.WarningAndDegradation;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Warning And Degradation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.WarningAndDegradationImpl#getDriverActions <em>Driver Actions</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.WarningAndDegradationImpl#getMeansAndControls <em>Means And Controls</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.WarningAndDegradationImpl#getOperationsTimeInterval <em>Operations Time Interval</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class WarningAndDegradationImpl extends FunctionalSafetyRequirementImpl implements WarningAndDegradation
{
  /**
   * The default value of the '{@link #getDriverActions() <em>Driver Actions</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDriverActions()
   * @generated
   * @ordered
   */
  protected static final String DRIVER_ACTIONS_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getDriverActions() <em>Driver Actions</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDriverActions()
   * @generated
   * @ordered
   */
  protected String driverActions = DRIVER_ACTIONS_EDEFAULT;

  /**
   * This is true if the Driver Actions attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean driverActionsESet;

  /**
   * The default value of the '{@link #getMeansAndControls() <em>Means And Controls</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMeansAndControls()
   * @generated
   * @ordered
   */
  protected static final String MEANS_AND_CONTROLS_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getMeansAndControls() <em>Means And Controls</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMeansAndControls()
   * @generated
   * @ordered
   */
  protected String meansAndControls = MEANS_AND_CONTROLS_EDEFAULT;

  /**
   * This is true if the Means And Controls attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean meansAndControlsESet;

  /**
   * The default value of the '{@link #getOperationsTimeInterval() <em>Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperationsTimeInterval()
   * @generated
   * @ordered
   */
  protected static final Integer OPERATIONS_TIME_INTERVAL_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getOperationsTimeInterval() <em>Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperationsTimeInterval()
   * @generated
   * @ordered
   */
  protected Integer operationsTimeInterval = OPERATIONS_TIME_INTERVAL_EDEFAULT;

  /**
   * This is true if the Operations Time Interval attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean operationsTimeIntervalESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WarningAndDegradationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getWarningAndDegradation();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDriverActions()
  {
    return driverActions;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDriverActions(String newDriverActions)
  {
    String oldDriverActions = driverActions;
    driverActions = newDriverActions;
    boolean oldDriverActionsESet = driverActionsESet;
    driverActionsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.WARNING_AND_DEGRADATION__DRIVER_ACTIONS, oldDriverActions, driverActions, !oldDriverActionsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetDriverActions()
  {
    String oldDriverActions = driverActions;
    boolean oldDriverActionsESet = driverActionsESet;
    driverActions = DRIVER_ACTIONS_EDEFAULT;
    driverActionsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.WARNING_AND_DEGRADATION__DRIVER_ACTIONS, oldDriverActions, DRIVER_ACTIONS_EDEFAULT, oldDriverActionsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetDriverActions()
  {
    return driverActionsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMeansAndControls()
  {
    return meansAndControls;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMeansAndControls(String newMeansAndControls)
  {
    String oldMeansAndControls = meansAndControls;
    meansAndControls = newMeansAndControls;
    boolean oldMeansAndControlsESet = meansAndControlsESet;
    meansAndControlsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.WARNING_AND_DEGRADATION__MEANS_AND_CONTROLS, oldMeansAndControls, meansAndControls, !oldMeansAndControlsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetMeansAndControls()
  {
    String oldMeansAndControls = meansAndControls;
    boolean oldMeansAndControlsESet = meansAndControlsESet;
    meansAndControls = MEANS_AND_CONTROLS_EDEFAULT;
    meansAndControlsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.WARNING_AND_DEGRADATION__MEANS_AND_CONTROLS, oldMeansAndControls, MEANS_AND_CONTROLS_EDEFAULT, oldMeansAndControlsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetMeansAndControls()
  {
    return meansAndControlsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getOperationsTimeInterval()
  {
    return operationsTimeInterval;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOperationsTimeInterval(Integer newOperationsTimeInterval)
  {
    Integer oldOperationsTimeInterval = operationsTimeInterval;
    operationsTimeInterval = newOperationsTimeInterval;
    boolean oldOperationsTimeIntervalESet = operationsTimeIntervalESet;
    operationsTimeIntervalESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.WARNING_AND_DEGRADATION__OPERATIONS_TIME_INTERVAL, oldOperationsTimeInterval, operationsTimeInterval, !oldOperationsTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetOperationsTimeInterval()
  {
    Integer oldOperationsTimeInterval = operationsTimeInterval;
    boolean oldOperationsTimeIntervalESet = operationsTimeIntervalESet;
    operationsTimeInterval = OPERATIONS_TIME_INTERVAL_EDEFAULT;
    operationsTimeIntervalESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.WARNING_AND_DEGRADATION__OPERATIONS_TIME_INTERVAL, oldOperationsTimeInterval, OPERATIONS_TIME_INTERVAL_EDEFAULT, oldOperationsTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetOperationsTimeInterval()
  {
    return operationsTimeIntervalESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION__DRIVER_ACTIONS:
        return getDriverActions();
      case Safe10Package.WARNING_AND_DEGRADATION__MEANS_AND_CONTROLS:
        return getMeansAndControls();
      case Safe10Package.WARNING_AND_DEGRADATION__OPERATIONS_TIME_INTERVAL:
        return getOperationsTimeInterval();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION__DRIVER_ACTIONS:
   			setDriverActions((String)newValue);
        return;
      case Safe10Package.WARNING_AND_DEGRADATION__MEANS_AND_CONTROLS:
   			setMeansAndControls((String)newValue);
        return;
      case Safe10Package.WARNING_AND_DEGRADATION__OPERATIONS_TIME_INTERVAL:
   			setOperationsTimeInterval((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION__DRIVER_ACTIONS:
        unsetDriverActions();
        return;
      case Safe10Package.WARNING_AND_DEGRADATION__MEANS_AND_CONTROLS:
        unsetMeansAndControls();
        return;
      case Safe10Package.WARNING_AND_DEGRADATION__OPERATIONS_TIME_INTERVAL:
        unsetOperationsTimeInterval();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION__DRIVER_ACTIONS:
        return isSetDriverActions();
      case Safe10Package.WARNING_AND_DEGRADATION__MEANS_AND_CONTROLS:
        return isSetMeansAndControls();
      case Safe10Package.WARNING_AND_DEGRADATION__OPERATIONS_TIME_INTERVAL:
        return isSetOperationsTimeInterval();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (driverActions: ");
    if (driverActionsESet) result.append(driverActions); else result.append("<unset>");
    result.append(", meansAndControls: ");
    if (meansAndControlsESet) result.append(meansAndControls); else result.append("<unset>");
    result.append(", operationsTimeInterval: ");
    if (operationsTimeIntervalESet) result.append(operationsTimeInterval); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //WarningAndDegradationImpl
