/**
 */
package org.safe.metamodel.safe10.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.safe.metamodel.safe10.AUTOSARRunnableEntitySequenceConstraint;
import org.safe.metamodel.safe10.AUTOSARSequenceConstraint;
import org.safe.metamodel.safe10.AbstractErrorBehavior;
import org.safe.metamodel.safe10.AbstractQuantifiableSafetyRequirement;
import org.safe.metamodel.safe10.AbstractReference;
import org.safe.metamodel.safe10.AbstractSafetyRequirement;
import org.safe.metamodel.safe10.Actor;
import org.safe.metamodel.safe10.ActuatorError;
import org.safe.metamodel.safe10.ActuatorErrorDetection;
import org.safe.metamodel.safe10.ActuatorMonitor;
import org.safe.metamodel.safe10.AlivenessCheckpointTooEarly;
import org.safe.metamodel.safe10.AlivenessCheckpointTooLate;
import org.safe.metamodel.safe10.AlivenessCheckpointTooOften;
import org.safe.metamodel.safe10.AlivenessMonitor;
import org.safe.metamodel.safe10.AllocatableElement;
import org.safe.metamodel.safe10.AllocationTargets;
import org.safe.metamodel.safe10.AnalysisReport;
import org.safe.metamodel.safe10.Application;
import org.safe.metamodel.safe10.Assumption;
import org.safe.metamodel.safe10.AutosarAbstractComponentInstanceRef;
import org.safe.metamodel.safe10.AutosarAbstractPortInComponentInstanceRef;
import org.safe.metamodel.safe10.AutosarActuatorMonitor;
import org.safe.metamodel.safe10.AutosarAlivenessMonitor;
import org.safe.metamodel.safe10.AutosarCRC;
import org.safe.metamodel.safe10.AutosarCheckPoint;
import org.safe.metamodel.safe10.AutosarClientServerOperationInstanceRef;
import org.safe.metamodel.safe10.AutosarComparison;
import org.safe.metamodel.safe10.AutosarComparisonParam;
import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarContext;
import org.safe.metamodel.safe10.AutosarContextRangeCheck;
import org.safe.metamodel.safe10.AutosarEvaluationFunction;
import org.safe.metamodel.safe10.AutosarGradientCheck;
import org.safe.metamodel.safe10.AutosarHardwareSafetyExtension;
import org.safe.metamodel.safe10.AutosarInstanceRef;
import org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarPortInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarReference;
import org.safe.metamodel.safe10.AutosarSafetyExtension;
import org.safe.metamodel.safe10.AutosarSystemSafetyExtension;
import org.safe.metamodel.safe10.AutosarUndefinedInstanceRef;
import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.AutosarVfbSafetyExtension;
import org.safe.metamodel.safe10.Avoid;
import org.safe.metamodel.safe10.BooleanConfigParameterValue;
import org.safe.metamodel.safe10.CHROMOSOMEHealthMonitorNotification;
import org.safe.metamodel.safe10.CHROMOSOMEReference;
import org.safe.metamodel.safe10.CRC;
import org.safe.metamodel.safe10.CRCConfig;
import org.safe.metamodel.safe10.CRCErrorDetection;
import org.safe.metamodel.safe10.CRCFailed;
import org.safe.metamodel.safe10.CheckPoint;
import org.safe.metamodel.safe10.ChromosomeApplicationHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeApplicationSafetyExtension;
import org.safe.metamodel.safe10.ChromosomeComparison;
import org.safe.metamodel.safe10.ChromosomeComparisonParameter;
import org.safe.metamodel.safe10.ChromosomeComponentModeCondition;
import org.safe.metamodel.safe10.ChromosomeCpuSelfTest;
import org.safe.metamodel.safe10.ChromosomeErrorEventCondition;
import org.safe.metamodel.safe10.ChromosomeErrorHandler;
import org.safe.metamodel.safe10.ChromosomeHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeHeartbeatReceiver;
import org.safe.metamodel.safe10.ChromosomeHeartbeatSender;
import org.safe.metamodel.safe10.ChromosomeMemoryTest;
import org.safe.metamodel.safe10.ChromosomeNodeHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeSafeExtension;
import org.safe.metamodel.safe10.ChromosomeSystemSafetyExtension;
import org.safe.metamodel.safe10.ChromosomeVoter;
import org.safe.metamodel.safe10.ChromosomeVoterParameter;
import org.safe.metamodel.safe10.CodeGenerationConfiguration;
import org.safe.metamodel.safe10.Comparison;
import org.safe.metamodel.safe10.ComparisonDetection;
import org.safe.metamodel.safe10.ComparisonFalse;
import org.safe.metamodel.safe10.ComparisonParameter;
import org.safe.metamodel.safe10.ComparisonTrue;
import org.safe.metamodel.safe10.Component;
import org.safe.metamodel.safe10.ComponentModeInstanceRef;
import org.safe.metamodel.safe10.ComponentPrototypeCRC;
import org.safe.metamodel.safe10.ConfigParameter;
import org.safe.metamodel.safe10.ConfigParameterValue;
import org.safe.metamodel.safe10.ConstantComparisonParameter;
import org.safe.metamodel.safe10.Context;
import org.safe.metamodel.safe10.ContextParameter;
import org.safe.metamodel.safe10.ContextRangeCheck;
import org.safe.metamodel.safe10.ContextRangeCheckDetection;
import org.safe.metamodel.safe10.ControlBlock;
import org.safe.metamodel.safe10.ControlFlowError;
import org.safe.metamodel.safe10.ControlFlowErrorDetection;
import org.safe.metamodel.safe10.ControlFlowMonitor;
import org.safe.metamodel.safe10.ControllabilityReference;
import org.safe.metamodel.safe10.CpuSelfTest;
import org.safe.metamodel.safe10.CpuSelfTestConfig;
import org.safe.metamodel.safe10.CpuSelfTestDetection;
import org.safe.metamodel.safe10.CpuSelfTestFailed;
import org.safe.metamodel.safe10.DesignLevelSafetyExtension;
import org.safe.metamodel.safe10.DesignSpecification;
import org.safe.metamodel.safe10.Detect;
import org.safe.metamodel.safe10.EMPAnalysis;
import org.safe.metamodel.safe10.EMPBswModule;
import org.safe.metamodel.safe10.EMPDesign;
import org.safe.metamodel.safe10.EMPHwComponent;
import org.safe.metamodel.safe10.EMPReference;
import org.safe.metamodel.safe10.EMPSwComponent;
import org.safe.metamodel.safe10.EMTypeAnalysis;
import org.safe.metamodel.safe10.EMTypeApplicationEnvironment;
import org.safe.metamodel.safe10.EMTypeBswModule;
import org.safe.metamodel.safe10.EMTypeDesign;
import org.safe.metamodel.safe10.EMTypeHwComponent;
import org.safe.metamodel.safe10.EMTypeSwComponent;
import org.safe.metamodel.safe10.EastADLErrorBehavior;
import org.safe.metamodel.safe10.EastAdlReference;
import org.safe.metamodel.safe10.ErrorBehaviorMapping;
import org.safe.metamodel.safe10.ErrorModel;
import org.safe.metamodel.safe10.ErrorModelInstanceRef;
import org.safe.metamodel.safe10.ErrorModelMapping;
import org.safe.metamodel.safe10.ErrorModelPrototype;
import org.safe.metamodel.safe10.ErrorModelPrototype_analysisFunctionTarget;
import org.safe.metamodel.safe10.ErrorModelPrototype_designFunctionTarget;
import org.safe.metamodel.safe10.ErrorModelPrototype_hwTarget;
import org.safe.metamodel.safe10.ErrorModelType;
import org.safe.metamodel.safe10.EvaluationFunction;
import org.safe.metamodel.safe10.FMEAReport;
import org.safe.metamodel.safe10.FailureLogicFormula;
import org.safe.metamodel.safe10.FailureRate;
import org.safe.metamodel.safe10.FaultFailurePort_functionTarget;
import org.safe.metamodel.safe10.FaultFailurePort_hwPinTarget;
import org.safe.metamodel.safe10.FaultFailurePort_hwPortTarget;
import org.safe.metamodel.safe10.FaultFailurePropagationLink;
import org.safe.metamodel.safe10.FieldTestProtocol;
import org.safe.metamodel.safe10.Filter;
import org.safe.metamodel.safe10.FilterBasedHandling;
import org.safe.metamodel.safe10.FilterError;
import org.safe.metamodel.safe10.FilterExpression;
import org.safe.metamodel.safe10.FilterParameter;
import org.safe.metamodel.safe10.FloatConfigParameterValue;
import org.safe.metamodel.safe10.FormulaDocumentation;
import org.safe.metamodel.safe10.FormulaExpression;
import org.safe.metamodel.safe10.FunctionalSafetyExtension;
import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Goal;
import org.safe.metamodel.safe10.GradientCheck;
import org.safe.metamodel.safe10.GradientCheckDetection;
import org.safe.metamodel.safe10.GradientTooHigh;
import org.safe.metamodel.safe10.GradientTooLow;
import org.safe.metamodel.safe10.HWArchitecturalMetrics;
import org.safe.metamodel.safe10.HWComponentPrototypeScope;
import org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart;
import org.safe.metamodel.safe10.HWElementFailureRateClass;
import org.safe.metamodel.safe10.HWElementPrototypeScope;
import org.safe.metamodel.safe10.HWElementScopeInstanceRef;
import org.safe.metamodel.safe10.HWFMSingleContribution;
import org.safe.metamodel.safe10.HWFMSingleContributionFormula;
import org.safe.metamodel.safe10.HWFailureClassContainer;
import org.safe.metamodel.safe10.HWFailureClassContributionFormula;
import org.safe.metamodel.safe10.HWFailureMode;
import org.safe.metamodel.safe10.HWFailureRate;
import org.safe.metamodel.safe10.HWFault;
import org.safe.metamodel.safe10.HWLambdaPartFormula;
import org.safe.metamodel.safe10.HWLatentFaultMetric;
import org.safe.metamodel.safe10.HWLatentFaultMetricFormula;
import org.safe.metamodel.safe10.HWPMHF;
import org.safe.metamodel.safe10.HWPMHFFormula;
import org.safe.metamodel.safe10.HWPartFailure;
import org.safe.metamodel.safe10.HWPartFailureAnalysis;
import org.safe.metamodel.safe10.HWPartFailureMode;
import org.safe.metamodel.safe10.HWPartFailureRate;
import org.safe.metamodel.safe10.HWProbabilisticValue;
import org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis;
import org.safe.metamodel.safe10.HWSinglePointFaultMetric;
import org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula;
import org.safe.metamodel.safe10.Handle;
import org.safe.metamodel.safe10.HardwareComponentFailure;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.HardwareSafetyExtension;
import org.safe.metamodel.safe10.HardwareSafetyRequirement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification;
import org.safe.metamodel.safe10.Hazard;
import org.safe.metamodel.safe10.HazardandRiskSafetyExtension;
import org.safe.metamodel.safe10.HazardousEvent;
import org.safe.metamodel.safe10.HealthMonitor;
import org.safe.metamodel.safe10.HealthMonitorErrorCondition;
import org.safe.metamodel.safe10.HealthMonitoring;
import org.safe.metamodel.safe10.HeartBeatDeadlineMissed;
import org.safe.metamodel.safe10.HeartBeatDetection;
import org.safe.metamodel.safe10.Heartbeat;
import org.safe.metamodel.safe10.HeartbeatConfig;
import org.safe.metamodel.safe10.HeartbeatReceiver;
import org.safe.metamodel.safe10.HeartbeatSender;
import org.safe.metamodel.safe10.HwComponentScopeInstanceRef;
import org.safe.metamodel.safe10.Identifiable;
import org.safe.metamodel.safe10.IdentifierConfigParameterValue;
import org.safe.metamodel.safe10.ImplementationSafetyExtension;
import org.safe.metamodel.safe10.InputBlock;
import org.safe.metamodel.safe10.IntegerConfigParameterValue;
import org.safe.metamodel.safe10.InterfaceCRC;
import org.safe.metamodel.safe10.Item;
import org.safe.metamodel.safe10.ItemFunctionDescription;
import org.safe.metamodel.safe10.Justification;
import org.safe.metamodel.safe10.MFPBswPort;
import org.safe.metamodel.safe10.MFPFunctionPort;
import org.safe.metamodel.safe10.MFPHardwarePin;
import org.safe.metamodel.safe10.MFPHardwarePort;
import org.safe.metamodel.safe10.MFPOperation;
import org.safe.metamodel.safe10.MFPSwcPort;
import org.safe.metamodel.safe10.MFPVariable;
import org.safe.metamodel.safe10.MTComposite;
import org.safe.metamodel.safe10.MTCompositeElementPrototype;
import org.safe.metamodel.safe10.MTPrimitive;
import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.MalfunctionMapping;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.MemoryRange;
import org.safe.metamodel.safe10.MemorySelfTest;
import org.safe.metamodel.safe10.MemorySelfTestConfig;
import org.safe.metamodel.safe10.MemorySelfTestFailed;
import org.safe.metamodel.safe10.MemorySelfTesting;
import org.safe.metamodel.safe10.MultiLevelSafetyExtension;
import org.safe.metamodel.safe10.NativeErrorBehavior;
import org.safe.metamodel.safe10.Node;
import org.safe.metamodel.safe10.OperatingMode;
import org.safe.metamodel.safe10.OperationBlock;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.OutputBlock;
import org.safe.metamodel.safe10.PackageableElement;
import org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty;
import org.safe.metamodel.safe10.QuantifiedHWProperty;
import org.safe.metamodel.safe10.QuantitativeErrorModel;
import org.safe.metamodel.safe10.RangeCheckContext;
import org.safe.metamodel.safe10.Referrable;
import org.safe.metamodel.safe10.RequirementsLink;
import org.safe.metamodel.safe10.RequirementsReleationship;
import org.safe.metamodel.safe10.Restrictable;
import org.safe.metamodel.safe10.Restriction;
import org.safe.metamodel.safe10.RiskDescription;
import org.safe.metamodel.safe10.RunnableEntitySequenceElement;
import org.safe.metamodel.safe10.SAFE;
import org.safe.metamodel.safe10.SAFEElement;
import org.safe.metamodel.safe10.SAFEPackage;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeState;
import org.safe.metamodel.safe10.SafetyCase;
import org.safe.metamodel.safe10.SafetyConcept;
import org.safe.metamodel.safe10.SafetyExtension;
import org.safe.metamodel.safe10.Satisfy;
import org.safe.metamodel.safe10.SequenceBlock;
import org.safe.metamodel.safe10.SingleLevelSafetyExtension;
import org.safe.metamodel.safe10.Situation;
import org.safe.metamodel.safe10.SoftwareAlivenessDetection;
import org.safe.metamodel.safe10.SoftwareSafetyExtension;
import org.safe.metamodel.safe10.SoftwareSafetyRequirement;
import org.safe.metamodel.safe10.Solution;
import org.safe.metamodel.safe10.Strategy;
import org.safe.metamodel.safe10.StringConfigParameterValue;
import org.safe.metamodel.safe10.Tactic;
import org.safe.metamodel.safe10.TechnicalSafetyExtension;
import org.safe.metamodel.safe10.TechnicalSafetyRequirement;
import org.safe.metamodel.safe10.TestProtocol;
import org.safe.metamodel.safe10.Topic;
import org.safe.metamodel.safe10.TraceableSpecification;
import org.safe.metamodel.safe10.UnitTestProtocol;
import org.safe.metamodel.safe10.ValueAboveRange;
import org.safe.metamodel.safe10.ValueBelowRange;
import org.safe.metamodel.safe10.Variant;
import org.safe.metamodel.safe10.Verify;
import org.safe.metamodel.safe10.Voter;
import org.safe.metamodel.safe10.VoterConfig;
import org.safe.metamodel.safe10.VoterNoConsensus;
import org.safe.metamodel.safe10.VoterParameter;
import org.safe.metamodel.safe10.VoterValueMismatch;
import org.safe.metamodel.safe10.Voting;
import org.safe.metamodel.safe10.WarningAndDegradation;
import org.safe.metamodel.safe10.WarningAndDegradationHandle;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package
 * @generated
 */
public class Safe10AdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static Safe10Package modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Safe10AdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = Safe10Package.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Safe10Switch<Adapter> modelSwitch =
    new Safe10Switch<Adapter>()
    {
      @Override
      public Adapter caseFilterExpression(FilterExpression object)
      {
        return createFilterExpressionAdapter();
      }
      @Override
      public Adapter caseFormulaExpression(FormulaExpression object)
      {
        return createFormulaExpressionAdapter();
      }
      @Override
      public Adapter caseAbstractReference(AbstractReference object)
      {
        return createAbstractReferenceAdapter();
      }
      @Override
      public Adapter caseAutosarReference(AutosarReference object)
      {
        return createAutosarReferenceAdapter();
      }
      @Override
      public Adapter caseCHROMOSOMEReference(CHROMOSOMEReference object)
      {
        return createCHROMOSOMEReferenceAdapter();
      }
      @Override
      public Adapter caseEastAdlReference(EastAdlReference object)
      {
        return createEastAdlReferenceAdapter();
      }
      @Override
      public Adapter caseApplication(Application object)
      {
        return createApplicationAdapter();
      }
      @Override
      public Adapter caseComponent(Component object)
      {
        return createComponentAdapter();
      }
      @Override
      public Adapter caseComponentModeInstanceRef(ComponentModeInstanceRef object)
      {
        return createComponentModeInstanceRefAdapter();
      }
      @Override
      public Adapter caseNode(Node object)
      {
        return createNodeAdapter();
      }
      @Override
      public Adapter caseSystem(org.safe.metamodel.safe10.System object)
      {
        return createSystemAdapter();
      }
      @Override
      public Adapter caseTopic(Topic object)
      {
        return createTopicAdapter();
      }
      @Override
      public Adapter caseMultiLevelSafetyExtension(MultiLevelSafetyExtension object)
      {
        return createMultiLevelSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseSafetyExtension(SafetyExtension object)
      {
        return createSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseSingleLevelSafetyExtension(SingleLevelSafetyExtension object)
      {
        return createSingleLevelSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseFunctionalSafetyExtension(FunctionalSafetyExtension object)
      {
        return createFunctionalSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseHazardandRiskSafetyExtension(HazardandRiskSafetyExtension object)
      {
        return createHazardandRiskSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseAutosarHardwareSafetyExtension(AutosarHardwareSafetyExtension object)
      {
        return createAutosarHardwareSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseAutosarSafetyExtension(AutosarSafetyExtension object)
      {
        return createAutosarSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseAutosarSystemSafetyExtension(AutosarSystemSafetyExtension object)
      {
        return createAutosarSystemSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseAutosarVfbSafetyExtension(AutosarVfbSafetyExtension object)
      {
        return createAutosarVfbSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseChromosomeApplicationSafetyExtension(ChromosomeApplicationSafetyExtension object)
      {
        return createChromosomeApplicationSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseChromosomeSafeExtension(ChromosomeSafeExtension object)
      {
        return createChromosomeSafeExtensionAdapter();
      }
      @Override
      public Adapter caseChromosomeSystemSafetyExtension(ChromosomeSystemSafetyExtension object)
      {
        return createChromosomeSystemSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseImplementationSafetyExtension(ImplementationSafetyExtension object)
      {
        return createImplementationSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseDesignLevelSafetyExtension(DesignLevelSafetyExtension object)
      {
        return createDesignLevelSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseHardwareSafetyExtension(HardwareSafetyExtension object)
      {
        return createHardwareSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseSoftwareSafetyExtension(SoftwareSafetyExtension object)
      {
        return createSoftwareSafetyExtensionAdapter();
      }
      @Override
      public Adapter caseTechnicalSafetyExtension(TechnicalSafetyExtension object)
      {
        return createTechnicalSafetyExtensionAdapter();
      }
      @Override
      public Adapter casePackageableElement(PackageableElement object)
      {
        return createPackageableElementAdapter();
      }
      @Override
      public Adapter caseReferrable(Referrable object)
      {
        return createReferrableAdapter();
      }
      @Override
      public Adapter caseSAFE(SAFE object)
      {
        return createSAFEAdapter();
      }
      @Override
      public Adapter caseSAFEElement(SAFEElement object)
      {
        return createSAFEElementAdapter();
      }
      @Override
      public Adapter caseSAFEPackage(SAFEPackage object)
      {
        return createSAFEPackageAdapter();
      }
      @Override
      public Adapter caseIdentifiable(Identifiable object)
      {
        return createIdentifiableAdapter();
      }
      @Override
      public Adapter caseAutosarAbstractComponentInstanceRef(AutosarAbstractComponentInstanceRef object)
      {
        return createAutosarAbstractComponentInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarAbstractPortInComponentInstanceRef(AutosarAbstractPortInComponentInstanceRef object)
      {
        return createAutosarAbstractPortInComponentInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarClientServerOperationInstanceRef(AutosarClientServerOperationInstanceRef object)
      {
        return createAutosarClientServerOperationInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarComponentInCompositionInstanceRef(AutosarComponentInCompositionInstanceRef object)
      {
        return createAutosarComponentInCompositionInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarInstanceRef(AutosarInstanceRef object)
      {
        return createAutosarInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarModeInPortFromComponentInCompositionInstanceRef(AutosarModeInPortFromComponentInCompositionInstanceRef object)
      {
        return createAutosarModeInPortFromComponentInCompositionInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarPortInCompositionInstanceRef(AutosarPortInCompositionInstanceRef object)
      {
        return createAutosarPortInCompositionInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarUndefinedInstanceRef(AutosarUndefinedInstanceRef object)
      {
        return createAutosarUndefinedInstanceRefAdapter();
      }
      @Override
      public Adapter caseAutosarVariableDataPrototypeInstanceRef(AutosarVariableDataPrototypeInstanceRef object)
      {
        return createAutosarVariableDataPrototypeInstanceRefAdapter();
      }
      @Override
      public Adapter caseRestrictable(Restrictable object)
      {
        return createRestrictableAdapter();
      }
      @Override
      public Adapter caseRestriction(Restriction object)
      {
        return createRestrictionAdapter();
      }
      @Override
      public Adapter caseVariant(Variant object)
      {
        return createVariantAdapter();
      }
      @Override
      public Adapter caseErrorModel(ErrorModel object)
      {
        return createErrorModelAdapter();
      }
      @Override
      public Adapter caseErrorModelInstanceRef(ErrorModelInstanceRef object)
      {
        return createErrorModelInstanceRefAdapter();
      }
      @Override
      public Adapter caseErrorModelPrototype_analysisFunctionTarget(ErrorModelPrototype_analysisFunctionTarget object)
      {
        return createErrorModelPrototype_analysisFunctionTargetAdapter();
      }
      @Override
      public Adapter caseErrorModelPrototype_designFunctionTarget(ErrorModelPrototype_designFunctionTarget object)
      {
        return createErrorModelPrototype_designFunctionTargetAdapter();
      }
      @Override
      public Adapter caseErrorModelPrototype_hwTarget(ErrorModelPrototype_hwTarget object)
      {
        return createErrorModelPrototype_hwTargetAdapter();
      }
      @Override
      public Adapter caseFaultFailurePort_functionTarget(FaultFailurePort_functionTarget object)
      {
        return createFaultFailurePort_functionTargetAdapter();
      }
      @Override
      public Adapter caseFaultFailurePort_hwPinTarget(FaultFailurePort_hwPinTarget object)
      {
        return createFaultFailurePort_hwPinTargetAdapter();
      }
      @Override
      public Adapter caseFaultFailurePort_hwPortTarget(FaultFailurePort_hwPortTarget object)
      {
        return createFaultFailurePort_hwPortTargetAdapter();
      }
      @Override
      public Adapter caseMalfunctionInstanceRef(MalfunctionInstanceRef object)
      {
        return createMalfunctionInstanceRefAdapter();
      }
      @Override
      public Adapter caseAbstractErrorBehavior(AbstractErrorBehavior object)
      {
        return createAbstractErrorBehaviorAdapter();
      }
      @Override
      public Adapter caseEastADLErrorBehavior(EastADLErrorBehavior object)
      {
        return createEastADLErrorBehaviorAdapter();
      }
      @Override
      public Adapter caseFailureLogicFormula(FailureLogicFormula object)
      {
        return createFailureLogicFormulaAdapter();
      }
      @Override
      public Adapter caseNativeErrorBehavior(NativeErrorBehavior object)
      {
        return createNativeErrorBehaviorAdapter();
      }
      @Override
      public Adapter caseEMPAnalysis(EMPAnalysis object)
      {
        return createEMPAnalysisAdapter();
      }
      @Override
      public Adapter caseEMPBswModule(EMPBswModule object)
      {
        return createEMPBswModuleAdapter();
      }
      @Override
      public Adapter caseEMPDesign(EMPDesign object)
      {
        return createEMPDesignAdapter();
      }
      @Override
      public Adapter caseEMPHwComponent(EMPHwComponent object)
      {
        return createEMPHwComponentAdapter();
      }
      @Override
      public Adapter caseEMPReference(EMPReference object)
      {
        return createEMPReferenceAdapter();
      }
      @Override
      public Adapter caseEMPSwComponent(EMPSwComponent object)
      {
        return createEMPSwComponentAdapter();
      }
      @Override
      public Adapter caseEMTypeAnalysis(EMTypeAnalysis object)
      {
        return createEMTypeAnalysisAdapter();
      }
      @Override
      public Adapter caseEMTypeApplicationEnvironment(EMTypeApplicationEnvironment object)
      {
        return createEMTypeApplicationEnvironmentAdapter();
      }
      @Override
      public Adapter caseEMTypeBswModule(EMTypeBswModule object)
      {
        return createEMTypeBswModuleAdapter();
      }
      @Override
      public Adapter caseEMTypeDesign(EMTypeDesign object)
      {
        return createEMTypeDesignAdapter();
      }
      @Override
      public Adapter caseEMTypeHwComponent(EMTypeHwComponent object)
      {
        return createEMTypeHwComponentAdapter();
      }
      @Override
      public Adapter caseEMTypeSwComponent(EMTypeSwComponent object)
      {
        return createEMTypeSwComponentAdapter();
      }
      @Override
      public Adapter caseErrorModelPrototype(ErrorModelPrototype object)
      {
        return createErrorModelPrototypeAdapter();
      }
      @Override
      public Adapter caseErrorModelType(ErrorModelType object)
      {
        return createErrorModelTypeAdapter();
      }
      @Override
      public Adapter caseFaultFailurePropagationLink(FaultFailurePropagationLink object)
      {
        return createFaultFailurePropagationLinkAdapter();
      }
      @Override
      public Adapter caseFailureRate(FailureRate object)
      {
        return createFailureRateAdapter();
      }
      @Override
      public Adapter caseQuantitativeErrorModel(QuantitativeErrorModel object)
      {
        return createQuantitativeErrorModelAdapter();
      }
      @Override
      public Adapter caseMalfunctionPrototype(MalfunctionPrototype object)
      {
        return createMalfunctionPrototypeAdapter();
      }
      @Override
      public Adapter caseMalfunctionType(MalfunctionType object)
      {
        return createMalfunctionTypeAdapter();
      }
      @Override
      public Adapter caseMFPBswPort(MFPBswPort object)
      {
        return createMFPBswPortAdapter();
      }
      @Override
      public Adapter caseMFPFunctionPort(MFPFunctionPort object)
      {
        return createMFPFunctionPortAdapter();
      }
      @Override
      public Adapter caseMFPHardwarePin(MFPHardwarePin object)
      {
        return createMFPHardwarePinAdapter();
      }
      @Override
      public Adapter caseMFPHardwarePort(MFPHardwarePort object)
      {
        return createMFPHardwarePortAdapter();
      }
      @Override
      public Adapter caseMFPOperation(MFPOperation object)
      {
        return createMFPOperationAdapter();
      }
      @Override
      public Adapter caseMFPSwcPort(MFPSwcPort object)
      {
        return createMFPSwcPortAdapter();
      }
      @Override
      public Adapter caseMFPVariable(MFPVariable object)
      {
        return createMFPVariableAdapter();
      }
      @Override
      public Adapter caseMTComposite(MTComposite object)
      {
        return createMTCompositeAdapter();
      }
      @Override
      public Adapter caseMTCompositeElementPrototype(MTCompositeElementPrototype object)
      {
        return createMTCompositeElementPrototypeAdapter();
      }
      @Override
      public Adapter caseMTPrimitive(MTPrimitive object)
      {
        return createMTPrimitiveAdapter();
      }
      @Override
      public Adapter caseErrorBehaviorMapping(ErrorBehaviorMapping object)
      {
        return createErrorBehaviorMappingAdapter();
      }
      @Override
      public Adapter caseErrorModelMapping(ErrorModelMapping object)
      {
        return createErrorModelMappingAdapter();
      }
      @Override
      public Adapter caseMalfunctionMapping(MalfunctionMapping object)
      {
        return createMalfunctionMappingAdapter();
      }
      @Override
      public Adapter caseFormulaDocumentation(FormulaDocumentation object)
      {
        return createFormulaDocumentationAdapter();
      }
      @Override
      public Adapter caseHWFailureClassContributionFormula(HWFailureClassContributionFormula object)
      {
        return createHWFailureClassContributionFormulaAdapter();
      }
      @Override
      public Adapter caseHWFMSingleContributionFormula(HWFMSingleContributionFormula object)
      {
        return createHWFMSingleContributionFormulaAdapter();
      }
      @Override
      public Adapter caseHWLambdaPartFormula(HWLambdaPartFormula object)
      {
        return createHWLambdaPartFormulaAdapter();
      }
      @Override
      public Adapter caseHWLatentFaultMetricFormula(HWLatentFaultMetricFormula object)
      {
        return createHWLatentFaultMetricFormulaAdapter();
      }
      @Override
      public Adapter caseHWPMHFFormula(HWPMHFFormula object)
      {
        return createHWPMHFFormulaAdapter();
      }
      @Override
      public Adapter caseHWSinglePointFaultMetricFormula(HWSinglePointFaultMetricFormula object)
      {
        return createHWSinglePointFaultMetricFormulaAdapter();
      }
      @Override
      public Adapter caseHardwareFailureAnalysis(HardwareFailureAnalysis object)
      {
        return createHardwareFailureAnalysisAdapter();
      }
      @Override
      public Adapter caseHardwareComponentFailure(HardwareComponentFailure object)
      {
        return createHardwareComponentFailureAdapter();
      }
      @Override
      public Adapter caseHWFailureRate(HWFailureRate object)
      {
        return createHWFailureRateAdapter();
      }
      @Override
      public Adapter caseHWFailureMode(HWFailureMode object)
      {
        return createHWFailureModeAdapter();
      }
      @Override
      public Adapter caseHWFault(HWFault object)
      {
        return createHWFaultAdapter();
      }
      @Override
      public Adapter caseHWComponentPrototypeScope(HWComponentPrototypeScope object)
      {
        return createHWComponentPrototypeScopeAdapter();
      }
      @Override
      public Adapter caseHwComponentScopeInstanceRef(HwComponentScopeInstanceRef object)
      {
        return createHwComponentScopeInstanceRefAdapter();
      }
      @Override
      public Adapter caseHWComponentQuantifiedFMFromPart(HWComponentQuantifiedFMFromPart object)
      {
        return createHWComponentQuantifiedFMFromPartAdapter();
      }
      @Override
      public Adapter caseHWElementPrototypeScope(HWElementPrototypeScope object)
      {
        return createHWElementPrototypeScopeAdapter();
      }
      @Override
      public Adapter caseHWPartFailure(HWPartFailure object)
      {
        return createHWPartFailureAdapter();
      }
      @Override
      public Adapter caseHWPartFailureAnalysis(HWPartFailureAnalysis object)
      {
        return createHWPartFailureAnalysisAdapter();
      }
      @Override
      public Adapter caseHWPartFailureMode(HWPartFailureMode object)
      {
        return createHWPartFailureModeAdapter();
      }
      @Override
      public Adapter caseHWPartFailureRate(HWPartFailureRate object)
      {
        return createHWPartFailureRateAdapter();
      }
      @Override
      public Adapter caseHWElementScopeInstanceRef(HWElementScopeInstanceRef object)
      {
        return createHWElementScopeInstanceRefAdapter();
      }
      @Override
      public Adapter caseHWArchitecturalMetrics(HWArchitecturalMetrics object)
      {
        return createHWArchitecturalMetricsAdapter();
      }
      @Override
      public Adapter caseHWFMSingleContribution(HWFMSingleContribution object)
      {
        return createHWFMSingleContributionAdapter();
      }
      @Override
      public Adapter caseHWProbabilisticValue(HWProbabilisticValue object)
      {
        return createHWProbabilisticValueAdapter();
      }
      @Override
      public Adapter caseHWQuantitativeFailureAnalysis(HWQuantitativeFailureAnalysis object)
      {
        return createHWQuantitativeFailureAnalysisAdapter();
      }
      @Override
      public Adapter caseHWLatentFaultMetric(HWLatentFaultMetric object)
      {
        return createHWLatentFaultMetricAdapter();
      }
      @Override
      public Adapter caseHWSinglePointFaultMetric(HWSinglePointFaultMetric object)
      {
        return createHWSinglePointFaultMetricAdapter();
      }
      @Override
      public Adapter caseHWElementFailureRateClass(HWElementFailureRateClass object)
      {
        return createHWElementFailureRateClassAdapter();
      }
      @Override
      public Adapter caseHWFailureClassContainer(HWFailureClassContainer object)
      {
        return createHWFailureClassContainerAdapter();
      }
      @Override
      public Adapter caseHWPMHF(HWPMHF object)
      {
        return createHWPMHFAdapter();
      }
      @Override
      public Adapter caseActor(Actor object)
      {
        return createActorAdapter();
      }
      @Override
      public Adapter caseControllabilityReference(ControllabilityReference object)
      {
        return createControllabilityReferenceAdapter();
      }
      @Override
      public Adapter caseHazard(Hazard object)
      {
        return createHazardAdapter();
      }
      @Override
      public Adapter caseHazardousEvent(HazardousEvent object)
      {
        return createHazardousEventAdapter();
      }
      @Override
      public Adapter caseItem(Item object)
      {
        return createItemAdapter();
      }
      @Override
      public Adapter caseItemFunctionDescription(ItemFunctionDescription object)
      {
        return createItemFunctionDescriptionAdapter();
      }
      @Override
      public Adapter caseOperatingMode(OperatingMode object)
      {
        return createOperatingModeAdapter();
      }
      @Override
      public Adapter caseOperationalSituation(OperationalSituation object)
      {
        return createOperationalSituationAdapter();
      }
      @Override
      public Adapter caseRiskDescription(RiskDescription object)
      {
        return createRiskDescriptionAdapter();
      }
      @Override
      public Adapter caseSafeState(SafeState object)
      {
        return createSafeStateAdapter();
      }
      @Override
      public Adapter caseAbstractQuantifiableSafetyRequirement(AbstractQuantifiableSafetyRequirement object)
      {
        return createAbstractQuantifiableSafetyRequirementAdapter();
      }
      @Override
      public Adapter caseAbstractSafetyRequirement(AbstractSafetyRequirement object)
      {
        return createAbstractSafetyRequirementAdapter();
      }
      @Override
      public Adapter caseAllocatableElement(AllocatableElement object)
      {
        return createAllocatableElementAdapter();
      }
      @Override
      public Adapter caseAllocationTargets(AllocationTargets object)
      {
        return createAllocationTargetsAdapter();
      }
      @Override
      public Adapter caseFunctionalSafetyRequirement(FunctionalSafetyRequirement object)
      {
        return createFunctionalSafetyRequirementAdapter();
      }
      @Override
      public Adapter caseHardwareSafetyRequirement(HardwareSafetyRequirement object)
      {
        return createHardwareSafetyRequirementAdapter();
      }
      @Override
      public Adapter caseQuantifiedDiagnosticCoverageProperty(QuantifiedDiagnosticCoverageProperty object)
      {
        return createQuantifiedDiagnosticCoveragePropertyAdapter();
      }
      @Override
      public Adapter caseQuantifiedHWProperty(QuantifiedHWProperty object)
      {
        return createQuantifiedHWPropertyAdapter();
      }
      @Override
      public Adapter caseRequirementsLink(RequirementsLink object)
      {
        return createRequirementsLinkAdapter();
      }
      @Override
      public Adapter caseRequirementsReleationship(RequirementsReleationship object)
      {
        return createRequirementsReleationshipAdapter();
      }
      @Override
      public Adapter caseSafetyConcept(SafetyConcept object)
      {
        return createSafetyConceptAdapter();
      }
      @Override
      public Adapter caseSatisfy(Satisfy object)
      {
        return createSatisfyAdapter();
      }
      @Override
      public Adapter caseSoftwareSafetyRequirement(SoftwareSafetyRequirement object)
      {
        return createSoftwareSafetyRequirementAdapter();
      }
      @Override
      public Adapter caseTechnicalSafetyRequirement(TechnicalSafetyRequirement object)
      {
        return createTechnicalSafetyRequirementAdapter();
      }
      @Override
      public Adapter caseTraceableSpecification(TraceableSpecification object)
      {
        return createTraceableSpecificationAdapter();
      }
      @Override
      public Adapter caseVerify(Verify object)
      {
        return createVerifyAdapter();
      }
      @Override
      public Adapter caseWarningAndDegradation(WarningAndDegradation object)
      {
        return createWarningAndDegradationAdapter();
      }
      @Override
      public Adapter caseWarningAndDegradationHandle(WarningAndDegradationHandle object)
      {
        return createWarningAndDegradationHandleAdapter();
      }
      @Override
      public Adapter caseAssumption(Assumption object)
      {
        return createAssumptionAdapter();
      }
      @Override
      public Adapter caseContext(Context object)
      {
        return createContextAdapter();
      }
      @Override
      public Adapter caseGoal(Goal object)
      {
        return createGoalAdapter();
      }
      @Override
      public Adapter caseJustification(Justification object)
      {
        return createJustificationAdapter();
      }
      @Override
      public Adapter caseSafetyCase(SafetyCase object)
      {
        return createSafetyCaseAdapter();
      }
      @Override
      public Adapter caseSolution(Solution object)
      {
        return createSolutionAdapter();
      }
      @Override
      public Adapter caseStrategy(Strategy object)
      {
        return createStrategyAdapter();
      }
      @Override
      public Adapter caseAnalysisReport(AnalysisReport object)
      {
        return createAnalysisReportAdapter();
      }
      @Override
      public Adapter caseDesignSpecification(DesignSpecification object)
      {
        return createDesignSpecificationAdapter();
      }
      @Override
      public Adapter caseFieldTestProtocol(FieldTestProtocol object)
      {
        return createFieldTestProtocolAdapter();
      }
      @Override
      public Adapter caseFMEAReport(FMEAReport object)
      {
        return createFMEAReportAdapter();
      }
      @Override
      public Adapter caseTestProtocol(TestProtocol object)
      {
        return createTestProtocolAdapter();
      }
      @Override
      public Adapter caseUnitTestProtocol(UnitTestProtocol object)
      {
        return createUnitTestProtocolAdapter();
      }
      @Override
      public Adapter caseAvoid(Avoid object)
      {
        return createAvoidAdapter();
      }
      @Override
      public Adapter caseDetect(Detect object)
      {
        return createDetectAdapter();
      }
      @Override
      public Adapter caseHandle(Handle object)
      {
        return createHandleAdapter();
      }
      @Override
      public Adapter caseSituation(Situation object)
      {
        return createSituationAdapter();
      }
      @Override
      public Adapter caseTactic(Tactic object)
      {
        return createTacticAdapter();
      }
      @Override
      public Adapter caseAUTOSARRunnableEntitySequenceConstraint(AUTOSARRunnableEntitySequenceConstraint object)
      {
        return createAUTOSARRunnableEntitySequenceConstraintAdapter();
      }
      @Override
      public Adapter caseAUTOSARSequenceConstraint(AUTOSARSequenceConstraint object)
      {
        return createAUTOSARSequenceConstraintAdapter();
      }
      @Override
      public Adapter caseControlBlock(ControlBlock object)
      {
        return createControlBlockAdapter();
      }
      @Override
      public Adapter caseControlFlowError(ControlFlowError object)
      {
        return createControlFlowErrorAdapter();
      }
      @Override
      public Adapter caseControlFlowErrorDetection(ControlFlowErrorDetection object)
      {
        return createControlFlowErrorDetectionAdapter();
      }
      @Override
      public Adapter caseControlFlowMonitor(ControlFlowMonitor object)
      {
        return createControlFlowMonitorAdapter();
      }
      @Override
      public Adapter caseInputBlock(InputBlock object)
      {
        return createInputBlockAdapter();
      }
      @Override
      public Adapter caseOperationBlock(OperationBlock object)
      {
        return createOperationBlockAdapter();
      }
      @Override
      public Adapter caseOutputBlock(OutputBlock object)
      {
        return createOutputBlockAdapter();
      }
      @Override
      public Adapter caseRunnableEntitySequenceElement(RunnableEntitySequenceElement object)
      {
        return createRunnableEntitySequenceElementAdapter();
      }
      @Override
      public Adapter caseSequenceBlock(SequenceBlock object)
      {
        return createSequenceBlockAdapter();
      }
      @Override
      public Adapter caseAlivenessCheckpointTooEarly(AlivenessCheckpointTooEarly object)
      {
        return createAlivenessCheckpointTooEarlyAdapter();
      }
      @Override
      public Adapter caseAlivenessCheckpointTooLate(AlivenessCheckpointTooLate object)
      {
        return createAlivenessCheckpointTooLateAdapter();
      }
      @Override
      public Adapter caseAlivenessCheckpointTooOften(AlivenessCheckpointTooOften object)
      {
        return createAlivenessCheckpointTooOftenAdapter();
      }
      @Override
      public Adapter caseAlivenessMonitor(AlivenessMonitor object)
      {
        return createAlivenessMonitorAdapter();
      }
      @Override
      public Adapter caseAutosarAlivenessMonitor(AutosarAlivenessMonitor object)
      {
        return createAutosarAlivenessMonitorAdapter();
      }
      @Override
      public Adapter caseAutosarCheckPoint(AutosarCheckPoint object)
      {
        return createAutosarCheckPointAdapter();
      }
      @Override
      public Adapter caseCheckPoint(CheckPoint object)
      {
        return createCheckPointAdapter();
      }
      @Override
      public Adapter caseSoftwareAlivenessDetection(SoftwareAlivenessDetection object)
      {
        return createSoftwareAlivenessDetectionAdapter();
      }
      @Override
      public Adapter caseActuatorError(ActuatorError object)
      {
        return createActuatorErrorAdapter();
      }
      @Override
      public Adapter caseActuatorErrorDetection(ActuatorErrorDetection object)
      {
        return createActuatorErrorDetectionAdapter();
      }
      @Override
      public Adapter caseActuatorMonitor(ActuatorMonitor object)
      {
        return createActuatorMonitorAdapter();
      }
      @Override
      public Adapter caseAutosarActuatorMonitor(AutosarActuatorMonitor object)
      {
        return createAutosarActuatorMonitorAdapter();
      }
      @Override
      public Adapter caseAutosarEvaluationFunction(AutosarEvaluationFunction object)
      {
        return createAutosarEvaluationFunctionAdapter();
      }
      @Override
      public Adapter caseEvaluationFunction(EvaluationFunction object)
      {
        return createEvaluationFunctionAdapter();
      }
      @Override
      public Adapter caseAutosarCRC(AutosarCRC object)
      {
        return createAutosarCRCAdapter();
      }
      @Override
      public Adapter caseComponentPrototypeCRC(ComponentPrototypeCRC object)
      {
        return createComponentPrototypeCRCAdapter();
      }
      @Override
      public Adapter caseCRC(CRC object)
      {
        return createCRCAdapter();
      }
      @Override
      public Adapter caseCRCConfig(CRCConfig object)
      {
        return createCRCConfigAdapter();
      }
      @Override
      public Adapter caseCRCErrorDetection(CRCErrorDetection object)
      {
        return createCRCErrorDetectionAdapter();
      }
      @Override
      public Adapter caseCRCFailed(CRCFailed object)
      {
        return createCRCFailedAdapter();
      }
      @Override
      public Adapter caseInterfaceCRC(InterfaceCRC object)
      {
        return createInterfaceCRCAdapter();
      }
      @Override
      public Adapter caseAutosarComparison(AutosarComparison object)
      {
        return createAutosarComparisonAdapter();
      }
      @Override
      public Adapter caseAutosarComparisonParam(AutosarComparisonParam object)
      {
        return createAutosarComparisonParamAdapter();
      }
      @Override
      public Adapter caseChromosomeComparison(ChromosomeComparison object)
      {
        return createChromosomeComparisonAdapter();
      }
      @Override
      public Adapter caseChromosomeComparisonParameter(ChromosomeComparisonParameter object)
      {
        return createChromosomeComparisonParameterAdapter();
      }
      @Override
      public Adapter caseComparison(Comparison object)
      {
        return createComparisonAdapter();
      }
      @Override
      public Adapter caseComparisonDetection(ComparisonDetection object)
      {
        return createComparisonDetectionAdapter();
      }
      @Override
      public Adapter caseComparisonFalse(ComparisonFalse object)
      {
        return createComparisonFalseAdapter();
      }
      @Override
      public Adapter caseComparisonParameter(ComparisonParameter object)
      {
        return createComparisonParameterAdapter();
      }
      @Override
      public Adapter caseComparisonTrue(ComparisonTrue object)
      {
        return createComparisonTrueAdapter();
      }
      @Override
      public Adapter caseConstantComparisonParameter(ConstantComparisonParameter object)
      {
        return createConstantComparisonParameterAdapter();
      }
      @Override
      public Adapter caseAutosarContext(AutosarContext object)
      {
        return createAutosarContextAdapter();
      }
      @Override
      public Adapter caseAutosarContextRangeCheck(AutosarContextRangeCheck object)
      {
        return createAutosarContextRangeCheckAdapter();
      }
      @Override
      public Adapter caseContextParameter(ContextParameter object)
      {
        return createContextParameterAdapter();
      }
      @Override
      public Adapter caseContextRangeCheck(ContextRangeCheck object)
      {
        return createContextRangeCheckAdapter();
      }
      @Override
      public Adapter caseContextRangeCheckDetection(ContextRangeCheckDetection object)
      {
        return createContextRangeCheckDetectionAdapter();
      }
      @Override
      public Adapter caseRangeCheckContext(RangeCheckContext object)
      {
        return createRangeCheckContextAdapter();
      }
      @Override
      public Adapter caseValueAboveRange(ValueAboveRange object)
      {
        return createValueAboveRangeAdapter();
      }
      @Override
      public Adapter caseValueBelowRange(ValueBelowRange object)
      {
        return createValueBelowRangeAdapter();
      }
      @Override
      public Adapter caseChromosomeCpuSelfTest(ChromosomeCpuSelfTest object)
      {
        return createChromosomeCpuSelfTestAdapter();
      }
      @Override
      public Adapter caseCpuSelfTest(CpuSelfTest object)
      {
        return createCpuSelfTestAdapter();
      }
      @Override
      public Adapter caseCpuSelfTestConfig(CpuSelfTestConfig object)
      {
        return createCpuSelfTestConfigAdapter();
      }
      @Override
      public Adapter caseCpuSelfTestDetection(CpuSelfTestDetection object)
      {
        return createCpuSelfTestDetectionAdapter();
      }
      @Override
      public Adapter caseCpuSelfTestFailed(CpuSelfTestFailed object)
      {
        return createCpuSelfTestFailedAdapter();
      }
      @Override
      public Adapter caseFilter(Filter object)
      {
        return createFilterAdapter();
      }
      @Override
      public Adapter caseFilterBasedHandling(FilterBasedHandling object)
      {
        return createFilterBasedHandlingAdapter();
      }
      @Override
      public Adapter caseFilterError(FilterError object)
      {
        return createFilterErrorAdapter();
      }
      @Override
      public Adapter caseFilterParameter(FilterParameter object)
      {
        return createFilterParameterAdapter();
      }
      @Override
      public Adapter caseAutosarGradientCheck(AutosarGradientCheck object)
      {
        return createAutosarGradientCheckAdapter();
      }
      @Override
      public Adapter caseGradientCheck(GradientCheck object)
      {
        return createGradientCheckAdapter();
      }
      @Override
      public Adapter caseGradientCheckDetection(GradientCheckDetection object)
      {
        return createGradientCheckDetectionAdapter();
      }
      @Override
      public Adapter caseGradientTooHigh(GradientTooHigh object)
      {
        return createGradientTooHighAdapter();
      }
      @Override
      public Adapter caseGradientTooLow(GradientTooLow object)
      {
        return createGradientTooLowAdapter();
      }
      @Override
      public Adapter caseChromosomeApplicationHealthMonitor(ChromosomeApplicationHealthMonitor object)
      {
        return createChromosomeApplicationHealthMonitorAdapter();
      }
      @Override
      public Adapter caseChromosomeComponentModeCondition(ChromosomeComponentModeCondition object)
      {
        return createChromosomeComponentModeConditionAdapter();
      }
      @Override
      public Adapter caseChromosomeErrorEventCondition(ChromosomeErrorEventCondition object)
      {
        return createChromosomeErrorEventConditionAdapter();
      }
      @Override
      public Adapter caseChromosomeErrorHandler(ChromosomeErrorHandler object)
      {
        return createChromosomeErrorHandlerAdapter();
      }
      @Override
      public Adapter caseChromosomeHealthMonitor(ChromosomeHealthMonitor object)
      {
        return createChromosomeHealthMonitorAdapter();
      }
      @Override
      public Adapter caseCHROMOSOMEHealthMonitorNotification(CHROMOSOMEHealthMonitorNotification object)
      {
        return createCHROMOSOMEHealthMonitorNotificationAdapter();
      }
      @Override
      public Adapter caseChromosomeNodeHealthMonitor(ChromosomeNodeHealthMonitor object)
      {
        return createChromosomeNodeHealthMonitorAdapter();
      }
      @Override
      public Adapter caseHealthMonitor(HealthMonitor object)
      {
        return createHealthMonitorAdapter();
      }
      @Override
      public Adapter caseHealthMonitorErrorCondition(HealthMonitorErrorCondition object)
      {
        return createHealthMonitorErrorConditionAdapter();
      }
      @Override
      public Adapter caseHealthMonitoring(HealthMonitoring object)
      {
        return createHealthMonitoringAdapter();
      }
      @Override
      public Adapter caseChromosomeHeartbeatReceiver(ChromosomeHeartbeatReceiver object)
      {
        return createChromosomeHeartbeatReceiverAdapter();
      }
      @Override
      public Adapter caseChromosomeHeartbeatSender(ChromosomeHeartbeatSender object)
      {
        return createChromosomeHeartbeatSenderAdapter();
      }
      @Override
      public Adapter caseHeartbeat(Heartbeat object)
      {
        return createHeartbeatAdapter();
      }
      @Override
      public Adapter caseHeartbeatConfig(HeartbeatConfig object)
      {
        return createHeartbeatConfigAdapter();
      }
      @Override
      public Adapter caseHeartBeatDeadlineMissed(HeartBeatDeadlineMissed object)
      {
        return createHeartBeatDeadlineMissedAdapter();
      }
      @Override
      public Adapter caseHeartBeatDetection(HeartBeatDetection object)
      {
        return createHeartBeatDetectionAdapter();
      }
      @Override
      public Adapter caseHeartbeatReceiver(HeartbeatReceiver object)
      {
        return createHeartbeatReceiverAdapter();
      }
      @Override
      public Adapter caseHeartbeatSender(HeartbeatSender object)
      {
        return createHeartbeatSenderAdapter();
      }
      @Override
      public Adapter caseChromosomeMemoryTest(ChromosomeMemoryTest object)
      {
        return createChromosomeMemoryTestAdapter();
      }
      @Override
      public Adapter caseMemoryRange(MemoryRange object)
      {
        return createMemoryRangeAdapter();
      }
      @Override
      public Adapter caseMemorySelfTest(MemorySelfTest object)
      {
        return createMemorySelfTestAdapter();
      }
      @Override
      public Adapter caseMemorySelfTestConfig(MemorySelfTestConfig object)
      {
        return createMemorySelfTestConfigAdapter();
      }
      @Override
      public Adapter caseMemorySelfTestFailed(MemorySelfTestFailed object)
      {
        return createMemorySelfTestFailedAdapter();
      }
      @Override
      public Adapter caseMemorySelfTesting(MemorySelfTesting object)
      {
        return createMemorySelfTestingAdapter();
      }
      @Override
      public Adapter caseChromosomeVoter(ChromosomeVoter object)
      {
        return createChromosomeVoterAdapter();
      }
      @Override
      public Adapter caseChromosomeVoterParameter(ChromosomeVoterParameter object)
      {
        return createChromosomeVoterParameterAdapter();
      }
      @Override
      public Adapter caseVoter(Voter object)
      {
        return createVoterAdapter();
      }
      @Override
      public Adapter caseVoterConfig(VoterConfig object)
      {
        return createVoterConfigAdapter();
      }
      @Override
      public Adapter caseVoterNoConsensus(VoterNoConsensus object)
      {
        return createVoterNoConsensusAdapter();
      }
      @Override
      public Adapter caseVoterParameter(VoterParameter object)
      {
        return createVoterParameterAdapter();
      }
      @Override
      public Adapter caseVoterValueMismatch(VoterValueMismatch object)
      {
        return createVoterValueMismatchAdapter();
      }
      @Override
      public Adapter caseVoting(Voting object)
      {
        return createVotingAdapter();
      }
      @Override
      public Adapter caseBooleanConfigParameterValue(BooleanConfigParameterValue object)
      {
        return createBooleanConfigParameterValueAdapter();
      }
      @Override
      public Adapter caseCodeGenerationConfiguration(CodeGenerationConfiguration object)
      {
        return createCodeGenerationConfigurationAdapter();
      }
      @Override
      public Adapter caseConfigParameter(ConfigParameter object)
      {
        return createConfigParameterAdapter();
      }
      @Override
      public Adapter caseConfigParameterValue(ConfigParameterValue object)
      {
        return createConfigParameterValueAdapter();
      }
      @Override
      public Adapter caseFloatConfigParameterValue(FloatConfigParameterValue object)
      {
        return createFloatConfigParameterValueAdapter();
      }
      @Override
      public Adapter caseIdentifierConfigParameterValue(IdentifierConfigParameterValue object)
      {
        return createIdentifierConfigParameterValueAdapter();
      }
      @Override
      public Adapter caseIntegerConfigParameterValue(IntegerConfigParameterValue object)
      {
        return createIntegerConfigParameterValueAdapter();
      }
      @Override
      public Adapter caseStringConfigParameterValue(StringConfigParameterValue object)
      {
        return createStringConfigParameterValueAdapter();
      }
      @Override
      public Adapter caseHardwareSoftwareInterfaceElement(HardwareSoftwareInterfaceElement object)
      {
        return createHardwareSoftwareInterfaceElementAdapter();
      }
      @Override
      public Adapter caseHardwareSoftwareInterfaceSpecification(HardwareSoftwareInterfaceSpecification object)
      {
        return createHardwareSoftwareInterfaceSpecificationAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FilterExpression <em>Filter Expression</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FilterExpression
   * @generated
   */
  public Adapter createFilterExpressionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FormulaExpression <em>Formula Expression</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FormulaExpression
   * @generated
   */
  public Adapter createFormulaExpressionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AbstractReference <em>Abstract Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AbstractReference
   * @generated
   */
  public Adapter createAbstractReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarReference <em>Autosar Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarReference
   * @generated
   */
  public Adapter createAutosarReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CHROMOSOMEReference <em>CHROMOSOME Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CHROMOSOMEReference
   * @generated
   */
  public Adapter createCHROMOSOMEReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EastAdlReference <em>East Adl Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EastAdlReference
   * @generated
   */
  public Adapter createEastAdlReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Application <em>Application</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Application
   * @generated
   */
  public Adapter createApplicationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Component <em>Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Component
   * @generated
   */
  public Adapter createComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ComponentModeInstanceRef <em>Component Mode Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ComponentModeInstanceRef
   * @generated
   */
  public Adapter createComponentModeInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Node <em>Node</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Node
   * @generated
   */
  public Adapter createNodeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.System <em>System</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.System
   * @generated
   */
  public Adapter createSystemAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Topic <em>Topic</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Topic
   * @generated
   */
  public Adapter createTopicAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MultiLevelSafetyExtension <em>Multi Level Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MultiLevelSafetyExtension
   * @generated
   */
  public Adapter createMultiLevelSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SafetyExtension <em>Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SafetyExtension
   * @generated
   */
  public Adapter createSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SingleLevelSafetyExtension <em>Single Level Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SingleLevelSafetyExtension
   * @generated
   */
  public Adapter createSingleLevelSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FunctionalSafetyExtension <em>Functional Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FunctionalSafetyExtension
   * @generated
   */
  public Adapter createFunctionalSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension <em>Hazardand Risk Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HazardandRiskSafetyExtension
   * @generated
   */
  public Adapter createHazardandRiskSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension <em>Autosar Hardware Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarHardwareSafetyExtension
   * @generated
   */
  public Adapter createAutosarHardwareSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarSafetyExtension <em>Autosar Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarSafetyExtension
   * @generated
   */
  public Adapter createAutosarSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarSystemSafetyExtension <em>Autosar System Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarSystemSafetyExtension
   * @generated
   */
  public Adapter createAutosarSystemSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarVfbSafetyExtension <em>Autosar Vfb Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarVfbSafetyExtension
   * @generated
   */
  public Adapter createAutosarVfbSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeApplicationSafetyExtension <em>Chromosome Application Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeApplicationSafetyExtension
   * @generated
   */
  public Adapter createChromosomeApplicationSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeSafeExtension <em>Chromosome Safe Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeSafeExtension
   * @generated
   */
  public Adapter createChromosomeSafeExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeSystemSafetyExtension <em>Chromosome System Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeSystemSafetyExtension
   * @generated
   */
  public Adapter createChromosomeSystemSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ImplementationSafetyExtension <em>Implementation Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ImplementationSafetyExtension
   * @generated
   */
  public Adapter createImplementationSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.DesignLevelSafetyExtension <em>Design Level Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.DesignLevelSafetyExtension
   * @generated
   */
  public Adapter createDesignLevelSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HardwareSafetyExtension <em>Hardware Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HardwareSafetyExtension
   * @generated
   */
  public Adapter createHardwareSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SoftwareSafetyExtension <em>Software Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SoftwareSafetyExtension
   * @generated
   */
  public Adapter createSoftwareSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.TechnicalSafetyExtension <em>Technical Safety Extension</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.TechnicalSafetyExtension
   * @generated
   */
  public Adapter createTechnicalSafetyExtensionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.PackageableElement <em>Packageable Element</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.PackageableElement
   * @generated
   */
  public Adapter createPackageableElementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Referrable <em>Referrable</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Referrable
   * @generated
   */
  public Adapter createReferrableAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SAFE <em>SAFE</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SAFE
   * @generated
   */
  public Adapter createSAFEAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SAFEElement <em>SAFE Element</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SAFEElement
   * @generated
   */
  public Adapter createSAFEElementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SAFEPackage <em>SAFE Package</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SAFEPackage
   * @generated
   */
  public Adapter createSAFEPackageAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Identifiable <em>Identifiable</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Identifiable
   * @generated
   */
  public Adapter createIdentifiableAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarAbstractComponentInstanceRef <em>Autosar Abstract Component Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarAbstractComponentInstanceRef
   * @generated
   */
  public Adapter createAutosarAbstractComponentInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarAbstractPortInComponentInstanceRef <em>Autosar Abstract Port In Component Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarAbstractPortInComponentInstanceRef
   * @generated
   */
  public Adapter createAutosarAbstractPortInComponentInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarClientServerOperationInstanceRef <em>Autosar Client Server Operation Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarClientServerOperationInstanceRef
   * @generated
   */
  public Adapter createAutosarClientServerOperationInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef <em>Autosar Component In Composition Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef
   * @generated
   */
  public Adapter createAutosarComponentInCompositionInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarInstanceRef <em>Autosar Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarInstanceRef
   * @generated
   */
  public Adapter createAutosarInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef <em>Autosar Mode In Port From Component In Composition Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef
   * @generated
   */
  public Adapter createAutosarModeInPortFromComponentInCompositionInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarPortInCompositionInstanceRef <em>Autosar Port In Composition Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarPortInCompositionInstanceRef
   * @generated
   */
  public Adapter createAutosarPortInCompositionInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarUndefinedInstanceRef <em>Autosar Undefined Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarUndefinedInstanceRef
   * @generated
   */
  public Adapter createAutosarUndefinedInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef <em>Autosar Variable Data Prototype Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef
   * @generated
   */
  public Adapter createAutosarVariableDataPrototypeInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Restrictable <em>Restrictable</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Restrictable
   * @generated
   */
  public Adapter createRestrictableAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Restriction <em>Restriction</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Restriction
   * @generated
   */
  public Adapter createRestrictionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Variant <em>Variant</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Variant
   * @generated
   */
  public Adapter createVariantAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModel <em>Error Model</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModel
   * @generated
   */
  public Adapter createErrorModelAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelInstanceRef <em>Error Model Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelInstanceRef
   * @generated
   */
  public Adapter createErrorModelInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelPrototype_analysisFunctionTarget <em>Error Model Prototype analysis Function Target</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelPrototype_analysisFunctionTarget
   * @generated
   */
  public Adapter createErrorModelPrototype_analysisFunctionTargetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelPrototype_designFunctionTarget <em>Error Model Prototype design Function Target</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelPrototype_designFunctionTarget
   * @generated
   */
  public Adapter createErrorModelPrototype_designFunctionTargetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelPrototype_hwTarget <em>Error Model Prototype hw Target</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelPrototype_hwTarget
   * @generated
   */
  public Adapter createErrorModelPrototype_hwTargetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FaultFailurePort_functionTarget <em>Fault Failure Port function Target</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FaultFailurePort_functionTarget
   * @generated
   */
  public Adapter createFaultFailurePort_functionTargetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FaultFailurePort_hwPinTarget <em>Fault Failure Port hw Pin Target</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FaultFailurePort_hwPinTarget
   * @generated
   */
  public Adapter createFaultFailurePort_hwPinTargetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FaultFailurePort_hwPortTarget <em>Fault Failure Port hw Port Target</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FaultFailurePort_hwPortTarget
   * @generated
   */
  public Adapter createFaultFailurePort_hwPortTargetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MalfunctionInstanceRef <em>Malfunction Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MalfunctionInstanceRef
   * @generated
   */
  public Adapter createMalfunctionInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AbstractErrorBehavior <em>Abstract Error Behavior</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AbstractErrorBehavior
   * @generated
   */
  public Adapter createAbstractErrorBehaviorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EastADLErrorBehavior <em>East ADL Error Behavior</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EastADLErrorBehavior
   * @generated
   */
  public Adapter createEastADLErrorBehaviorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FailureLogicFormula <em>Failure Logic Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FailureLogicFormula
   * @generated
   */
  public Adapter createFailureLogicFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.NativeErrorBehavior <em>Native Error Behavior</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.NativeErrorBehavior
   * @generated
   */
  public Adapter createNativeErrorBehaviorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMPAnalysis <em>EMP Analysis</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMPAnalysis
   * @generated
   */
  public Adapter createEMPAnalysisAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMPBswModule <em>EMP Bsw Module</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMPBswModule
   * @generated
   */
  public Adapter createEMPBswModuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMPDesign <em>EMP Design</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMPDesign
   * @generated
   */
  public Adapter createEMPDesignAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMPHwComponent <em>EMP Hw Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMPHwComponent
   * @generated
   */
  public Adapter createEMPHwComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMPReference <em>EMP Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMPReference
   * @generated
   */
  public Adapter createEMPReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMPSwComponent <em>EMP Sw Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMPSwComponent
   * @generated
   */
  public Adapter createEMPSwComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMTypeAnalysis <em>EM Type Analysis</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMTypeAnalysis
   * @generated
   */
  public Adapter createEMTypeAnalysisAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMTypeApplicationEnvironment <em>EM Type Application Environment</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMTypeApplicationEnvironment
   * @generated
   */
  public Adapter createEMTypeApplicationEnvironmentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMTypeBswModule <em>EM Type Bsw Module</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMTypeBswModule
   * @generated
   */
  public Adapter createEMTypeBswModuleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMTypeDesign <em>EM Type Design</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMTypeDesign
   * @generated
   */
  public Adapter createEMTypeDesignAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMTypeHwComponent <em>EM Type Hw Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMTypeHwComponent
   * @generated
   */
  public Adapter createEMTypeHwComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EMTypeSwComponent <em>EM Type Sw Component</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EMTypeSwComponent
   * @generated
   */
  public Adapter createEMTypeSwComponentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelPrototype <em>Error Model Prototype</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelPrototype
   * @generated
   */
  public Adapter createErrorModelPrototypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelType <em>Error Model Type</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelType
   * @generated
   */
  public Adapter createErrorModelTypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FaultFailurePropagationLink <em>Fault Failure Propagation Link</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FaultFailurePropagationLink
   * @generated
   */
  public Adapter createFaultFailurePropagationLinkAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FailureRate <em>Failure Rate</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FailureRate
   * @generated
   */
  public Adapter createFailureRateAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.QuantitativeErrorModel <em>Quantitative Error Model</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.QuantitativeErrorModel
   * @generated
   */
  public Adapter createQuantitativeErrorModelAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MalfunctionPrototype <em>Malfunction Prototype</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MalfunctionPrototype
   * @generated
   */
  public Adapter createMalfunctionPrototypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MalfunctionType <em>Malfunction Type</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MalfunctionType
   * @generated
   */
  public Adapter createMalfunctionTypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPBswPort <em>MFP Bsw Port</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPBswPort
   * @generated
   */
  public Adapter createMFPBswPortAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPFunctionPort <em>MFP Function Port</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPFunctionPort
   * @generated
   */
  public Adapter createMFPFunctionPortAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPHardwarePin <em>MFP Hardware Pin</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPHardwarePin
   * @generated
   */
  public Adapter createMFPHardwarePinAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPHardwarePort <em>MFP Hardware Port</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPHardwarePort
   * @generated
   */
  public Adapter createMFPHardwarePortAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPOperation <em>MFP Operation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPOperation
   * @generated
   */
  public Adapter createMFPOperationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPSwcPort <em>MFP Swc Port</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPSwcPort
   * @generated
   */
  public Adapter createMFPSwcPortAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MFPVariable <em>MFP Variable</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MFPVariable
   * @generated
   */
  public Adapter createMFPVariableAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MTComposite <em>MT Composite</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MTComposite
   * @generated
   */
  public Adapter createMTCompositeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MTCompositeElementPrototype <em>MT Composite Element Prototype</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MTCompositeElementPrototype
   * @generated
   */
  public Adapter createMTCompositeElementPrototypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MTPrimitive <em>MT Primitive</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MTPrimitive
   * @generated
   */
  public Adapter createMTPrimitiveAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorBehaviorMapping <em>Error Behavior Mapping</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorBehaviorMapping
   * @generated
   */
  public Adapter createErrorBehaviorMappingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ErrorModelMapping <em>Error Model Mapping</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ErrorModelMapping
   * @generated
   */
  public Adapter createErrorModelMappingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MalfunctionMapping <em>Malfunction Mapping</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MalfunctionMapping
   * @generated
   */
  public Adapter createMalfunctionMappingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FormulaDocumentation <em>Formula Documentation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FormulaDocumentation
   * @generated
   */
  public Adapter createFormulaDocumentationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFailureClassContributionFormula <em>HW Failure Class Contribution Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFailureClassContributionFormula
   * @generated
   */
  public Adapter createHWFailureClassContributionFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFMSingleContributionFormula <em>HWFM Single Contribution Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFMSingleContributionFormula
   * @generated
   */
  public Adapter createHWFMSingleContributionFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWLambdaPartFormula <em>HW Lambda Part Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWLambdaPartFormula
   * @generated
   */
  public Adapter createHWLambdaPartFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWLatentFaultMetricFormula <em>HW Latent Fault Metric Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWLatentFaultMetricFormula
   * @generated
   */
  public Adapter createHWLatentFaultMetricFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWPMHFFormula <em>HWPMHF Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWPMHFFormula
   * @generated
   */
  public Adapter createHWPMHFFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula <em>HW Single Point Fault Metric Formula</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula
   * @generated
   */
  public Adapter createHWSinglePointFaultMetricFormulaAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HardwareFailureAnalysis <em>Hardware Failure Analysis</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HardwareFailureAnalysis
   * @generated
   */
  public Adapter createHardwareFailureAnalysisAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HardwareComponentFailure <em>Hardware Component Failure</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HardwareComponentFailure
   * @generated
   */
  public Adapter createHardwareComponentFailureAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFailureRate <em>HW Failure Rate</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFailureRate
   * @generated
   */
  public Adapter createHWFailureRateAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFailureMode <em>HW Failure Mode</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFailureMode
   * @generated
   */
  public Adapter createHWFailureModeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFault <em>HW Fault</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFault
   * @generated
   */
  public Adapter createHWFaultAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope <em>HW Component Prototype Scope</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWComponentPrototypeScope
   * @generated
   */
  public Adapter createHWComponentPrototypeScopeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef <em>Hw Component Scope Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HwComponentScopeInstanceRef
   * @generated
   */
  public Adapter createHwComponentScopeInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart <em>HW Component Quantified FM From Part</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart
   * @generated
   */
  public Adapter createHWComponentQuantifiedFMFromPartAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWElementPrototypeScope <em>HW Element Prototype Scope</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWElementPrototypeScope
   * @generated
   */
  public Adapter createHWElementPrototypeScopeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWPartFailure <em>HW Part Failure</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWPartFailure
   * @generated
   */
  public Adapter createHWPartFailureAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWPartFailureAnalysis <em>HW Part Failure Analysis</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWPartFailureAnalysis
   * @generated
   */
  public Adapter createHWPartFailureAnalysisAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWPartFailureMode <em>HW Part Failure Mode</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWPartFailureMode
   * @generated
   */
  public Adapter createHWPartFailureModeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWPartFailureRate <em>HW Part Failure Rate</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWPartFailureRate
   * @generated
   */
  public Adapter createHWPartFailureRateAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWElementScopeInstanceRef <em>HW Element Scope Instance Ref</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWElementScopeInstanceRef
   * @generated
   */
  public Adapter createHWElementScopeInstanceRefAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWArchitecturalMetrics <em>HW Architectural Metrics</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWArchitecturalMetrics
   * @generated
   */
  public Adapter createHWArchitecturalMetricsAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFMSingleContribution <em>HWFM Single Contribution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFMSingleContribution
   * @generated
   */
  public Adapter createHWFMSingleContributionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWProbabilisticValue <em>HW Probabilistic Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWProbabilisticValue
   * @generated
   */
  public Adapter createHWProbabilisticValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis <em>HW Quantitative Failure Analysis</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis
   * @generated
   */
  public Adapter createHWQuantitativeFailureAnalysisAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWLatentFaultMetric <em>HW Latent Fault Metric</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWLatentFaultMetric
   * @generated
   */
  public Adapter createHWLatentFaultMetricAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWSinglePointFaultMetric <em>HW Single Point Fault Metric</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWSinglePointFaultMetric
   * @generated
   */
  public Adapter createHWSinglePointFaultMetricAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWElementFailureRateClass <em>HW Element Failure Rate Class</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWElementFailureRateClass
   * @generated
   */
  public Adapter createHWElementFailureRateClassAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWFailureClassContainer <em>HW Failure Class Container</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWFailureClassContainer
   * @generated
   */
  public Adapter createHWFailureClassContainerAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HWPMHF <em>HWPMHF</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HWPMHF
   * @generated
   */
  public Adapter createHWPMHFAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Actor <em>Actor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Actor
   * @generated
   */
  public Adapter createActorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ControllabilityReference <em>Controllability Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ControllabilityReference
   * @generated
   */
  public Adapter createControllabilityReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Hazard <em>Hazard</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Hazard
   * @generated
   */
  public Adapter createHazardAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HazardousEvent <em>Hazardous Event</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HazardousEvent
   * @generated
   */
  public Adapter createHazardousEventAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Item <em>Item</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Item
   * @generated
   */
  public Adapter createItemAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ItemFunctionDescription <em>Item Function Description</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ItemFunctionDescription
   * @generated
   */
  public Adapter createItemFunctionDescriptionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.OperatingMode <em>Operating Mode</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.OperatingMode
   * @generated
   */
  public Adapter createOperatingModeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.OperationalSituation <em>Operational Situation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.OperationalSituation
   * @generated
   */
  public Adapter createOperationalSituationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.RiskDescription <em>Risk Description</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.RiskDescription
   * @generated
   */
  public Adapter createRiskDescriptionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SafeState <em>Safe State</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SafeState
   * @generated
   */
  public Adapter createSafeStateAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AbstractQuantifiableSafetyRequirement <em>Abstract Quantifiable Safety Requirement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AbstractQuantifiableSafetyRequirement
   * @generated
   */
  public Adapter createAbstractQuantifiableSafetyRequirementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AbstractSafetyRequirement <em>Abstract Safety Requirement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AbstractSafetyRequirement
   * @generated
   */
  public Adapter createAbstractSafetyRequirementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AllocatableElement <em>Allocatable Element</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AllocatableElement
   * @generated
   */
  public Adapter createAllocatableElementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AllocationTargets <em>Allocation Targets</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AllocationTargets
   * @generated
   */
  public Adapter createAllocationTargetsAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FunctionalSafetyRequirement <em>Functional Safety Requirement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FunctionalSafetyRequirement
   * @generated
   */
  public Adapter createFunctionalSafetyRequirementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HardwareSafetyRequirement <em>Hardware Safety Requirement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HardwareSafetyRequirement
   * @generated
   */
  public Adapter createHardwareSafetyRequirementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty <em>Quantified Diagnostic Coverage Property</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty
   * @generated
   */
  public Adapter createQuantifiedDiagnosticCoveragePropertyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.QuantifiedHWProperty <em>Quantified HW Property</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.QuantifiedHWProperty
   * @generated
   */
  public Adapter createQuantifiedHWPropertyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.RequirementsLink <em>Requirements Link</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.RequirementsLink
   * @generated
   */
  public Adapter createRequirementsLinkAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.RequirementsReleationship <em>Requirements Releationship</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.RequirementsReleationship
   * @generated
   */
  public Adapter createRequirementsReleationshipAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SafetyConcept <em>Safety Concept</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SafetyConcept
   * @generated
   */
  public Adapter createSafetyConceptAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Satisfy <em>Satisfy</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Satisfy
   * @generated
   */
  public Adapter createSatisfyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SoftwareSafetyRequirement <em>Software Safety Requirement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SoftwareSafetyRequirement
   * @generated
   */
  public Adapter createSoftwareSafetyRequirementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.TechnicalSafetyRequirement <em>Technical Safety Requirement</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.TechnicalSafetyRequirement
   * @generated
   */
  public Adapter createTechnicalSafetyRequirementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.TraceableSpecification <em>Traceable Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.TraceableSpecification
   * @generated
   */
  public Adapter createTraceableSpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Verify <em>Verify</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Verify
   * @generated
   */
  public Adapter createVerifyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.WarningAndDegradation <em>Warning And Degradation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.WarningAndDegradation
   * @generated
   */
  public Adapter createWarningAndDegradationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.WarningAndDegradationHandle <em>Warning And Degradation Handle</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.WarningAndDegradationHandle
   * @generated
   */
  public Adapter createWarningAndDegradationHandleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Assumption <em>Assumption</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Assumption
   * @generated
   */
  public Adapter createAssumptionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Context <em>Context</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Context
   * @generated
   */
  public Adapter createContextAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Goal <em>Goal</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Goal
   * @generated
   */
  public Adapter createGoalAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Justification <em>Justification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Justification
   * @generated
   */
  public Adapter createJustificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SafetyCase <em>Safety Case</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SafetyCase
   * @generated
   */
  public Adapter createSafetyCaseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Solution <em>Solution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Solution
   * @generated
   */
  public Adapter createSolutionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Strategy <em>Strategy</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Strategy
   * @generated
   */
  public Adapter createStrategyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AnalysisReport <em>Analysis Report</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AnalysisReport
   * @generated
   */
  public Adapter createAnalysisReportAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.DesignSpecification <em>Design Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.DesignSpecification
   * @generated
   */
  public Adapter createDesignSpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FieldTestProtocol <em>Field Test Protocol</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FieldTestProtocol
   * @generated
   */
  public Adapter createFieldTestProtocolAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FMEAReport <em>FMEA Report</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FMEAReport
   * @generated
   */
  public Adapter createFMEAReportAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.TestProtocol <em>Test Protocol</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.TestProtocol
   * @generated
   */
  public Adapter createTestProtocolAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.UnitTestProtocol <em>Unit Test Protocol</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.UnitTestProtocol
   * @generated
   */
  public Adapter createUnitTestProtocolAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Avoid <em>Avoid</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Avoid
   * @generated
   */
  public Adapter createAvoidAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Detect <em>Detect</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Detect
   * @generated
   */
  public Adapter createDetectAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Handle <em>Handle</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Handle
   * @generated
   */
  public Adapter createHandleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Situation <em>Situation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Situation
   * @generated
   */
  public Adapter createSituationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Tactic <em>Tactic</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Tactic
   * @generated
   */
  public Adapter createTacticAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AUTOSARRunnableEntitySequenceConstraint <em>AUTOSAR Runnable Entity Sequence Constraint</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AUTOSARRunnableEntitySequenceConstraint
   * @generated
   */
  public Adapter createAUTOSARRunnableEntitySequenceConstraintAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AUTOSARSequenceConstraint <em>AUTOSAR Sequence Constraint</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AUTOSARSequenceConstraint
   * @generated
   */
  public Adapter createAUTOSARSequenceConstraintAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ControlBlock <em>Control Block</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ControlBlock
   * @generated
   */
  public Adapter createControlBlockAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ControlFlowError <em>Control Flow Error</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ControlFlowError
   * @generated
   */
  public Adapter createControlFlowErrorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ControlFlowErrorDetection <em>Control Flow Error Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ControlFlowErrorDetection
   * @generated
   */
  public Adapter createControlFlowErrorDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ControlFlowMonitor <em>Control Flow Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ControlFlowMonitor
   * @generated
   */
  public Adapter createControlFlowMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.InputBlock <em>Input Block</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.InputBlock
   * @generated
   */
  public Adapter createInputBlockAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.OperationBlock <em>Operation Block</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.OperationBlock
   * @generated
   */
  public Adapter createOperationBlockAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.OutputBlock <em>Output Block</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.OutputBlock
   * @generated
   */
  public Adapter createOutputBlockAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.RunnableEntitySequenceElement <em>Runnable Entity Sequence Element</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.RunnableEntitySequenceElement
   * @generated
   */
  public Adapter createRunnableEntitySequenceElementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SequenceBlock <em>Sequence Block</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SequenceBlock
   * @generated
   */
  public Adapter createSequenceBlockAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AlivenessCheckpointTooEarly <em>Aliveness Checkpoint Too Early</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AlivenessCheckpointTooEarly
   * @generated
   */
  public Adapter createAlivenessCheckpointTooEarlyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AlivenessCheckpointTooLate <em>Aliveness Checkpoint Too Late</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AlivenessCheckpointTooLate
   * @generated
   */
  public Adapter createAlivenessCheckpointTooLateAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AlivenessCheckpointTooOften <em>Aliveness Checkpoint Too Often</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AlivenessCheckpointTooOften
   * @generated
   */
  public Adapter createAlivenessCheckpointTooOftenAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AlivenessMonitor <em>Aliveness Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AlivenessMonitor
   * @generated
   */
  public Adapter createAlivenessMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarAlivenessMonitor <em>Autosar Aliveness Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarAlivenessMonitor
   * @generated
   */
  public Adapter createAutosarAlivenessMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarCheckPoint <em>Autosar Check Point</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarCheckPoint
   * @generated
   */
  public Adapter createAutosarCheckPointAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CheckPoint <em>Check Point</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CheckPoint
   * @generated
   */
  public Adapter createCheckPointAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.SoftwareAlivenessDetection <em>Software Aliveness Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.SoftwareAlivenessDetection
   * @generated
   */
  public Adapter createSoftwareAlivenessDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ActuatorError <em>Actuator Error</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ActuatorError
   * @generated
   */
  public Adapter createActuatorErrorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ActuatorErrorDetection <em>Actuator Error Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ActuatorErrorDetection
   * @generated
   */
  public Adapter createActuatorErrorDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ActuatorMonitor <em>Actuator Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ActuatorMonitor
   * @generated
   */
  public Adapter createActuatorMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarActuatorMonitor <em>Autosar Actuator Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarActuatorMonitor
   * @generated
   */
  public Adapter createAutosarActuatorMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarEvaluationFunction <em>Autosar Evaluation Function</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarEvaluationFunction
   * @generated
   */
  public Adapter createAutosarEvaluationFunctionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.EvaluationFunction <em>Evaluation Function</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.EvaluationFunction
   * @generated
   */
  public Adapter createEvaluationFunctionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarCRC <em>Autosar CRC</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarCRC
   * @generated
   */
  public Adapter createAutosarCRCAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ComponentPrototypeCRC <em>Component Prototype CRC</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ComponentPrototypeCRC
   * @generated
   */
  public Adapter createComponentPrototypeCRCAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CRC <em>CRC</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CRC
   * @generated
   */
  public Adapter createCRCAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CRCConfig <em>CRC Config</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CRCConfig
   * @generated
   */
  public Adapter createCRCConfigAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CRCErrorDetection <em>CRC Error Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CRCErrorDetection
   * @generated
   */
  public Adapter createCRCErrorDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CRCFailed <em>CRC Failed</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CRCFailed
   * @generated
   */
  public Adapter createCRCFailedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.InterfaceCRC <em>Interface CRC</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.InterfaceCRC
   * @generated
   */
  public Adapter createInterfaceCRCAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarComparison <em>Autosar Comparison</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarComparison
   * @generated
   */
  public Adapter createAutosarComparisonAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarComparisonParam <em>Autosar Comparison Param</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarComparisonParam
   * @generated
   */
  public Adapter createAutosarComparisonParamAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeComparison <em>Chromosome Comparison</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeComparison
   * @generated
   */
  public Adapter createChromosomeComparisonAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeComparisonParameter <em>Chromosome Comparison Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeComparisonParameter
   * @generated
   */
  public Adapter createChromosomeComparisonParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Comparison <em>Comparison</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Comparison
   * @generated
   */
  public Adapter createComparisonAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ComparisonDetection <em>Comparison Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ComparisonDetection
   * @generated
   */
  public Adapter createComparisonDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ComparisonFalse <em>Comparison False</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ComparisonFalse
   * @generated
   */
  public Adapter createComparisonFalseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ComparisonParameter <em>Comparison Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ComparisonParameter
   * @generated
   */
  public Adapter createComparisonParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ComparisonTrue <em>Comparison True</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ComparisonTrue
   * @generated
   */
  public Adapter createComparisonTrueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ConstantComparisonParameter <em>Constant Comparison Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ConstantComparisonParameter
   * @generated
   */
  public Adapter createConstantComparisonParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarContext <em>Autosar Context</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarContext
   * @generated
   */
  public Adapter createAutosarContextAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarContextRangeCheck <em>Autosar Context Range Check</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarContextRangeCheck
   * @generated
   */
  public Adapter createAutosarContextRangeCheckAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ContextParameter <em>Context Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ContextParameter
   * @generated
   */
  public Adapter createContextParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ContextRangeCheck <em>Context Range Check</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ContextRangeCheck
   * @generated
   */
  public Adapter createContextRangeCheckAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ContextRangeCheckDetection <em>Context Range Check Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ContextRangeCheckDetection
   * @generated
   */
  public Adapter createContextRangeCheckDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.RangeCheckContext <em>Range Check Context</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.RangeCheckContext
   * @generated
   */
  public Adapter createRangeCheckContextAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ValueAboveRange <em>Value Above Range</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ValueAboveRange
   * @generated
   */
  public Adapter createValueAboveRangeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ValueBelowRange <em>Value Below Range</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ValueBelowRange
   * @generated
   */
  public Adapter createValueBelowRangeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeCpuSelfTest <em>Chromosome Cpu Self Test</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeCpuSelfTest
   * @generated
   */
  public Adapter createChromosomeCpuSelfTestAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CpuSelfTest <em>Cpu Self Test</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CpuSelfTest
   * @generated
   */
  public Adapter createCpuSelfTestAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CpuSelfTestConfig <em>Cpu Self Test Config</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CpuSelfTestConfig
   * @generated
   */
  public Adapter createCpuSelfTestConfigAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CpuSelfTestDetection <em>Cpu Self Test Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CpuSelfTestDetection
   * @generated
   */
  public Adapter createCpuSelfTestDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CpuSelfTestFailed <em>Cpu Self Test Failed</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CpuSelfTestFailed
   * @generated
   */
  public Adapter createCpuSelfTestFailedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Filter <em>Filter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Filter
   * @generated
   */
  public Adapter createFilterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FilterBasedHandling <em>Filter Based Handling</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FilterBasedHandling
   * @generated
   */
  public Adapter createFilterBasedHandlingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FilterError <em>Filter Error</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FilterError
   * @generated
   */
  public Adapter createFilterErrorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FilterParameter <em>Filter Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FilterParameter
   * @generated
   */
  public Adapter createFilterParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.AutosarGradientCheck <em>Autosar Gradient Check</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.AutosarGradientCheck
   * @generated
   */
  public Adapter createAutosarGradientCheckAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.GradientCheck <em>Gradient Check</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.GradientCheck
   * @generated
   */
  public Adapter createGradientCheckAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.GradientCheckDetection <em>Gradient Check Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.GradientCheckDetection
   * @generated
   */
  public Adapter createGradientCheckDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.GradientTooHigh <em>Gradient Too High</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.GradientTooHigh
   * @generated
   */
  public Adapter createGradientTooHighAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.GradientTooLow <em>Gradient Too Low</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.GradientTooLow
   * @generated
   */
  public Adapter createGradientTooLowAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeApplicationHealthMonitor <em>Chromosome Application Health Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeApplicationHealthMonitor
   * @generated
   */
  public Adapter createChromosomeApplicationHealthMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeComponentModeCondition <em>Chromosome Component Mode Condition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeComponentModeCondition
   * @generated
   */
  public Adapter createChromosomeComponentModeConditionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeErrorEventCondition <em>Chromosome Error Event Condition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeErrorEventCondition
   * @generated
   */
  public Adapter createChromosomeErrorEventConditionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeErrorHandler <em>Chromosome Error Handler</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeErrorHandler
   * @generated
   */
  public Adapter createChromosomeErrorHandlerAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeHealthMonitor <em>Chromosome Health Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeHealthMonitor
   * @generated
   */
  public Adapter createChromosomeHealthMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CHROMOSOMEHealthMonitorNotification <em>CHROMOSOME Health Monitor Notification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CHROMOSOMEHealthMonitorNotification
   * @generated
   */
  public Adapter createCHROMOSOMEHealthMonitorNotificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeNodeHealthMonitor <em>Chromosome Node Health Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeNodeHealthMonitor
   * @generated
   */
  public Adapter createChromosomeNodeHealthMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HealthMonitor <em>Health Monitor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HealthMonitor
   * @generated
   */
  public Adapter createHealthMonitorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HealthMonitorErrorCondition <em>Health Monitor Error Condition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HealthMonitorErrorCondition
   * @generated
   */
  public Adapter createHealthMonitorErrorConditionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HealthMonitoring <em>Health Monitoring</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HealthMonitoring
   * @generated
   */
  public Adapter createHealthMonitoringAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeHeartbeatReceiver <em>Chromosome Heartbeat Receiver</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeHeartbeatReceiver
   * @generated
   */
  public Adapter createChromosomeHeartbeatReceiverAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeHeartbeatSender <em>Chromosome Heartbeat Sender</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeHeartbeatSender
   * @generated
   */
  public Adapter createChromosomeHeartbeatSenderAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Heartbeat <em>Heartbeat</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Heartbeat
   * @generated
   */
  public Adapter createHeartbeatAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HeartbeatConfig <em>Heartbeat Config</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HeartbeatConfig
   * @generated
   */
  public Adapter createHeartbeatConfigAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HeartBeatDeadlineMissed <em>Heart Beat Deadline Missed</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HeartBeatDeadlineMissed
   * @generated
   */
  public Adapter createHeartBeatDeadlineMissedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HeartBeatDetection <em>Heart Beat Detection</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HeartBeatDetection
   * @generated
   */
  public Adapter createHeartBeatDetectionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HeartbeatReceiver <em>Heartbeat Receiver</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HeartbeatReceiver
   * @generated
   */
  public Adapter createHeartbeatReceiverAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HeartbeatSender <em>Heartbeat Sender</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HeartbeatSender
   * @generated
   */
  public Adapter createHeartbeatSenderAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeMemoryTest <em>Chromosome Memory Test</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeMemoryTest
   * @generated
   */
  public Adapter createChromosomeMemoryTestAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MemoryRange <em>Memory Range</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MemoryRange
   * @generated
   */
  public Adapter createMemoryRangeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MemorySelfTest <em>Memory Self Test</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MemorySelfTest
   * @generated
   */
  public Adapter createMemorySelfTestAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MemorySelfTestConfig <em>Memory Self Test Config</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MemorySelfTestConfig
   * @generated
   */
  public Adapter createMemorySelfTestConfigAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MemorySelfTestFailed <em>Memory Self Test Failed</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MemorySelfTestFailed
   * @generated
   */
  public Adapter createMemorySelfTestFailedAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.MemorySelfTesting <em>Memory Self Testing</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.MemorySelfTesting
   * @generated
   */
  public Adapter createMemorySelfTestingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeVoter <em>Chromosome Voter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeVoter
   * @generated
   */
  public Adapter createChromosomeVoterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ChromosomeVoterParameter <em>Chromosome Voter Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ChromosomeVoterParameter
   * @generated
   */
  public Adapter createChromosomeVoterParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Voter <em>Voter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Voter
   * @generated
   */
  public Adapter createVoterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.VoterConfig <em>Voter Config</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.VoterConfig
   * @generated
   */
  public Adapter createVoterConfigAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.VoterNoConsensus <em>Voter No Consensus</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.VoterNoConsensus
   * @generated
   */
  public Adapter createVoterNoConsensusAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.VoterParameter <em>Voter Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.VoterParameter
   * @generated
   */
  public Adapter createVoterParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.VoterValueMismatch <em>Voter Value Mismatch</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.VoterValueMismatch
   * @generated
   */
  public Adapter createVoterValueMismatchAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.Voting <em>Voting</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.Voting
   * @generated
   */
  public Adapter createVotingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.BooleanConfigParameterValue <em>Boolean Config Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.BooleanConfigParameterValue
   * @generated
   */
  public Adapter createBooleanConfigParameterValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.CodeGenerationConfiguration <em>Code Generation Configuration</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.CodeGenerationConfiguration
   * @generated
   */
  public Adapter createCodeGenerationConfigurationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ConfigParameter <em>Config Parameter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ConfigParameter
   * @generated
   */
  public Adapter createConfigParameterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.ConfigParameterValue <em>Config Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.ConfigParameterValue
   * @generated
   */
  public Adapter createConfigParameterValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.FloatConfigParameterValue <em>Float Config Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.FloatConfigParameterValue
   * @generated
   */
  public Adapter createFloatConfigParameterValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.IdentifierConfigParameterValue <em>Identifier Config Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.IdentifierConfigParameterValue
   * @generated
   */
  public Adapter createIdentifierConfigParameterValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.IntegerConfigParameterValue <em>Integer Config Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.IntegerConfigParameterValue
   * @generated
   */
  public Adapter createIntegerConfigParameterValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.StringConfigParameterValue <em>String Config Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.StringConfigParameterValue
   * @generated
   */
  public Adapter createStringConfigParameterValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement <em>Hardware Software Interface Element</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement
   * @generated
   */
  public Adapter createHardwareSoftwareInterfaceElementAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification <em>Hardware Software Interface Specification</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification
   * @generated
   */
  public Adapter createHardwareSoftwareInterfaceSpecificationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //Safe10AdapterFactory
