/**
 */
package autosar40.commonstructure.internalbehavior;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see autosar40.commonstructure.internalbehavior.InternalbehaviorFactory
 * @model kind="package"
 * @generated
 */
public interface InternalbehaviorPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "internalbehavior";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://autosar.org/schema/r4.0/autosar40/cs/ib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	InternalbehaviorPackage eINSTANCE = autosar40.commonstructure.internalbehavior.impl.InternalbehaviorPackageImpl.init();

	/**
	 * The meta object id for the '{@link autosar40.commonstructure.internalbehavior.impl.ExecutableEntityImpl <em>Executable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see autosar40.commonstructure.internalbehavior.impl.ExecutableEntityImpl
	 * @see autosar40.commonstructure.internalbehavior.impl.InternalbehaviorPackageImpl#getExecutableEntity()
	 * @generated
	 */
	int EXECUTABLE_ENTITY = 0;

	/**
	 * The number of structural features of the '<em>Executable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_ENTITY_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Executable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_ENTITY_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link autosar40.commonstructure.internalbehavior.ExecutableEntity <em>Executable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Executable Entity</em>'.
	 * @see autosar40.commonstructure.internalbehavior.ExecutableEntity
	 * @generated
	 */
	EClass getExecutableEntity();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	InternalbehaviorFactory getInternalbehaviorFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link autosar40.commonstructure.internalbehavior.impl.ExecutableEntityImpl <em>Executable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see autosar40.commonstructure.internalbehavior.impl.ExecutableEntityImpl
		 * @see autosar40.commonstructure.internalbehavior.impl.InternalbehaviorPackageImpl#getExecutableEntity()
		 * @generated
		 */
		EClass EXECUTABLE_ENTITY = eINSTANCE.getExecutableEntity();

	}

} //InternalbehaviorPackage
