package org.safe.metamodelgen.postprocessings;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;

import org.eclipse.eatop.eaadapter.ea2ecore.PostProcessingTemplate;
import org.eclipse.eatop.metamodelgen.util.ModelUtil;

public class CopyAutosarFiles extends PostProcessingTemplate {
	
	private static final String AUTOSAR_STUB_GENMODEL = "autosarStub.genmodel";
	private static final String AUTOSAR_STUB_ECORE = "autosarStub.ecore";
	
//	private static final String GAUTOSAR_GENMODEL = "gautosar.genmodel";
//	private static final String GAUTOSAR_ECORE = "gautosar.ecore";
	
	private File ecoreModelFile = null;
	private String autosarStubRootDir = null;
	
	public CopyAutosarFiles(File ecoreModelFile, String autosarStubRootDir) {
		this.ecoreModelFile = ecoreModelFile;
		this.autosarStubRootDir = autosarStubRootDir;
	}
	
	private void copyFile (File file, IContainer destFolder) throws FileNotFoundException, CoreException {
		IFile newFile = destFolder.getFile(new Path(file.getName()));
		newFile.create(new FileInputStream(file), true, null);
	}

	@Override
	public void execute() throws CoreException {
		IPath genModelPath = new Path(ecoreModelFile.getAbsolutePath());
		IFile iFile = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(
				genModelPath);
		IContainer destFolder = iFile.getParent();
			
//			//copy AUTOSAR STUB ecore
//			File file = ModelUtil.findFileByName(new File(autosarStubRootDir), 
//					AUTOSAR_STUB_ECORE);
//			copyFile(file, destFolder);
//			
//			//copy AUTOSAR STUB genmodel
//			file = ModelUtil.findFileByName(new File(autosarStubRootDir), 
//					AUTOSAR_STUB_GENMODEL);
//			copyFile(file, destFolder);
			
			//copy ecore
			IFolder autosarStubRootFolder = ResourcesPlugin.getWorkspace().getRoot().getFolder(new Path(autosarStubRootDir));
			IFile autosarStubEcoreFile = autosarStubRootFolder.getFile(AUTOSAR_STUB_ECORE);
			autosarStubEcoreFile.copy(destFolder.getFullPath().append(AUTOSAR_STUB_ECORE), true, null);
			
			//copy genmodel
			IFile autosarStubGenmodelFile = autosarStubRootFolder.getFile(AUTOSAR_STUB_GENMODEL);
			autosarStubGenmodelFile.copy(destFolder.getFullPath().append(AUTOSAR_STUB_GENMODEL), true, null);
	}
}

