package org.safe.metamodelgen.postprocessings;

import java.util.HashSet;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.eatop.eaadapter.ea2ecore.PostProcessingTemplate;

public class DetectUnusedReference extends PostProcessingTemplate{
	
	@Override
	public void execute() throws Exception {
		EList<EClassifier> referenceList = getReferenceEclassifiers();
		
		if(referenceList != null){
			TreeIterator<EObject> iter = model.eAllContents();
			while (iter.hasNext()) {
				EObject element = (EObject) iter.next();
				if (element instanceof EReference) {
					EReference eRef = (EReference) element;
					EClassifier eType = eRef.getEType();
					if (referenceList.contains(eType)) {
						referenceList.remove(eType);
					}
				}
			}								
			
			if(referenceList != null){
				for(EClassifier eReference : referenceList){				
					logger.info("Detecting Unused reference: " + eReference.getName());
				}
			}
			
		}
	}
	
	public EList<EClassifier> getReferenceEclassifiers(){
		EList<EClassifier> referenceList = new BasicEList<EClassifier>();
		TreeIterator<EObject> iter = model.eAllContents();
		while (iter.hasNext()) {
			EObject element = (EObject) iter.next();
			if (element instanceof EPackage) {
				String name = ((EPackage) element).getName();
				if(name.equals("eastadlreferences") || name.equals("autosarreferences") || name.equals("chromosomereferences")){
					referenceList.addAll(((EPackage) element).getEClassifiers());
				}
			}
		}
		return referenceList;
	}

}
