package org.safe.metamodelgen.postprocessings;

import java.io.File;
import java.io.IOException;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.eatop.eaadapter.ea2ecore.postprocessings.AddPersistenceMapping;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.sphinx.emf.serialization.generators.persistencemapping.XMLPersistenceMappingGenerator;
import org.safe.metamodelgen.serialization.generators.persistencemapping.SAFEXMLPersistenceMappingGenerator;

public class SAFEAddPersistenceMapping extends AddPersistenceMapping {
	
	public SAFEAddPersistenceMapping (File modelFile, IProgressMonitor monitor) {
		super(modelFile,monitor);
	}
	
	protected void addXMLPersistenceMapping() throws IOException {

		XMLPersistenceMappingGenerator xmlPersistenceMappingGenerator = new SAFEXMLPersistenceMappingGenerator(model);
		
		if(xmlPersistenceMappingGenerator != null){
			model = (EPackage) xmlPersistenceMappingGenerator.execute(monitor);		
		}
		
		//we have to serialize the ecore for the first time here so we can 
		//load it from file system in other PostProcessings
		//otherwise we will get an invalid genmodel
		org.eclipse.eatop.eaadapter.ea2ecore.Util.saveModel(model, modelFile);
	}

}
