package org.safe.metamodelgen.postprocessings;

import java.io.File;
import java.io.IOException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.eatop.eaadapter.ea2ecore.postprocessings.CreateXSDSchema;
import org.eclipse.emf.common.util.URI;
import org.eclipse.sphinx.emf.serialization.generators.xsd.Ecore2XSDGenerator;
import org.safe.metamodelgen.serialization.generators.xsd.SAFEEcore2XSDGenerator;

public class SAFECreateXSDSchema extends CreateXSDSchema{
	public SAFECreateXSDSchema (IProgressMonitor monitor, File modelFile, IFile eapFile) {
		super(monitor, modelFile, eapFile);
	}
	
	@Override
	protected void createXSD() throws IOException {		
		URI xsdFileURI = URI.createPlatformResourceURI(eapFile.getFullPath().toString().replace(".eap", ".xsd"), true);

		// xtend ecore to xsd generator
		Ecore2XSDGenerator ecore2XSDGenerator = new SAFEEcore2XSDGenerator(xsdFileURI, schemaFile, model);
		
		if(ecore2XSDGenerator != null){
			ecore2XSDGenerator.run(monitor);		
		}
	}
}
