package org.safe.metamodelgen.postprocessings;

import org.eclipse.eatop.eaadapter.util.IConstants;
import org.eclipse.eatop.eaadapter.util.SchemaUtil;
import org.eclipse.eatop.metamodelgen.postprocessings.SetTaggedValuesAndAssociatedAttributes;
import org.eclipse.eatop.metamodelgen.util.IEASTADLConstants;
import org.eclipse.eatop.metamodelgen.util.ModelUtil;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.safe.metamodelgen.util.SAFEConstants;

public class SAFESetTaggedValuesAndAssociatedAttributes extends SetTaggedValuesAndAssociatedAttributes{

	public SAFESetTaggedValuesAndAssociatedAttributes(String version) {
		super(version);
	}
	
	@Override
protected void configureName(ENamedElement element) {
		
		String suffixSingualr = "";
		String suffixPlural = "S";
		
		// check if namedElement is an EReference
		if (element instanceof EReference) {
			EReference ref = (EReference) element;
			// check if reference is not a composition
			if (!ref.isContainment()) {
				// check if reference is a normal reference or a type reference
				if (IEASTADLConstants.STEREOTYPE_IS_OF_TYPE
						.equalsIgnoreCase(ModelUtil.getStereotype(ref))) {
					// is of type reference found
					suffixSingualr = IEASTADLConstants.SUFFIX_SINGULAR_TYPE_REF;
					suffixPlural = IEASTADLConstants.SUFFIX_PLURAL_TYPE_REF;
				} else {
					// normal ref
					suffixSingualr = IEASTADLConstants.SUFFIX_SINGULAR_REF;
					suffixPlural = IEASTADLConstants.SUFFIX_PLURAL_REF;
				}
			}
		}
		
		//set tagged values
		ModelUtil.addDefaultTaggedValue(element, IEASTADLConstants.TAGGED_VALUE_XML_NAME, 
				SchemaUtil.buildXmlName(element.getName()) + suffixSingualr);
		
		ModelUtil.addDefaultTaggedValue(element, IEASTADLConstants.TAGGED_VALUE_XML_NAME_PLURAL, 
				SchemaUtil.buildXmlName(element.getName()) + suffixPlural);
		
		ModelUtil.addDefaultTaggedValue(element, IEASTADLConstants.TAGGED_VALUE_XML_NS_PREFIX, 
				containerNsPrefix);
		
		this.defaultNsUri = SAFEConstants.DEFAULT_SAFE_NSURI;
		if (version != null && version.length() > 0) {
			this.defaultNsUri = this.defaultNsUri + "/" + version;
		}
		this.containerNsUri = this.defaultNsUri;
				
		ModelUtil.addDefaultTaggedValue(element, IEASTADLConstants.TAGGED_VALUE_XML_NS_URI, 
				containerNsUri);
		
        //EcoreUtil.setAnnotation(element, IConstants.ANNOTATION_EAADAPTER, IConstants.EAADAPTER_METAMODEL_TYPE, metaModelType );
	}

}
